




     'AMEND [FMM-BASED VERSION]  Author : R J Morton     08AUG87      Amend.Bas

     'This program provides the processing necessary for the making of 
     'amendments to prospect records and creating new ones.
     'For load module FMM processing structure  - see FMM.DOC


     'DEFINITIONS & COMMON VARIABLES

     DefInt a-z                    'All numeric variables are 16-bit intergers
     rem $include: 'ComVars.INC'   'Marketeer's universal common variables


     'STRUCTURE OF PROSPECT RECORD

     'nnYYYYMDDYYYYMDD      2-byte field length+ two 7-byte date fields       16
     'nnXXXXXXXXXXXXXXXXX   2-byte field length+ up to 27 bytes Company name
     'nnXXXXXXXX            2-byte field length+ 8-byte namecode field       10
     'nnXXXXXXXXXXXXXXXXX   2-byte field length+ up to 27 bytes Premises Name
     'nnXXXXXXXXXXXXXXXXX   2-byte field length+ up to 27 bytes Street N/Name
     'nnXXXXXXXXXXXXXXXXX   2-byte field length+ up to 27 bytes Town Name
     'nnXXXXXXXXXXXXXXXXX   2-byte field length+ up to 27 bytes County
     'nnXXXXXXXX            2-byte field length+ 8-byte postcode field       10
     'nnXXXXXXXXXXXXXXXXX   2-byte field length+ up to 27 bytes phone number
     'nnXXXXXXXXXXXXXXXXX   2-byte field length+ up to 27 bytes telex number
     'nnXXXXXXXXXXXXXXXXX   2-byte field length+ up to 27 bytes contact name
     'nnXXXXXXXXXXXXXXXXX   2-byte field length+ up to 27 bytes job title
     'nnXXXXXXXX            2-byte field length+ 8-byte xref field           10
     '
     'Total for fixed fields                   46 bytes
     'Field lengths for the 9 variable fields  18 bytes
     'Maximum allowed name & address etc text 180 bytes
     'Spare                                    12 bytes
     '                                        ---
     'Total record size                       256 bytes
     '





     'DEFINITION & ARRAY DIMENSIONING

     dim rec$(12)              'Contains the current name & address details
     dim CMDW$(12)             'Holds current set of command words
     dim task$(5)              'Holds the current set of tasks
     dim keyvs$(4,18)          'Referred to by GetRec & PutRec.
     dim fields$(100)          'Used by EDBLOCK to store notes + dossier
     dim values$(18)           'Used by the block editor
     dim stamps$(12)           'Date stamps for diary notes 
     dim TempRec$(12)          'Stores original name & address prior to an edit
     '                         'which can be reinstated if edit is aborted.


     'BUFFER ALLOCATIONS FOR THE FILES USED BY THIS MODULE

     RecsFileNum=1     'Main prospect records
     AreaFileNum=2     'For finding which sales area a prospect is in
     KeysFileNum=3     'Contains prospect's selecion keys
     KeysRecLen= 8     'Record length of the keys file
     DateFileNum=4     'Dates of his last and next-planned events
     IndxFileNum=5     'Namecode or Postcode index depending on type of search
     IndxRecLen=16     'Record length of an index file
     DossFileNum=6
     LocalHelp=1       'N of the `Amend' help record
     ManChap=12        'Relevant chapter of the maual Chapter N +1
     NewLine$=chr$(13)+chr$(10)
     Keys$="0000@A@@"                   'Necessary for going straight into
     Attributes$=string$(16,"@")        'entering new records when setting
     Dates$="////@//////@//"            'up initial key values,
     rec$(0)=dates$                     'then using RLKV to put the same
     SelectorCode$=space$(16)           'values in subsequent new records.
     LatestNewRecord=0                  '
     LatestNewBlock=0                   'For the keys routine in IndxSort.FMM
     LatestNewOffset=4094               '
     gosub ExpiryTest                   'Don't run if expiry date past
     SearchFieldNum = 2                 'Namecode is default search field
     goto Initialization                'Go to initialize the FMM polling loop.
     '






     'EXTERNAL SUBROUTINE

Display: row=row+1
50   call ScrSub(ps$,row,column,colour):return   'Display as is

     'FINITE-STATE MACHINES INCLUDED IN THIS LOAD MODULE

     '$include: 'Keyboard.FMM'
     '$include: 'Find.FMM'
     '$include: 'RecordIO.FMM'
     '$include: 'KeysIO.FMM'
     '$include: 'DateIO.FMM'
     '$include: 'AttrIO.FMM'
     '$include: 'CodeIO.FMM'
     '$include: 'DistIO.FMM'
     '$include: 'LoadRec.FMM'
     '$include: 'UpdtRec.FMM'
     '$include: 'SaveRec.FMM'
     '$include: 'StoreRec.FMM'
     '$include: 'IndxSort.FMM'
     '$include: 'SaveDate.FMM'
     '$include: 'LoadAttr.FMM'
     '$include: 'LoadCode.FMM'
     '$include: 'UpdtKeys.FMM'
     '$include: 'UpdtCode.FMM'
     '$include: 'AmendKey.FMM'
     '$include: 'OpenFile.FMM'
     '$include: 'EdBox.FMM'
     '$include: 'EditKeys.FMM'
     '$include: 'ViewFile.FMM'
     ' 
     '$include: 'FuncKeys.FMM'       'OTHERS
     '$include: 'GetHelp.FMM'
     '$include: 'ShowAbox.INC'
     '$include: 'ShowMbox.INC'
     '$include: 'ShowKbox.INC'
     '$include: 'Decrypt.INC'
     '$include: 'Expiry.INC'
     '$include: 'Elapsed.INC'
     '$include: 'InDate.FMM'
     '$include: 'SaveAttr.FMM'
     '$include: 'SaveCode.FMM'
     ' 
     '$include: 'Select.FMM'
     '$include: 'NotesIO.FMM'
     '$include: 'EdField.FMM'
     '$include: 'EdBlock.FMM'
     '$include: 'EdNotes.FMM'
     '$include: 'ValiPost.INC'
     '$include: 'SelKeyvs.FMM'
     '$include: 'GetKeyvs.FMM'
     '$include: 'ShoKeyvs.INC'
     '$include: 'EdDoss.FMM'
     '$include: 'DossIO.FMM'
     '$include: 'Texcrypt.INC'
     '$include: 'Manual.FMM'
     '$include: 'DragNet.FMM'
     '






     'INITIALIZE THE FINITE STATE MACHINE POLLING LOOP

     'The service programs which perform the various tasks here are written as
     'Message-drived Finite State Machines. Each FMM is continually polled in
     'sequence from the following polling loop.

Initialization:
     DosMsg$="":ShowMessages=1
     GetKeyvsState = 1       'Activate the Key Values input FMM
     cmdl          = 4       'Number of characters in command word field
     connect       = 8       'Call initially not connected
     caps=1                  'In case people like Dick Stockman type ahead
     LoopActive    =-1

     WHILE LoopActive
     gosub Initializer       'Transfer of control from initialization
     gosub Search            'Record retrieval control FMM [Resident]
     gosub NextPrevFMM       'Get next/previous subscriber on request
     gosub LoadRecord        'Record loader FMM
     gosub Keyboard          'Add incoming chrs from keyboard to buffer str
     gosub CWPFMM            'Command Word Processor FMM
     gosub CWPfkeys          'Act on CWP fkey value if present
     gosub EdBox             'Edit the name & address box
     gosub EditSICN          'Edit the SIC N
     gosub EditKeys          'Edit the Selector Keys & dates
     gosub EditAttr          'Edit the Attributes [ie products/services]
     gosub EditCode          'Edit the Selector Code
     gosub StoreRec          'Store a new or amended name & address
     gosub KillRec           'Record deletion FMM
     gosub EdNotesFMM        'Diary Notes  Processor FMM
     gosub EdDossier
     gosub HelpFMM           'Help Screen Processor FMM
     gosub Trip              'Keystroke-triggered trip out of help/note screens
     gosub ViewFile          'Real-time file viewing window
     gosub OpenFileFMM       'General File Opening FMM
     gosub ShowMessages      'Display error messages
     gosub Manual            'Display the manual on request
     gosub QuitLoop          'Means of escape from the FMM polling loop
     gosub DragNet           'Dragnet search facility.
     WEND                    'Back to the beginning of the polling loop
     ps$=space$(40):row=4    'Wipe possible error message from the
     column=41:gosub 50      'standard error messages position.
     chain OldProg$          'Exit this load module; got back to menu


     'TRANSFER OF CONTROL FROM LOAD MODULE INITIALIZATION

Initializer:
     if GetKeyvsState=0  then return  'Initialization FMM inactive
     if GetKeyvsState<3  then _       'Initialization in progress
        gosub GetKeyvs:return         'Loop initialization FMM
     if GetKeyvsState=4 then beep     'If initialization process succeeded,
                                      'then display the print instructions

     row=1:column=19:colour=7:ps$=top$:gosub 50 'Display module name
     row=4:column=41:ps$=space$(40):gosub 50    'Clear menu help text
     RightBox$="":gosub ShowMbox                'Show market profile box
     column=1:colour=8:ps$=space$(80):for row=19 to 24:gosub 50:next

     gosub DefineCmndWords     'Set up command words used in this section
     gosub DefineTasks         'Display the task list
     gosub ShowTasks           'Display the Task List panel
     locate 24,1,0             'place cursor at bottom left of screen

     if prog$ = "MAIL" then
        MailAmend = 1
        LeftBox$="Abox" 
     else
        LeftBox$="":gosub ShowAbox    'Display the name & address box
     end if   

     if RecNum = 0 then               'If no record selected
        SearchState=1                 'activate the Record Search FMM
     else
        UpDown = 0
        NextPrevState = 1             'else activate the Record Loader FMM
     end if

     OldProg$=prog$
     prog$="AMEND"                    'Set program identification variable
     GetKeyvsState=0                  'De-activate the Initialization FMM
     return                           'Return control to the FMM polling loop


Cream:
     x$ = str$(x)
     ps$ = ps$ + space$(5 - len(x$)) + x$
     return
     '



                                                                               

     'SEARCH ROUTINE

     'This FMM searches for a record on entry of a namecode, postcode or ref
     'number. With namecode & postcode, it returns the record whose namecode
     'of postcode has the closest match to the one entered.

Search:
     if SearchState=0 then return      'Machine state 0: idle
     gosub FindRecord                  'Search Key Entry/Record Search utility FMM
     gosub OpenIndexFile               'Index File Opener + get index parameters
     gosub GetKeysRecord               'Gets the retrieved record's status keys
     on SearchState goto Search1, Search2, Search3
     return


     'MACHINE STATE 1: INITIALIZE THE SEARCH PROCESS

Search1:
     gosub ShowTasks                    'Display the Task List panel
     Task = 0 : gosub ShowTaskLamps     'Clear the task lamps
     SearchState = 2                    'Advance to next machine state
     if XrefFlag = 0 then               'If not searching for a cross-reference
        EdBoxState = 1
     else
        XrefFlag = 0                    'Cancel XrefFlag (it's done its job)
        SearchKey$ = Rec$(12)           'Get search key from record's Xref field
        if left$(SearchKey$,1) > " " then 'If prospect has a cross reference
           FindRecState = 3             'advance beyond search field entry
           OpenIndxState = 1            'Activate the index file opener
           IndexType = 1                'Set for namecode search
        else
           gosub ShowNoXrefMsg          'display `no cross reference' message
           SearchState = 0              'De-activate this FMM
           CWPstate = 1                 'Re-activate command processor FMM
        end if
     end if
     return
     '





     'MACHINE STATE 2: SUPERVISE SEARCH KEY ENTRY

Search2:
     if FindRecState = 3 then           'Await completion of search key entry
        PrevIndexType = IndexType       'Preserve search index type
        Task = 1 : gosub ShowTaskLamps  'Light the SEEKING lamp
        on PrevIndexType + 1 gosub_     'According to type of search,
           ShowReference,         _     'Display REFerence number
           ShowNamecode,          _     'Highlight namecode while searching
           ShowPostcode                 'Highlight postcode while searching
        SearchState = 3                 'advance to search process supervision
     elseif FindRecState = 6 then       'If entry was aborted or Esc key pressed
        FindRecState = 0                'De-activate the Record Retriever
        QuitFlag = 1                    'Set for quitting this load module
     end if
     return


     'MACHINE STATE 3: SUPERVISE THE SEARCH PROCESSES

Search3:
     if FindRecState = 5 then           'If required record has been found OK,
        FindRecState = 0                'De-activate record retrieval utility
        LoadRecordState = 1             'Activate the record loader
        SearchState = 0                 'De-activate the Search FMM
     elseif FindRecState > 5 then       'If required record cannot be found,
        SearchState = 1                 'then return to initial search state.
     end if
     return                             'Return control to FMM polling loop.
     '





     'KEY-INITIATED EXIT FROM HELP SCREEN

     'Unfortunately, striking a key is the only practical means of exiting the
     'Help Screen. Therefore, this routine has to be somewhat specific to the
     'main program in that it has to test the state of the Help FMM. If the
     'Help FMM is active, this routine therefore re-displays the main screen
     'and de-activates the Help FMM. In this event, the character struck is
     'not regarded as part of a command input, but is ignored.

Trip:if HelpState = 3 then Task = 0 : gosub ShowTaskLamps
     if HelpState > 3 then         'Help screen active or being displayed, then
        gosub TripSub
        if help = 4 then           'If Record Retrieval Help was displayed
           SearchState = 1         'then re-activate the Record Retrieval FMM
        else
           CWPstate = 1            'else re-activate the Command Processor FMM
           gosub DisplayRecord     'Re-display the record
        end if
        HelpState = 0              'De-activate the help screen
     elseif EdNotesState > 7 then  'If EdNotes FMM has just terminated, then
        EdNotesState = 0           'De-activate it
        gosub TripSub         
     elseif ViewFileState > 7 then 'If EdNotes FMM has just terminated, then
        ViewFileState = 0          'De-activate it
        gosub TripSub         
     elseif ManualState > 0 then   'If Manual FMM has just terminated, then
        if ManualContents = 0 then
           if NewRecord = 0 then ManChap = 13 else ManChap = 12
        end if
        if ManualState = 8 then    'If Manual FMM has just terminated, then
           ManualState = 0         'De-activate it
           gosub TripSub         
        end if
     end if
     return                        'Return control to FMM polling loop.


     'REINSTATE THE MAIN SCREEN & RE-DISPLAY RECORD

TripSub:
     LeftBox$  = "" : gosub ShowAbox    'Clear the name & address box
     RightBox$ = "" : gosub ShowMbox    'Display the Market Profile Box
     ShowMessages = 1                   'Activate the message display routine
     if HelpState = 0 then
        gosub DisplayRecord        'Re-display the record
        CurrentDisplay = 0
        CWPstate = 1               'and re-activate the command word processor.
     end if
     return
     '





     'COMMAND EXECUTOR  modify for amend functions

     'When a keyboard command has been entered, the Command Word Processor FMM
     'sets a value in CWPfkey corresponding to the command entered. This routine
     'initiates the processes required to execute the entered command.

CWPfkeys:
     if CWPfkey=0 and Nkey=0 _    'If neither command word or digit entered,
        then return               'return control to the FMM polling loop
     gosub ClearMessage           'Clear the `Call completed' message
     task=0:gosub ShowTaskLamps   'Kill READY lamp; light WAIT lamp


     'SELECTIONS FOR WHICH COMMAND PROCESSOR MUST REMAIN INACTIVE

     if CWPfkey=99 then LoopActive=0:goto CWPfkeys4                'Hard exit.
     if CWPfkey= 1 then help=LocalHelp:HelpState=1:goto CWPfkeys4  'HELP
     if CWPfkey= 6 then EditFlag=1:EdBoxState=1   :goto CWPfkeys4  'EDIT
     if CWPfkey= 7 then EdNotesState=1            :goto CWPfkeys4  'NOTE

     if CWPfkey = 2 and NewRecord = 0 and MailAmend = 0 then
        DupRec = 1
        StoreRecState = 1
        goto CWPfkeys4

 elseif CWPfkey=8 then                          'F8
        if NewRecord=1 then                     'NEW [Enter a new record]
           RLKV=0:goto CWPfkeys2                '
      else EdDossierState=1:goto CWPfkeys4      'DOSS [Edit dossier file]
           end if
 elseif CWPfkey=9 then                          'F9
        if NewRecord=1 then                     'NEW [Enter a new record]
           RLKV=1:goto CWPfkeys2                'RLKV Repeat last time's keys
      else ViewFileState=1:goto CWPfkeys4       'VIEW [Real-time File-window]
           end if
        end if
     if Nkey>0 then goto NumericsKeys


     'SELECTIONS FOR WHICH COMMAND PROCESSOR NEEDS RE-ACTIVATING

CWPfkeys1:
     if CWPfkey=3 then                  'NEXT
        if Trawl = 0 then
           updown = 1 : NextPrevState = 1 : goto CWPfkeys3 
        else
           DragNet = 1 : goto CWPfkeys4
        end if
     end if
     if CWPfkey=4 then updown= -1:NextPrevState=1:goto CWPfkeys3   'PREV
     if CWPfkey=5 then XrefFlag=1:SearchState  =1:goto CWPfkeys3   'XREF
     if CWPfkey=11 then QuitFlag=1               :goto CWPfkeys3   'QUIT
     if CWPfkey=10 and MailAmend=0 then KillRecState=1:goto CWPfkeys3   'KILL
CWPfkeys5:
     beep:CWPstate=1:goto CWPfkeys4
     '





CWPfkeys2: EdBoxState=1              'Activate the name & address editor
           gosub ClearInstructions   '
           goto CWPfkeys4            'NEW  Enter another new record
CWPfkeys3: if NewRecord = 1 then
              NewRecord = 0
              gosub DefineCmndWords1
           end if
CWPfkeys4: CWPfkey=0       'Clear F-Key N to avoid a repeate next pass
           KeyNum=Nkey     'Preserve the `Key Number' as displayed on screen
           Nkey=0          'Clear numeric selection to avoid a repeat next pass
           caps=0          'allow upper & lower case letters
           return          'Return control to the FMM polling loop.


     'NUMERICS KEY TESTS [FOR AMENDING KEY VALUES]

NumericsKeys:
     if Nkey=1 then EditSICNstate=1   :goto NumericsKeys1
     if Nkey=5 then EditAttrState=1   :goto NumericsKeys1       'Products
     if Nkey=6 then EditCodeState=1   :goto NumericsKeys1
     if Nkey=3 then KeyType=1:KeyArr=1:goto NumericsKeys2       'Relation
     if Nkey=4 then KeyType=2:KeyArr=2:goto NumericsKeys2       'Progress
     if Nkey=7 then KeyType=3:KeyArr=3:goto NumericsKeys2       'Last Event
     if Nkey=8 then KeyType=4:KeyArr=3:goto NumericsKeys2       'Next Event
     goto CWPfkeys5

NumericsKeys1: KeyArr=4       :goto CWPfkeys4
NumericsKeys2: EditKeysState=1:goto CWPfkeys4
     '





     'ERASE THE PROSPECT RECORD CURRENTLY ON-SCREEN

KillRec:
     if KillRecState = 0 then return    'Kill Record FMM idle

     if KillRecState = 1 then           'If this FMM has just been triggered

        ps$ = "F5-CONFIRM THAT YOU WISH TO DELETE THIS RECORDEsc-CONTINUE WITHOUT DELETING   "
        row = 24 : column = 1 : colour = 112 : gosub 50

        X$ = "" : WHILE X$ = "" : X$ = inkey$ : WEND

        if X$ = chr$(0) + chr$(63) then 'If key struck was F5 then
           IndxSortType = 3             'Set mode to eraseing an index entry
           IndxSortState = 1            'Activate the index processor
           KillRecState = 2             'Advance to post-initialization state
        else
           CWPstate = 1 : KillRecState = 0
           return
        end if
     end if

     if IndxSortState < 8 then          'While index processor not terminated
        gosub IndxSort                  'make a single pass through it
     else
        gosub WipeDoss                  'Erase the record's dossier file.
        if PrevIndexType = 0 then       'If REF N was last index used, then
           UpDown = 1                   'advance to, and load, the next record
        else
           UpDown = 0                   'use index element which has collapsed
        end if                          'down to the current Element N pos'n
        gosub ShowKilledMsg             'Display `Previous Record Deleted'
        IndxSortState = 0               'Deactivate the index processor
        NextPrevState = 1               'Active NextPrev FMM to get next record
        KillRecState = 0                'terminate self
        end if
     return                             'Return to FMM polling loop

WipeDoss:
     on error goto WipeDoss2            'Error if there is no dossier file
     x$ = str$(RecNum)
     x$ = right$(x$, len(X$) - 1)
     Kill DossFile$ + string$(5 - len(x$), "0") + x$
WipeDoss1:
     on error goto 0 : return

WipeDoss2:
     resume WipeDoss1                   'No dossier file, so exit anyway.
     '





     'GET NEXT/PREVIOUS RECORD [FMM]

NextPrevFMM:
     if NextPrevState=0 then return
     if NextPrevState=1 then       'If this machine is in State 1, then
        task=1:gosub ShowTaskLamps 'Light SEEKING lamp
        IndexType = PrevIndexType  'N of index used to retrieve last record
        FindNextState=1            'Activate Next/Prev record retrieval FMM
        NextPrevState=2            'Advance to the Wait State
     elseif NextPrevState=2 then   'If this machine is in State 2, then
        gosub FindNextRec
        gosub OpenIndexFile        'Index File Opener + get index parameters
        gosub GetKeysRecord        'Gets the retrieved record's status keys
        if FindNextState<4 then return
        if FindNextState=4 then    'If next/previous record has been found OK
           LoadRecordState=1       'Activate the record loader
        else
           LeftBox$="":gosub ShowAbox  're-display name/address box to clear it
           CWPstate=1              'Activate the Command Word Processor FMM
        end if
        task=0:gosub ShowTaskLamps 'Kill `seek' lamp
        UpDown=0                   'Clear `get next/previous record' request
        NextPrevState=0            'De-activate Next/prev search manager FMM
        FindNextState=0            'De-activate the Next/Prev search FMM
     end if
     return                        'Return control to the FMM polling loop.
     '





     'LOAD THE RETRIEVED RECORD
     'Uses LoadRec.FMM RecordIO.FMM and GetAreas.FMM to load the required 
     'prospect record, and then displays the record in the name & address
     'box. Also lights the task lamps as appropriate.

LoadRecord:
     if LoadRecordState = 0 then return 'State 0: Idle
     if LoadRecordState = 1 then        'State 1: Initialise record loader
        task = 2 : gosub ShowTaskLamps  'Kill `seek' lamp/light the LOADING lamp
        LoadRecState = 1                'Activate Record Loading Supervisor FMM
        LoadRecordState = 2             'Advance self to next state
     elseif LoadRecordState = 2 then    'State 2: Wait for record load to finish
        gosub LoadRec                   'Record loading supervisor FMM
        if LoadRecState < 6 then return
        if LoadRecState = 6 then        'If required record not yet loaded
           LoadAttrState = 1            'Activate the attr loader FMM
           LoadRecordState = 3          'Advance to the next machine state
        else
           goto LoadRecord4a            'else terminate
        end if
     elseif LoadRecordState = 3 then    'State 3: Wait for attr load to finish
        gosub LoadAttr                  'Load the prospect's code settings
        if LoadAttrState < 5 then return
        if LoadAttrState = 5 then       'If required record not yet loaded
           LoadCodeState = 1            'Activate the code loader FMM
           LoadRecordState = 4          'Advance to the next machine state
        else
           goto LoadRecord4a            'else terminate
        end if
     elseif LoadRecordState = 4 then    'State 4: Wait for code load to finish
        gosub LoadCode                  'Load the prospect's code settings
        if LoadCodeState > 4 goto LoadRecord4a    'Code loader finished
     end if
     return
     '





     'TERMINATOR

LoadRecord4a:
     task=0:gosub ShowTaskLamps     'Clear the `load' lamps
     LoadRecState=0                 'De-activate the record load supervisor
     LoadAttrState=0                'De-activate the codes  load supervisor
     LoadCodeState=0                'De-activate the codes  load supervisor
     LoadRecordState=0              'Go to successful termination state
     if CurrentDisplay = 1 then
        EdNotesState = 1
     elseif CurrentDisplay = 2 then
        EdDossierState = 1
     else
        gosub DisplayRecord         'Display the Prospect Record
        CWPstate=1                  'Activate the Command Word Processor FMM
     end if
     gosub ShowReference
     return

     'DISPLAY RETRIEVED RECORD

DisplayRecord:
     gosub ShowAddress            'Display the name & address
     gosub DefineCmndWords1       'Display the main command words
     gosub ShowTaskLamps          'Display current task lamps
     gosub Elapsed                'Compute & present the elapsed times
     gosub ShowProfile            '[in ShowMbox]
     gosub ShowInstructions
     return


     'NUMERIC FORMATTERS

     'This routine formats an interger x into a string x$ containing the number
     'padded out with leading zeros as necessary to make it y digits long, plus
     'an extra leading space or minus sign according to the sign of x.

LeadingZeros:
     x$ = str$(x)        'Number x as a string with a leading space or - sign
     x = len(x$) - 1
     if x > y then x$ = string$( y, "!" ) : return   'Out of range
     x$ = right$(x$,x)
     if x < y then x$ = string$( y - x , "0" ) + x$
     if x < 0 then x$ = "-" + x$ else x$ = " " + x$
     return
     '






     'QUIT FMM POLLING LOOP

QuitLoop:
     if QuitFlag = 0 then return        'No `quit' request pending
     close                              'Close all files and printer
     if SearchState = 0 and _           'If not exiting from search FMM 
        OldProg$ = "MENU" then          '
        LeftBox$  = "" : gosub ShowAbox 'Clear the name & address box
        RightBox$ = "" : gosub ShowMbox 'Display the Market Profile Box
        SearchState = 1                 'Re-activate the search key entry FMM
        CWPstate = 0                    'De-activate the command processor
        QuitFlag = 0                    'Cancel the quit process
        DosMsg$ = "" : DosClr = 7       'Clear possible error message
        ShowMessages = 1                'Activate the message display routine
        DragNet = 0                     'Cancel possible trawl (dragnet) search
     else
        LoopActive = 0                  'Else de-activate the polling loop
     end if
     return
     '





     'DISPLAY THE MAIN SET OF COMMAND WORDS

DefineCmndWords:
     CMDN=1               'Enable Key N entry
     cmdw$(1)="HELP"      'Get explanation of these command words
     cmdw$(2)="DUPL"      'Create a duplicate of this record
     cmdw$(3)="NEXT"      'Get next record in current index
     cmdw$(4)="PREV"      'Get previous record in current index
     cmdw$(5)="XREF"      'Get the record whose namecode is in the XREF field
     cmdw$(6)="EDIT"      'Edit the prospect's name & address data
     cmdw$(7)="NOTE"      'Display and edit the prospect's diary notes
DefineCmndWords1:
     if NewRecord=0 then  'If not creating a new record,
        cmdw$(8)="DOSS"  'Dossier command
        cmdw$(9)="VIEW"  'View real-time file window
   else cmdw$(8)="NEW"   'Repeat the last new record's key values in this one
        cmdw$(9)="RLKV"  'Repeat the last new record's key values in this one
        end if
     cmdw$(10)="KILL"     'Delete the currently displayed prospect record
     cmdw$(11)="QUIT"     'Escape back to the retrieval screen.
     cmdw=11              'else use all 11 command words
     return               'Return to calling program


     'DISPLAY THE TASKS AVAILABLE

DefineTasks:
     task$(1)="SEEKING "  'Searching current index for the requested record
     task$(2)="LOADING "  'Loading data from database files for found record
     task$(3)="STORING "  'Storing new/amended record and or key information
     task$(4)="SORTING "  'Placing new/amended index entry in appropriate index
     task$(5)="ERASING "  'Deleting record form database & index files.
     tasks=5:return       'Number of effective tasks
     '





     'DISPLAY/CLEAR INSTRUCTIONS FOR AMENDING KEYS ETC

ShowInstructions: column=41:colour=2
     PS$="                                        ":ROW=19:GOSUB 50
     PS$="  To amend Market Profile, type in the  ":ROW=20:GOSUB 50
     PS$="  N of the field you wish to amend as  ":ROW=21:GOSUB 50
     PS$="  highlighted on left hand side of box. ":ROW=22:GOSUB 50
     PS$="                                        ":ROW=23:GOSUB 50
     RETURN
ClearInstructions:
     colour=1:column=41:ps$=space$(40):for row=19 to 23:gosub 50:next:return


     'DISPLAY/CLEAR THE STORED/KILLED MESSAGES

ShowStoredMsg:
     if DupRec = 0 goto StoredAsSeen
     gosub ShowAddress
     ps$ = " DUPLICATE RDY TO EDIT"
     DupRec = 0
     ElementNum = DupElement
     colour=10:goto ShowMessage

ShowKilledMsg: ps$ = "Previous record erased" : colour =  2 : goto ShowMessage
ShowNoXrefMsg: ps$ = "    No cross-reference" : colour = 12 : goto ShowMessage
ShowFailedMsg: ps$ = "Could not store record" : colour = 12 : goto ShowMessage
     '
StoredAsSeen: colour = 10 : ps$=" NOW STORED AS SEEN   ":goto ShowMessage
ChangesMade:  colour = 14 : ps$=" CHANGES MADE. SAVE?  ":goto ShowMessage
ClearMessage: ps$=space$(80):gosub ShowMessage1
ClearAsSeen:  ps$=space$(22) : colour = 7
ShowMessage:  row=4:column=19:goto 50
     '
ShowMessages: if ShowMessages=0 then return
              ps$=left$(DosMsg$,80)
              ps$=ps$+space$(80-len(ps$))
ShowMessage1: ShowMessages=0:row=3:column=1:colour=DosClr:goto 50


     'HIGHLIGHT/LOWLIGHT A KEY NUMBER IN MARKET PROFILE BOX

ShowBright: colour=127:goto ShowBriDim  'Bright white on white
ShowDim:    colour=112                  'black on white
ShowBriDim: if KeyNum<7 then
               row=KeyNum+7
            else
               row=KeyNum+9
            end if
            ps$=right$(str$(KeyNum),1):column=44:goto 50


     'HIGHLIGHT/LOWLIGHT A DATE IN THE MARKET PROFILE BOX

HighlightDate:
     if KeyType=3 then ps$=LastDate$    'Last Event key
     if KeyType=4 then ps$=NextDate$    'Next Event key
     row=KeyNum+9:column=66:goto 50     'Highlight relevant date

