



     'BUILDLET.BAS                                                  PAGE 1 OF 5

     '
     'LETTER BUILDER            by R J Morton      17JUN87         BuildLet.bas
     '
     '
     DefInt a-z                    'All numeric variables are 16-bit intergers
     rem $include: 'ComVars.INC'   'Marketeer's universal common variables
     dim lc%(40)
     dim LibList$(40,1)            'Names of the messages in the letter library
     dim values$(40)               'Same used for the Select.bas routine
     dim fields$(200)              'Used by EDBLOCK to store notes & dossier
     NewLine$=chr$(13)+chr$(10):LenNewLine=len(NewLine$)
     ParaRecLen=1362
     row=1:column=19:colour=7:ps$=top$:gosub 50   'Display module name
     gosub 50
     gosub ExpiryTest          'Don't run if expiry date past
     '
     '
     'INITIALIZE THE FINITE STATE MACHINE POLLING LOOP
     '
     LettInitState=1        'Kick-start the initialization FMM hierarchy
     LibLstIOstate=1        'The initialisation process for this module is
     LibLstIOtask=5         'simply loading the library list.
     caps=1                 'Set caps entry for typing ahead a namecode entry
     DosMsg$="":DosClr=12   'Clear general error message field
     ShowMessages=1         'Activate message display routine
     ACTIVE=-1
     While ACTIVE
     gosub Initializer       'Transfer of control from initialization
     gosub Keyboard          'Add incoming chrs from keyboard to buffer str
     gosub OpenFileFMM       'General File Opening FMM
     gosub SelectLetter      'Select letter to be viewed/edited
     gosub BuildLetter       'Assemble selected paras into a letter
     gosub ShowMessages      'Display current state of each major FMM
     gosub EdName            'Letter Name Editor
     WEND                    'Back to the beginning of the polling loop
     CLOSE                   'Close printer and all files.
     prog$="SELCLETT"        'say where control came from
     if ExitPath=1 then chain"Menu"
     chain"Wmenu"            'Exit this load module; go back to menu
     '
     '
     'FINITE-STATE MACHINES INCLUDED IN THIS LOAD MODULE
     ' 
     rem $include: 'Keyboard.FMM'
     rem $include: 'OpenFile.FMM'
     rem $include: 'EdField.FMM'
     rem $include: 'EdBlock.FMM'
     rem $include: 'LettIO.FMM'
     rem $include: 'TexCrypt.INC'
     rem $include: 'Expiry.INC'
     rem $include: 'Select.FMM'
     rem $include: 'LibLstIO.FMM'
     rem $include: 'LibList.INC'
     rem $include: 'Decrypt.INC'
     '
50   call ScrSub(ps$,row,column,colour):return   'Display as is
     '
     '
     '


     'BUILDLET.BAS                                                  PAGE 2 OF 5


     '
     'SELECTION ROUTINE [SELF-DEACTIVATING]
     '
SelectLetter:
     if ImportState>0 then ImportState=0:SelectLetterState=1
     if SelectLetterState=0 then return
     '
     IF SelectLetterState=1 THEN        'INITIALIZE THE LIBRARY SELECTOR
        gosub ShowLibList
        if LibType=0 then
           x$="STANDARD PARAGRAPH":x=27:y$="paragraphs"
      else x$="LETTER/TELEX/FAX/EMAIL TEXTS":x=22:y$="letters"
           end if
        ps$=string$(x,196)+x$+" LIBRARY"+string$(x,196)
        column=1:row=4:colour=Grey:gosub 50
        colour=2
        ps$="  Below are the NAMES of the paragraphs ":row=5:gosub 50
        ps$="  currently in the Paragraph Library.   ":row=6:gosub 50
        ps$="  Please select the ones you wish your  ":row=7:gosub 50
        column=41
        ps$="   new sales letter to contain. Select  ":row=5:gosub 50
        ps$="   them in the order in which you want  ":row=6:gosub 50
        ps$="   them to appear in the new letter.    ":row=7:gosub 50
        column=41:colour=2
        ps$="  The new sales letter will appear in   ":row=20:gosub 50
        ps$="  the Sales Letter Library under the    ":row=21:gosub 50
        ps$="  name `NEW LETTER'. Afterwards please  ":row=22:gosub 50
        ps$="  go to the Sales Letter Library and    ":row=23:gosub 50
        ps$="  change its name to one more suitable. ":row=24:gosub 50
        ValuRow = 9                     'First row on which field occurs
        ValuCol = 2                     'First character of first column
        InstrCol= 1
        NumCols = 4                     'Number of columns
        PerCol  =10                     'Number of values per column
        InterCol=20                     'Column separation
        MaxVals =40                     'Maximum number of values displayed
        SelOrder= 1                     'Order of selections is irrelevant
        NumSels = 16                    'Number of selections allowed
        values$ = LibSels$              'Initial value selections on entry
                                        'VALUES$(K) set up in SHOWLIB.BAS
        EditingPermitted=2              'Permit editing of field names
        SelectState=1                   'Activate the selector FMM
        if MsgNum=0 then SelectPtr=LibNum else SelectPtr=MsgNum
        UseOldSelection=1               'Keep this selection for next entry
        SelectLetterState=2             'Activate the library selector
        x=1:NewLetter=0
        while x<41 and NewLetter=0
        if LibList$(x,1)="" then NewLetter=x
        x=x+1:wend
        if x>40 then
           DosMsg$="LETTER LIBRARY FULL":BEEP
           DosClr=12:ShowMessages=1
           end if
        END IF
     '
     '
     '


     'BUILDLET.BAS                                                  PAGE 3 OF 5


     '
     'AWAIT TERMINATION OF LIBRARY SELECTOR
     '
     IF SelectLetterState=2 THEN
        gosub Select                    'Library entry selection FMM
        if SelectState<8 then return    'Exit if Select.FMM not yet terminated
        if SelectEsc=1 or values$<"A" or NewLetter=0 then
           ACTIVE=0
      else BuildLetState=1              'Modified selection into Library String
           end if
        SelectState=0                   'De-activate self
        SelectLetterState=0             'De-activate self
        END IF
     RETURN
     '
     '
     'TRANSFER OF CONTROL FROM LOAD MODULE INITIALIZATION
     '
Initializer:
     if LettInitState=0 then return     'Initialization FMM inactive
     gosub LibLstIO                     'Loop initialization FMM else if 
     if LibLstIOstate<8 then return     'Initialization in progress
     LibLstIOstate=0                    'De-activate the Library List loader
     if LibNum>0 and LibNum<41 then     'Provided LibNum is within permitted
        LibSels$=chr$(LibNum+64)        'limits, set current selection chr
        MsgNum=LibNum
   else LibSels$="@"                    'for input to Select.fmm
        LibNum=0                        'Message currently in output file
        MsgNum=0                        'Message currently being viewed
        end if
     LettInitState=0                    'De-activate the Initialization FMM
     SelectLetterState=1                'activate the Record Search FMM
     return                             'Return control to FMM polling loop.
     '
     '
     'SHOW DOS MESSAGES
     '
ShowMessages:
     if ShowMessages>0 then             'and a message has not changed, then
        ShowMessages=0                  'Clear the `display messages' switch
        if DosClr>0 then                     
           ps$=DOSmsg$:colour=DosClr    'Display DOS error message
           ps$=ps$+space$(40-len(ps$))  'Pad message field to 35 chrs
           row=3:column=41:gosub 50     'DosClr used as display trigger
           DosClr=0
           end if
        end if
     return                             'Return control to FMM polling loop
     '
     '
     'SUBROUTINE FOR FMM ON NEXT PAGE
     '
BuildLetterSub:
     Paragraph=Paragraph+1              'Advance to first/next paragraph
     MsgNum=asc(mid$(values$,Paragraph,1))-64  'Library N of next paragraph
     LettIOstate=1:return               'Activate the paragraph I/O FMM
     '
     '
     '


     'BUILDLET.BAS                                                  PAGE 4 OF 5


     '
     'ASSEMBLE THE PARAGRAPHS INTO A NEW LETTER
     '
BuildLetter:
     if BuildLetState=0 then return     'FMM in standby state
     if BuildLetState=1 then            'If the Letter Builder just activated,
        Paragraphs=len(values$)         'N of paragraphs to combine
        Paragraph=0                     'Current paragraph -1
        LibType=0                       'Indicates Paragraph Library
        ParaBias=0                      'Pre-start Fields$( ) element N
        FrameDepth=18                   'Paragraphs can be up to 18 lines long
        LettIOtask=5                    'Set for LOADing a paragraph.
        BuildLetState=2                 'Go await completion of loading.
        goto BuildLetterSub             'Get N of first paragraph for letter
        end if                          'then activate the paragraph loader.
     '
     '
     'AWAIT LOAD COMPLETION AND LOOP BACK OR ACTIVATE STORING OF LETTER
     '
     IF BuildLetState=2 then
        gosub LettIO                    'Call the LettIO FMM to laod the para
        if LettIOstate<9 then return    'It has not finished loading yet.
        LettIOstate=0                   'It's now finished, so deactivate it.
        if LettIOtask=5 then            'If we're loading paragraphs, then
           if Paragraph<Paragraphs then 'If not yet done last of the paragraphs
              ParaBias=ParaBias+TotalLines+1
              fields$(ParaBias)=""      'Blank line between paragraphs.
              goto BuildLetterSub       'Get N of next para; activate loading
         else MsgNum=NewLetter          'Library N of the new letter
              FrameDepth=200            'Letters can be up to 200 lines long
              LibType=1                 'Set for handling LETTERS
              LettIOtask=6              'Activate storing of letter.
              LettIOstate=1             'Activate the letter I/O FMM
              end if                    '
      else LibSels$="@"                 'Say letter is nolonger in output file
           LibList$(NewLetter,LibType)="NEW LETTER"
           LibLstIOstate=1
           LibLstIOtask=6               'Activate storing of library list
           BuildLetState=3              'Go await completion of storing .
           end if
        END IF                          '
     '
     '
     'AWAIT STORING OF NEW LIBRARY ENTRY THEN RE-ACTIVATE SELECTOR FMM
     '
     if BuildLetState=3 then            'If machine is in State 3, then
        gosub LibLstIO
        if LibLstIOstate<8 then return  'When Library List storing termiated
        LibLstIOstate=0                 'de-activate the FMM concerned, and
        BuildLetState=0                 'De-activate self
        goto EndBuild                   'Re-activate the selector routine
        end if                          '
     '
     RETURN
     '
     '
     '


     'BUILDLET.BAS                                                  PAGE 5 OF 5


     '
     'EDIT/DELETE A LETTER NAME
     '
EdName: if EdNameState=0 then return
     '
     if EdNameState=1 then              'If machine is in State 1, then
        CharCol=1                       'Set cursor to start of field
        Caps=0                          'Permit upper & lower case input
        EdFieldState=1                  'Activate the field editor FMM
        EdNameState=2                   'Advance to the mext machine state
        end if
     '
     if EdNameState=2 then              'If machine is in State 2, then
        gosub EdFieldFMM
        if EdFieldState<3 then return   'Field editor has not terminated
        EdFieldState=0                  'de-activate field editor
        if AmendFlag>0 then             'If the field were amended, then
           LibList$(SelectPtr,LibType)=FieldStr$ 'Put amended title in Library
           LibSels$="@"                 'Say letter is nolonger in output file
           LibLstIOstate=1              'Activate the Library List I/O FMM
           LibLstIOtask=6               'Set its task as storing Library List
           EdNameState=3                'Advance to next machine state to
      else goto EndEdName
           end if                       '
        end if                          '
     '
     if EdNameState=3 then              'If machine is in State 3, then
        gosub LibLstIO
        if LibLstIOstate<8 then return  'When Library List storing termiated
        LibLstIOState=0                 'de-activate the FMM concerned, and
        values$(SelectPtr)=FieldStr$
        goto EndEdName
        end if                          '
     '
     RETURN
     '
EndEdName:
     EdNameState=0                      'De-activate self, re-highlight the
     gosub Select2g                     'field and re-position the cursor.
EndBuild:
     Caps=1                             'Permit upper & lower case input
     SelectState=2                      'revert to this FMM's main state.
     SelectLetterState=2
     return                             'Return to the main FMM polling loop.
     '
     '
     'NUMERIC FORMATTERS
     '
     'This routine formats an interger x into a string x$ containing the number
     'padded out with leading zeros as necessary to make it y digits long, plus
     'an extra leading space or minus sign according to the sign of x.
     '
LeadingZeros:
     x$=str$(x)        'Number x as a string with a leading space or - sign
     x=len(x$)-1
     if x>y then x$=string$(y,"!"):return   'Out of range
     x$=right$(x$,x)
     if x<y then x$=string$(y-x,"0")+x$
     if x<0 then x$="-"+x$ else x$=" "+x$
     return
     '
     ' 
     '
