






     '-------------------------------------------------------------------------
     'COMMAND WORD DISPLAY ROUTINE          08DEC86             [File: CWP.BAS]
     '-------------------------------------------------------------------------
     'ENTRY POINTS:
5305 GOTO 5329  'Display the command words
5306 GOTO 5423  'Display the task list
5307 GOTO 5430  'Set wait Lamps
5308 GOTO 5437  'Set task lamps
5309 GOTO 5440  'Clear the command words area [excluding task list]
     '
     'Inputs  CMDW$() - Command words to be displayed [must be 8 chrs]
     '        CMDW    - Number of command words
     '        TASK$() - Task list display
     '        TASKS   - Number of tasks effective
     '        TASK    - Number of active task [=0 if no task active]
     '        READY   - [=0 if WAIT lamp on; =1 if READY lamp on]
     '
     'Typical layout of command panel [Rows 20-24; Cols 1-40]
     '
     '   NEXT-F1 CULL-F2  Enter command SEEKING
     '   PREV-F3 PULL-F4   when READY  LOADING
     '   SAVE-F5 HOLD-F6               SORTING
     '   KILL-F7 NOTE-F8       WAIT   STORING
     '   QUIT-F9 HELP-10  ____  READY  ERASING
     '
     '-------------------------------------------------------------------------
     'DISPLAY COMMAND WORDS [RIGHT COLUMN ONLY IF UP TO 5 COMMAND WORDS]
     '
5329 column=1:x=0:for k=1 to 10
     ps$=cmdw$(k)
     if ps$="" then
        colour=grey:ps$=""
   else colour=2:ps$=ps$+space$(4-len(ps$))
        end if
     row=20+x:gosub 50:if column=1 then column=9 else column=1:x=x+1
     next
     '
     '-------------------------------------------------------------------------
     'DISPLAY FUNCTION KEY NUMBERS
     '
     Colour=grey:COLUMN=5
     ROW=20          :PS$="-F1 ":GOSUB 50         'Display in right column
     ROW=21          :PS$="-F3 ":GOSUB 50         'if <6 commands required,
     ROW=22          :PS$="-F5 ":GOSUB 50         'otherwise display in
     ROW=23          :PS$="-F7 ":GOSUB 50         'left column.
     ROW=24          :PS$="-F9 ":GOSUB 50
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'DISPLAY FUNCTION KEY NUMBERS [continued]
     '
     ROW=20:COLUMN=13:PS$="-F2 ":GOSUB 50         'Display in right column
     ROW=21          :PS$="-F4 ":GOSUB 50         'if more than 6 command
     ROW=22          :PS$="-F6 ":GOSUB 50         'words; else don't display
     ROW=23          :PS$="-F8 ":GOSUB 50         'at all.
     ROW=24          :PS$="-10 ":GOSUB 50
     '
     '-------------------------------------------------------------------------
     'ROUTINE TO DISPLAY THE ACTIVITIES
     '
5412 ROW=20:COLUMN=17:COLOUR=2:PS$=" Enter command "  :GOSUB 50
     ROW=21                   :PS$="  when READY  "  :GOSUB 50
     ROW=22                   :PS$="              "  :GOSUB 50
     ROW=23                   :PS$=" "+CHR$(25)+"    ":GOSUB 50
            COLUMN=23:Colour=grey:PS$=     " WAIT   "   :GOSUB 50
     ROW=24:COLUMN=17:COLOUR=7:PS$=" ____ "           :GOSUB 50
            COLUMN=23:Colour=grey:PS$=     " READY  "   :GOSUB 50
     '
     '-------------------------------------------------------------------------
     'DISPLAY THE TASK LIST
     '
5423 IF TASKS<5 THEN FOR K=TASKS+1 TO 5:TASK$(K)="":NEXT
     COLUMN=32:Colour=grey:FOR K=1 TO 5:ROW=19+K:PS$=""+TASK$(K):GOSUB 50:NEXT
     RETURN
     '
     '-------------------------------------------------------------------------
     'LIGHT APPROPRIATE WAIT/READY LAMP
     '
5430 PS$="":COLUMN=24:COLOUR=8:ROW=24-READY:GOSUB 50   'Kill WAIT or READY
     IF READY=0 THEN COLOUR=14 ELSE COLOUR=10
     ROW=23+READY:GOSUB 50                         'Light the effective on
     '
     '-------------------------------------------------------------------------
     'LIGHT APPROPRIATE TASK LAMP
     '
5437 PS$="":COLUMN=32
     COLOUR=8:FOR ROW=20 TO 24:GOSUB 50:NEXT          'Kill all task lamps
     IF TASK>0 THEN COLOUR=10:ROW=TASK+19:GOSUB 50    'Light active task's lamp
     RETURN
     '
     '-------------------------------------------------------------------------
     'CLEAR THE COMMAND WORDS AREA [EXCLUDING TASK LIST AREA]
     '
5440 PS$=SPACE$(31):COLUMN=1:FOR ROW=20 TO 24:GOSUB 50:NEXT:RETURN
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'GENERAL COMMAND WORD PROCESSOR                            [File: CWP.BAS]
     '-------------------------------------------------------------------------
     '
     'Inputs CMDW$() - Command word list
     '       CMDW    - Total number of command words
     '       CMDL    - Length of the command word field
     '       CMDN    - If set to 1 then selection numbers 1-9 returned in NKEY
     '                 if set to 2 then control keys returned as `y' values
     '
     'Output FKEY - Function key number equivalent to the entered command
     '       FROM - Passed on from INCHAR to say if modem interrupted
     '       NKEY - A keyed number entered 1-9
     '
     '
     '
     '-------------------------------------------------------------------------
     'INITIALIZATION
     '
5520 CMDW$="":I=0:GOSUB ClrKbdBuf           'Clear keyboard input buffer
     ROW=24:COLUMN=18:COLOUR= 7:PS$="____":GOSUB 50    'Entry field
5524 I=I+1:IF I>CMDL then beep:GOTO 5520    'Clear cmnd word if length exceeded
5525 LOCATE 24,I+17                         'Set cursor position
     caps=1:gosub InChar:caps=0             'Get character from keyboard
     '
     IF FKEY>0 THEN COLUMN=18:PS$=CMDW$(FKEY):GOSUB 50:RETURN
     '
     IF X<65 GOTO 5546                      'Control character [?]
     ROW=24:COLUMN=I+17:PS$=X$:GOSUB 50     'Display new character
     CMDW$=CMDW$+X$                         'Add new chr to cmnd word string
     '
     '-------------------------------------------------------------------------
     'SEARCH COMMAND WORD LIST CMDW$() FOR CURRENT COMMAND WORD STRING CMDW$
     '
5538 FKEY=1
5539 IF CMDW$=CMDW$(FKEY) THEN RETURN              'Exit if cmnd word found
     IF FKEY<CMDW THEN FKEY=FKEY+1:GOTO 5539       'Step to next cmnd word
     GOTO 5524
     '
     '-------------------------------------------------------------------------
     'A NUMERIC OR CONTROL CHARACTER WAS ENTERED
     '
5546 IF X>48 AND X<58 THEN NKEY=X-48:CMDN=0:RETURN  'Numeric selection entered
     IF Y=75 AND I=1 THEN CMDW$="PREV":GOTO 5538    'Cursor left
     IF Y=77 AND I=1 THEN CMDW$="NEXT":GOTO 5538    'Cursor right
     IF Y=83 GOTO 5520                              'Delete command word
     IF X=27 THEN CMDW$="QUIT":GOTO 5538            'Escape
     if y=73 then return                            'PgUp
     if y=81 then return                            'PgDn
     beep:goto 5525                                 'Bum character
     '
     '-------------------------------------------------------------------------
     '
