






     '-------------------------------------------------------------------------
     'E.B.S. DECRYPTION ALGORITHM [LEVEL 2]    28JUL87              DeCrupt.BAS
     '-------------------------------------------------------------------------
     '
     'Author : R J Morton
     '
     'This subroutine translates an encrypted literal into plain text.
     'Its main use is to safeguard literals such as authorship & copyright
     'notices and cut off dates from being changed by direct byte replacement
     'in EXE files by software pirates.
     '
     'Crypt$ - The encrypted string
     '   xs$ - De-crypted output string
     '
     '-------------------------------------------------------------------------
     'DE-CRYPT AN ENCRYPTED LITERAL
     '
Decrupt:
     '
     NumChars=len(crypt$)               'N of characters to be encrypted
     xs$=space$(NumChars)               'blank string to received de-cryption
     for CharNum=1 to NumChars          'For each character of input string...
     '
     crypt                           _  'ASCII value of de-crypted character
      =asc(mid$(crypt$,CharNum,1))   _  'is ASCII value of encrypted character
      -NumChars                      _  'minus total N of characters in line
      -4                                'minus Arbitrary Constant N 1
     '
     if crypt>255 then crypt=crypt-255  'Rotate ASCII value so that it stays
     if crypt<  1 then crypt=255-crypt  'in range 1 to 255 inclusive.
     '
     mid$(xs$,CharNum,1)=chr$(crypt)    'Add de-crypted char to output string
     next:return                        'Return to calling program
     '
     '-------------------------------------------------------------------------
     '
