






     '-------------------------------------------------------------------------
     'E.B.S. ENCRYPTION ALGORITHM              28JUL87              DeCrypt.BAS
     '-------------------------------------------------------------------------
     '
     'Author : R J Morton
     '
     'This subroutine translates an encrypted literal into plain text.
     'Its main use is to safeguard literals such as authorship & copyright
     'notices and cut off dates from being changed by direct byte replacement
     'in EXE files by software pirates.
     '
     'Crypt1$ - Version 1 of the encrypted string
     'Crypt2$ - Version 2 of the encrypted string
     '   Ps$  - De-crypted output string
     '
     '-------------------------------------------------------------------------
     'DE-CRYPT AN ENCRYPTED LITERAL
     '
Decrypt:
     NumChars=len(crypt1$)              'N of characters to be encrypted
     Ps$=space$(NumChars)               'blank string to received de-cryption
     for CharNum=1 to NumChars          'For each character of input string...
     crypt1                          _  'ASCII value of de-crypted character
      =asc(mid$(crypt1$,CharNum,1))  _  'is ASCII value of encrypted character
      +CharNum                       _  'plus position of character in line
      -NumChars                      _  'minus total N of characters in line
      -23                               'minus Arbitrary Constant N 1
     if crypt1>255 then crypt1=crypt1-255  'Rotate ASCII value so that it stays
     if crypt1<  1 then crypt1=255+crypt1  'in range 1 to 255 inclusive.
     crypt2                          _  'ASCII value of de-crypted character
      =asc(mid$(crypt2$,CharNum,1))  _  'is ASCII value of encrypted character
      -CharNum                       _  'minus position of character in line
      +19                               'plus Arbitrary Constant N 2
     if crypt2>255 then crypt2=crypt2-255  'Rotate ASCII value so that it stays
     if crypt2<  1 then crypt2=255+crypt2  'in range 1 to 255 inclusive.
     if crypt1<>crypt2 then system
     if crypt1=94 then crypt1=32        'Move the hidden space character back
     mid$(Ps$,CharNum,1)=chr$(crypt1)   'Add de-crypted char to output string
     next:return                        'Return to calling program
     '
     '-------------------------------------------------------------------------
     '
