





     'ENTER/EDIT KEYNAMES & KEYVALUES    by R J Morton   19NOV86    EdKeyvs.BAS

     'Enables you to set up or change the names and values of the main keys.

     DefInt a-z                'All interger
     rem $include: 'ComVars.INC'
     common DmapFlag           'Tells CompSA to go to Dmap instead of Menu
     dim Rec$(12)              'Dummy for ....
     dim Values$(18)           'Used by the block editor
     dim menu$( 9)             'Array to contain the keynames
     dim fields$(20)           'Fields fore key names & values while editing
     dim keyvs$(4,18)          'Input/output array for keynames & key values
     MenuHelp=1                'Help texts available
     ManChap=6                 'Relevant chapter of the Manual
     goto EdKeyvs1


     'EXTERNAL SUBROUTINES

     rem $include: 'InChar.INC'
     rem $include: 'EdField.INC'
     rem $include: 'EdBlock.INC'
     rem $include: 'Expiry.INC'
     rem $include: 'MultiBlk.INC'
     rem $include: 'GenMenu.INC'
     rem $include: 'GetKeyvs.INC'
     rem $include: 'PutKeyvs.INC'
     rem $include: 'ShowKbox.INC'
     rem $include: 'ShoKeyvs.INC'
     rem $include: 'SelKeyvs.INC'
     rem $include: 'Select.INC'
     rem $include: 'Decrypt.INC'
     rem $include: 'OpenFile.INC'

50   call ScrSub(ps$,row,column,colour):return       'Screen display subr

WipeInstructions:
     column=41:ps$=space$(40):colour=7:for row=20 to 24:gosub 50:next:return


     'ERROR DISPLAY SUBROUTINE

ShowError:
     if errer$="" then return      'Return if no error occurred
     ps$=errer$:errer$=""          'Set error message for display then clear it
     row=3:column=43:colour=12     'Position of error message display field
     gosub 50                      'Display error message
     return EdKeyvs2               'Return to the local menu
     '






     'MENU INITIALIZATION

EdKeyvs1:
     Retries=5                       'LAN delay retries
     gosub GetKeyvs                  'Load the names and values of the 5 keys
     ErrMsgRow= 3
     ErrMsgCol=43
     KeyvRow=5                       'Top row of Key Values display box
     KeyvCol=42                      'Left edge of  "   "      "     "
     gosub ExpiryTest
     Prgm$=Prog$
     Prog$="EDKEYVS"                 'Set program identification variable


     'SET UP THE MENU TITLE & OPTIONS

     menu= 8                         'Number of options on the menu 
     mpos =1                         'Left justified menu display
     abort=0                         'No abort indications
     menu$=Top$                      'Menu title
     menu$(1)="Edit Key Names"
     menu$(2)="Edit "       _        '
             +keyvs$(0,0)   _        'Term used for `sales area'
             +" names"               '
     '
     for k=3 to 6
     menu$(k)="Edit "       _        '
             +keyvs$(k-2,0) _        'name of respective key
             +" values"              'Set up key names as menu items
     next 
     '
     menu$(7)="Define "+Keyvs$(0,0)  'Term used for `sales area'
     menu$(8)="Show "       _
             +keyvs$(0,0)   _        'Term used for `sales area'
             +" Maps"
     '
     '--------------------------------------------------------------------------
     ps$=top$:row=1:column=19:colour=7:gosub 50
     '
EdKeyvs2:
     gosub MenuHelp0                 'Display initial right hand menu matter
     gosub ShowMenu                  'Display the menu
     if op=0 goto ExitEdKeyvs        'Exit
     gosub ChooseMenu6               'Kill `Busy' message
     row=3:column=41:colour=1:ps$=space$(40):gosub 50:row=4:gosub 50
     if op=8 then DmapFlag=1:goto ExitEdKeyvs      'Show sales area maps
     LeftBox$="":gosub ShowKbox      'Display the key values containment box
     gosub WipeInstructions
     if instr(LettFile$,"USER01")=0 then
        ps$="YOU ARE NOT AUTHORISED!"
        row=op+6:column=50:colour=79:gosub 50
        beep:goto EdKeyvs2
        end if
     if op=1 goto EdKeyvs3           'Edit the key names
     if op=7 goto EdKeyvs6           'Defin Sales Areas
     if op=9 goto ClearDatabase
     KeyNum=op-2:goto EdKeyvs4       'Edit the values of the selected key
     '
     '--------------------------------------------------------------------------
ExitEdKeyvs:
     if SAchanged=1 then chain"CompSA"
     if DmapFlag =1 then chain"Dmap"
     chain"Menu"
     '
     '--------------------------------------------------------------------------
     '






    '--------------------------------------------------------------------------
    'ENTER/AMEND THE NAMES OF THE KEYS
    ' 
EdKeyvs3:
    Title$="Key Names:"              'Title to be displayed in box
    for k=1 to 5                     'Copy the names of the keys
    MultiBlk$(k)=Keyvs$(k-1,0)       'into the multiblock array
    next                             'ready for editing.
    NumFlds = 5                      'Number of fields per column (block)
    NumBlks = 1                      'Number of columns (blocks)
    gosub EdKeyvs5                   'Multiblock driver
    if AmendM=1 then                 'If a key name was changed,
       for k=1 to  5                 'then transfer the edited
       Keyvs$(k-1,0)=MultiBlk$(k)    'version from the block editor
       next:gosub PutKeyvs           'array to the Keyvs$() array.
       end if
    goto EdKeyvs2                    'Go to edit the key names
    '
    '--------------------------------------------------------------------------
    'ENTER/AMEND THE VALUES OF THE SELECTED KEY
    ' 
EdKeyvs4:
    if KeyNum=0 then                    'The zero th set of key values
       x$=" names:"                     'are the key names!
  else x$=" values:"                    '
       end if
    Title$=Keyvs$(KeyNum,0)+x$          'Set up title of what is being edited
    for k=1 to 18                       'Copy the key values into the
    MultiBlk$(k)=Keyvs$(KeyNum,k)       'multiblock editor's array
    next                                'ready for editing.
    NumFlds = 9                         'Number of fields per column (block)
    NumBlks = 2                         'Number of columns (blocks)
    gosub EdKeyvs5                      'Multiblock driver
    if AmendM=1 then                    'If a key name was changed,
       for k=1 to 18                    'then transfer the edited
       Keyvs$(KeyNum,k)=MultiBlk$(k)    'version from the block editor
       next:gosub PutKeyvs              'array to the Keyvs$() array.
       end if
    goto EdKeyvs2                       'Go to edit the key values.
    '
    '--------------------------------------------------------------------------
    'COMMON MULTIBLOCK DRIVER
    '
EdKeyvs5:
    ps$=Title$+space$(30-len(Title$))  'Key Title
    row=KeyvRow+1:column=KeyvCol+1:colour=27:gosub 50
    row=19:column=45:colour=10:ps$="Edit the above as you require:":gosub 50
    InterBlk=19              'N of chrs between starts of adj columns 
    LenField=16              'Set field length for the Selector Code
    MultiCol=44              'Chr col marking start of first [column of] field
    MultiRow= 8              'Row on which first field is displayed 
    Cnt.H   = 1              'Horizontal position of character count (not used) 
    DC      = 0              'Character count not displayed
    C.Max   = 0              'No maximum character count
    MsgPos=1:Msg.V=6:Msg.H=73  'Override position for INSERT message
    Numerics=0               'Not numerics only 
    InstrCol=41              'Start column for editing instructions
    gosub ShowBlocks         'Display the fields initially
    gosub EdBlocks           'Call the Multiblock editor
    '
    if x=27 then AmendM=0:gosub ShowBlocks 'Re-display original if no amendments
    return                              'or amendments made then cancelled.
    '
    '--------------------------------------------------------------------------
     '





    '--------------------------------------------------------------------------
    'SELECT SALES AREA TO DEFINE
    '
EdKeyvs6:
    KeyNum=0                   'Sales area names
    NumSels=1                  'Number that may be selected concurrently
    KeyvRow=5                  'Key values display box starts on row 5
    KeyvCol=42                 'and in column 41 (at right of screen)
    Keyvs$=""                  'Clear key selection string
    gosub ShoKeyvs             'Display keys/attributes in appropriate box
EdKeyvs6a:
    ps$="  SELECT SALES AREA YOU WISH TO DEFINE  "
    row=19:column=41:colour=10:gosub 50
    InstrCol=41              'Start column for editing instructions
    gosub 8730                 'Accept key/attribute selection(s)
    if amendf=0 goto EdKeyvs2  'No sales area selected
    gosub WipeInstructions
    ps$=space$(40):row=19:column=41:colour=10:gosub 50
    SalesArea=asc(Keyvs$)-64   'Selected sales area number
    '
    '--------------------------------------------------------------------------
    '
    FileName$=AreaFile$:FileNum=1:RecLen=202:gosub OpenFile
    field#1,2 as a1$,200 as a2$
    get#1,SalesArea:NumAreas=cvi(a1$)
    for k=1 to NumAreas
    MultiBlk$(k)=mid$(a2$,k+k-1,2)
    next:close
    if NumAreas<100 then for k=NumAreas+1 to 100:MultiBlk$(k)="":next
    '
    '--------------------------------------------------------------------------
    '
    colour=1
    ps$="     ":column=35:for row=5 to 18:gosub 50:next
    ps$="  ":column=1:for row=5 to 18:gosub 50:next
    row=4:column=3:colour=19
    ps$="                                 ":gosub Display
    ps$="                                 ":gosub Display
    ps$=" Ŀ ":gosub Display
    ps$="                      "
    for k=1 to 10:gosub Display:next
    colour=1
    ps$="":gosub Display
    colour=10
    ps$=" ENTER POST CODES FOR SALES AREA        ":gosub Display  '19
    row=6:column=4:colour=27:ps$=Keyvs$(0,SalesArea):gosub 50
    '
    NumFlds =10     'Number of fields per column (block)
    NumBlks =10     'Number of columns (blocks)
    InterBlk= 3     'Number of chrs between starts of adj columns 
    LenField= 2     'Set field length for the Selector Code
    MultiCol= 5     'Chr col marking start of first [column of] field
    MultiRow= 8     'Row on which first field is displayed 
    InstrCol= 1     'Start column for editing instructions
    Cnt.H   = 1     'Horizontal position of character count (not used) 
    DC      = 0     'Character count not displayed
    C.Max   = 0     'No maximum character count
    Numerics =0     'Not numerics only 
    '
    gosub ShowBlocks              'Display the fields initially
    caps=1:gosub EdBlocks:caps=0  'Call the Multiblock editor
    '
    if x=27 then                  'If amendments cancelled,
       AmendM=0                   'clear the `amendments made' flag
       gosub ShowBlocks           'and re-display the original fields
       end if
    ps$=space$(40):column=1:colour=7:for row=19 to 24:gosub 50:next
    if AmendM=0 goto EdKeyvs6a    'Not amended
    '
    '--------------------------------------------------------------------------
    '
    FileName$=AreaFile$:FileNum=1:RecLen=202:gosub OpenFile
    field#1,2 as a1$,200 as a2$
    x$=""                         'Clear string for Post Area letter-pairs
    NumAreas=0                    'Clear N of Post Areas in this Sales Area
    for k=1 to 100                'For each element of the Post Areas array,
    y$=MultiBlk$(k)               'Get the [next] Post Area letter-pair
    if len(y$)=1 then y$=y$+" "   'Pad one-letter postcodes with a space
    if y$>"" then                 'If it is not a null element,
       x$=x$+y$                   'then tack it onto the output string
       NumAreas=NumAreas+1        'and increment the N of valid post areas
       end if
    next                          'Next post area element
    lset a1$=mki$(NumAreas)       'Save N of post areas in this sales area
    lset a2$=x$                   'Save the string of post area letter-pairs
    put#1,SalesArea
    close
    SAchanged=1                   'Set the `sales areas changed' flag
    goto EdKeyvs6a                'Return to menu
    '
    '--------------------------------------------------------------------------
Display: row=row+1:goto 50
    '--------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'CLEAR THE DATABASE
     '
ClearDatabase:
     row=4:column=41:colour=12
     ps$="    CLEAR THE DATABASE Ŀ   ":gosub Display
     ps$="                                      ":gosub Display
     ps$="     This facility enables you to     ":gosub Display
     ps$="     delete all existing Prospect     ":gosub Display
     ps$="     Records from your database.      ":gosub Display
     ps$="     The disk space thus freed is     ":gosub Display 
     ps$="     then automatically set up as     ":gosub Display
     ps$="     a new `empty' database ready     ":gosub Display
     ps$="     for you to start building up     ":gosub Display
     ps$="     a new set of sales prospects.    ":gosub Display
     ps$="                                      ":gosub Display
     ps$="     ARE YOU ABSOLUTELY SURE THIS     ":gosub Display
     ps$="       IS WHAT YOU WANT TO DO?        ":gosub Display
     ps$="                                      ":gosub Display
     ps$="     If not, press the Escape key.    ":gosub Display
     ps$="                                      ":gosub Display
     ps$="      IF YOU ARE ABSOLUTELY SURE,     ":gosub Display
     ps$="     TYPE-IN `CLEAR THE DATABASE':    ":gosub Display
     ps$="         [                  ]         ":gosub Display
     ps$="      ":gosub Display
     '
     'ACCEPT THE OPERATOR COMMAND
     '
ClearDatabase1:
     caps=1:h=52:v=23:b=18:k=0:a$=""
     pad$=" "
     msg.h=70:msg.v=4:cnt.h=40
     dc=0:c.max=0
     numerics=0:kolour=7
     gosub Edfield:caps=0
     if x=27 goto EdKeyvs2
     if a$<>"CLEAR THE DATABASE" goto ClearDatabase1
     FileName$=NameFile$:FileNum=1:RecLen=16:gosub OpenFile
     field#1,8 as n1$,2 as n2$
     FileName$=PostFile$:FileNum=2:RecLen=16:gosub OpenFile
     field#2,8 as p1$,2 as p2$
     FileName$=RecsFile$:FileNum=3:RecLen=256:gosub OpenFile
     field#3,8 as r3$,2 as r1$,2 as r2$,244 as r4$
     get#1,1:w=cvi(n1$):x=cvi(n2$)
     get#3,1:y=cvi(r1$):z=cvi(r2$)
     lset n1$=mki$(1):lset n2$=mki$(1):put#1,1
     lset p1$=mki$(1):lset p2$=mki$(1):put#2,1
     if w>y or y>9999 then _
     lset r1$=mki$(w):lset r2$=mki$(x):put#3,1  'Put old paramenters in flack
     close                                      'field.
     goto EdKeyvs2
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'MENU HELP TEXT
     '
MenuHelp0:
     ps$=space$(40):column=41:colour=2:for row=3 to 22:gosub 50:next
     ps$="       Press  keys to access the      ":row=23:gosub 50
     ps$="        help texts for this menu.       ":row=24:goto  50
     '
MenuHelp1:
     '
     ps$=" This option lets you enter or edit the ":row= 4:gosub 50
     ps$=" names of the major selection keys used ":row= 5:gosub 50
     ps$=" by Marketeer to select prospects       ":row= 6:gosub 50
     ps$=" belonging to a particular target group ":row= 7:gosub 50
     ps$="                                        ":row= 8:gosub 50
     ps$=" Please note however that whatever you  ":row= 9:gosub 50
     ps$=" call these keys two of them each has a ":row=10:gosub 50
     ps$=" predefined function as follows:        ":row=11:gosub 50
     ps$="                                        ":row=12:gosub 50
     ps$=" Key 1 has to be a `geographic' type of ":row=13:gosub 50
     ps$="       selector key.                    ":row=14:gosub 50
     ps$="                                        ":row=15:gosub 50
     ps$=" Key 2 is normally a `relation' key but ":row=16:gosub 50
     ps$="       can be given a different meaning ":row=17:gosub 50
     ps$="                                        ":row=18:gosub 50
     ps$=" Key 3 is normally a `product' key but  ":row=19:gosub 50
     ps$="       can be given a different meaning ":row=20:gosub 50
     ps$="                                        ":row=21:gosub 50
     ps$=" Key 4 has to be a next/previous        ":row=22:gosub 50
     ps$="       `event' type of selector key.    ":row=23:gosub 50
     ps$="                                        ":row=24:goto  50
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'MENU HELP TEXT
     '
MenuHelp2:
     '
     ps$=" To set up your own sales areas, please ":row= 4:gosub 50
     ps$=" proceed as follows:                    ":row= 5:gosub 50
     ps$="                                        ":row= 6:gosub 50
     ps$=" 1) Get a `BARTHOLOMEW/POST OFFICE      ":row= 7:gosub 50
     ps$="    Postcode Key Map of Great Britain   ":row= 8:gosub 50
     ps$="    and Northern Ireland.'              ":row= 9:gosub 50
     ps$="                                        ":row=10:gosub 50
     ps$=" 2) Decide how you are going to divide  ":row=11:gosub 50
     ps$="    the country into sales areas and    ":row=12:gosub 50
     ps$="    draw round the boundaries of your   ":row=13:gosub 50
     ps$="    sales areas on the map with a felt  ":row=14:gosub 50
     ps$="    tipped pen, always following the    ":row=15:gosub 50
     ps$="    nearest red post area boundary.     ":row=16:gosub 50
     ps$="                                        ":row=17:gosub 50
     ps$=" 3) Write the names of your sales areas ":row=18:gosub 50
     ps$="    on the map in felt tipped pen.      ":row=19:gosub 50
     ps$="                                        ":row=20:gosub 50
     ps$=" 4) Use this option to enter the names  ":row=21:gosub 50
     ps$="    of your upto 18 chosen sales areas. ":row=22:gosub 50
     ps$="    You may edit the names at any time. ":row=23:gosub 50
     ps$="                                        ":row=24:goto  50
     '
MenuHelp3:
     '
     ps$=" This option lets you enter or edit the ":row= 4:gosub 50
     ps$=" upto 18 values of the Relation Key.    ":row= 5:gosub 50
     ps$="                                        ":row= 6:gosub 50
     ps$=" The `values' of the `relation' key are ":row= 7:gosub 50
     ps$=" short (upto 16 character) descriptions ":row= 8:gosub 50
     ps$=" of each type of business relationship  ":row= 9:gosub 50
     ps$=" you could possibly have with one of    ":row=10:gosub 50
     ps$=" your prospects:                        ":row=11:gosub 50
     ps$="                                        ":row=12:gosub 50
     ps$=" Eg: one `value' of the relation key    ":row=13:gosub 50
     ps$=" could be influencer indicating that he ":row=14:gosub 50
     ps$=" is somebody you need to keep informed  ":row=15:gosub 50
     ps$=" on your products because he can influ- ":row=16:gosub 50
     ps$=" ence potential buyers of that product. ":row=17:gosub 50
     ps$="                                        ":row=18:gosub 50
     ps$=" NB: If you change the wording of a key ":row=19:gosub 50
     ps$=" value, make sure that the change of    ":row=20:gosub 50
     ps$=" meaning does not cause the value as    ":row=21:gosub 50
     ps$=" previously assigned to some prospects  ":row=22:gosub 50
     ps$=" to become confusing or incorrect.      ":row=23:gosub 50
     ps$="                                        ":row=24:goto  50
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'MENU HELP TEXT
     '
MenuHelp4:
     '
     ps$=" This option lets you enter or edit the ":row= 4:gosub 50
     ps$=" upto 18 values of the Progress Key.    ":row= 5:gosub 50
     ps$="                                        ":row= 6:gosub 50
     ps$=" The `values' of the `progress' key are ":row= 7:gosub 50
     ps$=" short (upto 16 character) descriptions ":row= 8:gosub 50
     ps$=" of each stage a prospect can be at     ":row= 9:gosub 50
     ps$=" while you are developing them.         ":row=10:gosub 50
     ps$="                                        ":row=11:gosub 50
     ps$="                                        ":row=12:gosub 50
     ps$=" Eg: one `value' of the `progress' key  ":row=13:gosub 50
     ps$=" could be `brand new' indicating that   ":row=14:gosub 50
     ps$=" he is somebody you have just found in  ":row=15:gosub 50
     ps$=" a directory listing and have not yet   ":row=16:gosub 50
     ps$=" even contacted for the first time.     ":row=17:gosub 50
     ps$="                                        ":row=18:gosub 50
     ps$=" NB: If you change the wording of a key ":row=19:gosub 50
     ps$=" value, make sure that the change of    ":row=20:gosub 50
     ps$=" meaning does not cause the value as    ":row=21:gosub 50
     ps$=" previously assigned to some prospects  ":row=22:gosub 50
     ps$=" to become confusing or incorrect.      ":row=23:gosub 50
     ps$="                                        ":row=24:goto  50
     '
MenuHelp5:
     '
     ps$=" This option allows you to enter/edit   ":row= 4:gosub 50
     ps$=" the upto 18 values of the Event Key.   ":row= 5:gosub 50
     ps$="                                        ":row= 6:gosub 50
     ps$=" The `values' of the 'event' key are    ":row= 7:gosub 50
     ps$=" short (upto 16 character) descriptions ":row= 8:gosub 50
     ps$=" of each type of `sales event' that can ":row= 9:gosub 50
     ps$=" occur in your dealings with a prospect ":row=10:gosub 50
     ps$="                                        ":row=11:gosub 50
     ps$="                                        ":row=12:gosub 50
     ps$=" Eg: one `value' of the `event' key     ":row=13:gosub 50
     ps$=" could be MAILSHOT indicating that the  ":row=14:gosub 50
     ps$=" last thing that happened between you   ":row=15:gosub 50
     ps$=" was that he was the recipient of a     ":row=16:gosub 50
     ps$=" mailshot from you.                     ":row=17:gosub 50
     ps$="                                        ":row=18:gosub 50
     ps$=" NB: The first 6 values of the `event'  ":row=19:gosub 50
     ps$=" key must have the meanings already set ":row=20:gosub 50
     ps$=" up by us because the Mail, Phone, FAX, ":row=21:gosub 50
     ps$=" Telex & Email subsystems automatically ":row=22:gosub 50
     ps$=" update prospects' event keys.          ":row=23:gosub 50
     ps$="                                        ":row=24:goto  50
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'MENU HELP TEXT
     '
MenuHelp6:
     '
     ps$=" This option allows you to enter/edit   ":row= 4:gosub 50
     ps$=" the upto 18 values of the Product Key. ":row= 5:gosub 50
     ps$="                                        ":row= 6:gosub 50
     ps$=" The `values' of the `product' key are  ":row= 7:gosub 50
     ps$=" short (upto 16 character) descriptions ":row= 8:gosub 50
     ps$=" of each of your types of product-line  ":row= 9:gosub 50
     ps$=" or `service' a prospect could be `in   ":row=10:gosub 50
     ps$=" the market' for:                       ":row=11:gosub 50
     ps$="                                        ":row=12:gosub 50
     ps$=" The values of your PRODUCT key should  ":row=13:gosub 50
     ps$=" not simply be the names of your prod-  ":row=14:gosub 50
     ps$=" ucts or services the way stock control ":row=15:gosub 50
     ps$=" or a service allocator would view them ":row=16:gosub 50
     ps$="                                        ":row=17:gosub 50
     ps$=" Instead, a VALUE of the PRODUCT key    ":row=18:gosub 50
     ps$=" should represent a group of products   ":row=19:gosub 50
     ps$=" or services which fulfil a single need ":row=20:gosub 50
     ps$=" such as a machine together with the    ":row=21:gosub 50
     ps$=" consumables it uses, training in its   ":row=22:gosub 50
     ps$=" use and a servicing/up-grading package ":row=23:gosub 50
     ps$="                                        ":row=24:goto  50
     '
MenuHelp7:
     '
     ps$=" This option allows you to define the   ":row= 4:gosub 50
     ps$=" extents and boundaries of your sales   ":row= 5:gosub 50
     ps$=" areas.                                 ":row= 6:gosub 50
     ps$="                                        ":row= 7:gosub 50
     ps$=" You should have previously set up the  ":row= 8:gosub 50
     ps$=" name of each of your sales areas using ":row= 9:gosub 50
     ps$=" Option 2 above. You now define a sales ":row=10:gosub 50
     ps$=" area as follows:                       ":row=11:gosub 50
     ps$="                                        ":row=12:gosub 50
     ps$=" 1) Select sales area according to the  ":row=13:gosub 50
     ps$="    instructions given on-screen.       ":row=14:gosub 50
     ps$=" 2) Look on the `Postcode Key Map of    ":row=15:gosub 50
     ps$="    Great Britain' to see the area you  ":row=16:gosub 50
     ps$="    want that sales area to cover.      ":row=17:gosub 50
     ps$=" 3) Type in the two (or one)-letter     ":row=18:gosub 50
     ps$="    post area code of each post area    ":row=19:gosub 50
     ps$="    within that sales area.             ":row=20:gosub 50
     ps$="                                        ":row=21:gosub 50
     ps$=" NOTE: To include unpostcoded prospects ":row=22:gosub 50
     ps$="       enter postarea code as `##'.     ":row=23:gosub 50
     ps$="                                        ":row=24:goto  50
     '






     'MENU HELP TEXT
     '
MenuHelp8:
     '
     ps$=" Allows you to display a map showing    ":row= 4:gosub 50
     ps$=" the extents and coverages of the sales ":row= 5:gosub 50
     ps$=" areas as defined in Option 7.          ":row= 6:gosub 50
     ps$="                                        ":row= 7:gosub 50
     ps$=" A sales area is defined as a group of  ":row= 8:gosub 50
     ps$=" postcode areas. When you select a      ":row= 9:gosub 50
     ps$=" sales area for display, all the post   ":row=10:gosub 50
     ps$=" areas which make up that sales area    ":row=11:gosub 50
     ps$=" are shaded in on a map of the U.K.     ":row=12:gosub 50
     ps$="                                        ":row=13:gosub 50
     ps$=" The percentage of prospects currently  ":row=14:gosub 50
     ps$=" in your Marketeer database who are     ":row=15:gosub 50
     ps$=" located in that sales area is shown as ":row=16:gosub 50
     ps$=" a bar graph beside the map. A second   ":row=17:gosub 50
     ps$=" bar graph shows the percentage of the  ":row=18:gosub 50
     ps$=" UK population located in that sales    ":row=19:gosub 50
     ps$=" area for comparison.                   ":row=20:gosub 50
     ps$="                                        ":row=21:gosub 50
     ps$=" A map of all sales areas together in   ":row=22:gosub 50
     ps$=" different colours can also be shown.   ":row=23:gosub 50
     ps$="                                        ":row=24:goto  50
     '
MenuHelp9:
     '
     ps$="                                        ":row= 4:gosub 50
     ps$=" Lets you to clear all your prospects'  ":row= 5:gosub 50
     ps$=" prospect's names and addresses and key ":row= 6:gosub 50
     ps$=" information from your database so that ":row= 7:gosub 50
     ps$=" the space may be used for starting to  ":row= 8:gosub 50
     ps$=" build up a new database from scratch.  ":row= 9:gosub 50
     ps$="                                        ":row=10:gosub 50
     ps$="Please note that `clearing' the database":row=11:gosub 50
     ps$="does not actually erase the names and   ":row=12:gosub 50
     ps$="addresses of your prospects: it simply  ":row=13:gosub 50
     ps$="tells the software that the space on the":row=14:gosub 50
     ps$="disk that they occupy may now be used as":row=15:gosub 50
     ps$="spare storage space for new information ":row=16:gosub 50
     ps$="as and when required.                   ":row=17:gosub 50
     ps$="                                        ":row=18:gosub 50
     ps$="WARNING: If you clear your database and ":row=19:gosub 50
     ps$="then copy Marketeer into a new computer,":row=20:gosub 50
     ps$="then all or part of your original names ":row=21:gosub 50
     ps$="& addresses and key selections are still":row=22:gosub 50
     ps$="there and can be recovered intact or in ":row=23:gosub 50
     ps$="part by an experienced programmer.      ":row=24:goto  50

