





      '------------------------------------------------------------------------
      'LOAD EMAIL SERVICE NAMES ETC     19NOV86             [File: GETEMSL.BAS]
      '------------------------------------------------------------------------
      '
      'Author : R J Morton
      '
      '
      '
      '
      '
      'Outputs  EMSL$(9) - Names of the available electronic mail services
      '         EMS      - Number of the currently effective service
      '           S      - Number of services currently defined
      '         SERVICE$ - Name of the currently effective service
      '
      '
      '------------------------------------------------------------------------
      'LOAD ELECTRONIC MAIL SERVICE OPTIONS [HELD IN RECORD#10 OF EMSD FILE]
      '
GetEmsl:
      FileName$=EmsdFile$:FileNum=1:RecLen=186
      gosub OpenFile
      if ErrNum>0 then s=0:goto GetEms3
      '
      get#1,10                   'Email menu held in Record #10
      '
      ems=cvi(input$(2,#1))      'No. of selected electronic mail service
      if ems<1 or ems>9 goto GetEms2
      s=cvi(input$(2,#1))        'Number of services currently set up
      if s<1 or s>9 then s=0:close:goto GetEms3
      '
      for k=1 to 9
      x=cvi(input$(2,#1))        'Length of electronic mail service name
      if x<1 or x>20 _
         then emsl$(k)="" _
         else emsl$(k)=input$(x,#1)
      next
      '
GetEms2:
      close
GetEms3:
      if s<9 then for k=s+1 to 9:emsl$(k)="":next
      '
      service$=emsl$(ems)        'Set up name of currently selected service
      ems$=chr$(ems+64)          'Selected service as Letter A to I
      return
      '
      '------------------------------------------------------------------------
     '
