





     'OUTGOING PHONE CALL HANDLER   Author:R J Morton  19APR87   File:Phone.Bas 

     'This program provides the processing necessary for the making of a
     'telephone call to a specified individual phone subscriber, or to a
     'target group of such subscribers.
     'See FMM.DOC for load module FMM processing structure

     '!!!!! DO NOT COMPILE WITH THE /Q SWITCH !!!!!


     'DEFINITIONS & COMMON VARIABLES

     DefInt a-z                    'All numeric variables are 16-bit intergers
     rem $include: 'ComVars.INC'   'Marketeer's universal common variables
     dim CallResult$(9)            'Text for call outcome options
     dim tty$(31)                  'Teletype control code mnemonics
     dim pp$(15)                   'Printer control strings
     dim rec$(12)                  'Contains the current name & address details
     dim temprec$(12)              'Contains the current name & address details
     dim keyvs$(4,18)              'Referred to by GetRec & PutRec.
     dim fields$(100)              'Used by EDBLOCK to store notes & dossier
     dim values$(18)               'Used by the block editor
     dim stamps$(12)               'Date stamps for diary notes 


     'DISPLAY THE MAIN SET OF COMMAND WORDS & TASKS

     dim CMDW$(10):cmdw=10              'Number of effective command words
     cmdw$(1)="HELP":cmdw$( 2)="QUIT"
     cmdw$(3)="NEXT":cmdw$( 4)="PREV"
     cmdw$(5)="DIAL":cmdw$( 6)="EDIT"
     cmdw$(7)="NOTE":cmdw$( 8)="DOSS"
     cmdw$(9)="VIEW":cmdw$(10)="KEYS"

     dim task$(5):tasks=4               'Number of effective tasks
     task$(1)="SEEKING"
     task$(2)="LOADING"
     task$(3)="STORING"
     task$(4)="SORTING"
     '





     'BUFFER ALLOCATIONS FOR THE FILES USED BY THIS MODULE

     RecsFileNum=1     'Main prospect records
     AreaFileNum=2     'For finding which sales area a prospect is in
     MoFileNum  =3     'Modem File buffer number
     KeysFileNum=4     'Contains prospect's selecion keys
     DateFileNum=5     'Dates of his last and next-planned events
     IndxFileNum=6     'Namecode or Postcode index depending on type of search
     KeysRecLen =8     'Contains prospect's selecion keys
     IndxRecLen=16     'Namecode or Postcode index depending on type of search
     ManChap=10        'Relevant chapter of the User Manual
     NewLine$=chr$(13)+chr$(10)

     ComType$="EMAIL"            'Set modem for `Terminal Mode' operation and
     ListFile$=PhonList$         'Path/Filespec of the Phone Calling List file

     LocalHelp=8:if op=2 then FoneShotFlag=1:TimeStamp=1:LocalHelp=8:RecNum=0
     gosub ExpiryTest                   'Don't run if expiry date past

     FoneInitState = 1       'Kick-start the initialization FMM hierarchy
     cmdl          = 4       'Number of characters in command word field
     MessagesVisible=1       'Enable the messages display routine
     connect       = 8       'Call initially not connected
     caps=1                  'Set caps entry for typing ahead a namecode entry
     DosMsg$="":DosClr=12    'Clear general error message field
     ShowMessages=1          'Activate message display routine
     SearchFieldNum = 2      'Namecode is default search field
     '





     'INITIALIZE THE FINITE STATE MACHINE POLLING LOOP

     'The service programs which perform the various tasks here are written as
     'Message-drived Finite State Machines. Each FMM is continually polled in
     'sequence from the following polling loop.

     ACTIVE=1                'Activate the polling loop
     While ACTIVE
     gosub Initializer       'Transfer of control from initialization
     gosub Search            'Record retrieval control FMM [Resident]
     gosub NextPrevFMM       'Get next/previous subscriber on request
     gosub LoadRecord        'Record loader FMM
     gosub HelpFMM           'Help Screen Processor FMM
     gosub Trip              'Reset routine for terminated processes in FMMs
     gosub EdNotesFMM        'Diary Notes  Processor FMM
     gosub EdDossier         'Dossier noted (encrypted)
     gosub ViewFile          'Real-time viewing window
     gosub Keyboard          'Add incoming chrs from keyboard to buffer str
     gosub CWPFMM            'Command Word Processor FMM
     gosub CWPfkeys          'Act on CWP fkey value if present
     gosub CallCtrl          'Call Control supervisor FMM
     gosub ModemIO           'Handle the modem I/O port
     gosub OpenFileFMM       'General File Opening FMM
     gosub EdBox
     gosub StoreRec:if JustStored = 1 then JustStored = 0:gosub ExtrPhoneNum
     gosub EditSICN
     gosub EditKeys
     gosub EditAttr
     gosub EditCode
     gosub Manual
     gosub ShowStatus        'Display current state of each major FMM
     gosub ShowDigit         'Highlight each digit as it is being dialled
     gosub QuitLoop          'Means of escape from the FMM polling loop
     WEND                    'Back to the beginning of the polling loop

     close                              'Close all files and modem
     ps$=space$(51):column=30
     row=2:gosub 50                     'Wipe task list
     row=4:gosub 50                     'Wipe error message field
     gosub WipeV24Lamps    
     prog$="PHONE"                      'say where control came from
     if ExitPath=1 then chain"Menu"
     chain"FoneMenu"                    'Exit this module; got back to menu
     '





     'EXTERNAL SUBROUTINE

Display: row=row+1
50   call ScrSub(ps$,row,column,colour):return   'Display as is


     'FINITE-STATE MACHINES INCLUDED IN THIS LOAD MODULE

     rem $include: 'FoneInit.FMM'       'THE INITIALIZATION GROUP
     rem $include: 'Keyboard.FMM'       'THE GENERAL INPUT/OUTPUT GROUP
     rem $include: 'GetPrt.FMM'         'To load the modem I/O channel filespec
     rem $include: 'ADM10.FMM'          'Modem currently in use
     rem $include: 'Find.FMM'           'THE RECORD RETRIEVAL GROUP
     rem $include: 'RecordIO.FMM'
     rem $include: 'StoreRec.FMM'
     rem $include: 'SaveRec.FMM'
     rem $include: 'IndxShft.FMM'
     rem $include: 'EdBox.FMM'
     rem $include: 'KeysIO.FMM'
     rem $include: 'DateIO.FMM'
     rem $include: 'AttrIO.FMM'
     rem $include: 'CodeIO.FMM'
     rem $include: 'DistIO.FMM'
     rem $include: 'LoadRec.FMM'
     rem $include: 'LoadAttr.FMM'
     rem $include: 'LoadCode.FMM'
     rem $include: 'SaveAttr.FMM'
     rem $include: 'SaveCode.FMM'
     rem $include: 'UpdtRec.FMM'
     rem $include: 'SaveDate.FMM'
     rem $include: 'ListGeIO.FMM'
     rem $include: 'ResuIO.FMM'
     rem $include: 'UpdtCode.FMM'
     rem $include: 'UpdtKeys.FMM'
     rem $include: 'AmendKey.FMM'
     rem $include: 'EditKeys.FMM'
     rem $include: 'InDate.FMM'
     rem $include: 'Select.FMM'
     rem $include: 'OpenFile.FMM'
     rem $include: 'FoneCtrl.FMM'       'THE CALL PROCESSING GROUP
     rem $include: 'NextTelx.FMM'
     rem $include: 'Funckeys.FMM'       'OTHERS
     rem $include: 'GetHelp.FMM'
     rem $include: 'ShowAbox.INC'
     rem $include: 'ShowMbox.INC'
     rem $include: 'ShowKbox.INC'
     rem $include: 'Elapsed.INC'
     rem $include: 'PhoneNum.INC'
     rem $include: 'Decrypt.INC'
     rem $include: 'Expiry.INC'
     rem $include: 'NotesIO.FMM'
     rem $include: 'EdField.FMM'
     rem $include: 'EdBlock.FMM'
     rem $include: 'EdNotes.FMM'
     rem $include: 'ValiPost.INC'
     rem $include: 'EdDoss.FMM'
     rem $include: 'DossIO.FMM'
     rem $include: 'ViewFile.FMM'
     rem $include: 'TexCrypt.INC'
     rem $include: 'SelKeyvs.FMM'
     rem $include: 'GetKeyvs.FMM'
     rem $include: 'ShoKeyvs.INC'
     rem $include: 'Manual.FMM'
     '





     'TRANSFER OF CONTROL FROM LOAD MODULE INITIALIZATION

     'This routine controls the activities of the Phone Module initialization
     'FMM FoneInit.FMM. When the initialization process has been completed once
     'upon first entry into the FMM polling loop, the FoneInitState is set to
     'zero thus ensuring that this whole subsystem takes no further part in the
     'proceedings and is thus not a burden to the FMM polling loop cycle.

Initializer:
     if FoneInitState=0 then return     'Initialization FMM inactive
     IF instr(KbStr$,chr$(27))=0 THEN   'Provided Esc key has not been struck
        if FoneInitState<8 then
           gosub FoneInit               'Initialization in progress
        else
           gosub CallResultsBox         'Display the call results
           gosub ShowCallResults        'Show call result options
           LeftBox$="":gosub ShowAbox   'Display the name & address box
           locate 24,1,0                'place cursor at bottom left of screen
           row=1:column=19:colour=7:ps$=top$:gosub 50     'Display module name
           ps$="            DIALLING   HOLDING          "
           row=3:column=41:colour=grey:gosub 50:gosub KillDialLamps
           column=1:colour=8:ps$=space$(80):for row=19 to 24:gosub 50:next
           gosub ShowTasks              'Display the Task List panel
           if FoneShotFlag=0 then       'If we are doing a one-off phone,
              if RecNum = 0 then
                 SearchState=1          'then activate the Record Search FMM
              else
                 UpDown = 0
                 NextPrevState = 1
              end if
           else
              updown=1                  'set to get the next call on the
              StartNextPrev=1           'calling list
              CWPstate=1                'Activate the command word processor
           end if
           FoneInitState=0              'De-activate the Initialization FMM
           PollState=1                  'Activate modem status polling
        end if
     ELSE
        ACTIVE=0                        'De-activate the polling loop
     END IF
     RETURN                             'Return control to FMM polling loop


     'QUIT FMM POLLING LOOP

QuitLoop:
     if QuitFlag=0 then return          'If a `quit' request is pending, then
     if CallCtrlState>0 then            'If a call is still in progress,
        if CallCtrlState>7 then return  'If Call Control has not terminated,
        ReleaseSequence=1               'Set call release indicator
        goto ReleaseLine                'initiate call termination.
 elseif ReleaseSequence=1 then          'If a call release just terminated,
        ReleaseSequence=0               'Cancel the release sequence indicator
 elseif KeyMods=1 then
        gosub general:KeyMods=0
 elseif SearchState=0 and    _          'If not exiting from search FMM, and
        FoneShotFlag=0 then             'we are in single phone call mode, then
        CWPstate=0                      'De-activate the command processor
        SearchState=1                   'Re-activate the search key entry FMM
        LeftBox$="":gosub ShowAbox      'Clear the name & address box
        DosMsg$="":DosClr=7             'Clear possible error message
        ShowMessages=1                  'Activate the message display routine
        gosub ClearInstructions         'Display the search FMM status panel
   else Active=0                        'else exit the polling loop.
        end if
     QuitFlag=0:return                  'Cancel the quit process
     '



                                                                               



     'SEARCH FOR KEYED RECORD

Search:
     IF SearchState=0 then return
     gosub FindRecord              'Search Key Entry/Record Search utility FMM
     gosub OpenIndexFile           'Index File Opener + get index parameters
     gosub GetKeysRecord           'Gets the retrieved record's status keys
     on SearchState goto Search1, Search2, Search3
     return


     'MACHINE STATE #1:INITIALIZE THE SEARCH PROCESS

Search1:
     Task = 0 : gosub ShowTaskLamps     'Clear the task lamps
     SearchState = 2                    'Advance to next machine state
     if XrefFlag = 0 then               'If not searching for a cross-reference
         EdBoxState = 1                 'Box Editor for search key entry
     else
        XrefFlag = 0                    'Cancel the XrefFlag (it's done its job)
        SearchKey$ = Rec$(12)           'Get search key from record's Xref field
        if left$(SearchKey$,1) > " " then 'If prospect has a cross reference
           FindRecState = 3             'advance beyond search field entry
           OpenIndxState = 1            'Activate the index file opener
           IndexType = 1                'Set for namecode search
        else
           gosub ShowNoXrefMsg          'display `no cross reference' message
           SearchState = 0              'De-activate this FMM
           CWPstate = 1                 'Re-activate the command processor FMM
        end if
     end if                             '[if XrefFlag=0]
     return
     '





     'MACHINE STATE #2:SUPERVISE SEARCH KEY ENTRY

Search2:
     if FindRecState = 3 then           'Await completion of search key entry
        PrevIndexType = IndexType       'Preserve search index type
        Task = 1 : gosub ShowTaskLamps  'Light the SEEKING lamp
        ps$ = str$(RecNum)
        on PrevIndexType + 1 gosub_     'According to type of search,
           ShowRefNumber,         _     'Display REFerence number
           ShowNamecode,          _     'Highlight namecode while searching
           ShowPostcode                 'Highlight postcode while searching
        SearchState = 3                 'advance to search process supervision
     elseif FindRecState = 6 then       'If entry aborted or Esc key pressed
        FindRecState = 0                'De-activate Record Retrieval Utility
        QuitFlag = 1                    'Set for quitting this load module
     end if
     return


     'MACHINE STATE #3:SUPERVISE THE SEARCH PROCESSES

Search3:
     if FindRecState = 5 then      'If the required record has been found OK,
        FindRecState = 0           'De-activate the record retrieval utility
        LoadRecordState = 1        'Activate the record loader
        SearchState = 0            'De-activate the Search FMM
     elseif FindRecState > 5 then  'If the required record cannot be found,
        SearchState = 1            'then return to initial search state.
     end if
     RETURN                        'Return control to the FMM polling loop.
     '





     'KEY-INITIATED EXIT FROM HELP SCREEN

Trip:if HelpState>3 then           'Help screen active or being displayed, so
        if help=4 then             'If Record Retrieval Help Screen displayed
           gosub TripSub:HelpState=0  'De-activate the help screen
           gosub ClearInstructions
           gosub ShowTasks
           SearchState=1
      else HelpState=0:gosub TripSub  'De-activate the help screen
           end if
        end if
     if EdNotesState >7 then EdNotesState =0:gosub TripSub        
     if ViewFileState>7 then ViewFileState=0:gosub TripSub        
     if ManualState  >7 then ManualState  =0:gosub TripSub        
     return                        'Return control to FMM polling loop. 


     'REINSTATE THE MAIN SCREEN & RE-DISPLAY RECORD

TripSub:
     ShowMessages=1              'Trigger a display of the messages
     MessagesVisible=1           'Enable Modem/Printer/DOS messages display
     LeftBox$="":gosub ShowAbox  'Re-display the name & address box
     RightBox$=""
     if KeyMods=0 then
        gosub CallResultsBox     'Box for call outcome & target data
   else gosub ShowMbox
        end if
     if HelpState=0 then gosub DisplayRecord else gosub ShowInstructions
     return
     '





     'COMMAND EXECUTOR

     'When a keyboard command has been entered, the Command Word Processor FMM
     'sets a value in CWPfkey corresponding to the command entered. This routine
     'initiates the processes required to execute the entered command.

CWPfkeys:
     if CWPfkey=0 and Nkey=0 then return'Neither F-key nor numeric key pressed
     gosub ClearMessage                 'Clear the `Call completed' message
     DosMsg$="":DosClr=12               'Clear general error message field
     ShowMessages=1                     'Activate message display routine
     task=0:gosub ShowTaskLamps         'Light the `wait' lamp


     'DETERMINE WHICH KEY WAS PRESSED

     if CWPfkey=99 then ACTIVE=0:ExitPath=1:goto CWPfkeyC   'EXIT to maiin menu
     if CWPfkey= 7 then EdNotesState  =1  :goto CWPfkeyA    'NOTE
     if CWPfkey= 8 then EdDossierState=1  :goto CWPfkeyA    'DOSS
     if CWPfkey= 9 then ViewFileState =1  :goto CWPfkeyA    'VIEW [file window]
     if CWPfkey= 1 and HelpState=0 then                     'HELP
        help=LocalHelp:HelpState=1        :goto CWPfkeyA
        end if

     if CMDN=1 then                                        'In Key Amend Mode
        if Nkey=1 then EditSICNstate=1   :goto CWPfkeyD    'SIC Numbers
        if Nkey=5 then EditAttrState=1   :goto CWPfkeyD    'Products
        if Nkey=6 then EditCodeState=1   :goto CWPfkeyD    'Selector Code
        if Nkey=3 then KeyType=1:KeyArr=1:goto CWPfkeyE    'Relation
        if Nkey=4 then KeyType=2:KeyArr=2:goto CWPfkeyE    'Progress
        if Nkey=7 then KeyType=3:KeyArr=3:goto CWPfkeyE    'Last Event
        if Nkey=8 then KeyType=4:KeyArr=3:goto CWPfkeyE    'Next Event
        gosub general                   'Stop numeric entries via Funckeys.FMM
        end if
     '





     'DETERMINE WHICH KEY WAS PRESSED [CONTINUED]

     if CWPfkey=2 or NextTelxMsg=1 then 'QUIT
        QuitFlag=1
 elseif CWPfkey=5 then                  'DIAL [prospect currently on-screen]
        if KeyMods=1 then gosub general:KeyMods=0
        CallCtrlState=1        
        gosub ShowInstructions 
        ManualNext=0        
        CWPstate=1                      'Re-active the command processor
 elseif CWPfkey=3 then                  'NEXT [prospect]
        updown= 1:StartNextPrev=1       'Trigger the Next/Prev search FMM
 elseif CWPfkey=4 then                  'PREV [ious prospect]
        updown=-1:StartNextPrev=1       'Trigger the Next/Prev search FMM
 elseif CWPfkey=6 then                  'EDIT
        EdBoxState=1
 elseif CWPfkey=10 then                 'If the `KEYS' command were entered,
        CMDN=1:KeyMods=1                'then activate numeric entry
        gosub ShowMbox                  'Display the Market Profile box
        gosub Elapsed           
        gosub ShowProfile               'Show the Market Profile Data and the
        gosub ShowKeyEditInstr          'Operator instructions for amending keys
        CWPstate=1                      'Re-active the command processor
   else beep:CWPstate=1                 'Bum key stroke
        end if
     goto CWPfkeyC     


     'EXIT SEQUENCES AFTER DETERMINING WHICH KEY WAS PRESSED

CWPfkeyA: MessagesVisible=0  'NOTE, DOSS or HELP Disable error messages display
CWPfkeyC: CWPfkey=0          'Clear F-Key N to avoid a repeat next pass
          KeyNum=Nkey        'Preserve the `Key Number' as displayed on screen
          Nkey=0             'Clear numeric selection to avoid a repeat next pass
          caps=0             'allow upper & lower case letters
          return             'Return control to the FMM polling loop.

CWPfkeyD: KeyArr=4:goto CWPfkeyC            'Terminator after a valid
CWPfkeyE: EditKeysState=1:goto CWPfkeyC     'numeric has been struck.
     '





     'GET NEXT/PREVIOUS RECORD [FMM] (Self-deactivating)

NextPrevFMM:
     IF NextPrevState=0 THEN            'If this FMM is currently idle, then
        if StartNextPrev=0 then return  'exit if it has not been triggered
        if KeyMods=1 then gosub general:KeyMods=0
        NextPrevState=1                 'else set this FMM to its initial state
        NextPrevReslt=0                 'clear its result code
        StartNextPrev=0                 'and its starter trigger flag.
        END IF
     IF NextPrevState=1 THEN            'If this machine is in State 1, then
        if CallCtrlState>0      _       'If a call is active,
           goto ReleaseLine             'then initiate a call release
        if FoneShotFlag=0 then          'If a single-shot call,
           Task=1:gosub ShowTaskLamps   'Light SEEKING lamp
           IndexType=PrevIndexType      'Index used to retrieve last record
           FindNextState=1              'Activate Next/Prev record retrieval FMM
      else NextTelxState=1              'activate Calling List Next/Prev FMM
           ManualNext=1                 'Set to loop back to 1 at end of file
           end if
        NextPrevState=2                 'Advance to the Wait State
        END IF
     IF NextPrevState=2 THEN               'If this machine is in State 2, then
        if FoneShotFlag=0 then             'if getting next one-off subscriber
           gosub FindNextRec
           gosub OpenIndexFile             'Get index parameters
           gosub GetKeysRecord             'Gets retrieved record's status keys
           if FindNextState<4 then return  'If next/previous record not yey got
           if FindNextState=4 then         'If next/previous record found OK
              LoadRecordState=1            'Activate the record loader
         else LeftBox$="":gosub ShowAbox   'then clear the name & address box
              end if
           FindNextState=0                 'De-activate Next/Prev search FMM
      else gosub NextTelx                  'Get next subscriber on list
           if NextTelxState<8 then return  'Next record still loading
           if NextTelxState=9 then         'If next record didn't load OK, then
              LeftBox$="":gosub ShowAbox   'then clear the name & address box
              end if
           NextTelxState=0                 'Deactivate calling list handler.
           end if
        NextPrevState=0                    'De-activate self
        UpDown=0                           'Kill `get next/prev record' request
        END IF
     RETURN                             'Return control to FMM polling loop.
     '





     'LOAD THE COMPLETE PROSPECT DETAILS [FINITE STATE MACHINE]

LoadRecord: if LoadRecordState=0 then return   'Machine inactive


     'MACHINE STATE #1:INITIALIZE LOADING OF THE RETRIEVED RECORD

     if LoadRecordState=1 then     'If this machine is in State#1, then
        Task=2:gosub ShowTaskLamps 'Kill SEEK lamp/light LOADING lamp
        LoadRecState=1             'Activate Record Loading Supervisor FMM
        LoadRecordState=2          'Advance self to next state
        end if


     'MACHINE STATE #2:LOAD THE RETRIEVED RECORD

     if LoadRecordState=2 then          'If this machine is in State#2, then
        gosub LoadRec                   'Record loading supervisor FMM
        if LoadRecState<6 then return
        if LoadRecState=6 then          'If required record loaded OK, then
           LoadRecState=0               'de-activate the record loading FMM
           if FoneShotFlag=0 then 
              LoadAttrState=1           'activate the attributes loader FMM
              LoadRecordState=4         'advance to next but one machine state
         else GetKeysState=1            'activate the Keys loader FMM
              LoadRecordState=3         'advance to the next machine state
              end if                    '
      else LoadRecState=0               'de-activate the record loading FMM
           goto LoadRecordError         'and exit via the error routine.
           end if                       '
        end if


     'MACHINE STATE #3:LOAD THE RETRIEVED KEYS

     if LoadRecordState=3 then          'If this machine is in State#3, then
        gosub GetKeysRecord             'Loads the prospect's key values
        if GetKeysState<3 then return   'Required key values not yet loaded
        if GetKeysState=3 then          'If required key values loaded OK, then
           GetKeysState=0               'de-activate the Keys loader FMM
           LoadAttrState=1              'activate the attributes laoder FMM
           LoadRecordState=4            'advance to the next machine state.
      else GetKeysState=0               'de-activate the Keys loading FMM
           goto LoadRecordError         'and exit via the error routine.
           end if
        end if
     '





     'MACHINE STATE #4:LOAD THE RETRIEVED ATTRIBUTES

     if LoadRecordState=4 then          'If this machine is in State#4, then
        gosub LoadAttr                  'Sales Area search FMM
        if LoadAttrState<5 then return  'If required record loaded OK, then
        if LoadAttrState=5 then         'If required record loaded OK, then
           LoadAttrState=0              'de-activate the attribute loader FMM
           LoadCodeState=1              'activate the selector code loader FMM
           LoadRecordState=5            'and advance to the next machine state.
      else LoadAttrState=0              'de-activate the attribute loader FMM
           goto LoadRecordError         'and exit via the error routine.
           end if                  
        end if


     'MACHINE STATE #5:LOAD THE RETRIEVED CODE

     if LoadRecordState=5 then          'If this machine is in State#5, then
        gosub LoadCode                  'General Prospect Record I/O FMM
        if LoadCodeState<5 then return  'If required record loaded OK, then
        if LoadCodeState=5 then         'If required record loaded OK, then
           LoadCodeState=0              'de-activate selecor code laoder FMM
           Task=0:gosub ShowTaskLamps   'Extinguish the `load' lamp
           if FoneShotFlag=0 then       'If single shot phone mode
              LoadRecordState=0         'then de-activate self
         else LoadRecordState=8         'Go to successful termination state
              end if
           gosub ExtrPhoneNum           'Extract Phone/Emailbox number
           gosub DisplayRecord          'Display the Prospect Record
      else LoadCodeState=0              'de-activate the code loader FMM
           goto LoadRecordError         'and exit via the error routine.
           end if
        end if
     return                             'return to the FMM polling loop.


     'ERROR EXIT

LoadRecordError:
     Task=0:gosub ShowTaskLamps    'Clear the `load' lamps
     if FoneShotFlag=0 then        'If we are not doing a telesales shot, then
        SearchState=1              'Activate the search FMM
   else CWPstate=1                 'activate command word processor
        end if
     LoadRecordState=9             'Set self to error state
     return
     '





     'DISPLAY RETRIEVED RECORD

DisplayRecord:
     gosub ShowAddress                  'Display the name & address
     gosub ClearMessage                 'Clear the `Call completed' message
     if KeyMods = 0 then                'If not editing the key values, then
        gosub ShowCallResults           're-display the call results
        gosub ShowInstructions          'and the normal dialling instructions
     else
        gosub Elapsed                   'Else, re-compute the elapsed time
        gosub ShowProfile               're-display the market profile data
        gosub ShowKeyEditInstr          'and the key editing instructions
        end if                          '
     CWPstate = 1                       'Enable the command word processor
     return
     '





     'DISPLAY THE STATUS MESSAGES BOX

CallResultsBox:
     if RightBox$<>"Cbox" then 
        ps$="  ":column=41:colour=7:for row=5 to 18:gosub 50:next
        row=4:column=43:colour=27:RightBox$="Cbox"
        ps$=" CALL RESULT OPTIONS:                 ":gosub Display    ' 5
        colour=19
        ps$=space$(38):for k=1 to 9:gosub Display:next
        ps$="  ":gosub Display    '15
        ps$=" Target N 00  Target Serial N 0000  ":gosub Display    '16
        ps$=" Prospect's List N 0000   of   0000  ":gosub Display    '17
        ps$=string$(38,223):colour=1:gosub Display    '18
        column=41:colour=grey:ps$=space$(40):gosub Display    '19
        end if
     return                     'Return control to the FMM polling loop.


     'SHOW FIRST 5 OPTIONS IN GREEN; LAST 4 OPTIONS IN RED

ShowCallResults:
     for i=1 to 9:x$=str$(i+1)                            'SUCCESSFUL CALLS
     if i>5 then colour=28 else colour=26
     row=5+i:column=44:ps$=str$(i):gosub 50     'Display option N
     if i>5 then colour=20 else colour=18
     column=47:ps$=CallResult$(i) :gosub 50     'Display option name
     next
     column=57:colour=23                                  'DISPLAY TARGET 
     x=TargNum :y=2:gosub LeadingZeros:TargNum$=x$        'INFORMATION
     x=ExtrFlag:y=4:gosub LeadingZeros:TargSer$=x$
     if FoneShotFlag=1 then
        ps$=TargNum$                            :row=16:column=53:gosub 50
        ps$=TargSer$                                   :column=74:gosub 50
        x=TargItem:y=4:gosub LeadingZeros:ps$=x$:row=17:column=62:gosub 50
        x=TargSize:y=4:gosub LeadingZeros:ps$=x$       :column=74:gosub 50 
        if TSuser>0 then
           x=TSuser:y=2:gosub LeadingZeros
           ps$="USER "+x$+"'s TELESALES LIST"
           row=19:column=49:colour=2:gosub 50
           end if
        end if
     return
     '






     'SHOW THE MODEM STATUS MESSAGES

     'Displays the modem status messages etc. whenever a status condition
     'changes as indicated by one of the status flags becoming non-zero.

     'This routine is linked into the FMM polling loop to provide a `live'
     'presentation of modem & printer status, machine states, lamp conditions
     'and other items of variable information on the screen.

ShowStatus:
     if Ringing=1 then
        if Ringing$<>Time$ then Ringing=0:gosub ClearMessage
        end if
     if ShowMessages=1 then                   'If a message has changed
        ShowMessages=0                        'Clear `display messages' switch
        if DosClr>0 then                      
           ps$=left$(DosMsg$,38):colour=DosClr'Display DOS error message
           ps$=ps$+space$(38-len(ps$))        'Pad message field to 35 chrs
           row=4:column=43:gosub 50:DosClr=0  'DosClr used as display trigger
           end if
        if MessagesVisible=1 then             'If on main display screen
           if LastTargItem<>TargItem then     'Whenever the Calling List N
              LastTargItem=TargItem:colour=23 'of the phone being sent 
              x=TargItem:y=4:gosub LeadingZeros  'increases, then display it.
              row=17:column=62:ps$=x$:gosub 50
              end if
           end if
        end if


     'EMERGENCY MESSAGE

     'This message warns the operator that the modem will not acknowledge
     'its acceptance and execution of a DISCONNECT command. Therefore, it
     'may not release the call. The operator's only option is to unplug it
     'from the Telecom Line wall socket.

     if Astatus=3 then      'If modem failed to acknowledged last command then
        FoneInitState = 0   'Set initialization supervisor FMM state `inactive'
        CallCtrlState = 0   'Set Call Control FMM state to `inactive'
        AmendKeyState = 0   'Set Event Update          FMM state to `inactive' 
        CWPstate      = 1   'Activate the command word processor
        column=41:colour=12
        row=20:ps$="   POSSIBLE MODEM MALFUNCTION: Unplug   ":gosub 50
        row=21:ps$="   it immediately from telephone line   ":gosub 50
        row=22:ps$="   and investigate the cause of its     ":gosub 50
        row=23:ps$="   non-acknowledgement of commands.     ":gosub 50
        close
        end if
     '





     'CALL PROCESSING LAMP CONTROL

     if CstatClr>0 and Cstatus=0 then   'DOS-originated modem error
        DosClr=CstatClr:CstatClr=0      '
        DosMsg$=Cstatus$:ShowMessages=1 '
        if DosMsg$>"" then              '
           DosMsg$="Modem:"+DosMsg$     '
           end if                       '
        end if                          '
     if Mstatus>0 then                  '
        if Mstatus=1 then               'If the modem is idle, then
           gosub KillDialLamps          'extinguish both lamps
           gosub ShowInstructions
    elseif Mstatus=2 then               'If the modem is dialling, then
           x=10:y=8:gosub ShowDialLamps 'Light Dial lamp, Kill HOLD lamp
    elseif Mstatus=3 then               'If the modem has finished dialling
           x=8:y=10:gosub ShowDialLamps 'Kill DIAL lamp, light HOLD lamp
           sound 3300,4                 'Tone to pick up the phone
    elseif Mstatus=5 then               'If there is an incoming call on the
           Ringing$=Time$:Ringing=1
           DosMsg$="Modem:"+Mstatus$     
           DosClr=MstatClr              'line, then display advice message
           MstatClr=0:ShowMessages=1
           end if
        end if


     'DISPLAY CALL RESULT MESSAGES

     if CallCtrlState>7 then            'Call Processing has terminated
        if CallCtrlState=8 then         'Call has completed successfully
           ps$="CALL COMPLETED"         'so display the `call complete' message
           colour=10                    'in bright green
      else ps$="  CALL ABORTED"         'display the `call aborted' message
           colour=12                    'in bright red
           end if
        row=4:column=26:gosub 50        'Display the message
        ShowMessages=1                  'Clear status messages
        Task=0:gosub ShowTaskLamps      'Clear the task lamps
        gosub ShowCallResults
        gosub ShowInstructions
        CWPstate=1                      'Re-activate command word processor
        CallCtrlState=0                 'De-activate Call Control FMM
        end if
     return                             'Return to the FMM polling loop


KillDialLamps: x=8:y=8
ShowDialLamps:
     row=3:ps$=""                      '
     colour=x:column=52:gosub 50        'the `Dialling' lamp
     colour=y:column=63:goto  50        'the `Holding' lamp
     '





     'CONDITIONNING FOR A MANDATORY DISCONNECT AND CALL RESULT SELECTION

ReleaseLine:
     if CallCtrlState>0 and   _   'If dial sequence aborted in early stages,
        CallCtrlState<4 then      '
        CallCtrlState=4           'activate from the call release phase
 elseif CallCtrlState=6 then      'If call has reached conversation phase,
        StartPhoneUdt=1           'Trigger prospect event key update etc.
        CallCtrlState=7           'activate a call result selection.
        end if
     return                       '


     'NUMERIC FORMATTERS

     'This routine formats an interger x into a string x$ containing the number
     'padded out with leading zeros as necessary to make it y digits long, plus
     'an extra leading space or minus sign according to the sign of x.

LeadingZeros:
     x$=str$(x)        'Number x as a string with a leading space or - sign
     x=len(x$)-1
     if x>y then x$=string$(y,"!"):return   'Out of range
     x$=right$(x$,x)
     if x<y then x$=string$(y-x,"0")+x$
     if x<0 then x$="-"+x$ else x$=" "+x$
     return
     '






     'DISPLAY OPERATOR INSTRUCTIONS

ShowInstructionsSub:
     column=41:ps$=space$(40):colour=2
     for row=20 to 23:gosub 50:next:row=19:return
ShowInstructions:
     if PhoneUdtState>0 or MessagesVisible=0 then return
     if CallCtrlState>0 and CallCtrlState<4 then
        gosub ShowInstructionsSub
        if ModemUnavailable=1 then
           CallCtrlState=6              'Set to conversation phase.
           column=46
           ps$="Pick up your phone and make the":gosub Display
           ps$=" call manually. Press Esc when ":gosub Display
           ps$="  you have finished the call."  :gosub Display
      else column=52
           ps$="Pick up phone when":gosub Display
           ps$="HOLDING lamp comes":gosub Display
           ps$="on and tone sounds":gosub Display
           end if
        else
        if FoneShotFlag=0 then
           gosub ClearInstructions
      else gosub ShowInstructionsSub:column=45
           if NextTelxMsg=1 then
              ps$="         NO CALLING LIST"         :gosub Display
              ps$="Use the telesales list generation":gosub Display
              ps$="option in Target Profiles section":gosub Display
       elseif TimeStamp$=space$(19) then
              ps$=" This prospect has not yet been"  :gosub Display
              ps$="telephoned via this calling list" :gosub Display
              ps$="  since it was last generated."   :gosub Display
         else ps$="  This prospect was telephoned"   :gosub Display
              ps$="  at                      with"   :gosub Display
              ps$="  the result highlighted above"   :gosub Display
              row=21:column=50:colour=10:ps$=TimeStamp$:gosub 50
              if ResultFlag$>"" then
                 x=asc(ResultFlag$)
                 if x>0 and x<10 then
                    column=47:row=5+x:ps$=CallResult$(x)
                    if x<6 then colour=10 else colour=12
                    gosub 50
                    end if              '[if x>0 and x<10]
                 end if                 '[if ResultFlag$>""]
              end if                    '[if TimeStamp$=space$(19)]
           end if                       '[if FoneShotFlag=1]
        end if                          '[if CallCtrlState>0 & CallCtrlState<4]
     return
     '






     'CLEAR INSTRUCTIONS

ClearInstructions:
     if PhoneUdtState=0 and MessagesVisible=1 then
        if SearchState = 0 then X = 23 else X = 24
        ps$=space$(40):column=41:colour=7:for row=20 to X:gosub 50:next
        end if
     return

ShowKeyEditInstr: column=41:colour=2
     PS$="  To amend Market Profile, type in the  ":ROW=20:GOSUB 50
     PS$="  N of the field you wish to amend as  ":ROW=21:GOSUB 50
     PS$="  highlighted on left hand side of box. ":ROW=22:GOSUB 50
     PS$="                                        ":ROW=23:GOSUB 50
     return
     '







     'HIGHLIGHT EACH TELEPHONE N DIGIT AS IT IS BEING DIALLED

ShowDigit:
     if MessagesVisible=0 then return
     if Mstatus<2 then return           'Exit if modem is not dialling/holding
     if LeftBox$<>"Abox" then return    'Do only if Name & Address box visible
     ps$=rec$(8):row=14                 'Displayed version of Phone N
     if HighLight=1 then
        HighLight=0                     'If a digit is highlighted then
        column=11:colour=23:gosub 50    'Re-display Phone N in normal colour
        end if
     if Mstatus>2 then return           'Dialling finished
     w$=right$(DialDigits$,1)           'Digit now being dialled
     if w$<"0" or w$>"9" then return    'Exit if character not a digit
     x=len(DialDigits$)-len(PABXprefix$)'N of main digits so far dialled
     l=len(ps$)
     if x<1 or x>l then return          'Exit if still dialling the prefix
     k=0:y=0:while k<x and y<l:y=y+1    'Find the position within the displayed
     z$=mid$(ps$,y,1)                   'version of the prospect's telephone N
     if z$>"/" and z$<":" then k=k+1    'of the digit currently being dialled
     wend:ps$=mid$(ps$,y,1)             'and extract it ready for display.
     if ps$<"0" or ps$>"9" then return  'Exit if character not a digit
     if ps$=w$ then                     'If displayed digit = dialled digit
        column=10+y:colour=30:gosub 50  'returned by modem then display it.
        HighLight=1                     'Set the `a digit is highlighted' flag;
   else DosMsg$="Dialling error"        'modem is not the same as the corr-
        DosClr=4:ShowMessages=1         'esponding digit in prospect record,
        sound 220,10                    'then display the dialling error
        end if                          'message & sound the alarm.
     return                             'Return to FMM polling loop
     '





     'DISPLAY/CLEAR THE STORED/KILLED MESSAGES

ShowStoredMsg:ps$="  RECORD STORED AS SEEN":colour=2:goto ShowMessage
ShowKilledMsg:ps$="PREVIOUS RECORD DELETED":colour=2:goto ShowMessage
ShowNoXrefMsg:ps$="     NO CROSS-REFERENCE":colour=4:goto ShowMessage
ShowFailedMsg:ps$="COULD NOT STORE RECORD:":colour=4:goto ShowMessage
ClearMessage: ps$=space$(38):ShowMessages=0
              row=4:column=43:colour=3:gosub 50
              ps$=space$(23)
ShowMessage:  row=4:column=19:goto 50


     'HIGHLIGHT/LOWLIGHT A KEY NUMBER IN MARKET PROFILE BOX

ShowBright: colour=127:goto ShowBriDim  'Bright white on white
ShowDim:    colour=112                  'black on white
ShowBriDim: if KeyNum<7 then
               row=KeyNum+7
          else row=KeyNum+9
               end if
            ps$=""+right$(str$(KeyNum),1):column=43:goto 50


     'HIGHLIGHT/LOWLIGHT A DATE IN THE MARKET PROFILE BOX

HighlightDate:
     if KeyType=3 then ps$=LastDate$    'Last Event key
     if KeyType=4 then ps$=NextDate$    'Next Event key
     row=KeyNum+9:column=66:goto 50     'Highlight relevant date

General:
     gosub CallResultsBox            'Display the Call Results Box
     gosub ShowCallResults           'and the call results options
     gosub ClearInstructions         'clear operator instructions window.
     CMDN=0:CWPstate=1:return        'Stop numeric entries via Funckeys.FMM

