





     '-------------------------------------------------------------------------
     'POST-MAILSHOT REPORT              12JUN87                  File:PhRep.Bas
     '-------------------------------------------------------------------------
     '
     'Author : R J Morton
     '
     'Enables the user to print out a list of the names & addresses of all the 
     'prospects to whom a specified mailshot was sent.
     '
     '-------------------------------------------------------------------------
     'INITIALIZATION
     '
     DefInt a-z                    'All intergers
     rem $include: 'ComVars.INC'   'Merge in the common variables
     rem $include: 'ComVart.INC'   'Target-specific common variables
     dim rec$(12)                  'Array to hold name & address data
     dim pp$(20)                   'Holds printer port specs & control codes
     dim CallResult$(10)           'Call results text
     dim NumOfCalls%(10)           'Call result summary statistics
     '
     dim Punc$(11)             'INTER-FIELD PUNCTUATION [Total 24 bytes]
     Punc$( 3)=", "            ' 2   These punctuation items 
     Punc$( 4)=", "            ' 2   appear immediately after
     Punc$( 5)=", "            ' 2   the record field of the
     Punc$( 6)=", "            ' 2   same number.
     Punc$( 8)=", Ph:"         ' 4
     Punc$( 9)=", Tx:"         ' 4
     Punc$(10)=", "            ' 2
     Punc$(11)=", "            ' 2
     '
     PrRecLen = 1024
     RecNum = 0
     FMMflag=0                 'Set to 1 to display the FMM states
     ListFile$=PhonList$       'File Name of the Mialling list file
     RecFileNum=1              'File N under which Records File is opened
     AreaFileNum=2             'File N under which Sales Areas File is opened
     ListFileNum=3             'File N under which Mailling List File opened
     ResuFileNum=4             'Set File Number under which print file opened
     PrtBufNum=5               'File N under which Printer I/O File is opened
     ErrMsgRow= 3              'Row on which DOS error messages are displayed
     ErrMsgCol=45              'Start column for DOS error message displays
     paper = 1                 'To be printed on 15 by 11 inch listing paper
     PrtRow=20                 'First row of printer display panel
     PrtCol= 3                 'Left-most column of printer display panel
     gosub ReSetNums
     NewLine$=chr$(13)+chr$(10)
     BlankLine$=space$(5)+NewLine$
     locate 21,32              'Cursor in printer control box
     '
     ReportTitle$="TELEPHONE SESSION REPORT"
     CallResult$(10)="Call not yet attempted"
     if op=6 then SummaryOnly=1               'Summary Report only.
     '
     ps$=space$(40):row=19:column=1:gosub 50  'Clear row above printer box
     gosub ShowPpanel                         'Display printer control panel
     gosub showstates3
     ListInitState=1           'Activate the Initialization FMM
     PrtIntegState=1           'Activate the Printer Integrity Watch Dog FMM
     gosub ExpiryTest
     goto  StartLoop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'EXTERNAL SUBROUTINES
     '
 50  Call ScrSub(ps$,row,column,colour):return
     '
     rem $include: 'GetPrt.FMM'
     rem $include: 'GetKeyvs.FMM'
     rem $include: 'PrintIO.FMM'
     rem $include: 'KeyBoard.FMM'
     rem $include: 'PPanel.FMM'
     rem $include: 'RecordIO.FMM'
     rem $include: 'ListGeIO.FMM'
     rem $include: 'ListInit.FMM'
     rem $include: 'ResuIO.FMM'
     rem $include: 'OpenFile.FMM'
     rem $include: 'Expiry.INC'
     rem $include: 'Decrypt.INC'
     rem $include: 'TexCrypt.INC'
     '
     '-------------------------------------------------------------------------
     'FMM CONTROL LOOP
     '
     StartLoop:
     active=1
     WHILE active
     gosub ListInit      'Load printer codes & error messages & initialize loop
     gosub KeyBoard      'Keyboard input/output FMM
     gosub PrintIO       'Printer input/output FMM
     gosub LoopCtrl      'Record print loop control
     gosub FileCtrl      'Opening/close of the required files
     gosub NextAddr      'Get data for next addressee in the mailshot list
     gosub RecordIO      'Handles the input of the main prospect records
     gosub GetAreas      'Handles the input of the sales area data
     gosub ListGeIO      'Handles the input of the target list of prospects
     gosub OpenFileFMM   'General file opener FMM
     gosub PrintLine     'Set up lines of print as required
     gosub KeybCtrl      'Loop escape watch dog for exiting this load module
     gosub PrtInteg      'Printer opener & interity watch dog
     gosub ShowMsgs      'Display any DOS messages picked up by above routines
     gosub ShowStates    'Display FMM states
     WEND
     FileNum=0:gosub CloseFile   'then close printer & all files
     ps$="":gosub ShowMsgs1      'clear error message field
     prog$="PHREP"               '
     chain"FoneMenu"             'exit this load module back to Lmenu
     '
     '-------------------------------------------------------------------------
     'FMM CONTROL LOOP
     '
DeActivate:
     LoopCtrlState=0    'Record print loop control
     FileCtrlState=0    'Controls the opening and closing of the required files
     RecordIOState=0    'Handles the input of the main prospect records
     GetAreasState=0    'Handles the input of the sales area data
     ListGeIOstate=0    'Handles the input of the target list of prospects
     OpenFileState=0    'General file opener FMM
     HderCtrlState=0
     ResuIOState=0
     for Filenum=1 to 4:gosub CloseFile:next:return  'Close all disk files
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'SHOW MESSAGES
     '
ShowMsgs:
     '
     if ShowMessages=0 then return   'No messages waiting to be displayed
     '
     if DosClr>0 then           _    'If there is a DOS message to be displayed
        colour=DosClr           _    'set the appropriate message colour
       :DosClr=0                _    'Message colour acts as message trigger
       :ps$=DosMsg$             _    'set up the message in the display string
       :gosub ShowMsgs1              'display message
     '
     if PrtClr>0 then           _    'If there's a Printer Status message to be
        colour=PrtClr           _    'displayed, set appropriate message colour
       :PrtClr=0                _    'Message colour acts as message trigger
       :row=23:column=46        _
       :ps$=left$(Pstatus$,30)  _    'set up the message in the display string
       +space$(30-len(pstatus$))_    'Pad out to 30 character message field
       :gosub 50                _    'display message
       :gosub ShowPlamps             'display pritner status lamps
     '
     ShowMessages=0                  'Cancel the `message display request'
     return                          'Return control to the Polling Loop
     '
ShowMsgs1:
     row=ErrMsgRow:column=ErrMsgCol  'Set message co-ordinates
     ps$=left$(ps$,36)
     ps$=ps$+space$(36-len(ps$))     'Pad out to 36 character message field
     gosub 50                        'Call the fast screen display routine
     return                          'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'KEYBOARD CONTROL
     '
KeybCtrl:
     gosub NextChar                   
     if CtrlChar = 87 then              'If Shift-F4 hit, then
        FMMflag = 1                     'Enable FMM states display
        goto ShowStates3                'Show the display panel
     end if
     '
     if KbChar = 27 or CtrlChar = 61 then active = 0 : return
     if KbChar <> 13 and CtrlChar <> 60 then return
     if LoopCtrlState = 0 goto KeybCtrl1
     '
     if HaltPrinterFlag=0        _  'If not currently in a halt state
        then HaltPrinterFlag=1   _  'then set printer to halt state
        else HaltPrinterFlag=0   _  'else clear the halt state
            :ps$=""              _
            :gosub ShowMsgs1        'clear possible error message.
     '
     gosub ShowPostStartMsgs        'Display appropriate messages.
     return                         'Return control to the Polling Loop
     '
KeyBCtrl1:                          'Try to activate the Print Loop FMM
     '
     if PrtIntegState=2 and      _  'If printer Integrity Watch Dog active
        ListInitState=4 then     _  'and the Lister Module initialized
        LoopCtrlState=1             'then activate the print loop FMM.
     '
     HaltPrinterFlag=0
     gosub ShowPostStartMsgs        'Display appropriate messages.
     return                         'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'LOOP CONTROL FMM
     '
     'NOTE: Target list parameters (ie the contents of Record#1 of the Target
     '      List File) are already in Local Common Variables.
     '
LoopCtrl:
     on LoopCtrlState goto LoopCtrl1, LoopCtrl2, LoopCtrl3,_
                           LoopCtrl4, LoopCtrl5, LoopCtrl6,_
                           LoopCtrl7, LoopCtrl8, LoopCtrl9
     return

LoopCtrl1:                              'INITIATE OPENING OF ALL REQUIRED FILES
     FileCtrlState=1                    'Activate the file opening process
     LoopCtrlState=2                    'Advance to next machine state
     return

LoopCtrl2:
     if FileCtrlState=5 then            'If all files opened successfully, then
        TargItem=0                      'Set to get Mailling List header record
        ListGeIOstate=4                 'activate the getting of the record
        LoopCtrlState=3                 'set to loop advancement state
     elseif FileCtrlState=8 then        'If file opening process failed, then
        gosub DeActivate                'De-activate all FMMs
     end if
     return

LoopCtrl3:                              'WAIT FOR HEADER RECORD TO LOAD
     if ListGeIOstate=5 then            'If header record got sucessfully, then
        gosub SetUpReportHeading 
        TargItem=0                      'Set to get the first record
        gosub ShowListSize    
        ResuIOstate=1                   'activate Call Results I/O FMM
        ResuIOmode=1                    'and set it to GET mode
        LoopCtrlState=4                 'set to loop advancement state
     elseif ListGeIOstate=10 then       'If file opening process failed, then
        gosub DeActivate                'De-activate all FMMs
     end if
     return

LoopCtrl4:                              'WAIT FOR CALL RESULT OPTIONS TO LOAD
     gosub ResuIO
     if ResuIOstate<8 then return       'If header record got sucessfully, then
     if ResuIOstate=8 then
        LoopCtrlState=5                 'set to loop advancement state
     else
        gosub DeActivate                'De-activate all FMMs
     end if
     ResuIOstate=0
     return

LoopCtrl5:                              'ADVANCE TO NEXT PROSPECT ON TARGET LIST
     if TargItem<TargSize then          'If last list member has been printed
        TargItem=TargItem+1             'Advance to [next] member of target list
        NextAddrState=1                 'Get the details of the mext addressee
        LoopCtrlState=6                 'Advance to the Get Record state
     else
        PrintIOflush = 1
        LoopCtrlState = 9
     end if
     return

LoopCtrl6:                              'GET NEXT LIST MEMBER'S RECORD NUMBER
     if NextAddrState=5  then           'If next target list record got OK then
        LoopCtrlState=7                 'Advance to the next machine state
     elseif NextAddrState=6  then       'If error occurred while getting record,
        gosub DeActivate                'then de-activate all FMMs.
     end if
     return

LoopCtrl7:                              'WAIT FOR PRINT OUTPUT STACK TO EMPTY
     if len(PrStr$)<PrRecLen then       'If there is plenty of room on printer
        PrintLineState=1                'output stack then ask PrintLine.FMM
        LoopCtrlState=8                 'to set up another line & return 
     end if                             'to get the next record.
     return

LoopCtrl8:                              'WAIT FOR NEXT PRINT LINE TO BE SET UP
     if PrintLineState=2 then           'If next print line has been set up
        PrintLineState=0                'then de-activate print line setter up
        PrStr$=PrStr$+PrintLine$        'add the new print line to the printer
        LoopCtrlState=5                 'output stack and go for next record.
     end if
     return                             'Return control to the Polling Loop

LoopCtrl9:
     if PrStr$="" and PrBlk$="" then    'If printer ouput stack finally drained
        Pstatus$="FINISHED"             'after last record has been processed
        PrtClr=10:ShowMessages=1        'then display the FINISHED message and
        gosub ShowMsgs
        gosub DeActivate                'de-activate all FMM/close files
     end if                             'and the printer.
     return

     '






     '--------------------------------------------------------------------------
     'PRINT LINE ROUTINE
     '
     'When externally set to State 1, this routine assembles the namecode, Ref
     'N, Cross Ref, postcode, sales area letter and name & address fields for
     'one prospect on the target list into a print line. It then transmutes to
     'State 2 indicating that the assembled print line is ready for printing.
     '
     '--------------------------------------------------------------------------
     'SET UP KEY FIELDS IN PRINT LINE
     '
PrintLine:                             'State 0: inactive
     if PrintLineState<>1 then return  'State 1: set up print line
                                       'State 2: print line ready
     '
     if SummaryOnly=1 then         _   'If summary report only, then
        gosub SummaryReportOnly    _
       :goto PrintLine3
     '
     PrintLine$=""                     'Clear the print line assembly string
     '
     if PageLineNum=0              _   'If it is the start of a new page
        then gosub PageHeader          'then set up a new page heading
     '
     gosub PrintLine1                  'Set up a normal print line
     '
     if TargItem=TargSize then     _   'If this is the final line of print
        gosub SummaryReport        _   'then append the summary report
       :goto PrintLine3                'and exit.
     '
     BlockLineNum=BlockLineNum+1       'Increment N of line in current block
     '
     if BlockLineNum=5 and         _   'If now 5 lines in latest block
        PageLineNum<39 then        _   'and the page is not full
        BlockLineNum=0             _   'then reset block line count to start 
       :PrintLine$=PrintLine$      _   'next block and add a line feel in
               +BlankDotted$           'order to skip a line between blocks.
     '
     PageLineNum=PageLineNum+1         'Increment N of lines on current page
     '
     if PageLineNum=40 then        _   'If there are now 40 lines on this page
        PageLineNum=0              _   'clear line count for next page and
       :BlockLineNum=0                 'clear block line count for first block
     '
     if PageLineNum=0 then         _   'If about to begin a new page, then
        gosub NormalFooter         _   'print normal page footer and
       :PageNum=PageNum+1              'and increment the page number.
     '
PrintLine3:
     '
     PrintLineState=2                  'Set to `print line ready' state
     return                            'Return to line control loop
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'ASSEMBLE A NORMAL PRINT LINE
     '
PrintLine1:  'Form Ref N, Message N as 4-digit strings with leading zeros
     '
     Number=RecNum   :gosub FiveDigit:RecNum$=Number$
     Number=LetterNum:gosub FourDigit:LetterNum$=Number$
     '
     LetterRef$=RecNum$     +" "_   '4-digit Ref N
               +SalesAreaID$+" "_   'Sales Area I/D letter
               +TargNum$    +" "_   'Target Profile Specification N
               +TargSer$    +" "_   'Target List Serial N
               +LetterNum$          'Letter Serial N
     Y=8
     X=2:gosub PrintLine2:NameCode$=X$
     X=7:gosub PrintLine2:PostCode$=X$
     '
     x=asc(ResultFlag$):if x<1 or x>9 then x=10
     Y=32:X$=left$(CallResult$(x),Y):gosub PrintLine4:CallResult$=X$
     NumOfCalls%(x)=NumOfCalls%(x)+1
     '
     Y=20:X=8:gosub PrintLine2
     X=instr(X$,"*"):if X>0 then Y=Y-X+1:mid$(X$,X,Y)=space$(Y)
     PhoneNum$=X$
     Y=29
     X= 1:gosub PrintLine2:CompName$=X$
     X=10:gosub PrintLine2:ContName$=X$
     X=11:gosub PrintLine2:JobTitle$=X$
     '
     PrintLine$=PrintLine$  + "| " _
               +NameCode$   +" | " _   'Namecode             8
               +TimeStamp$  +" | " _   'Letter Date          4
               +LetterRef$  +" | " _   'Letter Reference     4
               +PostCode$   +" | "     'Postcode             8
     PrintLine$=PrintLine$         _
               +PhoneNum$   +" | " _
               +CallResult$ +" |"  _
               +CompName$   + "|"  _
               +ContName$   + "|"  _
               +JobTitle$   + "|"  _
               +NewLine$
     return
     '
PrintLine2: X$=left$(rec$(X),Y)
PrintLine4: X$=X$+space$(Y-len(X$)):return
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'PRINT NEW PAGE HEADING
     '
PageHeader:
     if PageNum=1 then                  'If this is the first page, then
        PrintLine$=PrintLine$ _         '
                  +pp$(2)     _         'Reset printer & set to draft mode
                  +pp$(5)               'set to landscape mode if appropriate
        end if
     gosub PageHeader1:PrintLine$=PrintLine$+HeaderLine2$+ColumnHeadings$:return
     '
PageHeader1:
     PageNum$=str$(PageNum)              'Form the page number
     PageNum$=space$(4-len(PageNum$)) _  'into a 4-character string
             +PageNum$                   'with leading spaces.
     PrintLine$=PrintLine$        _
               +pp$(7)            _    'Set printer to 8.25 characters per inch
               +HeaderLine1$      _    'Print the first title line
               +PageNum$+NewLine$ _    'Page number
               +pp$(6)            _    'Switch to 16.5 chrs/inch
               +BlankLine$
     return
     '
     '--------------------------------------------------------------------------
     'PRINT NORMAL PAGE FOOTER
     '
NormalFooter:
     PrintLine$=PrintLine$        _   'Add to the print line:
               +BlankLine$        _
               +FootNote$         _
               +BlankLine$        _
               +"Continued..."    _   'Normal page footer
               +chr$(12)              'Throw the page
     return
     '
     '--------------------------------------------------------------------------
     'PRINT THE FINAL FOOTER
     '
FinalFooter:
     PrintLine$=PrintLine$ _   'Add to the printer output stack:
               +BlankLine$ _
               +FootNote$  _
               +BlankLine$ _
               +"END"      _   'Print final footer
               +chr$(12)   _   'Throw the page
               +pp$(4)     _   'Switch printer back to 10 chrs/inch
               +pp$(3)         'Reset printer to default configuration
ReSetNums:
     PageNum=1                 'Current page number
     PageLineNum =0            'N of lines printed so far on this page
     BlockLineNum=0            'N of lines printed so far in this 5-line block
     return
     '
     '--------------------------------------------------------------------------
     'FORM 4-DIGIT NUMBER AS A STRING WITH LEADING ZEROS
     '
FiveDigit: LenFld=5:goto FFFFdigit
FourDigit: LenFld=4
     '
FFFFdigit:
     Number$=str$(Number)
     Number$=right$(Number$,len(Number$)-1)
     LenNum=len(Number$)
     if LenNum>LenFld then
        Number$=string$(LenFld,"/")
        else
        if LenNum<LenFld then Number$=string$(LenFld-LenNum,"0")+Number$
        end if
     return
     '
     '--------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'FILE OPENING CONTROL FMM          State 5=Open Wait State 7=Closed
     '
FileCtrl:
     IF FileCtrlState=1 THEN            'OPEN MAIN RECORDS FILE
        RecordIOstate=1                 'Activate record I/O FMM to open
        FileCtrlState=2                 'records file and advance to next state
     '
 ElseIF FileCtrlState=2 THEN            'OPEN SALES AREAS FILE
        if RecordIOstate=3  then        'If the records file is now open, then
           GetAreasState=1              'Activate areas file input FMM to open
           FileCtrlState=3              'target list file/advance to next state
    elseif RecordIOstate=10 then        'If records file wouldn't open, then
           goto FileCtrlA               'de-activate all FMMs involved and exit
           end if
     '
 ElseIF FileCtrlState=3 THEN            'OPEN TARGET LIST FILE
        if GetAreasState=3  then        'If the areas file is now open, then
           ListGeIOstate=1              'Activate target file I/O FMM to open
           FileCtrlState=4              'target list file/advance to next state
    elseif GetAreasState=8 then         'If areas file wouldn't open, then
           goto FileCtrlA               'de-activate all FMMs involved and exit
           end if
     '
 ElseIF FileCtrlState=4 THEN            'WAIT FOR TARGET LIST FILE TO OPEN
        if ListGeIOstate=3  then        'If records file is now open, then
           FileCtrlState=5              'target list file/advance to next state
    elseif ListGeIOstate=10 then        'If records file wouldn't open, then
           goto FileCtrlA               'de-activate all FMMs involved and exit
           end if
     '
 ElseIF FileCtrlState=6 THEN            'CLOSE ALL FILES
        FileNum=1:gosub CloseFile       'Close Records File
        FileNum=2:gosub CloseFile       'Close Areas File
        FileNum=3:gosub CloseFile       'Close Target File
        gosub DeActivate                'De-activate
        FileCtrlState=7                 'Successful Termination State
        END IF
     RETURN
     '
FileCtrlA:                              'FILE OPENING FAILED
     gosub DeActivate                   'De-activate
     FileCtrlState=8                    'Set this FMM to its error state
     return
     '
     '--------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'SET UP TITLE LINE 1 - PACKAGE NAME, LISTING TITLE, SERIAL, DATE, PAGE
     '
     'Note: The first line is printed in 8.25 chr/inch lettering which allows
     '      108 characters across the standard 15-inch platen.
     '
SetUpReportHeading:
     '
     Number=ExtrFlag                'Form the target serial number 
     gosub FourDigit                'into a
     TargSer$=Number$               '4-digit string with leading zeros.
     '
     if TargNum<1 or TargNum>20 then TargNum=0
     TargNum$=str$(TargNum)
     if TargNum>9 then TargNum$=    right$(TargNum$,2)_
                  else TargNum$="0"+right$(TargNum$,1)
     '
     HeaderDrop$=BlankLine$+BlankLine$+BlankLine$+BlankLine$+BlankLine$
     '
     if CompanyName$="" then CompanyName$="E.B.S. MARKETEER"
     '
     CompanyName$=left$(CompanyName$,27) 'Safety limit for company name
     ReportTitle$=left$(ReportTitle$,24) 'Safety limit for report title
     '
     x=53                     _          'N of spare character spaces
      -len(CompanyName$)      _          'minus lengths of company name &
      -len(ReportTitle$)                 'report title giving spaces left.
     '
     y=x/2:x=x-y                         'Divide the spaces left in two.
     Number=ExtrFlag:gosub FourDigit:TargSer$=Number$
     '
     HeaderLine1$=HeaderDrop$         _  'First heading line comprises...
       +CompanyName$+space$(x)        _  'Company name + padding
       +ReportTitle$+space$(y)        _  '+ Report Title + padding =   52 chrs
       +"TARGET NO "+TargNum$+"  "    _  '10+4+2 characters            16 chrs
       +"SERIAL NO "+TargSer$+"  "    _  '10+4+2 characters            16 chrs
       +sd$                  +"  "    _  'System date  15+2            17 chrs
       +"PAGE"                           'Page N  4+4=                 8 chrs
     '                                                                ---
     'Total                                                           109 chrs
     '
     'Note: The page number which is 4-characters long is appended to this
     '      string at the time each page heading is set up during printing.
     '
     HeaderLine2$=BlankLine$+space$(33)+"| CALL REF             |"+NewLine$
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'SET UP TITLE LINE 4 - THE COLUMN HEADINGS
     '
SetUpReportHeading3:
     '
     BlankDotted$_
     ="|----------|---------------------|----------------------|----------|"_
     +"----------------------|----------------------------------|"_
     +"-----------------------------|"_
     +"-----------------------------|"_
     +"-----------------------------|"_
     +NewLine$
     '
     ColumnHeadings$_
     ="| NAMECODE | TIME & DATE OF CALL |  Ref  S TP TS   CS   | POSTCODE |"_
     +" TELEPHONE NUMBER     | CALL RESULT                      |"_
     +" NAME OF COMPANY             |"_
     +" NAME OF CONTACT             |"_
     +" JOB TITLE                   |"_
     +NewLine$+BlankDotted$
     '
     FootNote$_
       ="Key to Call Ref:    "_                               ' 20
       +"Ref=Prospect's Ref Number  "_                        ' 27
       +"S=Prospect's Sales Area I/D (see Map Display)  "_    ' 47
       +"TP=Target Profile Specification Number  "_           ' 40
       +"CS=Individual Call's Serial Number"                  ' 35
     '
     return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'DISPLAY FMM STATES TABLE
     ' 
ShowStates3: ps$=space$(40):column=41:colour=grey
                                                    row= 3:gosub 50
                                                    row= 5:gosub 50
     if FMMflag=0 then
     for row=6 to 15:gosub 50:next
     else
     ps$="    Ŀ    ":row= 6:gosub 50
     ps$="    FMM STATES                        ":row= 7:gosub 50
     ps$="    Ĵ    ":row= 8:gosub 50
     ps$="    ListInit 0      HderCtrl 0        ":row= 9:gosub 50
     ps$="    PrintI/O 0      ResuIO   0        ":row=10:gosub 50
     ps$="    LoopCtrl 0      NextAddr 0        ":row=11:gosub 50
     ps$="    FileCtrl 0      ListGeIO 0        ":row=12:gosub 50
     ps$="    OpenFile 0      RecordIO 0        ":row=13:gosub 50
     ps$="    PrtInteg 0      GetAreas 0        ":row=14:gosub 50
     ps$="        ":row=15:gosub 50
     end if
     ps$="    Ŀ    ":row=16:gosub 50
     ps$="    N of addressees on List  0000    ":row=17:gosub 50
     ps$="    Printing Addressee N     0000    ":row=18:gosub 50
     ps$="        ":row=19:gosub 50
     ps$="    Ŀ    ":row=20:gosub 50
     ps$="    PRINTER STATUS                    ":row=21:gosub 50
     ps$="    Ĵ    ":row=22:gosub 50
     ps$="                                      ":row=23:gosub 50
     ps$="        ":row=24:gosub 50
     '
     return
     '
ShowListSize: number=TargSize:row=17:colour=7:gosub ShowStates1:return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'DISPLAY THE FMM STATES  [COLUMN 1]
     '
ShowStates: colour=7:if FMMflag=0 goto ShowStates4
     '
     column=54
     if LastListInitState<>ListInitState then _
        LastListInitState =ListInitState      _
       :row= 9:Ps$=str$(ListInitState):gosub 50
     '
     if LastPrintIOstate<>PrintIOState  then  _
        LastPrintIOstate =PrintIOState        _
       :row=10:Ps$=str$(PrintIOstate):gosub 50
     '
     if LastLoopCtrlState<>LoopCtrlState then _
        LastLoopCtrlState =LoopCtrlState      _
       :row=11:Ps$=str$(LoopCtrlState):gosub 50
     '
     if LastFileCtrlState<>FileCtrlState then _
        LastFileCtrlState =FileCtrlState      _
       :row=12:Ps$=str$(FileCtrlState):gosub 50
     '
     if LastOpenFileState<>OpenFileState then _
        LastOpenFileState =OpenFileState      _
       :row=13:Ps$=str$(OpenFileState):gosub 50
     '
     if LastPrtIntegState<>PrtIntegState then _
        LastPrtIntegState =PrtIntegState      _
       :row=14:Ps$=str$(PrtIntegState):gosub 50
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'DISPLAY THE FMM STATES [COLUMN 2]
     '
     column=70
     if LastResuIOState<>ResuIOState then _
        LastResuIOState =ResuIOState      _
       :row=10:Ps$=str$(ResuIOState):gosub 50
     '
     if LastNextAddrState<>NextAddrState then _
        LastNextAddrState =NextAddrState      _
       :row=11:Ps$=str$(NextAddrState):gosub 50
     '
     if LastListGeIOstate<>ListGeIOstate then _ 
        LastListGeIOstate =ListGeIOstate      _
       :row=12:Ps$=str$(ListGeIOstate):gosub 50
     '
     if LastRecordIOstate<>RecordIOState then _
        LastRecordIOstate =RecordIOState      _
       :row=13:Ps$=str$(RecordIOstate):gosub 50
     '
     if LastGetAreasState<>GetAreasState then _
        LastGetAreasState =GetAreasState      _
       :row=14:Ps$=str$(GetAreasState):gosub 50
     '
ShowStates4:
     if LastTargItem<>TargItem then _
        LastTargItem =TargItem      _
       :row=18:number=TargItem:gosub ShowStates1
     '
     return
     '
ShowStates1: gosub FourDigit:column=72:ps$=number$:goto 50
     '
     '-------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'PRINTER INITIALIZATION & INTEGRITY MONITOR
     '
PrtInteg:
     '
     IF PrtIntegState=1 THEN            'WAIT FOR INITIALIZATION TO COMPLETE
        if ListInitState=4 then         'If initialization process completed
           PrtIntegState=2              'Initiate the opening of the printer
    elseif ListInitState=5 then         'Ifinitialization process has failed
           ListInitState=1              're-activate it & try again.
           end if
     '
 ElseIF PrtIntegState=2 THEN            'SEE IF PRINTER IN OPEN
        if PrintIOstate=3 then return   'Printer I/O FMM in normal active state
        if PrintIOstate=4 then return   'Printer I/O FMM in X-off state
        PrtIntegState=3                 'Advance to wait for printer on
        PrintIOstate=1                  'Activate the printer I/O FMM
        gosub ShowPreStartMsgs          'Show `switch on the printer' message
     '
 ElseIF PrtIntegState=3 THEN            'WAIT FOR PRINTER TO OPEN
        if PrintIOstate>2 then          'If the printer is on and ready or
           PrtIntegState=2              're-set Printer Watchdog to monitoring
           end if
        END IF
     RETURN                             'Return to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'LOAD ALL DETAILS FOR THE NEXT ADDRESSEE ON THE MAILSHOT LIST
     'State 5: termination state    State 6: error state
     '
NextAddr: if NextAddrState=0 then return
     '
     IF NextAddrState=1 THEN            'GET NEXT ADDRESSEE'S REF N
        ListGeIOstate=4                 'Activate getting of next targ list rec
        NextAddrState=2                 'Advance to next state
     '
 ElseIF NextAddrState=2 THEN            'GET THE NEXT LIST MEMBER'S RECORD N
        if ListGeIOstate=5  then        'If next target list record got OK then
           RecordIOstate=4              'Activate the main record `get' process
           NextAddrState=3              'Advance to the next machine state
    elseif ListGeIOstate=10 then        'If error occurred while getting record
           NextAddrState=6              'Go to error state
           end if
     '
 ElseIF NextAddrState=3 THEN            'GET THE NEXT LIST MEMBER'S RECORD
        if RecordIOstate=5  then        'If next target list record got OK then
           GetAreasState=4              'Activate the sales area search
           NextAddrState=4              'Advance to next state
    elseif RecordIOstate=10 then        'If error occurred while getting record
           NextAddrState=6              'Go to error state
           end if
     '
 ElseIF NextAddrState=4 THEN            'GET THE NEXT LIST MEMBER'S SALES AREA
        if GetAreasState=5  then        'If next target list record got OK then
           NextAddrState=5              'got to the termination state
    elseif GetAreasState=8  then        'If error occurred while getting record
           NextAddrState=6              'Go to error state
           end if
        END IF
     RETURN                             'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'CALL RESULTS REPORT
     '
     'This routine presents a summary in the form of the numbers of calls with
     'each call result, with a total number of calls made at the end.
     '
SummaryReport: if SummaryOnly=1 then gosub PageHeader1:goto SummaryReport1
     '
     if PageLineNum>30             _  'If Summary Report won't fit on this page
        then gosub NormalFooter    _  'then print the normal footer
            :PageNum=PageNum+1     _  'report will be on next page
            :gosub PageHeader1     _  'and top heading line of the next page.
        else PrintLine$=PrintLine$ _  'else add to the print line:
                       +BlankLine$ _
                       +FootNote$
SummaryReport1:
     '
     x$=   BlankLine$+BlankLine$+BlankLine$_
       +   "| NO OF CALLS | CALL RESULT                      |"+NewLine$_
       +   "|-------------|----------------------------------|"+NewLine$
     '
     TotalCalls=0
     '
     for CallResultType=1 to 10
     '
     NumOfCalls=NumOfCalls%(CallResultType)    'N of calls with this result
     TotalCalls=TotalCalls+NumOfCalls          'Add to total calls made
     Calls$=left$(str$(NumOfCalls),5)          'Form N of calls as fixed
     Calls$=space$(11-len(Calls$))+Calls$      'length character field.
     CallResult$=CallResult$(CallResultType)
     CallResult$=CallResult$+space$(32-len(CallResult$))
     '
     x$=x$+"| "+Calls$+ " | "+CallResult$+" |"+NewLine$
     next
     '
     y$=left$(str$(TotalCalls),5):y$=space$(11-len(y$))+y$
     x$=x$+"|-------------|----------------------------------|"+NewLine$_
          +"| "  +y$+   " | TOTAL                            |"+NewLine$
     '
     PrintLine$=PrintLine$+x$
     FootNote$="":gosub FinalFooter:return
     '
     '-------------------------------------------------------------------------
     'SUMMARY REPORT ONLY PROCESSING
     '
SummaryReportOnly:
     x=asc(ResultFlag$)                 'Call result number
     if x<1 or x>9 then x=10            'Range validation
     NumOfCalls%(x)=NumOfCalls%(x)+1    'Increment N of calls with this result
     if TargItem=TargSize then          'If this is the final line of print
        gosub SummaryReport             'then append the summary report
        end if
     return

