





     '-------------------------------------------------------------------------
     'PRINTS CHAPTER OF MANUAL     by R J Morton    28MAR89        PrintMan.BAS
     '-------------------------------------------------------------------------
     'Enables the user to print out a list of the names & addresses of all the 
     'prospects who are on a specified Target List.
     '-------------------------------------------------------------------------
     DefInt a-z                    'All interger
     rem $include: 'ComVars.INC'   'Merge in the common variables
     dim pp$(20)                   'Holds printer port specs & control codes
     dim values$(18)
     PrtBufNum=4               'File N under which Printer I/O File is opened
     ErrMsgRow= 3              'Row on which DOS error messages are displayed
     ErrMsgCol=45              'Start column for DOS error message displays
     PrtRow=20                 'First row of printer display panel
     PrtCol= 3                 'Left-most column of printer display panel
     PrRecLen = 4096           '4k spool file output buffering.
     NewLine$ = chr$(13) + chr$(10)
     BL$=space$(5)+NewLine$
     gosub ExpiryTest
     ps$="[PRINT USER MANUAL]":column=1:row=3:colour=7:gosub 50
     ps$=space$(40):row=19:column=1:gosub 50  'Clear row above printer box
     gosub ShowPpanel                         'Display printer control panel
     gosub ShowStates3
     '
     '-------------------------------------------------------------------------
     'FMM CONTROL LOOP
     '
     PrintManState=1                    'Activate the FMM polling loop.
     While PrintManState<8
     gosub PrintMan
     gosub KeyBoard                     'Keyboard input/output FMM
     gosub PrtInteg
     gosub PrintIO                      'Printer input/output FMM
     gosub OpenFileFMM                  'General file opener FMM
     gosub ShowMsgs                     'Display any DOS messages
     gosub ShowStates                   'Display FMM states
     wend:chain"Conf"                   'exit this load module
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'EXTERNAL SUBROUTINES
     '
50   Call ScrSub(ps$,row,column,colour):return
     '
     rem $include: 'GetPrt.FMM'
     rem $include: 'MsgTitle.FMM'
     rem $include: 'PrintIO.FMM'
     rem $include: 'KeyBoard.FMM'
     rem $include: 'PPanel.FMM'
     rem $include: 'Select.FMM'
     rem $include: 'OpenFile.FMM'
     rem $include: 'Expiry.INC'
     rem $include: 'Decrypt.INC'
     rem $include: 'TexCrypt.INC'
     '
     '-------------------------------------------------------------------------
     'SHOW MESSAGES
     '
ShowMsgs:
     if ShowMessages>0 then             'If messages waiting to be displayed,
        if DosClr>0 then                'If a DOS message to be displayed
           colour=DosClr                'set appropriate message colour
           DosClr=0                     'Message colour acts as message trigger
           ps$=DosMsg$                  'set up message in the display string
           gosub ShowMsgs1              'display message
           end if
        if PrtClr>0 then                'If a Printer message to be displayed,
           colour=PrtClr                'set appropriate message colour
           PrtClr=0                     'Message colour acts as message trigger
           row=23:column=46         
           ps$=Pstatus$            _    'set up message in the display string
          +space$(30-len(pstatus$))     'Pad out to 30 character message field
           gosub 50                     'display message
           gosub ShowPlamps             'display pritner status lamps
           end if
        ShowMessages=0                  'Cancel `message display request'
        end if
     return                             'Return control to Polling Loop
     '
ShowMsgs1:
     row=ErrMsgRow:column=ErrMsgCol     'Set message co-ordinates
     ps$=ps$+space$(36-len(ps$))        'Pad out to 36 character message field
     gosub 50                           'Call the fast screen display routine
     return                             'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'DISPLAY FMM STATES TABLE
     ' 
ShowStates3: column=41:colour=grey
     '
     ps$=space$(40):for row=5 to 15:gosub 50:next
     ps$="    Ŀ    ":row=16:gosub 50
     ps$="    N of lines of text       0000    ":row=17:gosub 50
     ps$="    Line now being printed    0000    ":row=18:gosub 50
     ps$="        ":row=19:gosub 50
     ps$="    Ŀ    ":row=20:gosub 50
     ps$="    PRINTER STATUS                    ":row=21:gosub 50
     ps$="    Ĵ    ":row=22:gosub 50
     ps$="                                      ":row=23:gosub 50
     ps$="        ":row=24:goto  50
     '
ShowStates4: number=NumManLines:row=17:goto ShowStates1
     '
     '--------------------------------------------------------------------------
     'DISPLAY THE FMM STATES
     '
ShowStates:
     if LastManLine<>ManLine then
        LastManLine =ManLine
        row=18:number=ManLine
        gosub ShowStates1
        end if
     return
     '
ShowStates1: gosub FourDigit:column=72:colour=7:ps$=number$:gosub 50
     '
     '-------------------------------------------------------------------------
     'FORM 4-DIGIT NUMBER AS A STRING WITH LEADING ZEROS
     '
FourDigit: LenFld=4
     Number$=str$(Number)
     Number$=right$(Number$,len(Number$)-1)
     LenNum=len(Number$)
     if LenNum>LenFld then
        Number$=string$(LenFld,"/")
        else
        if LenNum<LenFld then Number$=string$(LenFld-LenNum,"0")+Number$
        end if
     return
     '
     '-------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'PRINT NEW PAGE HEADING
     '
PageHeader:
     PrintLine$=PrintLine$        _
               +EightPitch$       _    'Set printer to 8.25 characters per inch
               +TOF$              _
               +"EBS MARKETEER"   _
               +space$(51-len(ChapName$))   _
               +ChapName$+NewLine$_
               +BL$+BL$           _
               +TenPitch$              'Switch to 10 chrs/inch
     return
     '
     '--------------------------------------------------------------------------
     'PRINT NORMAL PAGE FOOTER
     '
NormalFooter:
     x$=str$(PageNum)
     x$=right$(x$,len(x$)-1)
     if len(x$)=1 then x$="0"+x$
     x$=ManChap$+"."+x$
     '
     PrintLine$=PrintLine$        _     'Add to the print line:
               +BL$+BL$           _
               +Edition$          _     ' Edition 04    10
               +space$(20)        _     '               20
               +x$                _     ' 00.00          5
               +space$(20)        _                     20
               +EdDate$+NewLine$  _     ' 02 AUG 89      9
               +chr$(12)                'Throw the page 64
     return
     '
     '--------------------------------------------------------------------------
     'PRINT THE FINAL FOOTER
     '
FinalFooter:
     gosub NormalFooter
     PrintLine$=PrintLine$        _   'Add to the printer output stack:
               +TenPitch$             'Switch printer back to 10 chrs/inch
     return
     '
     '--------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'PRINTER INITIALIZATION & INTEGRITY MONITOR
     '
PrtInteg:
     IF PrtIntegState=1 THEN            'WAIT FOR INITIALIZATION TO COMPLETE
        if PrintIOstate<3 or    _       'Printer I/O FMM in normal active state
           PrintIOstate>4 then          'Printer I/O FMM in X-off state
           PrtIntegState=2              'Advance to wait for printer on
           PrintIOstate=1               'Activate the printer I/O FMM
           gosub ShowPreStartMsgs       'Show `switch on the printer' message
           end if
 elseIF PrtIntegState=2 THEN            'WAIT FOR PRINTER TO OPEN
        if PrintIOstate>2 then          'If the printer is on and ready or
           PrtIntegState=1              're-set Printer Watchdog to monitoring
           end if
        END IF
     RETURN                             'Return to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'LOAD THE PRINTER CONTROL CODES
     '
PrintMan:
     IF PrintManState=1 THEN            'If not initialized then
        gosub PrintManInit              'Initialization FMM
        if PrintManInitState=0 then     'If initializer not activated, then
           PrintManInitState=1          'activate it
    elseif PrintManInitState=8 then     'Initializer completed
           ps$="Initialised: ":colour=2:column=12:row=22:gosub 50
           PrintManState=2
    elseif PrintManInitState=9 then     'Initialization failed
           PrintManState=9
           end if
     '
     '-------------------------------------------------------------------------
     'DISPLAY THE CONTENTS LIST
     '
 elseIF PrintManState=2 THEN           'Contents initialization state
        PageLineNum=0                  'N of lines printed so far on this page
        PageNum=0
        ManLine=0
        MBL$=space$(63):MBM$=space$(68)
        ps$=string$(48,220):row= 4:column=4:colour=1:gosub 50
        ps$=" Chap TITLE  Chap TITLE "
        row=5:colour=19:gosub 50
        ps$=space$(48):for row=6 to 14:GOSUB 50:next
        ps$=string$(48,223):row=15:colour=1:gosub 50
        colour=7:row=16:ps$=space$(36):GOSUB 50:row=17:gosub 50
        values$(1)=" - Foreword"       :values$(10)=" 9 Telephone/Telesales"
        values$(2)=" 1 Background"     :values$(11)="10 Telex & Data Comms"
        values$(3)=" 2 System Overview":values$(12)="11 New Prospects"
        values$(4)=" 3 Requirements"   :values$(13)="12 Maintain Records" 
        values$(5)=" 4 Installation"   :values$(14)="13 Define Targets"
        values$(6)=" 5 Define Market"  :values$(15)="14 Target Lists"
        values$(7)=" 6 Statistics"     :values$(16)="15 Finding Prospects"
        values$(8)=" 7 Sales Letters"  :values$(17)=" - Index"
        values$(9)=" 8 Mailshots"      :values$(18)=" - Software Licence"
        colour=23
        column= 7:for k=1 to 9:row=k+5:ps$=values$(k  ):gosub 50:next
        column=28:for k=1 to 9:row=k+5:ps$=values$(k+9):gosub 50:next
        column=54:colour=2
        ps$="Use      to highlight" :row=5:gosub 50
        ps$="chapter, Ins to select":row=6:gosub 50
        ps$="it then F2 to print it.":row=7:gosub 50
        ps$="Press Esc to quit."   :row=8:gosub 50
        colour=10
        column=58:ps$=""+chr$(26)+"":row=5:gosub 50
        column=63:ps$="Ins":row=6:gosub 50
        column=62:ps$="F2" :row=7:gosub 50
        column=60:ps$="Esc":row=8:gosub 50
     '
        ValuRow  = 6            'First row on which field occurs
        ValuCol  = 5            'First character of first column
        InstrCol = 1
        NumCols  = 2            'Number of columns
        PerCol   = 9            'Number of values per column
        InterCol =21            'Column separation
        MaxVals  =18            'Maximum number of values displayed
        SelOrder = 0            'Order in which printcolumnade is irrelevant
        NumSels  = 1            'Number of selections allowed
        values$=chr$(ManChap+64)'Initial value selections on entry
        EditingPermitted=0      'Permit editing of field names
        SelectInstr=1           'Select.FMM not to display instructions
        SelectPtr=ManChap       'Set up current selection for highlighting
        UseOldSelection=1       '
        SelectState=1           'Activate the selector FMM
        PrintManState=3           'Activate the library selector
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'AWAIT TERMINATION OF THE LIBRARY SELECTOR
     '
 elseIF PrintManState=3 THEN
        gosub Select                    'Selector FMM
        if SelectState<8 then return
        ManChap=asc(values$)-64         'Form Chap N of the selected letter
        if SelectEsc=1 or ManChap=0 then
           gosub ManualExit
      else PrintManState=4              'Activate the letter searcher/loader
           if PrtType$="" then
              column=4:colour=2
              ps$="Enter D  for Draft quality printer:":row=16:gosub 50
              ps$="      L  for Letter quality printer":row=17:gosub 50
              ps$=space$(35):row=18:colour=7:gosub 50
              colour=10:column=10
              ps$="D":row=16:gosub 50
              ps$="L":row=17:gosub 50
              locate 18,10,1,6,7
              X$="":while X$="":X$=inkey$:wend
              if X$="d" then X$="D":paper = 1 'print on 15 x 11'' listing paper
              if X$="l" then X$="L":paper = 4 'print on plain A4 typing paper
              PrtType$=X$+"Q"
              ps$=space$(35):column=4:for row=16 to 18:gosub 50:next
              end if
           if PrtType$="LQ" then
              PrStr$=pp$(8)+pp$(18)+pp$(9)   'Sets LQ printer's margin etc.
              TOF$=""
              if TopOfForm>0 then
                 for k=1 to TopOfForm
                 TOF$=TOF$+BL$:next
                 end if
       elseif PrtType$="DQ" then
              TOF$=BL$+BL$+BL$+BL$
              EightPitch$=pp$(7)        'Switches draft printer to 8-pitch
              TenPitch$=pp$(4)          'Switches draft printer to 10-pitch
         else gosub ManualExit
              end if
           end if
        SelectState=0                   'De-activate self
     '
     '-------------------------------------------------------------------------
     'SET UP THE APPROPRIATE CHAPTER FILE NAME
     '
 elseIF PrintManState=4 THEN
        x=ManChap-1
        if x=16 then x=18               'Index to printed version is CHAP18
        ManChap$=str$(x):ManChap$=right$(ManChap$,len(ManChap$)-1)
        if len(ManChap$)=1 then ManChap$="0"+ManChap$
        FileName$=ManuFile$+ManChap$
        if ManFile=0 then ManFile=1
        FileNum=ManFile
        RecLen=64
        LockFile=3                      'Self and others may read-only
        OpenFileState=1
        PrintManState=5                 'Activate the letter searcher/loader
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'CHAPTER DISPLAY
     '
 elseIF PrintManState=5 THEN
        if OpenFileState<5 then return  'File opener not yet completed
        if OpenFileState=5 then         'File opened OK
           field ManFile,64 as View$
           if LastManChap<>ManChap then ManBias=0:LastManChap=ManChap
           get ManFile,1:gosub ManualF
           NumManLines=cvi(left$(x$,2))
           gosub ShowStates4
           Edition$ = "Edition " + mid$(x$,5,2)
           EdDate$ = mid$(x$,8,2) + " " + mid$(x$,10,3) + " " + mid$(x$,13,2)
           x$ = mid$(x$,16,38) : x = len(x$) : y = 0
           while x > 0
           if mid$(x$,x,1) < "!" then x = x - 1 else y = x : x = 0
           wend
           ChapName$ = left$(x$,y)
           PageNum=1                    'Current page number
           PrtIntegState=1              'Activate the printer FMM
           locate 21,32                 'Cursor to printer control box
           PrintManState=6
      else gosub ManualExit             'Could not open the Manual File
           end if
        OpenFileState=0
     '
     '-------------------------------------------------------------------------
     'MONITOR KEYBOARD
     '
 elseIF PrintManState=6 THEN
        if PrintManEsc=1 then
           if PrintIOstate<6 then return
           goto ManualExit
    elseif KbStr$>"" then               'No key has been struck
           KbChar=asc(left$(KbStr$,1))  'Get ASCII value of next character &
           KbStr$=right$(KbStr$,len(KbStr$)-1) 'chop off Keyboard input stack
           if KbChar=27 then            'If the `Esc' key has been pressed
              PrintIOstate=5            'force-deactivate print I/O FMM.
              PrintManEsc=1:return
       elseif KbChar=13 then            'Invalid key stroke if not a C/R
              if HaltPrinterFlag=0 then 'If not currently in a halt state
                 HaltPrinterFlag=1      'then set printer to halt state
            else HaltPrinterFlag=0      'else clear the halt state
                 ps$="":gosub ShowMsgs1 'clear possible error message.
                 end if
              gosub ShowPostStartMsgs   'Display appropriate messages.
              end if                    'see if it can be activated.
           end if
        if PrintIOstate<>3 then return  'Exit if printer not ready
        IF len(PrStr$)<PrRecLen THEN    'If print stack is not full, then
           PrintLine$=""                'Clear the print line assembly string
           if PageLineNum=0 then        'If it is the start of a new page
              gosub PageHeader          'then set up a new page heading
              end if
           ManLine=ManLine+1            'Advance to next line of text
           get ManFile,ManLine+1        'Get next line of text from manual file
           gosub ManualF                'decrypt the line of text
           x$=right$(x$,len(x$)-1):x=len(x$):y=5
           while x>5:if mid$(x$,x,1)<"!" then x=x-1 else y=x:x=5
           wend
           PrintLine$=PrintLine$  _     'Add to the print stack
            +left$(x$,y)+NewLine$       'plus the decrypted text.
           if ManLine=NumManLines then  'If this is the final line of print
              gosub FinalFooter         'then append the final page footer
              PrintIOflush = 1
              PrintManState=7
         else PageLineNum=PageLineNum+1 'Increment N of lines on current page
              if PageLineNum=52 then    'If there are now 52 lines on this page
                 PageLineNum=0          'clear line count for next page and
                 end if
              if PageLineNum=0 then     'If about to begin a new page, then
                 gosub NormalFooter     'print normal page footer and
                 PageNum=PageNum+1      'and increment the page number.
                 end if
              end if
              PrStr$=PrStr$+PrintLine$  'and put it on the print stack.
           END IF
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'SET UP FINISHED MESSAGE & DEACTIVATE
     '
 elseIF PrintManState=7 THEN
        if PrStr$="" and PrBlk$="" and _
           PrtIntegState=1 then         'If the record has been stored OK
           Pstatus$="FINISHED"       
           PrtClr=10:ShowMessages=1     '
           PrintIOState=0               'Printer input/output FMM
           PrtIntegState=0
           PrintManState=2
           OpenFileState=0              'General file opener FMM
           FileNum=0:gosub CloseFile    'Close printer & all files
           end if                       '
        END IF
     '
     RETURN                             'Return to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     'ADVANCE OR BACK-UP A SINGLE LINE OF TEXT
     '
ManualF:                                'DECRYPT A LINE OF TEXT
     w=asc(left$(view$,1))-77           'Length of text line+1
     x$=MBL$:for j=2 to w               'For each character of input string...
     x=asc(mid$(view$,j,1))+39-w+j      'ASCII value of encrypted character
     if X>255 then
        X=X-256                         'Rotate ASCII value so it stays
 elseif X<0 then
        X=X+256                         'in range 1 to 224 inclusive.
        end if
     mid$(x$,j-1,1)=chr$(x)
     next:return
     '
ManualExit:
     for k=0 to 18:values$(k)="":next   'Vacate string space
     MBL$="":MBM$="":x$=""
     colour=12:ps$=""
     fileNum=0:gosub CloseFile          'Close all files
     gosub ShowMsgs1                    'clear error message field
     ManualContents=0
     PrintManState=8
     return                             'Go to termination state
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'INITIALIZATION FMM
     '
PrintManInit:
     IF PrintManInitState=1 THEN        'If not initialized then
        gosub GetPrtCodes               'Printer Control Code Loader FMM
        if GetPrtState=0 then           'If loader not activated, then
           GetPrtState=1                'activate it
    elseif GetPrtState=3 then           'Printer control codes loaded OK
           PrintManInitState=2
    elseif GetPrtState=4 then           'Printer control codes would not load
           PrintManInitState=9
           end if
 elseIF PrintManInitState=2 THEN        'If not initialized then
        gosub MsgTitle                  'Top of Form Loader FMM
        if MsgTitleState=0 then         'If loader not activated, then
           MsgTitleState=1              'activate it
    elseif MsgTitleState=3 then         'Printer control codes loaded OK
           PrintManInitState=8          '
    elseif MsgTitleState=4 then         'Printer control codes would not load
           PrintManInitState=9
           end if
        END IF
     RETURN
     '
     '-------------------------------------------------------------------------

