





    '--------------------------------------------------------------------------
    'SET UP PRINTER CONTROL CODES         18NOV86          [File: PRTCODES.BAS]
    '--------------------------------------------------------------------------
    '
    'Enables you to set up the Printer Control Codes for type-size
    'and margin adjustments
    '
    DefInt a-z
    rem $include: 'ComVars.INC'
    '
    dim     pp$(20)    'Array to contain the printer port fielspec fields
    dim fields$(18)    'Fields to hold the above for editing
    '
    row=1:column=19:colour=7:ps$=top$:gosub 50      'Display module name
    goto Start
    '
    rem $include: 'Decrypt.INC'
    rem $include: 'GetPrtr.INC'
    rem $include: 'PutPrtr.INC'
    rem $include: 'InChar.INC'
    rem $include: 'EdField.INC'
    rem $include: 'EdBlock.INC'
    rem $include: 'Expiry.INC'
    '
40 row=row+1          
50  call ScrSub(ps$,row,column,colour):return
    '
    '--------------------------------------------------------------------------
    'EDIT THE PRINTER PORT FILESPECS
    '
Start:
    gosub ExpiryTest
    gosub ShowForm             'Display printer port containment box
    gosub GetPortSpecs         'Load printer port filespecs
    gosub EdPrtPorts           'Display & edit printer port filespecs
    '
    if Amendf=1 and y=60 _
       then gosub PutPortSpecs     'Store edited printer port filespecs
    '
    row=3:column=41:colour=7:ps$=space$(40):gosub 50
    prog$="PRTCODES":chain"Conf"   'Return to the printer menu
    '
    '--------------------------------------------------------------------------
     '






    '--------------------------------------------------------------------------
    'DISPLAY THE SUBSCRIBER DETAILS FRAME
    '
ShowForm:
    ps$="    ":column=1:colour=1:for row=3 to 20:gosub 50:next
    column=77:for row=3 to 20:gosub 50:next
    row=2:column=5
    PS$="                      ":GOSUB 40    '3
    ps$=string$(72,""):colour=1:gosub 40
    colour=19
    PS$=" PRINTER FUNCTION     ":GOSUB 40    '4
    PS$=" DQ initialise        ":GOSUB 40    '6
    PS$=" DQ reset             ":GOSUB 40    '7
    PS$=" DQ portrait+10cpi    ":GOSUB 40    '8
    PS$=" DQ landscape         ":GOSUB 40    '9
    PS$=" DQ set 16 or 20cpi   ":GOSUB 40    '0
    PS$=" DQ set  8 or 10cpi   ":GOSUB 40    '1
    PS$=" LQ reset             ":GOSUB 40    '2
    PS$=" LQ left & top margin ":GOSUB 40    '3
    PS$=" LQ bold print set    ":GOSUB 40    '4
    PS$=" LQ bold print cancel ":GOSUB 40    '5
    PS$=" LQ underline set     ":GOSUB 40    '6
    PS$=" LQ underline cancel  ":GOSUB 40    '7
    PS$=" LQ Italic set        ":GOSUB 40    '8
    PS$=" LQ Italic cancel     ":GOSUB 40    '9
    PS$=" LQ pitch+size+face   ":GOSUB 40    '9
    colour=2:column=1
    PS$="                          ":GOSUB 40    '0
    PS$="    PRINTERS:             ":GOSUB 40    '3
    PS$="    DQ = Draft Quality    ":GOSUB 40    '1
    PS$="    LQ = Letter Quality   ":GOSUB 40    '2
    PS$="                          ":GOSUB 40    '4
    '                                              
    ROW=2:COLUMN=27:COLOUR=2
    PS$="Enter appropriate codes as found in Printer Manual":GOSUB 40
    colour=19:row=4
    PS$="  CONTROL STRING AS A SET OF 3-DIGIT ASCII CODES  ":GOSUB 40
    PS$="                                                  "
    for k=1 to 15:GOSUB 40:next:colour=7
    PS$="                                                      "
    GOSUB 40:GOSUB 40:GOSUB 40:GOSUB 40   'Clear rows 21-24
    '
    RETURN
    '
    '--------------------------------------------------------------------------
     '





    '--------------------------------------------------------------------------
    'LOAD PRINTER CONTROL STRINGS
    '
GetPortSpecs:
    gosub GetPrtr                       'Call GETPRTR
    j=1:for k=1 to 15                   'PP$(0),PP$(1) contain port specs
    if k=9 then j=3
    fields$(k)=pp$(k+j)                 'PP$(2 to 9) to FIELDS$(1 to 8)
    next:return
    '
    '--------------------------------------------------------------------------
    'SET UP AND CALL THE FIELD BLOCK EDITOR [EDBLOCK]
    '
EdPrtPorts:
    BlockRow= 6         'Row on which first field appears
    BlockCol=29         'Column in which left-hand field-column starts
    InstrCol=29         'Instructions display
    MsgPos=1            'INSERT message position override
    Msg.V=21            'for INSERT message
    Msg.H=71
    LenField=45
    NumFlds =15         'Number of fields
    numerics= 1         'Set up EDBLOCK & EDFIELD for colour band numerics
    gosub EdBlock1      'Display the operator's editing instructions
    gosub EdBlock3      'Display the original field contents
    gosub EdBlock4      'Edit the fields
    return              'Exit
    '
    '--------------------------------------------------------------------------
    'STORE PRINTER CONTROL STRINGS
    '
PutPortSpecs:
    j=1:for k=1 to 15
    if k=9 then j=3
    pp$(k+j)=fields$(k):next
    gosub PutPrtr:return         'Call PUTPRTR
    '
    '--------------------------------------------------------------------------
     '
