




     'DISPLAY THE VALUES OF A KEY        22NOV86           [File: ShoKeyvs.INC]

     'Displays the [upto] 18 values of a specified Key and allows the user
     'to "select" one or more values for prospect profiling or targeting.

     'Inputs  KEYVROW - Top row of the key values containment box
     '        KEYVCOL - Left-most column of the key values containment box
     '        KEYARR  - Array number of Key whose values are to be displayed
     '        KEYVS$  - Sting of letters representing the Values of this key
     '                  which were originally "selected" prior to entry
     '        NUMSELS - Number of selections allowed (1 or 15)
     '        KEYVS$(KEYNUM,K) - Array containing name & values of the keys
     '                           K=0       contains the key's name
     '                           K=1 to 18 contain the key's values

     'Output VALUES$(18) - Input array for SELECT.BAS containing key values


     'DISPLAY THE KEY VALUES CONTAINMENT BOX

ShoKeyvs: gosub ShowKBox      'Display the standard key values box

     ps$=" * shows the currently selected value"
     if NumSels=1 then ps$=ps$+"  " else  ps$=ps$+"s "
     row=17:column=KeyvCol:colour=19:gosub 50
     ps$="*":column=KeyvCol+1:colour=27:gosub 50
     '
     if KeyArr=0 then X$="NAMES" else X$="Key Values"
     ps$=keyvs$(KeyArr,0)+" "+X$+":"
     row=KeyvRow+ 1:column=KeyvCol+1:colour=27:gosub 50


     'DISPLAY THE VALUES OF THIS KEY
ShowKeyvs:
     colour=23
     for k=1 to 9:row=KeyvRow+k+2
     column=KeyvCol+ 3:x=0:gosub ShoKeyvs1
     column=KeyvCol+22:x=9:gosub ShoKeyvs1
     next:return
ShoKeyvs1:
     ps$=keyvs$(KeyArr,k+x)
     values$(k+x)=ps$
     ps$=ps$+space$(16-len(ps$))
     gosub 50:return

