





     'PRINT STATISTICS REPORT                 04SEP87           File: StRep.BAS
     '-------------------------------------------------------------------------
     '
     'This routine provides a printed version of the current Statistics.
     'It places the report in the universal print
     'stack PrStr$ and then calls the general print handler `PrintIO'.
     '
     'Author : R J Morton
     '
     '-------------------------------------------------------------------------
     'INITIALIZATION
     '
     DefInt a-z                    'A=single precision for elapsed time Routine
     rem $include: 'ComVars.INC'   'Merge in the common variables
     '
     dim StatsCount%(6,18)    '(0,x) = Sales areas statistics counter
                              '(1,x) = Relation    statistics counter
                              '(2,x) = Status      statistics counter
                              '(3,x) = Product     statistics counter
                              '(4,x) = Last Event  statistics counter
                              '(5,x) = Next Event  statistics counter
                              '(6,x) = Sales area Populations
     '
     dim Keyvs$(6,18)         '(1,x) = Relation    key name & values
                              '(2,x) = Status      key name & values
                              '(3,x) = Product     key name & values
                              '(4,x) = Last Event  key name & values
                              '(5,x) = Next Event  key name & values
                              '(6,x) = Sales area Populations
     '
     common StatsCount%()
     common Keyvs$()
     common i.max
     common TotPop
     '
     dim pp$(20)               'Holds printer port specs & control codes
     PrtBufNum=4               'File N under which Printer I/O File is opened
     ErrMsgRow= 3              'Row on which DOS error messages are displayed
     ErrMsgCol=45              'Start column for DOS error message displays
     paper = 1                 'To be printed on 15 by 11 inch listing paper
     PrtRow=20                 'First row of printer display panel
     PrtCol= 3                 'Left-most column of printer display panel
     gosub ResetNums
     NewLine$=chr$(13)+chr$(10)
     BlankLine$=space$(5)+NewLine$
     locate 21,32              'Cursor in printer control box
     '
     gosub ExpiryTest
     '
     ps$=space$(40):row=19:column=1:gosub 50  'Clear row above printer box
     gosub ShowPpanel                         'Display printer control panel
     gosub ShowSpanel                         'Display printer control panel
     ListInitState=1           'Activate the Initialization FMM
     PrtIntegState=1           'Activate the Printer Integrity Watch Dog FMM
     goto StartLoop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'EXTERNAL SUBROUTINES
     '
 50  Call ScrSub(ps$,row,column,colour):return
     '
     rem $include: 'GetPrt.FMM'
     rem $include: 'GetKeyvs.FMM'
     rem $include: 'PrintIO.FMM'
     rem $include: 'KeyBoard.FMM'
     rem $include: 'PPanel.FMM'
     rem $include: 'ListInit.FMM'
     rem $include: 'OpenFile.FMM'
     rem $include: 'Expiry.INC'
     rem $include: 'Decrypt.INC'
     '
     '-------------------------------------------------------------------------
     'FMM CONTROL LOOP
     '
StartLoop:
     active=1
     WHILE active
     gosub ListInit      'Load printer codes & error messages & initialize loop
     gosub KeyBoard      'Keyboard input/output FMM
     gosub PrintIO       'Printer input/output FMM
     gosub LoopCtrl      'Record print loop control
     gosub OpenFileFMM   'General file opener FMM
     gosub KeybCtrl      'Loop escape watch dog for exiting this load module
     gosub PrtInteg      'Printer opener & interity watch dog
     gosub ShowMsgs      'Display any DOS messages picked up by above routines
     WEND
     close                      'then close printer & all files
     ps$="":gosub ShowMsgs1     'clear error message field
     prog$="STREP"              'Set program identification variable
     chain"Stati"               'exit this load module back to Lmenu
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'SHOW MESSAGES
     '
ShowMsgs:
     '
     if ShowMessages=0 then return   'No messages waiting to be displayed
     '
     if DosClr>0 then           _    'If there is a DOS message to be displayed
        colour=DosClr           _    'set the appropriate message colour
       :DosClr=0                _    'Message colour acts as message trigger
       :ps$=DosMsg$             _    'set up the message in the display string
       :gosub ShowMsgs1              'display message
     '
     if PrtClr>0 then           _    'If there's a Printer Status message to be
        colour=PrtClr           _    'displayed, set appropriate message colour
       :PrtClr=0                _    'Message colour acts as message trigger
       :row=23:column=46        _
       :ps$=Pstatus$            _    'set up the message in the display string
       +space$(30-len(pstatus$))_    'Pad out to 30 character message field
       :gosub 50                _    'display message
       :gosub ShowPlamps             'display pritner status lamps
     '
     ShowMessages=0                  'Cancel the `message display request'
     return                          'Return control to the Polling Loop
     '
ShowMsgs1:
     '
     row=ErrMsgRow:column=ErrMsgCol  'Set message co-ordinates
     ps$=ps$+space$(36-len(ps$))     'Pad out to 36 character message field
     gosub 50                        'Call the fast screen display routine
     return                          'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'KEYBOARD CONTROL
     '
KeybCtrl: gosub NextChar
     '
     if KbChar=27 or CtrlChar=61 then active=0 : return
     if KbChar<>13 and CtrlChar<>60 then return
     if LoopCtrlState=0 goto KeybCtrl1  'activate printer
     '
     if HaltPrinterFlag=0        _  'If not currently in a halt state
        then HaltPrinterFlag=1   _  'then set printer to halt state
        else HaltPrinterFlag=0   _  'else clear the halt state
            :ps$=""              _
            :gosub ShowMsgs1        'clear possible error message.
     '
     gosub ShowPostStartMsgs        'Display appropriate messages.
     return                         'Return control to the Polling Loop
     '
KeyBCtrl1:                          'Try to activate the Print Loop FMM
     '
     if PrtIntegState=2 and      _  'If printer Integrity Watch Dog active
        ListInitState=4 then     _  'and the Lister Module initialized
        gosub SetUpReport        _
       :LoopCtrlState=1             'then activate the print loop FMM.
     '
     HaltPrinterFlag=0
     gosub ShowPostStartMsgs        'Display appropriate messages.
     return                         'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'LOOP CONTROL FMM
     '
LoopCtrl: if LoopCtrlState=0 then return
     '
     if PrStr$="" then           _   'When printer ouput stack is finally
        Pstatus$="FINISHED"      _   '
       :PrtClr=10:ShowMessages=1 _   '
       :LoopCtrlState=0          _   'Record print loop control
       :OpenFileState=0              'General file opener FMM
     '
     return                          'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'FORM 4-DIGIT NUMBER AS A STRING WITH LEADING ZEROS
     '
FourDigit:
     '
     if Number<0 or Number>9999 then Number$="////":return
     Number$=str$(Number)
     Number$=right$(Number$,len(Number$)-1)
     LenNum=len(Number$)
     if LenNum<4 then Number$=string$(4-LenNum,"0")+Number$
     return
     '
     '--------------------------------------------------------------------------
ShowSpanel:                        'Display printer control panel
     column=41:colour=grey
     ps$="    Ŀ    ":row=20:gosub 50
     ps$="    PRINTER STATUS                    ":row=21:gosub 50
     ps$="    Ĵ    ":row=22:gosub 50
     ps$="                                      ":row=23:gosub 50
     ps$="        ":row=24:gosub 50
     return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'PRINTER INITIALIZATION & INTEGRITY MONITOR
     '
PrtInteg:
     '
     on PrtIntegState goto  _  'State 0: inactive
        PrtInteg1,          _  'State 1: wait for initialization to complete
        PrtInteg2,          _  'State 2: check printer initially or after error
        PrtInteg3              'State 3: wait for the printer to open
     '
     return                    'Return to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     'WAIT FOR THE INITIALIZATION PROCESS TO COMPLETE
     '
PrtInteg1:
     '
     if ListInitState=4 then _      'If the initialization process completed
        PrtIntegState=2             'Initiate the opening of the printer
     '
     if ListInitState=5 then _      'If the initialization process has failed
        ListInitState=1             'the re-activate it & try again.
     '
     return                         'Return control to the Polling Loop
     '
     '--------------------------------------------------------------------------
     'SEE IF PRINTER IN OPEN
     '
PrtInteg2:
     '
     if PrintIOstate=3 then return  'Printer I/O FMM in normal active state
     if PrintIOstate=4 then return  'Printer I/O FMM in X-off state
     '
     PrtIntegState=3                'Advance to wait for printer on
     PrintIOstate=1                 'Activate the printer I/O FMM
     gosub ShowPreStartMsgs         'Show the `switch on the printer' message
     return                         'Return to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     'WAIT FOR PRINTER TO OPEN
     '
PrtInteg3:
     '
     if PrintIOstate>2 then      _  'If the printer is on and ready or
        PrtIntegState=2          _  're-set the Printer Watchdog to monitoring
     '
     return                         'Return to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'OPEN THE PRINT SPOOL FILE & PRINT REPORT TITLE
     '
SetUpReport:
     x$=BlankLine$+BlankLine$+BlankLine$+BlankLine$+BlankLine$+BlankLine$
     PrStr$=pp$(2)    _             'Reset printer & set to draft mode
           +pp$(5)    _             'and to Landscape mode
           +pp$(7)+x$ _             'Switch printer to 8.25 chrs/inch
           +"E.B.S. MARKETEER - STATISTICS REPORT - "_
           +sd$+NewLine$   _
           +BlankLine$_
           +BlankLine$_
           +pp$(6)+"|"              'Switch printer to 16.5 chrs/inch
     '
     '-------------------------------------------------------------------------
     'COLUMN HEADINGS
     '
     for k=0 to 5
     x$=Keyvs$(k,0):PrStr$=PrStr$+" "+x$+space$(19-len(x$))+"Prospects |"
     next
     '
     x$=Keyvs$(6,0)
     PrStr$=PrStr$_
           +" "+x$+space$(19-len(x$))+"Addresses |"+NewLine$_
           +"|                              |"_
           +"                              |                              |"_
           +"                              |                              |"_
           +"                              |                              |"_
           +NewLine$
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'PRINT NAME, QUANTITY & PERCENTAGE FOR ONE KEY VALUE 
     '
     ProspCount=0                  'Subroutine control
     for KeyValue=1 to 18          '18 rows
     PrStr$=PrStr$+"|"
     for KeyType =0 to  6          ' 7 keys
     '
     x$=Keyvs$(KeyType,KeyValue)
     y=StatsCount%(KeyType,KeyValue):y$=str$(y)
     if KeyType=0 then ProspCount=ProspCount+y
     gosub CalcPercent
     if KeyType=6 then y$=y$+"k" 
     '
     x$=left$(x$,16)
     '
     PrStr$=PrStr$_                      '
           +" "   _                      '
           +x$    _                      '
           +space$(23-len(x$)-len(y$))_  '
           +y$    _                      '
           +space$(4-len(z$))_           '
           +z$    _                      '
           +"% |"                        '
     '
     next
     PrStr$=PrStr$+NewLine$
     next
     PrStr$=PrStr$+BlankLine$
     '
     '-------------------------------------------------------------------------
     'FOOTNOTES
     '
     if ProspCount<i.max _
        then x$=str$(i.max-ProspCount):_
             x$=right$(x$,len(x$)-1):_
             PrStr$=PrStr$+x$+" addresses are unpostcoded."+BlankLine$
     '
     PrStr$=PrStr$_
     +"Prospects = number of prospects currently on file having"_
     +" each respective value of the key concerned"+NewLine$         _
     +space$(10)+"+ this expressed as a percentage of the"+str$(i.max)_
     +" prospects CURRENTLY ON FILE."+NewLine$+BlankLine$
     '
     PrStr$=PrStr$_
     +"Addresses = the number of postal addresses contained in each"_
     +" respective "+Keyvs$(0,0)+". (`k' means `times 1000')"+NewLine$_
     +"          + this expressed as a percentage of the"+str$(TotPop)_
     +"000 addresses in the United Kingdom."+NewLine$_
     +chr$(12) _           'Throw page
     +pp$(4)  _            'Switch printer back to 10 chrs/inch
     +pp$(3)               'Reset printer to default configuration.
ResetNums:
     PageNum=1                 'Current page number
     PageLineNum =0            'N of lines printed so far on this page
     BlockLineNum=0            'N of lines printed so far in this 5-line block
     return
     '
     '-------------------------------------------------------------------------
     'PERCENTAGE CALCULATION
     '
CalcPercent:
     if KeyType=6 then           '
        a!=TotPop                '
   else a!=i.max                 '
        end if
     if a!=0 then                '
        y=0                      '
   else alpha!=y                 '
        alpha!=100*alpha!/a!     '
        y=int(alpha!)            '
        end if
     z$=str$(y):return
     '
     '-------------------------------------------------------------------------
     '
