





     '-------------------------------------------------------------------------
     'GET/PUT TARGET DEFINITIONS            02JAN87        [File: TARGDEFS.BAS]
     '-------------------------------------------------------------------------
     'TargDef$ - filespec of the target definitions file
     'TargNum  - number of the target required [range 1 to 20]
     'TargNum$ - in leading zero string form
     '
     'Target File's Record Structure:
     '
     'TargStat$  *   SIC                Which of the 10 keys restrict target pr
     '           *   Sales Area
     '           *   Relation
     '           *   Status
     '           *   Product
     '           *   Codes
     '           *   Last Event
     '           *   Next Event
     '           *   Last Dates
     '           *   Next Dates
'    Dim sic$(18) '111122221111222211112222111122221111   18 x 4-digit
     '             111122221111222211112222111122221111   SIC Numbers
'    Dim key$( 5) 'ABCDEFGHIJKLMNOPQR     Selected Sales Areas
     '             ABCDEFGHIJKLMNOPQR     Selected Relation Values
     '             ABCDEFGHIJKLMNOPQR     Selected Status Values
     '             ABCDEFGHIJKLMNOPQR     Selected Products
     '             ABCDEFGHIJKLMNOPQR     Selected Last Events
     '             ABCDEFGHIJKLMNOPQR     Selected Next Events
'    Dim tme(8)    999      last event    past cut-off limit (days from today)
     '             999          "       future cut-off limit (days from today)
     '             999      next event    past cut-off limit (days from today)
     '             999          "       future cut-off limit (days from today)
     '             1        last event    past cut off limit in effect flag
     '             1            "       future cut-off limit in effect flag
     '             1        next event    past cut off limit in effect flag
     '             1            "       future cut-off limit in effect flag
'    Dim cde$(18) '****************  
     '             ****************       Asterisks on one line represent code
     '             ****************       values of all of which must be held
     '             ****************       by a member of the target group
     '             ****************       logically ANDed. A space indicates a
     '             ****************       code character position which is 
     '             ****************       ignored (imposes no restriction).
     '             ****************       Code values in the same `column' are
     '             ****************       logically ORed.
     '             ................
     '             ****************  
     'TargDate$ _hh:mm am DD MMM YY   Date target def. last updated
     'ListDate$ _hh:mm am DD MMM YY   Date target list last updated
     'SeqTyp     9                    List sequence type 1-9
     'PostZone$  AAAA                 Post code restrictor
     'TargName$                       Name of the Target Profile
     'ExtrFlag   Set to current Target List Serial N if latest Def extracted
     'PrntFlag   Set to 1 if current target list printed
     '     
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'LOAD THE TARGET DEFINITION
     '
     'This routine loads the Target Profile specification, for Target Number
     'held in TargNum, into the set of variables and arrays defined above.
     '
GetTarg:
     FileNum=1:gosub OpenFile          'Open the Target Profiles file
     get#1,TargNum                     'Get appropriate Target Record
     TargStat$=input$(10,1)            '* marks which keys have restrictions
     '
     for k=1 to 18:x$=input$(4,1):gosub GetTarg2:sic$(k)=x$:next  'Get SICs
     '
     '-------------------------------------------------------------------------
     'LOAD & VALIDATE THE KEY SELECTIONS
     '
     for k=0 to  5                      'For each key type
     y$=""           'Clear string for current key-type's `accepted selections'
     for j=1 to 18   'For each selection character in the 18-character field
     x$=input$(1,1)                     'Get [next] character
     if x$>"@" and x$<"S" then y$=y$+x$ 'If character within `A to R' range,
                                        'add it to `accepted selections' string
     next                               'next character
     key$(k)=y$                         'Store complete valid selections
     next                               'Next key-type
     '
     '-------------------------------------------------------------------------
     '
     for k=1 to  8:tme(k)=cvi(input$(2,1)):next  'Get time restrictions
     for k=1 to 18:x$=input$(16,1):gosub GetTarg2:cde$(k)=x$:next  'Codes
     '
     TargDate$=input$(19,1)            'Get date target def. was last amended
     ListDate$=input$(19,1)            'Get date target list was last amended
     SeqTyp=cvi(input$(2,1))           'List sequence type 1-9
     if SeqTyp<1 or SeqTyp>6 then SeqTyp=2
     PostZone$=input$(4,1)             'Post Area limitation [not used yet]
     TargName$=input$(14,1)            'Target Profile's Name
     close
     goto GetTarg1                     'Get Target List status
     '
     '-------------------------------------------------------------------------
     '
GetTarg2:                                        'Replace any null or control
     x=len(x$):for j=1 to x                      'characters raked up from the
     if mid$(x$,j,1)<" " then mid$(x$,j,1)=" "   'disk by space characters to
     next:return                                 'avoid formatting & editing
                                                 'upsets later on.
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'MARK KEYS WHICH IMPOSE RESTRICTIONS TO THIS TARGET PROFILE
     '
PutTarg:
     TargStat$=space$(10)
     x= 1:for k=1 to 18:if Sic$(k)>"    " then gosub PutTarg1
          next
     x= 2:if key$(0)>"" then gosub PutTarg1   'Sales Area
     x= 3:if key$(1)>"" then gosub PutTarg1   'Relation
     x= 4:if key$(2)>"" then gosub PutTarg1   'Status
     x= 5:if key$(3)>"" then gosub PutTarg1   'Products
     x= 6:for k=1 to 18:if cde$(k)>space$(16) then gosub PutTarg1   'Codes
          next
     x= 7:if key$(4)>space$(18) then gosub PutTarg1   'Last Event
     x= 8:if key$(5)>space$(18) then gosub PutTarg1   'Next Event
     x= 9:if tme(5)=1 or tme(6)=1 then gosub PutTarg1 'Last event time limits
     x=10:if tme(7)=1 or tme(8)=1 then gosub PutTarg1 'Next event time limits
     goto PutTarg2
     '
PutTarg1: mid$(TargStat$,x,1)="*":return
     '
     '-------------------------------------------------------------------------
     'STORE THE TARGET DEFINITION
     '
PutTarg2:
     FileNum=1:gosub OpenFile               'Open the Target Definitions file
     x=10:x$=TargStat$:gosub PutTarg3        '* marks restricting keys
     '
     x= 4:for k=1 to 18:x$=sic$(k):gosub PutTarg3:next  'Put SIC numbers
     x=18:for k=0 to  5:x$=key$(k):gosub PutTarg3:next  'Put Key restrictions
          for k=1 to  8:print#1,mki$(tme(k));:   next  'Put time restrictions
     x=16:for k=1 to 18:x$=cde$(k):gosub PutTarg3:next  'Put code restrictions
     print#1,TargDate$;                                'Target Profile date
     print#1,ListDate$;                                'Target List date
     print#1,mki$(SeqTyp);                             'List sequence type 1-9
     x= 4:X$=PostZone$:gosub PutTarg3
     x=14:x$=TargName$:gosub PutTarg3
     put#1,TargNum:close:goto PutTarg4
     '
PutTarg3:
     if len(x$)<x then x$=x$+space$(x-len(x$))
     if len(x$)>x then x$=left$(x$,x)
     print#1,x$;:return
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'LOAD THE LATEST TARGET LISTS PARAMETERS
     '
GetTarg1:
     FileNum=2:gosub OpenFile
     get#2,1
     TargSize=cvi(s1$)         'Number of prospects in this Target List
     FileSize=cvi(s2$)         'Total extent of database indexes
     ExtrFlag=cvi(s3$)         '0 is latest version not extracted TP?
     PrntFlag=cvi(s4$)         'Latest target list printed?
     close:return
     '
     '-------------------------------------------------------------------------
     'SAVE THE LATEST TARGET LISTS PARAMETERS
     '
PutTarg4:
     FileNum=2:gosub OpenFile
     Lset s1$=mki$(TargSize)    'Number of prospects on this Target List
     Lset s2$=mki$(FileSize)    'Total number of prospects on file
     Lset s3$=mki$(ExtrFlag)    '0 if latest version not yet extracted
     Lset s4$=mki$(PrntFlag)    'Latest target list printed?
     put#2,1:close:return
     '
     '-------------------------------------------------------------------------
     'FILE OPEN/FIELD SPECS FOR THE OPENFILE SUBROUTINE
     '
File1: open TargFile$ as #1 len=560:goto FileOpen
File2: x$=str$(TargNum):x$=right$(x$,len(x$)-1):if len(x$)=1 then x$="0"+x$
       TargList$=TargFile$+x$
       open TargList$ as #2 len=  8
       field#2,2 as s1$,2 as s2$,2 as s3$,2 as s4$:goto FileOpen
File3: goto FileOpen
File4: goto FileOpen
File5: goto FileOpen  'Dummy file entries required by OErrHdlr.bas
File6: goto FileOpen
File7: goto FileOpen
File8: goto FileOpen
File9: goto FileOpen
     '
FatalError:
     return       'Normal return [hard luck that no data is displayed]
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'GET & PUT TARGET NAMES
     '
     '[TargName$(0) contains currently selected Target as a letter `A thru R']
     '
     'Although the name of each target is kept in the appropriate Target
     'Definition record [1 thru 18], all the target names are kept together
     'in Record #19 so that they can be quickly accesses for display by the
     'routines which select which target is to be used to generate a mailling
     'list, telephone calling list or telexshot transmission list.
     '
     'The TargListSerNum variable contains the universal target serial number
     'which is updated each time a new target list is EXTRACTED. This number
     'is also placed in the ExtrFlag field in the first record of the
     'respective target list file.
     '
GetTargNames:
     FileNum=1:gosub OpenFile
     get#1,19
     TargListSerNum=cvi(input$(2,1))     'Serial number of latest target list
     for k=0 to 18
     x=cvi(input$(2,1))
     if x<1 or x>14 then x$="" else x$=input$(x,1)
     TargNames$(k)=x$
     next:close:return
     '
PutTargNames:
     FileNum=1:gosub OpenFile
     print#1,mki$(TargListSerNum);       'Serial number of latest target list
     for k=0 to 18
     x$=TargNames$(k)
     x=len(x$)
     print#1,mki$(x)x$;
     next:put#1,19:close:return
     '
     '-------------------------------------------------------------------------
     '
