





     'E.B.S. ENCRYPTION ALGORITHM              28JUL87             Texcrypt.BAS


     'Author : R J Morton

     'This subroutine translates an encrypted literal into plain text.
     'Its main use is to safeguard literals such as authorship & copyright
     'notices and cut off dates from being changed by direct byte replacement
     'in EXE files by software pirates.

     'PlainText$
     'Scrambled$


     'DE-CRYPT AN ENCRYPTED LITERAL

TextEncrypt:

     NumChars=len(PlainText$)           'N of characters to be encrypted
     Scrambled$=space$(NumChars)        'blank string to received de-cryption
     for CharNum=1 to NumChars          'For each character of input string...
     '
     ThisChar_
     =asc(mid$(PlainText$,CharNum,1))   'ASCII value of encrypted character
     if ThisChar=32 then ThisChar=94    'Hide the space character by shift
     ThisChar=ThisChar               _
             -NumChars               _  'plus total N of characters in line
             +CharNum                _  'minus position of character in line
             +23                        'minus Arbitrary Constant (23) - 31
     '
     if ThisChar>254 then ThisChar=ThisChar-223  'Rotate ASCII value so it stays
     if ThisChar< 32 then ThisChar=223+ThisChar  'in range 1 to 224 inclusive.
     mid$(Scrambled$,CharNum,1)=chr$(ThisChar)   'Add encrypted char to output string
     next:return                           'Return to calling program


     'DE-CRYPT AN ENCRYPTED LITERAL

TextDecrypt:

     NumChars=len(Scrambled$)           'N of characters to be encrypted
     PlainText$=space$(NumChars)        'blank string to received de-cryption
     for CharNum=1 to NumChars          'For each character of input string...
     '
     ThisChar_
     =asc(mid$(Scrambled$,CharNum,1))_  'ASCII value of encrypted character
     +NumChars                       _  'plus total N of characters in line
     -CharNum                        _  'minus position of character in line
     -23                                'minus Arbitrary Constant (23) - 31
     '
     if ThisChar>254 then ThisChar=ThisChar-223  'Rotate ASCII value so it stays
     if ThisChar< 32 then ThisChar=223+ThisChar  'in range 1 to 224 inclusive.
     if ThisChar=94 then ThisChar=32             'Move hidden space character back
     mid$(PlainText$,CharNum,1)=chr$(ThisChar)   'Add de-crypted char to output string
     next:return                        'Return to calling program

