






     '-------------------------------------------------------------------------
     'TERMINAL MENU      Author : R J Morton    23FEB87         File: Tmenu.BAS
     '-------------------------------------------------------------------------
     'This is the menu from which access is gained to all the Communications
     'Terminal function modules.
     '-------------------------------------------------------------------------
     DefInt a-z
     rem $include: 'ComVars.INC'
     common EMS$                'Name of selected Electronic Mail Service
     common EMS                 'Its menu list number
     common EM
     dim menu$(9)
     dim emsl$(10)              'Electronic mail service names
     dim emsd$(10)              'Electronic mail service data
     dim tty$(31)               'Teletype control code mnemonics
     dim values$(18)
     ManChap=11                 'ManualChapter
     MenuHelp=1                 'Help texts available
     goto Tmenu1
     '
     '-------------------------------------------------------------------------
     'EXTERNAL SUBROUTINES
     '
     rem $include: 'GenMenu.INC'
     rem $include: 'InChar.INC'
     rem $include: 'GetEMSL.INC'
     rem $include: 'OpenFile.INC' 
     rem $include: 'Expiry.INC'
     rem $include: 'Decrypt.INC'
     rem $include: 'Manual.FMM'
     rem $include: 'Select.FMM'
     rem $include: 'OpenFile.FMM'
     rem $include: 'KeyBoard.FMM'
     '
Display: row=row+1
50   call ScrSub(ps$,row,column,colour):return
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'COMMUNICATIONS MENU
     '
Tmenu1:
     gosub GetEMSL      'Load the Comms Services names
     EMS = 0            'These are set automatically by GetEmsl to the service
     EMS$=""            'currently selected for automatic electronic mailshots
     '
     row=1:column=19:colour=7:ps$=top$+space$(37-len(top$)):gosub 50
     row=2:column=58:colour=7:ps$=space$(23):gosub 50
     row=3:column= 1:ps$=space$(80):gosub 50
     '
     AlphaChoice=s      'Number of alphabetically annotated choices in menu box
     '
     menu$   =top$                               'Menu title
     menu$(1)="Electronic Mail & Telex"
     menu$(2)="Communication Terminal"
     menu$(3)="Received Messages Library"
     menu$(4)="Communications Services"
     menu$(5)="Services Protocol Macros"
     menu$(6)="Services Subscriber Details"
     menu$(7)="Modem Control Information"
     '
     menu=7             'Number of valid options
     MPos=1             'Display menu in left half of screen
     gosub ExpiryTest
     prog$="TMENU"
     gosub MenuHelp0
Tmenu2:
     Caps=1:gosub ShowMenu:Caps=0
     '
     if ManualState=1 then
        while ManualState<8
        gosub Keyboard
        gosub Manual
        wend
        gosub MenuHelp0
        goto Tmenu2
        end if
     ' 
     if lop>0 then          
        EMS=lop                    'Number of selected service
        EMS$=EMSL$(lop)            'Name of selected service
        chain"Terminal"            'proceed to the terminal module.
        end if
     '
     if op=1 then    chain"Emenu"
     if op=2 then    chain"Terminal"
     if op=3 then    chain"RXlib"
     if op=4 then    chain"EdComms"
     if op=5 then    chain"Macros"
     if op=6 then    chain"EMSD"
     if op=7 then    chain"EdModem"
     '
     chain"Menu"
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'COMMUNICATIONS SERVICES DISPLAY BOX
     '
MenuHelp0: row=3:column=41:colour=grey
     '
     ps$="                                        ":gosub Display
     ps$="     Ŀ      ":gosub Display
     ps$="       COMMUNICATIONS SERVICES        ":gosub Display
     ps$="     Ĵ      ":gosub Display
     ps$="      A                               ":gosub Display
     ps$="      B                               ":gosub Display
     ps$="      C                               ":gosub Display
     ps$="      D                               ":gosub Display
     ps$="      E                               ":gosub Display
     ps$="      F                               ":gosub Display
     ps$="      G                               ":gosub Display
     ps$="      H                               ":gosub Display
     ps$="      I                               ":gosub Display
     ps$="           ":gosub Display
     colour=2
     ps$="  Alternatively, please type in the     ":gosub Display
     ps$="  letter of the communications service  ":gosub Display
     ps$="  you wish to automatically log on to.  ":gosub Display
     ps$="                                        ":gosub Display
     ps$="      Press Home to get User Manual     ":gosub Display
     ps$="       Press  keys to access the      ":gosub Display
     ps$="        help texts for this menu.       ":gosub Display
     colour=10
     row=22:column=53:ps$="Home":gosub 50
     row=23:column=54:ps$="":gosub 50
     ps$="COMMUNICATIONS SERVICES"
     row = 6 : column = 49 : colour = 14 : gosub 50
     '
     for k=1 to s                                  'Display the names of
     row=7+k                                       'the available comms
     column=48:ps$=chr$(k+64):gosub 50   'services onto which
     column=51:ps$=emsl$(k)  :gosub 50   'you can auto logon.
     next:return
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'MENU HELP TEXT
     '
MenuHelp1:
     '
     ps$="                                        ":row= 4:gosub 50
     ps$=" Allows you to:                         ":row= 5:gosub 50
     ps$="                                        ":row= 6:gosub 50
     ps$="  -send messages by telex or electronic ":row= 7:gosub 50
     ps$="   mail to single individuals or to the ":row= 8:gosub 50
     ps$="   addressees on a telexshot list.      ":row= 9:gosub 50
     ps$="                                        ":row=10:gosub 50
     ps$="  -print a telex shot report giving the ":row=11:gosub 50
     ps$="   text of the message sent and a list  ":row=12:gosub 50
     ps$="   of addressees to whom it was sent.   ":row=13:gosub 50
     ps$="                                        ":row=14:gosub 50
     ps$="  -select the electronic mail service   ":row=15:gosub 50
     ps$="   you wish to be used for sending      ":row=16:gosub 50
     ps$="   telex & electronic mail messages     ":row=17:gosub 50
     ps$="   out of the services avaliable to     ":row=18:gosub 50
     ps$="   which you subscribe.                 ":row=19:gosub 50
     ps$="                                        ":row=20:gosub 50
     ps$="  -View the format in which prospects'  ":row=21:gosub 50
     ps$="   electronic mailbox and telex numbers ":row=22:gosub 50
     ps$="   should be entered on the Telex N    ":row=23:gosub 50
     ps$="   line in his name & address box.      ":row=24:goto  50
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'MENU HELP TEXT
     '
MenuHelp2:
     '
     ps$="                                        ":row= 4:gosub 50
     ps$=" Activates Marketeer's communications   ":row= 5:gosub 50
     ps$=" terminal which allows you to:          ":row= 6:gosub 50
     ps$="                                        ":row= 7:gosub 50
     ps$="  -type in a telephone N to auto-dial  ":row= 8:gosub 50
     ps$="   a communications service with which  ":row= 9:gosub 50
     ps$="   you may then converse manually via   ":row=10:gosub 50
     ps$="   the keyboard.                        ":row=11:gosub 50
     ps$="                                        ":row=12:gosub 50
     ps$="  -transmit the message which you have  ":row=13:gosub 50
     ps$="   previously set up for transmission   ":row=14:gosub 50
     ps$="   using option 3 of the Main Menu.     ":row=15:gosub 50
     ps$="                                        ":row=16:gosub 50
     ps$="  -receive incoming data into a message ":row=17:gosub 50
     ps$="   file which is automatically placed   ":row=18:gosub 50
     ps$="   in the received messages library.    ":row=19:gosub 50
     ps$="                                        ":row=20:gosub 50
     ps$="  -print incoming and outgoing data.    ":row=21:gosub 50
     ps$="                                        ":row=22:gosub 50
     ps$=" You can logon to a service automatic-  ":row=23:gosub 50
     ps$=" ally by hitting the appropriate letter ":row=24:goto  50
     '
MenuHelp3:
     '
     ps$="                                        ":row= 4:gosub 50
     ps$=" The Received Messages Library holds    ":row= 5:gosub 50
     ps$=" upto 40 messages which have been       ":row= 6:gosub 50
     ps$=" received via the terminal from the     ":row= 7:gosub 50
     ps$=" telephone line.                        ":row= 8:gosub 50
     ps$="                                        ":row= 9:gosub 50
     ps$=" This option allows you to:             ":row=10:gosub 50
     ps$="                                        ":row=11:gosub 50
     ps$=" -select and view any message currently ":row=12:gosub 50
     ps$="  held in the library for display in a  ":row=13:gosub 50
     ps$="  viewing window on the screen. The     ":row=14:gosub 50
     ps$="  text of the message may be scrolled   ":row=15:gosub 50
     ps$="  up and down in the viewing window.    ":row=16:gosub 50
     ps$="                                        ":row=17:gosub 50
     ps$=" -print the message currently in view   ":row=18:gosub 50
     ps$="  on the draft printer.                 ":row=19:gosub 50
     ps$="                                        ":row=20:gosub 50
     ps$=" -delete a message from the library. A  ":row=21:gosub 50
     ps$="  message may only be deleted once it   ":row=22:gosub 50
     ps$="  has been printed.                     ":row=23:gosub 50
     ps$="                                        ":row=24:goto  50
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'MENU HELP TEXT
     '
MenuHelp4:
     '
     ps$="                                        ":row= 4:gosub 50
     ps$="                                        ":row= 5:gosub 50
     ps$="                                        ":row= 6:gosub 50
     ps$="                                        ":row= 7:gosub 50
     ps$="                                        ":row= 8:gosub 50
     ps$=" Allows you to enter, edit or delete    ":row= 9:gosub 50
     ps$=" the names of the communications        ":row=10:gosub 50
     ps$=" services to which you subscribe.       ":row=11:gosub 50
     ps$="                                        ":row=12:gosub 50
     ps$="                                        ":row=13:gosub 50
     ps$="                                        ":row=14:gosub 50
     ps$="                                        ":row=15:gosub 50
     ps$="                                        ":row=16:gosub 50
     ps$="                                        ":row=17:gosub 50
     ps$="                                        ":row=18:gosub 50
     ps$="                                        ":row=19:gosub 50
     ps$="                                        ":row=20:gosub 50
     ps$="                                        ":row=21:gosub 50
     ps$="                                        ":row=22:gosub 50
     ps$="                                        ":row=23:gosub 50
     ps$="                                        ":row=24:goto  50
     '
MenuHelp5:
     '
     ps$=" Allows you to enter the communications ":row= 4:gosub 50
     ps$=" protocols for each of the communica-   ":row= 5:gosub 50
     ps$=" tions services to which you subscribe. ":row= 6:gosub 50
     ps$="                                        ":row= 7:gosub 50
     ps$=" A communications protocol is a series  ":row= 8:gosub 50
     ps$=" of prompts and responses through which ":row= 9:gosub 50
     ps$=" a user converses with a communications ":row=10:gosub 50
     ps$=" service. Marketeer accepts protocols   ":row=11:gosub 50
     ps$=" of up to 10 lines. Each line comprises ":row=12:gosub 50
     ps$=" a PROMPT expected to be received from  ":row=13:gosub 50
     ps$=" the communications service on the left ":row=14:gosub 50
     ps$=" and the corresponding RESPONSE which   ":row=15:gosub 50
     ps$=" the service expects back on the right. ":row=16:gosub 50
     ps$="                                        ":row=17:gosub 50
     ps$=" Lines 1 to 4 of a protocol contain the ":row=19:gosub 50
     ps$=" logon procedure, lines 5 to 9 contain  ":row=18:gosub 50
     ps$=" the procedure for sending each single  ":row=20:gosub 50
     ps$=" message and line 10 contains the       ":row=21:gosub 50
     ps$=" log-off procedure. See each service's  ":row=22:gosub 50
     ps$=" user guide for details of the appropr- ":row=23:gosub 50
     ps$=" iate protocol.                         ":row=24:goto  50
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'MENU HELP TEXT
     '
MenuHelp6:
     '
     ps$="                                        ":row= 4:gosub 50
     ps$="                                        ":row= 5:gosub 50
     ps$="                                        ":row= 6:gosub 50
     ps$="                                        ":row= 7:gosub 50
     ps$="                                        ":row= 8:gosub 50
     ps$="                                        ":row= 9:gosub 50
     ps$=" Allows you to enter your subscriber    ":row=10:gosub 50
     ps$=" data for each of the communications    ":row=11:gosub 50
     ps$=" services to which you subscribe. These ":row=12:gosub 50
     ps$=" details are issued to you by the prop- ":row=13:gosub 50
     ps$=" rietors of a communications service    ":row=14:gosub 50
     ps$=" when you become a subscriber.          ":row=15:gosub 50
     ps$="                                        ":row=16:gosub 50
     ps$="                                        ":row=17:gosub 50
     ps$="                                        ":row=18:gosub 50
     ps$="                                        ":row=19:gosub 50
     ps$="                                        ":row=20:gosub 50
     ps$="                                        ":row=21:gosub 50
     ps$="                                        ":row=22:gosub 50
     ps$="                                        ":row=23:gosub 50
     ps$="                                        ":row=24:goto  50
     '
MenuHelp7:
     '
     ps$="                                        ":row= 4:gosub 50
     ps$="                                        ":row= 5:gosub 50
     ps$="                                        ":row= 6:gosub 50
     ps$="                                        ":row= 7:gosub 50
     ps$="                                        ":row= 8:gosub 50
     ps$="                                        ":row= 9:gosub 50
     ps$="                                        ":row=10:gosub 50
     ps$=" Allows you to enter the modem control  ":row=11:gosub 50
     ps$=" data to suit the transmission mode of  ":row=12:gosub 50
     ps$=" the communications service you are     ":row=13:gosub 50
     ps$=" currently using and any special data   ":row=14:gosub 50
     ps$=" needed for operating through a PABX.   ":row=15:gosub 50
     ps$="                                        ":row=16:gosub 50
     ps$="                                        ":row=17:gosub 50
     ps$="                                        ":row=18:gosub 50
     ps$="                                        ":row=19:gosub 50
     ps$="                                        ":row=20:gosub 50
     ps$="                                        ":row=21:gosub 50
     ps$="                                        ":row=22:gosub 50
     ps$="                                        ":row=23:gosub 50
     ps$="                                        ":row=24:goto  50
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'MENU HELP TEXT
     '
MenuHelp8:
     '
     ps$="                                        ":row= 4:gosub 50
     ps$="                                        ":row= 5:gosub 50
     ps$="                                        ":row= 6:gosub 50
     ps$="                                        ":row= 7:gosub 50
     ps$="                                        ":row= 8:gosub 50
     ps$="                                        ":row= 9:gosub 50
     ps$="                                        ":row=10:gosub 50
     ps$="                                        ":row=11:gosub 50
     ps$="                                        ":row=12:gosub 50
     ps$="                                        ":row=13:gosub 50
     ps$="                                        ":row=14:gosub 50
     ps$="                                        ":row=15:gosub 50
     ps$="                                        ":row=16:gosub 50
     ps$="                                        ":row=17:gosub 50
     ps$="                                        ":row=18:gosub 50
     ps$="                                        ":row=19:gosub 50
     ps$="                                        ":row=20:gosub 50
     ps$="                                        ":row=21:gosub 50
     ps$="                                        ":row=22:gosub 50
     ps$="                                        ":row=23:gosub 50
     ps$="                                        ":row=24:goto  50
     '
MenuHelp9:
     '
     ps$="                                        ":row= 4:gosub 50
     ps$="                                        ":row= 5:gosub 50
     ps$="                                        ":row= 6:gosub 50
     ps$="                                        ":row= 7:gosub 50
     ps$="                                        ":row= 8:gosub 50
     ps$="                                        ":row= 9:gosub 50
     ps$="                                        ":row=10:gosub 50
     ps$="                                        ":row=11:gosub 50
     ps$="                                        ":row=12:gosub 50
     ps$="                                        ":row=13:gosub 50
     ps$="                                        ":row=14:gosub 50
     ps$="                                        ":row=15:gosub 50
     ps$="                                        ":row=16:gosub 50
     ps$="                                        ":row=17:gosub 50
     ps$="                                        ":row=18:gosub 50
     ps$="                                        ":row=19:gosub 50
     ps$="                                        ":row=20:gosub 50
     ps$="                                        ":row=21:gosub 50
     ps$="                                        ":row=22:gosub 50
     ps$="                                        ":row=23:gosub 50
     ps$="                                        ":row=24:goto  50
     '
     '-------------------------------------------------------------------------
     '
