





     'POSTCODE VALIDATION         08DEC86                  [File: VALIPOST.BAS]
     '
     'Inputs  PC$ - the 8-character postcode string
     '        Invalid   - Set =1 if postcode has been amended
     '
     'Checks the UK post code for correct format & content. Does not check
     'that the presented postcode actually exists geographically.
     '
     'RATIONALIZATION AND VALIDATION ROUTINE
     '
ValidatePostcode:
     invalid=0                             'Clear the invalidity flag
     row=12:column=11:colour=23            'Set display co-ordinates
     PC$=left$(rec$(7),8)                  'Get POSTCODE
     PC$=PC$+space$(8-len(PC$))            'Set postcode into 8-characters bed
     if PC$=space$(8) then return          'Exit if address unpostcoded
     CharCol=1:h=2:gosub ValidatePostcode2
     x=asc(mid$(PC$,2,1))                  'Get the second character
     if x>32 and x<65 then                 'If the 2nd character is a number
        PC$=left$(PC$,1)+" "+mid$(PC$,2,6) 'insert a space after the first chr
        end if
     CharCol=2:h=2:gosub ValidatePostcode2
     CharCol=3:h=1:gosub ValidatePostcode2
     if x>32 then                          'If current chr not a space
        if mid$(PC$,4,1)=" " or         _  'If the 4th character is a space
           mid$(PC$,5,1)>"@" then       _  'or the 5th character is a letter
           PC$=left$(PC$,2)+"0"         _  'then insert a zero immediately
              +mid$(PC$,3,5)               'after first 2 letters of postcode
        end if
     CharCol=4:h=3:gosub ValidatePostcode2
     if mid$(PC$,5,1)>" " then             'If 5th character is not a space
        PC$=left$(PC$,4)+" "+mid$(PC$,5,3) 'then add a space immediately after
        end if                             'first 4 characters of postcode.
     CharCol=6:h=1:gosub ValidatePostcode2
     CharCol=7:h=2:gosub ValidatePostcode2
     CharCol=8:h=2:gosub ValidatePostcode2
     ps$=PC$:gosub 50                      'Re-display the postcode
     gosub ShowPostMsg                     'Re-display the original text
     rec$(7)=PC$:return
     '
     '
     'VALIDATION SUBROUTINE
     '
ValidatePostcode2:
     x=asc(mid$(PC$,CharCol,1))         'Get CHARCOLth chr of postcode
     if x=32 then return
     if h=1 and x=79 then mid$(PC$,CharCol,1)="0":return  'If O put 0
     if x>47 and x<58 and (h=1 or h=3) then return
     if x>64 and x<91 and (h=2 or h=3) then return
     return ValidatePostcode3
ValidatePostcode3:
     ps$=PC$:gosub 50:colour=28         'Display rationalized postcode
     column=10+CharCol:ps$=chr$(x):gosub 50 'Highlight offending character
     if h=1 then ps$="Must be a number"
     if h=2 then ps$="Must be a letter"
     if h=3 then ps$="Number or letter"
     column=20:colour=71:gosub 50:sound 3300,1  'Display error message
     rec$(7)=PC$                        'Put rationalized postcode in array
     invalid=1:return                   'Set `postcode invalid' flag

