     'START (LOGON)             12 DEC 1986                   [File: START.BAS]

     'Author: R J Morton

     'NOTE: Compile this module QB START/C:4096/E/Q; to set up a 4k COM buffer
     'because this is always the first module to be run. No other module (incl-
     'uding the modules handling comms) needs be compiled with the C switch.

     'Displays logo and accepts password. Stores system date as date last used.
     'Puts day of week in display system date. Set up all generic file names as
     'common variables for all the other programs.


     'INITIALIZATION

     defint a-z
     rem $include: 'ComVars.INC'
     dim rec$(12)                 'To avoid `undefined' error from ELAPSED.BAS
     dim pp$(20)                  'for loading the View File path/filename
     screen 0:width 80
     locate 1,31:locate,,1
     ps$="E.B.S. MARKETEER: Initialising":row=1:column=1:colour=7:gosub 50
     rem $include: 'ErrMsgs.INC'
     locate,,0

     prog$="START"             'Tell Menu where it received control from
     Grey=8                    'Set grey as grey or green {not implemented yet}
     RecsFileNum=1             'Buffer N under which the Pass File in opened
     MaxRecNum=32765           'Set default database size to 32,765 records
  '  out &H3E0,43              'Enable on-board modem (used in ADM8 only)


     'STANDARD ABBREVIATIONS FOR MONTH NAMES AND DAY NAMES

     dim MonthName$(12):dim WeekDay$(7)
     MonthName$( 1)="JAN":MonthName$( 2)="FEB":MonthName$( 3)="MAR"
     MonthName$( 4)="APR":MonthName$( 5)="MAY":MonthName$( 6)="JUN"
     MonthName$( 7)="JUL":MonthName$( 8)="AUG":MonthName$( 9)="SEP"
     MonthName$(10)="OCT":MonthName$(11)="NOV":MonthName$(12)="DEC"

     WeekDay$(1)="SUN":WeekDay$(2)="MON":WeekDay$(3)="TUE":WeekDay$(4)="WED"
     WeekDay$(5)="THU":WeekDay$(6)="FRI":WeekDay$(7)="SAT"

     DosRow=3:DosCol=1            'Error message co-ordinates

     c$ = COMMAND$                'Pick up the arguments from the command line
     L = len(c$)                  'Total length of the command line
     m = (L / 2) + 1              'maximum possible number of arguments
     dim arg$(m)                  'dynamic since dimensioned with a variable
     i = 1                        'character counter
     n = 0                        'number of command line arguments
     f = 0                        'set flag = outside an argument
     while i <= L                 'while chr number <= length of command line
	x$ = mid$(c$,i,1)         'extract the i th character
	if x$ = " " then          'if it is a space character
	   if f = 1 then          'if we were inside an argument
	      f = 0               'set flag = outside an argument
	      n = n + 1           'move up to next argument in the array
	   end if
	else                      'else if it is a non-space character
	   f = 1                  'set flag = inside an argument
	   arg$(n) = arg$(n) + x$ 'add the character to the argument
	end if
	i = i + 1                 'move to the next character
     wend
     goto Start


     'EXTERNAL SUBROUTINE CALLS & OVERLAYS

50   call ScrSub(ps$,row,column,colour):return

     rem $include: 'Elapsed.INC'
     rem $include: 'Decrypt.INC'
     rem $include: 'GrafChar.INC'        'Included as flack!
     rem $include: 'Expiry.INC'
     rem $include: 'Keyboard.FMM'
     rem $include: 'OpenFile.FMM'
     rem $include: 'GetPrt.FMM'

     '







     'MULTI-USER PARTITION DEFINITIONS

Start:
     EXE$=""                          'Executable files directory
     FIX$=EXE$                        'Fixed data files directory
     MAN$=EXE$                        'User Manual chapters directory
     x$ = arg$(0)                     'First command argument
     SHA$=x$+"\SHARED\"               'Shared data directory
     y$ = arg$(1)                     'Second command argument
     if y$ = "" then y$ = x$          'Use first path if second is null
     USR$=y$+"\USER01\"               'Private user data directory


     'FILENAME VARIABLES

     IssuFile$=SHA$+"ISSUES.BAS"      'Issues/Subjects index file
     MapsFile$=FIX$+"MAP.BAS"         'Sales area map image for sinle area
     MappFile$=FIX$+"MAPP.BAS"        'Sales area map image for all areas
     PltsFile$=FIX$+"PLOTS.DAT"       'Graphics pixel plots of post areas
     PltiFile$=FIX$+"PLOTI.DAT"       'Index to start of each post area data
     PapsFile$=FIX$+"PAP.DAT"         'Number of postal addresses/post area
     DsstFile$=FIX$+"DSSTAT.DAT"      'Line status conditions for Email
     TtycFile$=FIX$+"CODES.TTY"       '
     Hlp2File$=FIX$+"HELP.TXT"        'General help screens

     NameFile$=SHA$+"NAMECODE"        'Namecode index file
     PostFile$=SHA$+"POSTCODE"        'Postcode index file
     KeysFile$=SHA$+"KEYS"            'Key values held by each prospect
     AttrFile$=SHA$+"ATTRIBS"         'Attribute values held by each prospect
     DistFile$=SHA$+"DISTRICT"        'Post district of each prospect
     DateFile$=SHA$+"DATES"           'Date of latest event for each prospect
     RecsFile$=SHA$+"RECORDS"         'Name & Address details of each prospect
     NoteFile$=SHA$+"NOTES"           'Diary notes on each prospect
     CodeFile$=SHA$+"SELCODES"        '
     DossFile$=SHA$+"D"               'Prospects dossier files root name

     PassFile$=SHA$+"PASS"            'Passwords
     ModmFile$=SHA$+"MODEM.MSG"       'Modem mode & dialling information
     SelfFile$=SHA$+"OWNNAME"         'Name & address of user
     FoneFile$=SHA$+"PHSTAT"          'Call outcome definitions
     MacrFile$=SHA$+"MACROS"          'Electronic Mail protocol macros
     KeyvFile$=SHA$+"KEYVS"           'The key NAMES and their VALUES
     AreaFile$=SHA$+"AREAS"           'Post areas making up each sales area
     SapsFile$=SHA$+"SAP"             'Sales Area Populations (post addresses)
     SafsFile$=SHA$+"SAF"             'Sales Area ............................
     SacsFile$=SHA$+"COLOURS"         'Sales Area colour allocations

     PrtcFile$=USR$+"PRTCODES"        'Printer port filespecs & control codes
     EmsdFile$=USR$+"EMSD"            'Electronic Mail Subscriber Details
     TargFile$=USR$+"TARGET"          'Target profile definition
     StatFile$=USR$+"STATS"           'General statistics
     PrntList$=USR$+"PR-LIST"         'Current Letter print list
     XmitList$=USR$+"TX-LIST"         'Destination List for Data transmission
     PhonList$=USR$+"PH-LIST"         'Current telephone calling list
     TelxList$=USR$+"EM-LIST"         'Current Email/Telex transmission list
     ViewFile$=""                     'Used to show stock etc in Amend & Phone
     AltColor$=""                     'Spare - not used any more
     ManuFile$=MAN$+"CHAP"            'Chapter files access for User Manual

     SignFile$=USR$+"SIGNY"           'Letter signatory, override dates etc
     LibrFile$=USR$+"LIBRARY"         'Letter library - list of letter names
     ParaFile$=USR$+"PARAG"           'Paragraphs used to build letters
     LettFile$=USR$+"LETTER"          'Individual finished letters

     Tx.File$=USR$+"TX-File"          'File for transmission via terminal
     Rx.File$=USR$+"RX-File"          'Data received via terminal
     ComFile$=USR$+"INMSG"            'Automatically received files
     '







     'PACKAGE START-UP FINITE STATE MACHINE

     GetState=1                         'Kick-start the file I/O FMM
     ViewEnable=1                       'Enable loading of view file spec
StartPoll:
     if GetState=9 or    _              'If the File I/O machine has failed
        GetPrtState=4 or _              'If hard error getting data from file
        OpenFileState=3 then            'or the File Opener is on timeout, then
        gosub Keyboard                  'Poll the keyboard
        if KbChar$=chr$(27) then end    'then wait for Esc from keyboard, then
        end if                          'Avoids cursor display when access OK!
     if GetState=8 then                 'Data got from file successfully
        GetState=0                      'De-activate the security FMM
        GetPrtState=1                   'Activate the view file spec loader
        end if
     if GetPrtState=3 then              'Data got from file successfully
        ViewFile$=pp$(11)               'Set ViewFile spec in common variable
        if len(ViewFile$)>1 then
           grey=val(left$(ViewFile$,2))
           ViewFile$=right$(ViewFile$,len(ViewFile$)-2)
           end if
        if grey<1 or grey>7 then grey=8
        goto Terminator
        end if
     gosub OpenFileFMM                  'Call the file opener FMM.
     gosub GetSecurity                  'Get the data from the file
     gosub GetPrtCodes
     gosub ShowMessages                 'Show possible error messages
     goto StartPoll                     'Loop back to start of polling loop


     'ERROR MESSAGE DISPLAY ROUTINE

ShowMessages:
     if ShowMessages=1 then             'If there is a message to be shown, 
        ShowMessages=0                  'Cancel the message display trigger
        ps$=left$(DosMsg$,80)
        ps$=ps$+space$(80-len(ps$))
        row=DosRow:column=DosCol
        colour=DosClr:gosub 50:DosClr=0
        if DosMsg$>"" then
           ps$="Press Esc to return to DOS"
           row=24:colour=2:gosub 50
           ps$="Esc"
           column=7:colour=10:gosub 50
           locate 5,27
           end if
        end if

     return


     'FILE I/O ERROR HANDLER FOR GET# ETC

GetError:  DosMsg$=er$(err)+" in "+FileName$
           ShowMessages=1:DosClr=12
           resume GetError1
GetError1: on error goto 0
           GetState=9
           return
     '







     'RETRIEVE OFFICIAL PASSWORD & THE DATE MARKETEER WAS LAST USED

GetSecurity:
     if GetState=1 then                 'If the machine is in State 1, then
        FileName$=RecsFile$             'Set up the file name
        FileNum=RecsFileNum             'Set up the Buffer Number
        RecLen=256                      'Set up the Record Length
        LockFile=0                      'Read/Write, others may read & write
        OpenFileState=1                 'Activate the file opener FMM
        GetState=2                      'Advance to the next machine state
        end if

     if GetState=2 then                 'If the machine is in State 2, then
        if OpenFileState<5 then return  'File Opener not yet terminated
        if OpenFileState=5 then         'If the file opened OK, then
           on error goto GetError

           field RecsFileNum,  _        'Field formats for the Recs File
                16 as Recs1$,  _        'Field 1: Flack (last 7 bytes as *)
                16 as Recs2$,  _        'Field 2: Licence 2
                16 as Recs3$,  _        'Field 3: Expiry date1
                16 as Recs4$,  _        'Field 4: Pass Word2
                16 as Recs5$,  _        'Field 5: 9 bytes = Menu permit flags
                36 as Recs9$,  _        'Field 9: User Name 1
                16 as Recs6$,  _        'Field 6: Pass Word1
                16 as Recs7$,  _        'Field 7: Licence 1
                16 as Recs8$,  _        'Field 8: ExpiryDate2
                36 as Recs0$,  _        'Field 0: User Name 2
                16 as RecsA$            'Field A: * Back-stop date

           get RecsFileNum,1            'Load the pass data
           AltColor$=left$(Recs5$,9)    'Main menu item permit flags
           ExpiryDate1$=Recs3$          'A common variable
           ExpiryDate2$=Recs8$          'A common variable

           x=cvi(left$(Recs7$,2)):if x>0 and x<15 then crypt1$=mid$(Recs7$,3,x)
           x=cvi(left$(Recs2$,2)):if x>0 and x<15 then crypt2$=mid$(Recs2$,3,x) 
           gosub Decrypt:Licence$=ps$

           crypt1$=right$(RecsA$,7)     'Get the two encrypted versions of the 
           crypt2$=left$(RecsA$,7)      'system date Marketeer was last used
           gosub Decrypt                'and decrypt (rationalised form in ps$)

           gosub RatSysDate             'Get rationalised System Date into x$
           if Licence$="00000" _        'If licence has not yet been ratified
              and ps$>x$ then           'and last used date is future to current
              close:end                 'system date, refuse to proceed further
         else gosub Encrypt             'Encrypt system date into crypt1$ and
              lset RecsA$=crypt2$+"X-"_ 'crypt2$, then assign it to the buffer
                         +crypt1$       'variables for storing.
              Put RecsFileNum,1         'Store the double encrypted system date
              end if                    'as new date last used.
           on error goto 0:close
           GetState=8                   'Set this machine to termination state
      else GetState=9                   'Set this machine to its error state
           end if
        OpenFileState=0
        end if

     RETURN                             'Return to the FMM polling loop
     '







     'COMPUTE THE DAY OF THE WEEK

Terminator:
     gosub ExpiryTest     'Sets up SystemDay, SystemMonth, SystemYear
     dait$ = "1990K05"    'Reference date 5th November 1990
     dn = 2               'Known to be a Monday
     gosub Elapsed2       'Compute the elapsed time, T since the above date

     dn = dn + t          'Compute day of the week
     while dn > 7
     dn = dn - 7
     wend


     'FORM THE DISPLAY FORMAT FOR THE SYSTEM DATE [A COMMON VARIABLE]

     sd$ = WeekDay$(dn)                      _  '3-letter day name
         + " "                               _  'spacer
         + mid$(date$, 4, 2)                 _  '2-digit day number
         + " "                               _  'spacer
         + MonthName$(val(left$(date$, 2)))  _  '3-letter month name
         + " "                               _  'spacer
         + right$(date$, 4)                     '4-digit year number


     'DEFINE & INITIALIZE LOCAL VARIABLES

     key off : for k = 1 to 10 : key k,"" : next      'Kill the Function Keys
 '   out &H3E0,81                                     'Reset on-board modem
     chain"Menu"                                      'Pass control to Menu

     'E.B.S. ENCRYPTION ALGORITHM               28JUL87


     'This subroutine encrypts a string of ASCII characters into a coded form.
     'Input  x$ - string of characters to be encrypted
     'Output crypt1$ and crypt2$ - encrypted strings

Encrypt:

     'ENCRYPTION LOOP

     l=len(x$)                  'N of characters to be encrypted
     crypt1$="":crypt2$="" 
     for i=1 to l               'For each character in the input string...
     w=asc(mid$(x$,i,1))        '
     if w=124 then w=32         'Necessary to preserve trailing spaces on INPUT
     if w=32 then w=94          'ASCII value of an encrypted character is:

     y=w-i+l+23                 'Encrypt according to algorith N 1
     if y>255 then y=y-255      'rotate ASCII value as necessary
     if y<  1 then y=255-y
     crypt1$=crypt1$+chr$(y)    'Add character to first encryption string

     z=w+i  -19                 'Encrypt according to algorith N 2
     if z>255 then z=z-255
     if z<  1 then z=255-z
     crypt2$=crypt2$+chr$(z)    'Add character to second encryption string

     next:return


