


     '                               - 1 -


     '
     'DEFINE A TARGET PROFILE     Author:R J Morton     05JAN87     DefTarg.BAS
     '
     '
     'Enables the user to specify the profile of an ideal target prospect and
     'then extract from the database a shortlist of those prospects who fit it. 
     '
     defint a-z                    'A=single precision for elapsed time Routine
     rem $include: 'ComVars.INC'   'Merge in the common variables
     rem $include: 'ComVarT.INC'   'Local group commons
     Dim Rec$(12)                  'Dummy for ....
     Dim Fields$(18)               'Used by EDBLOCK to store notes
     Dim Values$(18)               'Used by the block editor
     Dim MultiBlk$(18)             'Used by the block editor
     '
     Dim CMDW$(10)                 'Holds current set of command words
     '
     CMDW$(1)="HELP":CMDW$(2)="QUIT":CMDW$(3)="NEXT"
     CMDW$(4)="PREV":CMDW$(5)="NAME":CMDW$(6)="EXTR"
     CMDW$(7)="SIFT":CMDW$(8)="LIST":CMDW$(9)="ORDR"
     '
     Dim Task$(5)                  'Holds the current set of tasks
     '
     TASK$(1)="SEARCH ":TASK$(2)="LOADING":TASK$(3)="SORTING":
     TASK$(4)="STORING":TASK$(5)="ERASING":TASKS=5
     '
     gosub ExpiryTest                   'Software licence protection
     '
     TargFileNum=1:TargRecLen=8
     DefsFileNum=2:DefsRecLen=560
     '
     Overlay$ = "MENU"                  'Default exit to main menu
     RecNum = 0
     InitState = 1                      'Activate the module initialiser FMM
     '
     '
     '


     '                               - 2 -


     '
     'FMM POLLING LOOP
     '
     ACTIVE=1                           'Activate the FMM polling loop
     WHILE ACTIVE                       'While the FMM polling loop is active
       gosub Initialise                 'Local initialiser for this bas module
       gosub Keyboard                   'Poll the keyboard and clock
       gosub CWPFMM                     'Function Key detector
       gosub CWPfkeys                   'Function Key selector
       gosub OpenFileFMM                'General file opening service
       gosub EdSic                      'SIC code editor
       gosub HelpFMM                    'Help display FMM
       gosub NextPrev                   'Load the details of the next target.
       gosub GetKeyvs                   'Key Values Loader FMM
       gosub DefTarg                    'Target I/O machine
       gosub TargName                   'Target Name amendment FMM
       gosub EdFieldFMM                 'General field editor machine
       gosub EdBlockFMM                 'Block editor driver FMM for...
       gosub MultiBlk                   'Multi-block driver FMM for...
       gosub SelSeq                     'Listing Order Selector
       gosub Select                     'General selector service machine
       gosub SelKvals                   'Key Values Selector
       gosub Select                     'General key selector service machine
       gosub ShowMessages               'Dos message and task lamp display FMM
       gosub HelpTrip
     WEND
     CLOSE                              'Close all files
     Prog$="DEFTARG"                    'Set program identification variable
     CHAIN Overlay$                     'Pass to the next appropriate overlay
     '
     '
     '
     '$include: 'GetHelp.FMM'
     '$include: 'OpenFile.FMM'
     '$include: 'KeyBoard.FMM'
     '$include: 'FuncKeys.FMM'
     '$include: 'MultiBlk.FMM'
     '$include: 'EdBlock.FMM'
     '$include: 'EdField.FMM'
     '$include: 'GetKeyvs.FMM'
     '$include: 'DefTarg.FMM'
     '$include: 'Select.FMM'
     '$include: 'ShowKbox.INC'
     '$include: 'ShoKeyVs.INC'
     '$include: 'Expiry.INC'
     '$include: 'Decrypt.INC'
     '
     '
     '


     '                               - 3 -


     '
     'INITIALISATION FMM
     '
Initialise:
     if InitState=0 then return         'Initialisation completed
     IF InitState=1 THEN
        GetKeyvsState=1                 'Activate the Key Values loader FMM
        gosub ShowTasks
        InitState=2
     '
     '
     'NOTE SPECIAL REQUIREMENTS ON RETURN FROM EXTRACT
     '
     'This is extra processing which must be done when control has been returned
     'to this module from the Extract Module on completion of a Target List
     'extraction process. It has to store the current date stamp and extraction
     'flag (Target List Serial Number) in the appropriate Target Definition
     'record; and the updated central Target List Serial Number in Record #19
     'of the Target Definitions File.
     '
 ElseIF InitState=2 THEN
        if GetKeyvsState<3 then return  'Key Values loader not yet finished
        DateStamp$=mid$(sd$,4,8)_       'Day of the month + name of the month
                  +right$(sd$,2)        'Last two digits of the 4-digit year N
        if Prog$="EXTRACT" then         'If control received from Extract.EXE
           gosub GetTime                'then get time stamp,
           ListDate$=" "+clock$+DateStamp$  'store the date the Target List
           TargNames$(0)=chr$(TargNum+64)  'See note at end of DefTarg.FMM
           DefTargMode=1                'Set to store target profile + names
           RightBox$="TargBox"          'Prevent unnecessary redisplay.
      else DefTargMode=0                'Set to load Target Profile & names
           if TargNum=0 then
              TargNum=1:TargNum$="01"
              end if
           end if
        DefTargState=1                  'Activate the Target File I/O FMM
        InitState=3
     '
     '
     'AWAIT TERMINATION OF TARGET DATA LOADER, THEN DISPLAY INITIAL SCREENFILL
     '
 ElseIF InitState=3 THEN
        if DefTargState>0 and DefTargState<9 then return
        if DefTargState=0 then
           row=1:column=19:colour=7:ps$=Top$:gosub 50    'Display module name
           row=4:column=1:ps$=space$(80):gosub 50        'Clear Ref information
           KeyvRow=5:KeyvCol=1
           gosub ShowTargStat           'Show the status box
           UpDown=0                     'Load current target profile
           MsgPos=1:Msg.H=34:Msg.V=5:Msg.C=27  'INSERT message position, colour
           DisplayCount=0:Cnt.H=28      'No display of character count
           CWPstate=1                   'Activate the command processor
           InitState=0                  'Initialisation completed
    elseif KbStr$="" then
           InitState=1                  'Re-try if no key stroke pending
      else ACTIVE=0
           end if
        END IF
     RETURN
     '
     '
     '


     '                               - 4 -


     '
     'COMMAND EXECUTOR  modify for amend functions
     '
     'When a keyboard command has been entered, the Command Word Processor FMM
     'sets a value in CWPfkey corresponding to the command entered. This routine
     'initiates the processes required to execute the entered command.
     '
CWPfkeys:
     if CWPfkey=0 and Nkey=0 _          'If neither cmnd word or digit entered,
        then return                     'return control to the FMM polling loop
     gosub ClearStoredMsg               'Clear the `Record Stored' message
     DosMsg$="":DosClr=7:ShowMwssages=1 'Clear DOS error message.
     if CWPfkey=1 then
        Help=17:HelpState=1             'HELP Display help text
        LeftBox$="HELP":RightBox$="HELP"
 elseif CWPfkey=2 then
        ACTIVE=0                        'QUIT  Exit back to main menu
 elseif CWPfkey=3 then
        UpDown= 1:NextPrevState=1       'NEXT  Get the next record
 elseif CWPfkey=4 then
        UpDown=-1:NextPrevState=1       'PREV  Get the previous record
 elseif CWPfkey=5 then
        TargNameState=1                 'NAME  Amend target name
 elseif CWPfkey=6 then                  'EXTR  extract a target list
        Overlay$="EXTRACT":ACTIVE=0:task=3 'Go to the extraction module
 elseif CWPfkey=7 then
        Overlay$="Sift":ACTIVE=0        'SIFT  cut individuals from tgt list
 elseif CWPfkey=8 then
        Overlay$="Lmenu":ACTIVE=0       'LIST  printout routine
 elseif CWPfkey=9 then
        SelSeqState=1                   'ORDR  Get the previous record
 elseif Nkey=1 then
        SicCodeMode=0                   'Edit SIC Ns
        EdSicState=1                    'Activate SIC/Selector Code editor
 elseif Nkey=2 THEN
        KeyArr=0:KeySel=0:SelkValsState=1     'Sales area
 elseif Nkey=3 then
        KeyArr=1:KeySel=1:SelkValsState=1     'Relation
 elseif Nkey=4 then
        KeyArr=2:KeySel=2:SelkValsState=1     'Progress [Status]
 elseif Nkey=5 then
        KeyArr=4:KeySel=3:SelkValsState=1     'Products
 elseif Nkey=6 then
        SicCodeMode=1                   'Edit Selector Codes
        EdSicState=1                    'Activate SIC/Selecto Code editor
 elseif Nkey=7 then
        KeyArr=3:KeySel=4:SelkValsState=1     'Last event
 elseif Nkey=8 then
        KeyArr=3:KeySel=5:SelkValsState=1     'Next event
   else beep:CWPstate=1
        end if
     if Nkey>0 then                     'If a numeric key was struck, then
        LeftBox$=""
        if Nkey<7 then row=Nkey+7 else row=Nkey+9
        ps$=right$(str$(Nkey),1):colour=127:column=44:gosub 50
        end if
     CWPfkey=0:Nkey=0:return
     '
     '
     '


     '                               - 5 -


     '
     'HELP TRIP ROUTINE
     '
HelpTrip:
     if HelpState>3 then                'If the HELP machine has terminated,
        gosub ShowTargStat              'Display the status screen
        CWPstate=1                      'Re-activate the command processor
        HelpState=0                     'De-activate the HELP machine.
        end if
     return
     '
     '
     'FIND AND LOAD NEXT/PREVIOUS TARGET PROFILE
     '
NextPrev:
     IF NextPrevState=1 THEN
        TargNum=TargNum+UpDown          'Record N of [next] target definition
        if TargNum>18 then TargNum=1 
        if TargNum<1 then TargNum=18
        TargNum$=str$(TargNum)
        TargNum$=right$(TargNum$,len(TargNum$)-1)
        if len(TargNum$)=1 then
           TargNum$="0"+TargNum$
           end if
        DefTargMode=0                   'Set mode for loading target details
        DefTargState=1                  'Activate the Target Data I/O machine
        NextPrevState=0                 'De-activate self
        end if
     RETURN
     '
     '
     '


     '                               - 6 -


     '
     'ENTER TARGET NAME
     '
TargName:
     IF TargNameState=0 THEN return     'Machine idling
     '
     IF TargNameState=1 THEN
        FieldRow= 5                     'In box title row
        FieldCol=62                     'After field name `TARGET NAME: '
        FieldLen=18                     'Target Name can be upto 18 chars long
        Numerics= 0
        l=len(TargName$):k=0:while l>0
        if mid$(TargName$,l,1)<"!" then l=l-1 else k=l:l=0
        wend:FieldStr$=left$(TargName$,k)
        MaxCharCount=18
        Kolour=23
        NoEscape=0
        CAPS=1:CharCol=1
        EdFieldState=1
        TargNameState=2
     '
 ElseIF TargNameState=2 THEN            'If the machine is in State 2, then
        if EdFieldState<3 then return   'Field editor not yet terminated.
        EdFieldState=0                  'De-activate it.
        if AmendFlag>0 then             'If the field were amended, then
           TargName$=FieldStr$
           TargNames$(TargNum)=TargName$
           ExtrFlag=0                   'Clear the `extracted' flag
           PrntFlag=0                   'Clear the `printed' flag
           gosub GetTime                'Get current time NOW
           TargDate$=" "+clock$+DateStamp$  'Set Target Profile date to system date
           DefTargMode =1               'Set mode to store target
           DefTargState=1               'Activate the target data storer
      else gosub ShowTargStat           'else re-display original field data
           CWPstate=1                   'Re-activate the command processor
           end if                       '
        TargNameState=0                 'De-activate self
        END IF
     '
     RETURN
     '
     '
     '


     '                               - 7 -


     '
     'SELECT THE LISTING ORDER
     '
SelSeq: IF SelSeqState=0 THEN RETURN    'Machine idling
     '
     IF SelSeqState=1 THEN              'INITIALISE THE SELECTOR FMM
        if LeftBox$<>"SeqBox" then      'Display box if not already displayed
           LeftBox$="SeqBox"
           ps$=space$(39):column=1:colour=19:for row=5 to 17:gosub 50:next
           ps$=" "+string$(37,196)+" ":row= 7:gosub 50
           ps$=string$(39,223):colour=1:row=18:gosub 50
           end if
        row=6:column=4:colour=27:ps$="SELECT REQUIRED LISTING ORDER":GOSUB 50
        gosub ClearInstructions         'Clear the key-edit instructions
        ValuRow =8                      'First row of values display
        ValuCol =2                      'Left-most column of values display
        PerCol  =6                      'N values per [tabular] column
        NumCols =1                      'N of tabular columns columns
        InterCol=0                      'N chrs separating tabular columns
        MaxVals =6                      'Number of values displayed
        SelOrder=0                      'Selection order irrelevant
        NumSels =1                      'N concurrent selections permitted
        EditingPermitted=0              'No editing of values text permitted
        Values$=chr$(SeqTyp+64)
        Values$(1)="Alphabetic order of Namecode"
        Values$(2)="Reference Number order"
        Values$(3)="Namecode order within Post Area"
        Values$(4)="Namecode order within Post District"
        Values$(5)="Namecode order within Post Sector"
        Values$(6)="Alphanumeric order of Postcode"
        column=4:colour=19:for k=1 to 6:ps$=values$(k):row=k+7:gosub 50:next
        SelectState=1                   'Activate the general selector FMM
        SelSeqState=2                   'Advance to next machine state.
     '
 ElseIF SelSeqState=2 then              'AWAIT TERMINATION OF SELECTOR FMM
        if SelectState<8 then return    'General selector not yet terminated
        if SelectState=8 and _          'If it has terminated successfullt and
           AmendF>0 then                'the selection was amended, then
           if Values$="" then Values$="A" 'Make sure there is a valid selection
           SeqTyp=asc(Values$)-64       'Listing Order N
           DefTargMode=1                'Set mode to store target.
           DefTargState=1               'Activate the Target Profile saver.
      else gosub ShowTargStat           'else re-display original field data
           CWPstate=1                   'Re-activate the command processor.
           end if
        SelectState=0                   'De-activate the general selector FMM.
        SelSeqState=0                   'De-activate self.
        END IF
     '
     RETURN
     '
     '
     '


     '                               - 8 -


     '
     'ENTER/AMEND SIC NUMBER SELECTIONS
     '
EdSic:
     IF EdSicState=0 THEN RETURN
     '
     IF EdSicState=1 THEN
        if SicCodeMode=0 then
           gosub ShowSicBox             'Display the SIC box
           InterBlk= 5                  'N of chrs between adj columns
           FieldLen= 4                  'Set field length for the SIC
           for k=1 to 18:MultiBlk$(k)=SIC$(K):next
      else gosub ShowCbox               'Display key values containment box
           InterBlk=19                  'N of chrs separating adj columns
           FieldLen=16                  'Set field length for the Selector Code
           for k=1 to 18:MultiBlk$(K)=Cde$(K):next
           end if
        NoEscape=0
        CAPS=0:CharCol=1
        gosub ClearInstructions         'Clear instructions window
        NumFields=9                     'Number of fields per column (block)
        NumBlks=2                       'Number of columns (blocks)
        MultiRow=8                      'Row on which first field is displayed
        MultiCol=3                      'Start column of field
        Numerics=0                      'Not numerics only
        gosub ShowBlocks                'Display the fields initially
        MultiBlkState=1                 'Activate the multiblock processor
        EdSicState=2
     '
 ElseIF EdSicState=2 THEN
        if MultiBlkState<3 then return  'Multi-Block editor not yet terminated
        if AmendM>0 then                'Amendment was made to multiple block
           if SicCodeMode=0 then
              for k=1 TO 18:SIC$(k)=MultiBlk$(k):next
         else for k=1 TO 18:CDE$(k)=MultiBlk$(k):next
              end if
           DefTargMode=1                'Set mode to store target.
           DefTargState=1               'Activate the Target Profile saver.
      else CWPstate=1                   'Re-activate the command processor.
           gosub ShowTargStat           'Display the target Profile data
           end if
        MultiBlkState=0                 'De-activate the Multi-Block editor.
        EdSicState=0                    'De-activate self.
        END IF
     '
     RETURN
     '
     '


     '                               - 9 -


     '
     'SELECT KEY VALUES
     '
SelKvals:
     IF SelKvalsState=0 THEN RETURN     'Machine idling.
     '
     IF SelKvalsState=1 THEN
        gosub ClearInstructions         'Clear the key-edit instructions
        NumSels=18                      'N that may be selected concurrently
        KeyvRow=5                       'Key values display box starts on row 5
        KeyvCol=1                       'and column 1 (extreme left of screen)
        Keyvs$=Key$(KeySel)             'Get new key selection into key string
        if KeySel=4 then TMEbias=0 else TMEbias=2
        gosub ShoKeyvs                  'Display keys/attributes in box
        ValuRow=KeyVrow+3               'First row on which field occurs
        ValuCol=KeyvCol+1               'First character of first column
        Percol  = 9                     'Number of values per column
        NumCols = 2                     'Number of columns
        InterCol=19                     'Column separation
        MaxVals =18                     'Maximum number of values displayed
        SelOrder= 0                     'Order in which selections made
        Values$=Keyvs$                  'Initial value selections on entry
        KeyvsAmend=0                    'Clear the amend indicator
        SelectState=1                   'Activate general key value selector
        SelKvalsState=2                 'Advance to next machine state
     '
 ElseIF SelKvalsState=2 THEN
        if SelectState<8 then return 'Selector Machine not yet terminated
        if AmendF>0 then
           Keyvs$=Values$
           KeyvsAmend=1              'Set that a selection was made 
           end if                    'Not an event key so go store data.
        if KeyArr<>3 or SelectKeyPressed=0 goto SelKvals2
        gosub TimesSub               'Put interger times into `fields$'
        gosub TWBox                  'Display the Time Window box
        BlockRow=7
        BlockCol=KeyvCol+4
        FieldLen=4
        NumFields=2
        FieldNum=1
        MultiBlk=0
        Numerics=0
        EdBlockState=1               'Activate the block editor
        SelKvalsState=3              'advance to the next state
     '
     '
     '


     '                              - 10 -


     '
     'SET UP AND CALL THE GENERAL FIELD BLOCK EDITOR
     '
 ElseIF SelKvalsState=3 THEN
        if EdBlockState<3 then return   'Block Editor not yet terminated
        if AmendF=0 goto SelKvals2      'No amendments to time window
        KeyvsAmend=1                    'Set the Keys Amended indicator
        T1=val(fields$(1))              '
        T2=val(fields$(2)):ps$=""       'Check to see if T1 & T2 are in range
        if T1<-999 or T1>999 then ps$="T1 out of range  "
        if T2<-999 or T2>999 then ps$=ps$+"T2 out of range"
        if ps$="" then                  'If both T1 & T2 are valid, then
           x=0:y=0:z=0
           TME(1+TMEbias)=T1            'set T1 in its storage arrays
           TME(2+TMEbias)=T2            'set T2 in its storage arrays
           if fields$(1)>"" then y=1
           if fields$(2)>"" then z=1
           TME(5+TMEbias)=y
           TME(6+TMEbias)=z             'Restriction flags
           EdBlockState=0               'De-activate the block editor
           goto SelKvals2               'Activate the target storage FMM
      else row=20:column=44             'else display the T1/T2 out of range
           colour=79:gosub 50           'message.
           gosub TimesSub               'Re-load original times into fields$()
           gosub EdBlockFMM1c           'and re-display them.
           EdBlockState=1               'Re-enter the block editor to
           end if                       're-edit the times.
        END IF
     RETURN
     '
SelKvals2:
     if KeyvsAmend=1 then            'If Selected Events &or T1 T2 amended,
        Key$(KeySel)=Keyvs$          'Put new key selection in key string
        ExtrFlag=0:PrntFlag=0        'Kill Extract & Print Flags
        gosub GetTime
        TargDate$=" "+clock$+DateStamp$  'Set Target Profile date to system date
        DefTargMode=1                'Set mode to store target.
        DefTargState=1               'Activate the Target Profile saver.
   else CWPstate=1                   'Re-activate the command processor.
        gosub ShowTargStat           'Re-display the target data
        end if
     SelKvalsState=0                 'De-activate self
     RETURN
     '
     '


     '                              - 11 -


     '
     'LOAD THE OLD [ORIGINAL] TIME LIMITS
     '
TimesSub:
     for k=1 to 2                       'For each of the two times T1 & T2,
     if tme(4+k+TMEbias)=0 then         'If the IN EFFECT flag is unset, then
        x$=""                           'start with a null field entry
   else x$=str$(tme(k+TMEbias))         'Form the display string of the time
        end if                          '
     fields$(k)=x$:next:return          'Put it in the appropriate field.
     '
     '
     'EXTERNAL SUBROUTINES
DISPLAY: row=row+1
SHOW: 
50   Call ScrSub(ps$,row,column,colour):return
     '
     'DISPLAY/CLEAR INSTRUCTIONS FOR AMENDING KEYS ETC
     '
ClearInstructions:
     column=41:colour=7:ps$=space$(40):for row=19 to 23:gosub 50:next:return
     '
     '
     'DISPLAY/CLEAR THE STORED/KILLED MESSAGES
     '
ClearStoredMsg: ps$="                       ":colour=7
ShowStoredMsg1: row=4:column=18:gosub 50:return
     '
     '
ShowMessages:
     if ShowMessages>0 then             'If message display service required,
        row=4:column=1:colour=DosClr    'then display the message in DosMsg$
        ps$=DosMsg$:gosub 50            'in the designated message position
        ShowMessages=0                  'and reset the message display request.
        end if                          '
     if LastTask<>Task then             'If task status has changed, then
        if LastTask=4 and Task=0 then   'If last task was storing, then
           ps$=" Target stored as seen ":colour=10:gosub ShowStoredMsg1
           end if
        LastTask=task                   'Note the new current task
        gosub ShowTaskLamps             'LAMPS SET IN DefTarg.FMM
        end if
     return
     '
     '


     '                              - 12 -


     '
     'DISPLAY THE SIC ENTRY BOX
     '
ShowSicBox:
     if LeftBox$<>"SICbox" then
        LeftBox$="SICbox"
        colour=27:row=5:column=1:ps$=space$(39):gosub 50
        ps$="  SIC RESTRICTIONS:                    ":gosub display
        colour=19
        ps$="    ":gosub display
        ps$="            Enter the SIC N of each  ":gosub display
        ps$="            SIC class you wish to be  ":gosub display
        ps$="            included in this target.  ":gosub display
        ps$="            Enter each N as 1, 2, 3  ":gosub display
        ps$="            or 4 digits according to  ":gosub display
        ps$="            how wide or narrow each   ":gosub display
        ps$="            classification required.  ":gosub display
        ps$="            See HMSO publication on   ":gosub display
        ps$="            the Standard Industrial   ":gosub display
        ps$="             Classification system.    ":gosub display
        colour=1:ps$=string$(39,223):gosub display
        ps$=space$(40):gosub display
        end if
     return

     '
     'DISPLAY THE TIME WINDOW CONTAINMENT BOX
     '
TWBox:
     if LeftBox$<>"TWbox" then
        LeftBox$="TWbox"
        row=4:column=1
        colour=27:ps$=" TIME CONSTRAINTS:"+space$(21):gosub Display
        colour=19
        ps$="Ŀ":gosub Display 
        ps$="T1:      Enter T1 & T2 as a sign [+-]":gosub Display
        ps$="T2:      followed by upto 3 digits.  ":gosub Display
        ps$="":gosub Display
        ps$=" If a prospect's LAST EVENT is T days  ":gosub Display
        ps$=" from today, then he will fall within  ":gosub Display
        ps$=" this target profile if T1=>T=>T2.     ":gosub Display
        ps$=" Omitting T1 or T2 simplifies the con- ":gosub Display
        ps$=" dition to T=>T2 & T<=T1 respectively. ":gosub Display
        ps$=" T1=0 or T2=0 captures prospects whose ":gosub Display
        ps$=" LAST EVENTS occurred today. T, T1 and ":gosub Display
        ps$=" T2 are +ve if past and -ve if future. ":gosub Display
        colour=1:ps$=string$(39,223):gosub Display
        end if
     if KeySel=5 then        
        ps$="NEXT":colour=19
        row=11:column=18:gosub 50
        row=17:column= 2:gosub 50
        end if
     return
     '
     '


     '                              - 13 -


     '
     'DISPLAY THE TARGET LIST STATUS
     '
ShowTargStat: 
     if LeftBox$<>"StatBox" then
        LeftBox$="StatBox"
        ps$=space$(39):row=5:column=1:colour=27:gosub 50
        ps$="  TARGET STATUS                        ":row= 6:gosub 50
        colour=19
        ps$="    ":row= 7:gosub 50
        ps$="  Total Market       prospects (    )  ":row= 8:gosub 50
        ps$="  Target Group       prospects (    )  ":row= 9:gosub 50
        ps$="                                       ":row=10:gosub 50
        ps$="  Last Extracted                       ":row=11:gosub 50
        ps$="  List Serial N                       ":row=12:gosub 50
        ps$=space$(39):for row=13 to 17:gosub 50:next
        ps$=string$(39,223):row=18:colour=1:gosub 50
        ps$=space$(40):row=19:colour=7:gosub 50
        end if
     ps$=str$(FileSize):ps$=space$(6-len(ps$))+ps$
     column=15:colour=23:row= 8:gosub 50
     column=33:ps$="100%":gosub 50       
     ps$=str$(TargSize):ps$=space$(6-len(ps$))+ps$
     column=15:row= 9:gosub 50
     '
     if FileSize>0 then    'If there is at least one prospect on file, then
        x!=TargSize        'N of prospects in Target Group as a `real' variable
        y!=FileSize        'Total N of prospects on file as a `real' variable
        z!=x!*100!/y!      'Do the percentage calculation
        z =z!              'Transfer percentage to an interger variable
   else z=0                'else set the interger persentage to zero
        end if
     ps$=str$(z):ps$=right$(ps$,len(ps$)-1)
     column=33:ps$=space$(3-len(ps$))+ps$+"%":gosub 50
     row=11
     if ExtrFlag=0 then
        colour=71:ps$=" Not yet extracted!"
   else colour=23:ps$=ListDate$
        end if
     column=19:gosub 50
     ps$=str$(ExtrFlag):ps$=right$(ps$,len(ps$)-1)
     l=len(ps$):if l<4 then ps$=string$(4-l,"0")+ps$
     row=12:column=19:ps$=" "+ps$:gosub 50
     row=14:column=3
     if ExtrFlag=0 then
        ps$=space$(29):colour=23
 elseif PrntFlag=0 then
        colour=71:ps$="NO UP TO DATE LISTING EXISTS"
   else ps$="AN UP TO DATE LISTING EXISTS"
        end if
     gosub 50                           'Go straight on to TargBox
     '
     '
     '


     '                              - 14 -


     '
     'DISPLAY TARGET PROFILE BOX + TARGET DATA  
     '
     if RightBox$<>"TargBox" then
        RightBox$="TargBox"
        W$=Keyvs$(0,0):W$=W$+space$(16-len(W$))   'Sales Area
        X$=Keyvs$(1,0):X$=X$+space$(16-len(X$))   'Relationship
        Y$=Keyvs$(2,0):Y$=Y$+space$(16-len(Y$))   'Progress
        Z$=Keyvs$(4,0):Z$=Z$+space$(16-len(Z$))   'Interests
        row=4:column=41:colour=7:PS$=space$(40):GOSUB 50
        column=43:colour=19:colour=27
        ps$=" TARGET PROFILE"+space$(23):gosub Display
        colour=19
        PS$=" Last amended:                        ":Gosub Display
        PS$="  ":Gosub Display
        PS$=" 1 SIC or `ACORN'                     ":Gosub Display
        PS$=" 2 "   +W$+       "                   ":Gosub Display
        PS$=" 3 "   +X$+       "                   ":Gosub Display
        PS$=" 4 "   +Y$+       "                   ":Gosub Display
        PS$=" 5 "   +Z$+       "                   ":Gosub Display
        PS$=" 6 Selection Code                     ":Gosub Display
        PS$="  ":Gosub Display
        PS$=" EVENTSType:         Time:          ":Gosub Display
        PS$=" 7 Last                             ":Gosub Display
        PS$=" 8 Next                             ":Gosub Display
        colour=1:PS$=string$(38,223):Gosub Display
        ROW=19:PS$=space$(40):Gosub Display
        end if
     '
     ps$="   ":column=40:colour=7:for row=5 to 18:gosub 50:next
     for Nkey=1 to 8
     if Nkey<7 then row=Nkey+7 else row=Nkey+9
     ps$="":colour=23:column=43:gosub 50
     ps$=right$(str$(Nkey),1):colour=112:column=44:gosub 50
     next
     colour=23
     x$=str$(TargNum):ps$=right$(x$,len(x$)-1):if len(ps$)=1 then ps$="0"+ps$
     row=5:column=59:colour=31:ps$=ps$+" "+TargName$:gosub 50 'Target N & Name
     row=6:colour=23:column=58:ps$=TargDate$:gosub 50         'Target date
     x=0:column=64:for row=8 to 13:gosub TargSub:next
     'SIC number, Sales Area, Relation, Progress, Interests, Selector code
     '
     row=16:column=52:gosub TargSub             'Last event (Type)
     row=17          :gosub TargSub             'Next event (Type)
     row=16:column=67:gosub TargSub             'Last event (Date)
     row=17          :gosub TargSub             'Next event (Date)
     column=41:colour=2
     ps$="                                        ":row=19:gosub 50
     ps$="   To alter the restrictions imposed by ":row=20:gosub 50
     ps$="   a particular key, enter the Key's N ":row=21:gosub 50
     ps$="   and select or enter values according ":row=22:gosub 50
     ps$="   to the data instructions then given. ":row=23:gosub 50
     return
     '
TargSub: X=X+1
         if mid$(TargStat$,x,1)=" " then
            ps$="unrestricted":colour=23
       else ps$="restrictions":colour=79
            end if
         gosub 50:return
     '
     '

