






    'DISPAY SALES AREA MAPS         01FEB87                      File: DMAP.BAS

    'Author : R J Morton

    DefInt a-z
    rem $include: 'ComVars.INC'

    h=119                          'Number of U.K. post codes including London
    dim PlotStartRecs(18,100)      'Post area plot start record numbers
    dim Keyvs$(4,18)               'Key values & names [for sales area names]
    dim SalesAreaPros(18)          'Sales area prospect populations
    dim SalesAreaColr(18)          'Sales area display colour allocations
    dim SalesAreaPop#(18)          'N of postal addresses in each sales area
    dim SAexists(18)               '1=exists, 0=does not exist.
    dim PP$(20)
    gosub ExpiryTest
    gosub GetPrtr
    goto Initialization

    rem $include: 'InChar.INC'
    rem $include: 'Decrypt.INC'
    rem $include: 'GrafChar.INC'
    rem $include: 'GetKeyvs.INC'
    rem $include: 'GetHelp.INC'
    rem $include: 'Expiry.INC'
    rem $include: 'GetPrtr.INC'

50  Call ScrSub(ps$,row,column,colour):return

     '






    'LOAD ALL NECESSARY DATA

Initialization:
    gosub GetKeyvs      'Call `GetKeyvs'
    ss$=keyvs$(0,0)     'Key name [eg Sales Areas, Territories etc]
    for k=1 to 18
    if keyvs$(0,k)>"" then SAexists(k)=1
    next

    on error goto Dmap3
    open SacsFile$ for input as #1
    for i=1 to 18:input#1,SalesAreaColr(i):next
Dmap2:
    on error goto 0:close:goto Dmap4      'Sales Area colour designations
Dmap3:
    resume Dmap2

Dmap4:
    on error goto Dmap6
    open SapsFile$ for input as #1
    qq#=0
    for i=1 to 18
    input#1,x$
    if SAexists(i)=1 then x=val(x$):SalesAreaPop#(i)=x:qq#=qq#+x
    next
Dmap5:
    on error goto 0:close:goto Dmap7
Dmap6:
    RESUME Dmap5

    'PROSPECT POPULATION
Dmap7:
    on error goto Dmap9
    open StatFile$ for input as #1
    input#1,x$:ej=val(x$):if ej=0 then ej=1
    for k=1 to 18:input#1,x$:SalesAreaPros(k)=val(x$):next
Dmap8:
    on error goto 0:close:goto Dmap10
Dmap9:
    RESUME Dmap8

     '






    'LOAD PLOTS FILE START RECORDS
Dmap10:
    on error goto Dmap11
    open SafsFile$ for input as #1
    for i=1 to 18:input#1,x$:y=val(x$):PlotStartRecs(i,0)=y
    if y>0 then for j=1 to y:input#1,x$:PlotStartRecs(i,j)=val(x$):next
    next
Dmap12: on error goto 0:close:goto Dmap13
Dmap11: resume Dmap12


    'MENU

Dmap13:
    row=5:column=1:ps$=space$(1600):gosub 50
    l=11-len(ss$)/2
    ps$=string$(l,196)+" "+ss$+" DISPLAY OPTIONS "+string$(l,196)
    colour=3:row=5:column=21:gosub 50
    row=7
    for i=1 to 18    'For each sales area name
    '
    if i<10 _
       then row=6+i:column=22 _     'Left-hand column
       else row=i-3:column=42       'Right-hand column
    '
    colour = 11 : ps$ = chr$( i + 64 ) : gosub 50
    column = column + 2
    colour = 3 : ps$ = Keyvs$( 0, i ) : gosub 50
    next


    'OPERATOR INSTRUCTIONS

Dmap14:
    ps$="[ ] Please type-in letter corresponding"
    row=17:column=21:colour= 3                                  :gosub 50
    row=18:column=25:ps$="to the "+ss$                          :gosub 50
    row=19:column=25:ps$="you wish to display."                 :gosub 50
    row=22:column=21:colour= 2:ps$="Press "                     :gosub 50
           column=27:colour=10:ps$="Enter"                      :gosub 50
           column=32:colour= 2:ps$=" to display all "+ss$+"s."  :gosub 50
    row=23:column=21          :ps$="Press "                     :gosub 50
           column=27:colour=10:ps$="#"                          :gosub 50
           column=28:colour= 2:ps$=" to assign "+ss$+" colours.":gosub 50
    row=24:column=21          :ps$="Press "                     :gosub 50
           column=27:colour=10:ps$="Esc"                        :gosub 50
           column=30:colour= 2:ps$=" to quit Map displays."     :gosub 50


    'ACCEPT THE SALES AREA SELECTION

Dmap15:
    locate 17,22:gosub ClrKbdBuf:caps=1:gosub InChar
    if x$="#" then flag=0:goto Dmap30
    if x=27 then prog$="DMAP":chain"EdKeyvs"
Dmap16:
    if x>31 then print x$
    i=x-64:b=1:w$="":ii=i
    if x=13 then b=0:w$="S":goto Dmap18      'Display all sales areas together
    if i<1 or i>18 then gosub Dmap37:goto Dmap14
Dmap17:
    x$=Keyvs$(0,i):x=len(x$):if x>0 goto Dmap18
    gosub Dmap36:goto Dmap14


    'DISPLAY THE MAP IMAGE

Dmap18:
    QW$ = str$(i)                       'Map number
    QW$ = right$(QW$, len(QW$) - 1)
    if len(QW$) = 1 then QW$ = "0" + QW$

    screen 1 : color 1, 0 : color  , 0 : x = Dmap16
    if b = 0 then
       hb = 165 : File$ = MappFile$
    else
       hb = 150 : File$ = MapsFile$
    end if
    Bload File$


    'PLOT THE SALES AREAS

    color 1, 0
    locate 22, 1 + (25 - len(ss$) ) / 2
    if w$ = "S" then locate , 1 + ( 15 - len(ss$) ) / 2
    print "Shading-in the "ss$;
    if w$ = "S" then print " structure";
    print : locate 24, 15 : print "Please wait!";

     '






    'DISPLAY THE POST AREAS

    open PltsFile$ as #1 len = 8
    field#1, 2 as x1$, 2 as y1$, 2 as x2$, 2 as y2$

    kf = 1                      'Single sales area displayed in green

    if b = 0 then               'If we are displaying all sales areas...
       for ii = 1 to 18         'For each sales area
       kf = SalesAreaColr( ii ) 'Get the sales area's display colour
    end if

    if SAexists( ii ) = 1 then  'If sales area name exists, then
       aa = PlotStartRecs(ii,0) 'Number of post areas in this sales area
       for k = 1 to aa          'For each post area in this sales area...
       r = PlotStartRecs(ii,k)  'Get record number of [next] plot line

    if r > 0 then               'If next plot line exists, then
       get#1, r                 'get the plot line record
       jj = cvi( x1$ )          'N of plot-lines/plot points in this post area
       for j = 1 to jj          'For each plot-line/plot-point...
       get#1, r + j             'get the plotting co-ordinates

    if kf > 0 then          'If sales area colour not black, then
       x2 = cvi( x2$ )      'Zero line end co-ordinates mean it is a point plot
       if x2=0 then
          pset(hb + cvi(x1$), cvi(y1$) ), kf                         'Point plot
       else
          line( hb + cvi(x1$), cvi(y1$)) - (hb + x2, cvi(y2$) ), kf  'Line plot
       end if
    end if               '[kf>0]
    next                 'Next `j'  plot line/plot point
    end if               '[r>0]
    next                 'Next `k'  post area
    end if               '[keyvs$(0,ii)>""]

    if b = 0 then next   'Next `ii' sales area if showing all sales areas
    close


    'DISPLAY HALT

    ii = i                         '

    if b = 0 then                  'If we are displaying all sales areas
       gosub Dmap38
    else
       yb = 25 : gosub Dmap25
       yb =  0 : gosub Dmap25      '
    end if

    locate 22,1                    '

    if w$ = "S" then
       locate ,(16 - len(ss$)) / 2 : print" Current U.K. "SS$" Structure  "
    else
       x$ = Keyvs$( 0 ,ii )
       locate 22, 1
       sp = (33 - len(x$) - len(ss$)) / 2
       print spc(sp)"The `"x$"' "ss$ spc(sp)
    end if

    locate 24,1 : print "Please type HELP, SAVE or QUIT";


    'COMMAND WORD ENTRY

Dmap22:
    gosub ClrKbdBuf
    locate,33:print"____";:i=0:a$=""
Dmap23:
    i=i+1:if i>4 then beep:goto Dmap22
    locate,32+i:gosub Dmap26:a$=a$+x$
    if x>32 then print x$;

    if a$="HELP" then    _
       SysTime$=""       _
      :gosub Dmap24      _
      :help=12-b         _
      :gosub GetHelp     _      'Call `GetHelp'
      :goto Dmap18              'Go to re-display the map

    if a$="SAVE" then                'If the save command was entered
       def seg = &HB800              'Set memory segment to start of screen
       x$ = "\IMAGE"+QW$+".BIN"
       Bsave x$,0,&H4000             'Save the screen image to Image.BIN file
       def seg                       're-set segment to basic run time.
       goto Dmap22
    end if

    if a$="QUIT" or x=27 then gosub Dmap24:SysTime$="":goto Dmap13

    goto Dmap23

Dmap24:
    screen 0:width 80:locate,,0:row=1:colour=7
    column= 1:ps$="E.B.S. MARKETEER"+space$(49)+sd$:gosub 50
    column=19:ps$=top$                             :gosub 50
    return


    'POPULATION BAR GRAPH

Dmap25:
    if yb = 0 then
       q# = ej                     'set q# to N of prospects currently on file
    else
       q# = qq#                    '
    end if

    if q# = 0 then q# = 1          '
    z = 0                          '

    if yb = 0 then
       SalesAreaPop# = SalesAreaPros( i )
    else
       SalesAreaPop# = SalesAreaPop#( i )
    end if

    y = int( 100 * SalesAreaPop# / q# + .5# )

    if y > 0 then
       for k = 1 to y
       line( yb + 71, 157 - k - z )-( yb + 89, 157 - k - z ), kf
       next
    end if

    return

     '






    'KEY INPUT WITH FLASHING CURSOR

Dmap26:
    locate,,0,0,0
    vv=csrlin:hh=pos(0):cu$=chr$(screen(vv,hh)):t=0:f=1
Dmap27:
    locate ,hh:x$=inkey$:if x$>"" then x=asc(x$):goto Dmap28
    if tyme$=time$ goto Dmap27
    tyme$=time$:f=-f:if f=1 then y=1 else y=2
    print chr$(y);:goto Dmap27
Dmap28:
    if len(x$)=1 goto Dmap29
    x=asc(right$(x$,1)):if x=75 then x=8
    if x=77 then x=21
    x$=chr$(x)
Dmap29:
    if x>96 and x<123 then x=x-32:x$=chr$(x)
    print chr$(y);:locate ,hh:return

     '






    '--------------------------------------------------------------------------
    'COLOUR AMENDMENT MENU
    '
Dmap30:
    row=5:column=1:ps$=space$(1600):gosub 50
    l=11-len(ss$)/2
    ps$=string$(l,196)+" "+ss$+" DISPLAY OPTIONS "+string$(l,196)
    row=5:column=21:colour=3:gosub 50
Dmap31:
    row = 7 : column = 1
    for i = 1 to 18
    kf = SalesAreaColr( i ) * 2  'Currently assigned colour for this sales area
    if kf = 0 then kf = 1        'Default colour
    '
    if i < 10 then
       row = 6 + i : column = 21
    else
       row = i - 3 : column = 41
    end if

    colour = kf
    ps$ = "[" + chr$( i + 64 ) + "] " + Keyvs$( 0, i ) : gosub 50
    next


    'OPERATOR INSTRUCTIONS

Dmap32:
    ps$="[ ] Please type-in letter corresponding"
    row=17:column=21:colour= 3                                     :gosub 50
    row=18:column=25:ps$="to the "+ss$:ps$=ps$+space$(35-len(ps$)) :gosub 50
    row=19:column=25:ps$="you wish to colour.                     ":gosub 50
    row=21:column=25:colour= 1:ps$="0=blue "                       :gosub 50
           column=32:colour= 2:ps$="1=green "                      :gosub 50
           column=40:colour= 4:ps$="2=red "                        :gosub 50
           column=46:colour= 6:ps$="3=brown"                       :gosub 50

    ps$ = "Press Esc to set area colours as shown above"
    row=24:column=19:colour=2:gosub 50
    ps$="Esc":column=25:colour=10:gosub 50


    'ACCEPT THE SALES AREA SELECTION

Dmap32a:
    locate 17,22:gosub ClrKbdBuf:gosub InChar:if x=27 goto Dmap35
    if x>31 then print x$ else beep:goto Dmap32a
    i=x-64:if i<1 or i>18 then gosub Dmap37:goto Dmap33
    x$=Keyvs$(0,i):x=len(x$):if x>0 goto Dmap33
    gosub Dmap36:goto Dmap32


    'SELECT COLOUR

Dmap33:
    x = SalesAreaColr( i ) * 2
    if x = 0 then x = 1
    vp = i : if i > 9 then vp = i - 9
    hp = 1 : if i > 9 then hp = 20
    locate 6 + vp, 20 + hp
    color x + 16
    print "[" chr$( i + 64 ) "] " Keyvs$( 0, I )


    'OPERATOR INSTRUCTIONS

Dmap34:
    colour = 3
    ps$ = "[ ] Please type-in number corresponding"
    row = 17 : column = 21 : gosub 50
    ps$ = "to the colour you wish to make the  "
    row = 18 : column = 25 : gosub 50
    ps$ = "flashing " + ss$ + "." : ps$ = ps$ + space$( 35 - len(ps$) )
    row = 19               : gosub 50
    '
    '--------------------------------------------------------------------------
    'ACCEPT THE SALES AREA SELECTION
    '
    locate 17,22:gosub ClrKbdBuf:gosub InChar:if x=27 goto Dmap31
    if x>31 then print x$
    x=x-48:if x<0 or x>3 then gosub Dmap37:goto Dmap34
    SalesAreaColr(i)=x:flag=1:goto Dmap31
    '
    '--------------------------------------------------------------------------
     '






    '--------------------------------------------------------------------------
    'STORE UPDATED COLOUR ALLOCATIONS
    '
Dmap35:
    if flag=0 goto Dmap13
    ps$="       Storing data - please wait       "
    row=24:column=21:colour=9:gosub 50
    open SacsFile$ for output as #1
    for i=1 to 18:print#1,SalesAreaColr(i):next:close:goto Dmap13
    '
     '-------------------------------------------------------------------------
    'INVALIDITY SUBROUTINE
    '
Dmap36:
    row=16:column=10:colour=12:ps$="Sales Area":gosub 50
    row=17                    :ps$=" not yet  ":gosub 50
    row=18                    :ps$=" defined  ":gosub 50
    beep:goto Dmap15
Dmap37:
    row=16:column=10:colour=12:ps$=" Invalid  ":gosub 50
    row=17                    :ps$="   try    ":gosub 50
    row=18                    :ps$="  again   ":gosub 50
    beep:goto Dmap15


     'DISPLAY THE SALES AREA NAMES AND COLOUR-KEY BOXES ON THE MAP SCREEN

Dmap38:
     y = 9                      'Up-biased vertical start-point
     for i = 1 to 18            'For all sales areas
     x = 25                     'Left margin (starting point)
     y = y + 8                  'Move 8 pixels down the screen
     kf = 1                     'Set colour for display of sales area names
     ps$ = Keyvs$( 0, i )

     if ps$ > "" then
        ps$ = chr$( 64 + i ) + " " + ps$  'Form sales area letter + name string
        gosub GrafChar          'Display the string as Graphics Chrs.+
        kf = SalesAreaColr( i ) 'Get this sales area's designated colour 
        x = Dmap17              'Set horiz position of `key box'
     end if

     if kf > 0 then
        x = 134 : yy = y                   'If colour is not background
        for k = 1 to 7                     'then display the 7-pixel deep
        line( x, yy ) - ( x + 8, yy ) ,kf  'by 9 pixel wide key box.
        yy = yy + 1
        next
     end if

     next:return                'Next sales area
     '
     '-------------------------------------------------------------------------
     '


     'GRAPHICS SCREEN DUMP ONTO OLYMPIA PRINTER                    GrafPrnt.BAS

     defint a-z
     input"Filespec of Screen Image File";Filespec$
     input"Printer Port spec            ";Portspec$
     input"Set DPI: 300, 150, 100, 75";DPI$

     screen 1
     color 1, 0
     bload FileSpec$
     open PP$(1) as #1
     width#1,255

     'SET UP THE HP DESKJET PRINTER FOR GRAPHICS PLOTTING

     print#1,chr$(27)"*p150X";
     print#1,chr$(27)"*p300Y";

     print#1,chr$(27)"*rB";             'Reset raster-graphics mode
     print#1,chr$(27)"*t"DPI$"R";       'Set graphics resolution (dpi)
     print#1,chr$(27)"*r1A";            'Start Raster Graphics
     print#1,chr$(27)"*r320S";          'Set graphics raster width

     'PLOTTING LOOP

     for y = 0 to 180                   'Vertical axis

     b = 128                            'Set the most significant bit
     a = 0                              'Clear the 8-pixel byte
     c$ = string$(40,0)                 'Form output string of 40 null bytes
     c = 1                              'Point to first byte of output string

     for x = 0 to 319                   'Horizontal axis

     if point( x, y ) > 0 then
        a = a or b                      'Set bit if pixel on
     end if

     if b = 128 then                    '8
        b = 64                          '
     elseif b = 64 then                 '7
        b = 32                          '
     elseif b = 32 then                 '6
        b = 16                          '
     elseif b = 16 then                 '5
        b = 8                           '
     elseif b = 8 then                  '4
        b = 4                           '
     elseif b = 4 then                  '3
        b = 2                           '
     elseif b = 2 then                  '2
        b = 1                           '
     elseif b = 1 then                  '1
        mid$(c$, c, 1) = chr$(a)        'implant bit pattern in output string
        c = c + 1                       'increment to next byte in row-string
        a = 0                           'reset the accumulator byte
        b = 128                         'shift setter bit back to MS position
     end if                             '

     next                               'Next horixontal pixel

     print#1,chr$(27)"*b40W"c$;         'Print the line of pixels
     next                               'Next row of pixels
     print#1,chr$(27)"*rB"chr$(12);     'End raster-graphics mode

     close
     screen 0
     print"Finished:"
     end


