

     RecNum = 1
     SearchState = 1
     DragNet = 1
     SearchStr$ = "0727-41311"
     DosMsg$ = "SEARCHING"
     DosClr = 12
     ShowMessages = 1

DragNet:
     if DragNet = 0 then return         'Dragnet search inactive.
     if LoadRecState = 6 then           'If [next] record loaded,

        k = 0 : v = 0
        while k < 11 and v = 0          'See if one of the fields
        k = k + 1
        v = instr(Rec$(k),SearchStr$)   'contains the search string.
        wend

        if v > 0 then                   'If yes,
           DosMsg$ = "FOUND"            'Display the `FOUND' message
           DosClr = 10                  'in bright green.
           SearchState = 1              'Load & display the required record
           goto DragNet1
        end if
     else                               'If search string not found,
        if RecNum < MaxRecNum then      'provided we are not on last record
           RecNum = RecNum + 1          'advance to next record
           LoadRecState = 1             'ask for it to be loaded
        else                            'Else we have tried the last record
           RecNum = 0                   'and still not found what we're
           DosMsg$ = "NOT FOUND"        'looking for, so display the
           DosClr = 12                  'NOT FOUND message, and
           goto DragNet1
        end if
     end if
     return
DragNet1:
     ShowMessages = 1
     LoadRecState = 0
     DragNet = 0                  'disable the dragnet search.
     return

