





     '-------------------------------------------------------------------------
     'SET UP MODEM CONTROL DATA             17NOV86         [File: EdModem.Bas]
     '-------------------------------------------------------------------------
     '
     'Author : R J Morton
     '
     'Enables you to set up the control parameters for the modem.
     '
     '-------------------------------------------------------------------------
     defint a-z
     '
     rem $include: 'ComVars.INC'
     common ems$, ems, em
     '
     dim menu$(9)      'Array to contain the electronic mail service names
     dim fields$(6)    'Fields to hold the subscriber details for each service
     dim ModemData$(8) 'Modem data array
     '
     goto EdModem1
     '
     rem $include: 'InChar.INC'
     rem $include: 'EdField.INC'
     rem $include: 'EdBlock.INC'
     rem $include: 'Multiblk.INC'
     rem $include: 'OpenFile.INC'
     rem $include: 'Decrypt.INC'
     rem $include: 'Expiry.INC'
     '
Display: row=row+1
50   call ScrSub(ps$,row,column,colour):return   'Fast screen display subr
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'EDIT THE SUBSCRIBER DETAILS OF SELECTED ELECTRONIC MAIL SERVICE
     '
EdModem1: gosub ExpiryTest
     ps$=space$(40):column=1
     for row=19 to 24:gosub 50:next
     '
     gosub GetModem                    'Load existing modem control parameters
     for k=1 to 7
     Multiblk$(k)=ModemData$(k):next   'Set them up in the editor array
     gosub EdModem2                    'Edit the modem parameters
     '
     if AmendM=1 then                  'Store edited modem control parameters
        for k=1 to 7                 
        ModemData$(k)=MultiBlk$(k)   
        next
        Y$=""
        for k=4 to 7
        x$=ModemData$(k)
        x=7                             'V21 - default
        if X$="V23-HOST" then x=1
        if X$="V23-TERM" then x=2
        if X$="V22"      then x=3
        if X$="V22BIS"   then x=4
        if X$="V21O"     then x=5
        if X$="V21A"     then x=6
        Y$=Y$+chr$(x)
        next
        ModemData$(8)=left$(ModemData$(1),1)+Y$
        gosub PutModem
        end if
     '
     prog$="EDMODEM":chain"Tmenu"      'Return to the Electronic mail main menu
     '
     '--------------------------------------------------------------------------
     '






     '------------------------------------------------------------------------
     'ENTER/EDIT THE MODEM CONTROL INFORMATION
     '
EdModem2:
     ps$=" ":colour=1
     column=79:for row=6 to 16:gosub 50:next
     column=41:for row=6 to 16:gosub 50:next
     ps$=space$(40):row=5:gosub 50
     for row=20 to 24:gosub 50:next
     row=5:column=42
     ps$="":gosub Display
     colour=19
     ps$=" MODEM CONTROL INFORMATION            ":gosub Display
     ps$="  ":gosub Display
     ps$=" Dialling: `PULSE' or` TONE'         ":gosub Display
     ps$=" PABX dialling prefix                ":gosub Display
     ps$=" N of rings before answer           ":gosub Display
     ps$=" CCITT mode Point-to-Point           ":gosub Display
     ps$=" CCITT mode Electronic Mail          ":gosub Display
     ps$=" CCITT mode Telex                    ":gosub Display
     ps$=" CCITT mode Terminal default         ":gosub Display
     colour=1
     ps$="":gosub Display
     colour=2:column=41
     ps$="                                        ":gosub Display
     ps$="   Please enter/edit the above modem    ":gosub Display
     ps$="   control information as necessary.    ":gosub Display
     '
     row=4:column=5:colour=2
     ps$="                                ":gosub Display
     ps$="                                ":gosub Display
     ps$="                                ":gosub Display
     ps$="                                ":gosub Display
     ps$="      Ŀ      ":gosub Display
     ps$="      CCITT MODE CHOICES      ":gosub Display
     ps$="      Ĵ      ":gosub Display
     ps$="         V23-TERM             ":gosub Display
     ps$="         V23-HOST             ":gosub Display
     ps$="         V22                  ":gosub Display
     ps$="         V22BIS               ":gosub Display
     ps$="         V21O                 ":gosub Display
     ps$="         V21A                 ":gosub Display
     ps$="         V21 (default)        ":gosub Display
     ps$="            ":gosub Display
     ps$="                                ":gosub Display
     '------------------------------------------------------------------------
     'SET UP AND CALL THE FIELD BLOCK EDITOR [EDBLOCK]
     '
     NumFlds = 7         'Number of fields
     NumBlks = 1
     InterBlk= 0
     LenField= 8         'Length of fields
     MultiRow= 9         'Row on which first field appears
     MultiCol=71         'Column in which left-hand field-column starts
     MsgPos=1            'Insert message position override
     Msg.v=4:Msg.h=70    'Message co-ordinates
     InstrCol=41
     caps=1
     gosub ShowBlocks    'Display the operator's editing instructions
     gosub EdBlocks      'Call MultiBlk
     return              'Exit
     '
     '--------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'LOAD MODEM CONTROL DATA
     '
     'Inputs  COMTYPE$ - type of communication required as shown below
     '       MODMFILE$ - File containing the required data
     '                   Record#1 - dialling method "PULSE" or "TONE"
     '                   Record#2 - PABX dialling prefix
     '                   Record#3 - number of rings before answer
     '                   Record#4 - CCITT mode for point-to-point
     '                   Record#5 - CCITT mode for telex
     '                   Record#6 - CCITT mode for for electronic mail
     '                   Record#7 - CCITT mode for terminal operation
     '
     'Outputs DIAL$ - type of dialling required [PULSE/TONE]
     '       CCITT$ - CCITT mode of transmission V21, V23, V22 etc
     '
     '
     '------------------------------------------------------------------------
     'SET CCITT V-MODE, DIAL METHOD [PULSE/TONE] & No OF RINGS BEFORE ANSWER
     '
GetModem:
     FileName$=ModmFile$:FileNum=1:RecLen=8:gosub OpenFile
     field#1,8 as f1$
     for k=1 to 7:get#1,k:ModemData$(k)=f1$:next
     close:return
     '
     '------------------------------------------------------------------------
     'STORE THE MODEM INFORMATION
     '
PutModem:
     FileName$=ModmFile$:FileNum=1:RecLen=8:gosub OpenFile
     field#1,8 as f1$
     for k=1 to 8:lset f1$=ModemData$(k):put#1,k:next
     close:return
     '
     '------------------------------------------------------------------------
     '
