





     'POST-MAILSHOT REPORT              12JUN87                  File:EmRep.Bas
     '-------------------------------------------------------------------------
     '
     'Author : R J Morton
     '
     'Enables the user to print out a list of the names & addresses of all the 
     'prospects to whom a specified mailshot was sent.
     '
     '-------------------------------------------------------------------------
     'INITIALIZATION
     '
     DefInt a-z                    'All intergers
     rem $include: 'ComVars.INC'   'Merge in the common variables
     common ems$, ems, em
     rem $include: 'ComVart.INC'   'Target-specific common variables
     dim rec$(12)                  'Array to hold name & address data
     dim pp$(20)                   'Holds printer port specs & control codes
     '
     dim Punc$(11)             'INTER-FIELD PUNCTUATION [Total 24 bytes]
     Punc$( 3)=", "            ' 2   These punctuation items 
     Punc$( 4)=", "            ' 2   appear immediately after
     Punc$( 5)=", "            ' 2   the record field of the
     Punc$( 6)=", "            ' 2   same number.
     Punc$( 8)=", Ph:"         ' 4
     Punc$( 9)=", Tx:"         ' 4
     Punc$(10)=", "            ' 2
     Punc$(11)=", "            ' 2
     '
     PrRecLen = 1024
     RecNum = 0
     ListFile$=TelxList$       'File Name of the Mialling list file
     RecFileNum=1              'File N under which Records File is opened
     AreaFileNum=2             'File N under which Sales Areas File is opened
     ListFileNum=3             'File N under which Mailling List File opened
     PrntFileNum=4             'Set File Number under which print file opened
     PrtBufNum=5               'File N under which Printer I/O File is opened
     ErrMsgRow= 3              'Row on which DOS error messages are displayed
     ErrMsgCol=45              'Start column for DOS error message displays
     paper = 1                 'To be printed on 15 by 11 inch listing paper
     PrtRow=20                 'First row of printer display panel
     PrtCol= 3                 'Left-most column of printer display panel
     gosub ResetNums
     NewLine$=chr$(13)+chr$(10)
     BlankLine$=space$(5)+NewLine$
     locate 21,32              'Cursor in printer control box
     '
     ReportTitle$="TELEXSHOT REPORT"
     '
     ps$=space$(40):row=19:column=1:gosub 50  'Clear row above printer box
     gosub ShowPpanel                         'Display printer control panel
     gosub showstates3
     ListInitState=1           'Activate the Initialization FMM
     PrtIntegState=1           'Activate the Printer Integrity Watch Dog FMM
     gosub ExpiryTest
     goto  StartLoop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'EXTERNAL SUBROUTINES
     '
 50  Call ScrSub(ps$,row,column,colour):return
     '
     rem $include: 'GetPrt.FMM'
     rem $include: 'GetKeyvs.FMM'
     rem $include: 'PrintIO.FMM'
     rem $include: 'KeyBoard.FMM'
     rem $include: 'PPanel.FMM'
     rem $include: 'RecordIO.FMM'
     rem $include: 'ListGeIO.FMM'
     rem $include: 'ListInit.FMM'
     rem $include: 'PrntFile.FMM'
     rem $include: 'OpenFile.FMM'
     rem $include: 'Decrypt.INC'
     rem $include: 'TexCrypt.INC'
     rem $include: 'Expiry.INC'
     '
     '-------------------------------------------------------------------------
     'FMM CONTROL LOOP
     '
StartLoop:
     active=1
     WHILE active
     gosub ListInit      'Load printer codes & error messages & initialize loop
     gosub KeyBoard      'Keyboard input/output FMM
     gosub PrintIO       'Printer input/output FMM
     gosub LoopCtrl      'Record print loop control
     gosub FileCtrl      'Controls opening and closing of the required files
     gosub NextAddr      'Get data for next addressee in the mailshot list
     gosub RecordIO      'Handles the input of the main prospect records
     gosub GetAreas      'Handles the input of the sales area data
     gosub ListGeIO      'Handles the input of the target list of prospects
     gosub HderCtrl      'Controls the printing of the header page
     gosub PrntFile      'Print the text of the letter
     gosub OpenFileFMM   'General file opener FMM
     gosub PrintLine     'Set up lines of print as required
     gosub KeybCtrl      'Loop escape watch dog for exiting this load module
     gosub PrtInteg      'Printer opener & interity watch dog
     gosub ShowMsgs      'Display any DOS messages picked up by above routines
     gosub ShowStates    'Display FMM states
     WEND
     FileNum=0:gosub CloseFile   'then close printer & all files
     ps$="":gosub ShowMsgs1      'clear error message field
     prog$="EMREP"               'tell next prog where control passed from
     chain"Emenu"                'exit this load module back to Lmenu
     '
     '-------------------------------------------------------------------------
     'FMM CONTROL LOOP
     '
DeActivate:
     LoopCtrlState=0    'Record print loop control
     FileCtrlState=0    'Controls the opening and closing of the required files
     RecordIOState=0    'Handles the input of the main prospect records
     GetAreasState=0    'Handles the input of the sales area data
     ListGeIOstate=0    'Handles the input of the target list of prospects
     OpenFileState=0    'General file opener FMM
     HderCtrlState=0
     PrntFileState=0
     for Filenum=1 to 4:gosub CloseFile:next:return  'Close all disk files
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'SHOW MESSAGES
     '
ShowMsgs:
     if ShowMessages=0 then return   'No messages waiting to be displayed
     if DosClr>0 then                'If there is a DOS message to be displayed
        colour=DosClr                'set the appropriate message colour
        DosClr=0                     'Message colour acts as message trigger
        ps$=DosMsg$                  'set up the message in the display string
        gosub ShowMsgs1              'display message
        end if
     if PrtClr>0 then                'If there's a Printer Status message to be
        colour=PrtClr                'displayed, set appropriate message colour
        PrtClr=0                     'Message colour acts as message trigger
        row=23:column=46         
        ps$=Pstatus$            _    'set up the message in the display string
       +space$(30-len(pstatus$))     'Pad out to 30 character message field
        gosub 50                     'display message
        gosub ShowPlamps             'display pritner status lamps
        end if
     ShowMessages=0                  'Cancel the `message display request'
     return                          'Return control to the Polling Loop
     '
ShowMsgs1:
     row=ErrMsgRow:column=ErrMsgCol  'Set message co-ordinates
     ps$=ps$+space$(36-len(ps$))     'Pad out to 36 character message field
     gosub 50                        'Call the fast screen display routine
     return                          'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'KEYBOARD CONTROL
     '
KeybCtrl:
     gosub NextChar                   
     if CtrlChar = 87 then              'If Shift-F4 hit, then
        FMMflag = 1                     'Enable FMM states display
        goto ShowStates3                'Show the display panel
     end if

     if KbChar=27 or CtrlChar=61 then active=0:return
     if KbChar<>13 and CtrlChar<>60 then return
     if LoopCtrlState=0 goto KeybCtrl1
     '
     if HaltPrinterFlag=0        _  'If not currently in a halt state
        then HaltPrinterFlag=1   _  'then set printer to halt state
        else HaltPrinterFlag=0   _  'else clear the halt state
            :ps$=""              _
            :gosub ShowMsgs1        'clear possible error message.
     '
     gosub ShowPostStartMsgs        'Display appropriate messages.
     return                         'Return control to the Polling Loop
     '
KeyBCtrl1:                          'Try to activate the Print Loop FMM
     if PrtIntegState=2 and      _  'If printer Integrity Watch Dog active
        ListInitState=4 then     _  'and the Lister Module initialized
        LoopCtrlState=1             'then activate the print loop FMM.
     HaltPrinterFlag=0
     gosub ShowPostStartMsgs        'Display appropriate messages.
     return                         'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'LOOP CONTROL FMM
     '
     'NOTE: Target list parameters (ie the contents of Record#1 of the Target
     '      List File) are already in Local Common Variables.
     '
LoopCtrl:
     IF LoopCtrlState=0 THEN RETURN     'MACHINE IDLE
     '
     IF LoopCtrlState=1 THEN            'INITIATE OPENING OF ALL REQUIRED FILES
        FileCtrlState=1                 'Activate the file opening process
        LoopCtrlState=2                 'Advance to next machine state
        END IF
     '
     IF LoopCtrlState=2 THEN            'WAIT FOR FILE-OPENING TO COMPLETE
        if FileCtrlState<5 then return  'all files not yet open, so exit
        if FileCtrlState=5 then         'If all files opened successfully, then
           TargItem=0                   'Set to get Mailling List header record
           ListGeIOstate=4              'activate the getting of the record
           LoopCtrlState=3              'set to loop advancement state
      else goto DeActivate              'De-activate all FMMs
           end if
        END IF
     '
     IF LoopCtrlState=3 THEN            'WAIT FOR HEADER RECORD TO LOAD
        if ListGeIOstate=5 then         'If header record got sucessfully, then
           gosub SetUpReportHeading 
           TargItem=0                   'Set to get first record of list
           gosub ShowListSize    
           HderCtrlState=1              'activate the report header page FMM
           LoopCtrlState=4              'set to loop advancement state
    elseif ListGeIOstate=10 then        'If file opening process failed, then
           goto DeActivate              'De-activate all FMMs
           end if
        END IF
     '
     IF LoopCtrlState=4 THEN            'WAIT FOR HEADER PAGE TO BE SET UP
        if HderCtrlState<4 then return  'Header getting process not finished
        if HderCtrlState=4 then         'If header record got sucessfully, then
           LoopCtrlState=5              'set to loop advancement state
      else goto DeActivate              'De-activate all FMMs
           end if
        END IF
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'LOOP CONTROL FMM (continued)
     '
     IF LoopCtrlState=5 THEN            'GO TO NEXT PROSPECT ON TARGET LIST
        if TargItem<TargSize then       'If last list member has been printed
           TargItem=TargItem+1          'Advance to [next] member of target list
           NextAddrState=1              'Get the details of the mext addressee
           LoopCtrlState=6              'Advance to the Get Record state
        else
           PrintIOflush = 1
           LoopCtrlState = 9
        end if
    END IF
  
    IF LoopCtrlState = 9 THEN
       if PrStr$ = "" and PrBlk$ = "" then  'If last record processed and
          Pstatus$="FINISHED"          'print output stack has finally been
          PrtClr=10:ShowMessages=1     'drained, show the FINISHED message &
          gosub ShowMsgs
          goto DeActivate              'De-activate FMM/close files & printer
       end if
     END IF
     '
     IF LoopCtrlState=6 THEN            'GET NEXT LIST MEMBER'S RECORD NUMBER
        if NextAddrState=5  then        'If next target list record got OK then
           LoopCtrlState=7              'Advance to the next machine state
    elseif NextAddrState=6  then        'If error occurred while getting record,
           goto DeActivate              'De-activate all FMMs
           end if
        END IF
     '
     IF LoopCtrlState=7 THEN            'WAIT FOR PRINT OUTPUT STACK TO EMPTY
        if len(PrStr$)<PrRecLen then    'If plenty of room on printer output
           PrintLineState=1             'stack then ask PrintLine.FMM to set up
           LoopCtrlState=8              'another line & return to get the next
           end if                       'record.
        END IF
     '
     IF LoopCtrlState=8 THEN            'WAIT FOR NEXT PRINT LINE TO BE SET UP
        if PrintLineState=2 then        'If the next print line has been set up
           PrintLineState=0             'de-activate the print line setter up
           PrStr$=PrStr$+PrintLine$     'add the new print line to the printer
           LoopCtrlState=5              'output stack and go for next record.
           end if
        END IF
     RETURN                             'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'PRINT LINE ROUTINE
     '
     'When externally set to State 1, this routine assembles the namecode, Ref
     'N, Cross Ref, postcode, sales area letter and name & address fields for
     'one prospect on the target list into a print line. It then transmutes to
     'State 2 indicating that the assembled print line is ready for printing.
     '
     '--------------------------------------------------------------------------
     'SET UP KEY FIELDS IN PRINT LINE
     '
PrintLine:                             'State 0: inactive
     if PrintLineState<>1 then return  'State 1: set up print line
                                       'State 2: print line ready
     PrintLine$=""                     'Clear the print line assembly string
     '
     if PageLineNum=0              _   'If it is the start of a new page
        then gosub PageHeader          'then set up a new page heading
     '
     gosub PrintLine1                  'Set up a normal print line
     '
     if TargItem=TargSize then     _   'If this is the final line of print
        gosub FinalFooter          _   'then append the final page footer
       :goto PrintLine3                'and exit.
     '
     BlockLineNum=BlockLineNum+1       'Increment N of line in current block
     '
     if BlockLineNum=5 and         _   'If now 5 lines in latest block
        PageLineNum<39 then        _   'and the page is not full
        BlockLineNum=0             _   'then reset block line count to start 
       :PrintLine$=PrintLine$      _   'next block and add a line feel in
               +BlankDotted$           'order to skip a line between blocks.
     '
     PageLineNum=PageLineNum+1         'Increment N of lines on current page
     '
     if PageLineNum=40 then        _   'If there are now 40 lines on this page
        PageLineNum=0              _   'clear line count for next page and
       :BlockLineNum=0                 'clear block line count for first block
     '
     if PageLineNum=0 then         _   'If about to begin a new page, then
        gosub NormalFooter         _   'print normal page footer and
       :PageNum=PageNum+1              'and increment the page number.
     '
PrintLine3:
     '
     PrintLineState=2                  'Set to `print line ready' state
     return                            'Return to line control loop
     '
     '--------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'ASSEMBLE A NORMAL PRINT LINE
     '
PrintLine1:  'Form Ref N, Message N as 4-digit strings with leading zeros
     '
     Number=RecNum   :gosub FiveDigit:RecNum$=Number$
     Number=LetterNum:gosub FourDigit:LetterNum$=Number$
     '
     LetterRef$=RecNum$     +" "_   '4-digit Ref N
               +SalesAreaID$+" "_   'Sales Area I/D letter
               +TargNum$    +" "_   'Target Profile Specification N
               +TargSer$    +" "_   'Target List Serial N
               +LetterNum$          'Letter Serial N
     Y=8
     X= 2:gosub PrintLine2:NameCode$=X$
     X= 7:gosub PrintLine2:PostCode$=X$
     '
     If StatusFlag=1 then StatusMsg$=" Sent " else StatusMsg$="      "
     '
     gosub TelexNumFormat
     Y=29
     X= 1:gosub PrintLine2:CompName$=X$
     X=10:gosub PrintLine2:ContName$=X$
     X=11:gosub PrintLine2:JobTitle$=X$
     '
     PrintLine$=PrintLine$  + "| " _
               +NameCode$   +" | " _   'Namecode             8
               +TimeStamp$  +" | " _   'Letter Date          4
               +LetterRef$  +" | " _   'Letter Reference     4
               +PostCode$   +" | " _   'Postcode             8
               +StatusMsg$  +" | "     'Postcode             8
     PrintLine$=PrintLine$         _
               +TelexNum$   +" | " _
               +EmailNum$   +" |"  _
               +CompName$   + "|"  _
               +ContName$   + "|"  _
               +JobTitle$   + "|"  _
               +NewLine$
     return
     '
PrintLine2: X$=left$(rec$(X),Y):X$=X$+space$(Y-len(X$)):return
     '
     '--------------------------------------------------------------------------
     'UNRAVEL THE TELEX & ELECTRONIC MAIL NUMBERS
     '
     'This routine gets the Telex/E-mail numbers from the Telex Field of the
     'prospect's record and formates the Telex Number into a 20 character
     'field and the Electronic Mailbox number into a 10-character field.
     '
TelexNumFormat:                        '  {123456789}
     X$=rec$(9)                        '  x         y
     x=instr(X$,"{")
     y=instr(X$,"}")
     if x=0 or y=0 then
        EmailNum$=""
        x=instr(X$,"*")
   else z=y-x-1
        if z>1 then
           if z>10 then z=10
           EmailNum$=mid$(X$,x+1,z)
           end if
        end if
     EmailNum$=EmailNum$+space$(10-len(EmailNum$))
     if x<1 or x>21 then x=21
     TelexNum$=left$(X$,X-1)
     TelexNum$=TelexNum$+space$(20-len(TelexNum$))
     return
     '
     '-------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'PRINT NEW PAGE HEADING
     '
PageHeader:
     PageNum$=str$(PageNum)              'Form the page number
     PageNum$=space$(4-len(PageNum$)) _  'into a 4-character string
             +PageNum$                   'with leading spaces.
     PrintLine$=PrintLine$        _
               +pp$(7)            _    'Set printer to 8.25 characters per inch
               +HeaderLine1$      _    'Print the first title line
               +PageNum$+NewLine$ _    'Page number
               +BlankLine$        _
               +pp$(6)            _    'Switch to 16.5 chrs/inch
               +HeaderLine2$      _
               +ColumnHeadings$        'Print column headings
     return
     '
     '--------------------------------------------------------------------------
     'PRINT NORMAL PAGE FOOTER
     '
NormalFooter:
     PrintLine$=PrintLine$        _   'Add to the print line:
               +BlankLine$        _
               +FootNote$         _
               +BlankLine$        _
               +"Continued..."    _   'Normal page footer
               +chr$(12)              'Throw the page
     return
     '
     '--------------------------------------------------------------------------
     'PRINT THE FINAL FOOTER
     '
FinalFooter:
     PrintLine$=PrintLine$ _   'Add to the printer output stack:
               +BlankLine$ _
               +FootNote$  _
               +BlankLine$ _
               +"END"      _   'Print final footer
               +chr$(12)   _   'Throw the page
               +pp$(4)     _   'Switch printer back to 10 chrs/inch
               +pp$(3)         'Reset the printer to default configuration
ResetNums:
     PageNum=0                 'Current page number
     PageLineNum =0            'N of lines printed so far on this page
     BlockLineNum=0            'N of lines printed so far in this 5-line block
     return
     '
     '--------------------------------------------------------------------------
     'FORM 4-DIGIT NUMBER AS A STRING WITH LEADING ZEROS
     '
FiveDigit: LenFld=5:goto FFFFdigit:
FourDigit: LenFld=4
     '
FFFFdigit:
     Number$=str$(Number)
     Number$=right$(Number$,len(Number$)-1)
     LenNum=len(Number$)
     if LenNum>LenFld then
        Number$=string$(LenFld,"/")
        else
        if LenNum<LenFld then Number$=string$(LenFld-LenNum,"0")+Number$
        end if
     return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'FILE OPENING CONTROL FMM
     '
FileCtrl:
     on FileCtrlState goto _    'State 0: Inactive
        FileCtrl1,         _    'State 1: Activate Records file opening
        FileCtrl2,         _    'State 2: Activate Areas file opening
        FileCtrl3,         _    'State 3: Activate Target file opening
        FileCtrl4,         _    'State 4: If all files open goto Wait State
        FileCtrl5,         _    'State 5: File open wait state
        FileCtrl6               'State 6: Close all involved files
     '                          'State 7: Successful Termination state
     return                     'State 8: Error state
     '
     '--------------------------------------------------------------------------
     'OPEN MAIN RECORDS FILE
     '
FileCtrl1:
     '
     RecordIOstate=1            'Activate the record input/output FMM to open
     FileCtrlState=2            'the records file and advance to next state.
     return
     '
     '--------------------------------------------------------------------------
     'OPEN SALES AREAS FILE
     '
FileCtrl2:
     '
     if RecordIOstate=3  then _ 'If the records file is now open, then
        GetAreasState=1       _ 'Activate areas file input FMM to open
       :FileCtrlState=3         'the target list file; advance to next state.
     '
     if RecordIOstate=10      _ 'If records file wouldn't open, then
        goto FileCtrl8        _ 'de-activate all FMMs involved and exit.
     '
     return
     '
     '--------------------------------------------------------------------------
     'OPEN TARGET LIST FILE
     '
FileCtrl3:
     '
     if GetAreasState=3  then _ 'If the areas file is now open, then
        ListGeIOstate=1       _ 'Activate target file input/output FMM to open
       :FileCtrlState=4         'the target list file; advance to next state.
     '
     if GetAreasState=8       _ 'If areas file wouldn't open, then
        goto FileCtrl8        _ 'de-activate all FMMs involved and exit.
     '
     return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'WAIT FOR TARGET LIST FILE TO OPEN
     '
FileCtrl4:
     if ListGeIOstate=3  then   'If the records file is now open, then
        FileCtrlState=5         'the target list file; advance to next state.
 elseif ListGeIOstate=10 then   'If records file wouldn't open, then
        goto FileCtrl8          'de-activate all FMMs involved and exit.
        end if
     return
     '
     '--------------------------------------------------------------------------
     'ALL FILES OPEN & READY FOR I/O
     '
FileCtrl5: return               'All files open Wait State
     '
     '--------------------------------------------------------------------------
     'CLOSE ALL FILES
     '
FileCtrl6:
     FileNum=1:gosub CloseFile  'Close Records File
     FileNum=2:gosub CloseFile  'Close Areas File
     FileNum=3:gosub CloseFile  'Close Target File
     gosub DeActivate           'De-activate
     FileCtrlState=7            'Successful Termination State
     '
     '--------------------------------------------------------------------------
     'ALL FILES CLOSED OK
     '
FileCtrl7: return               'Wait State
     '
     '--------------------------------------------------------------------------
     'FILE OPENING FAILED
     '
FileCtrl8:                      'Open failure
     gosub DeActivate           'De-activate
     FileCtrlState=8            'Set this FMM to its error state
     return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'SET UP TITLE LINE 1 - PACKAGE NAME, LISTING TITLE, SERIAL, DATE, PAGE
     '
     'Note: The first line is printed in 8.25 chr/inch lettering which allows
     '      108 characters across the standard 15-inch platen.
     '
SetUpReportHeading:
     Number=ExtrFlag                'Form the target serial number 
     gosub FourDigit                'into a
     TargSer$=Number$               '4-digit string with leading zeros.
     '
     if TargNum<1 or TargNum>20 then TargNum=0
     TargNum$=str$(TargNum)
     if TargNum>9 then TargNum$=    right$(TargNum$,2)_
                  else TargNum$="0"+right$(TargNum$,1)
     '
     HeaderDrop$=BlankLine$+BlankLine$+BlankLine$+BlankLine$+BlankLine$
     '
     if CompanyName$="" then CompanyName$="E.B.S. MARKETEER"
     '
     CompanyName$=left$(CompanyName$,27) 'Safety limit for company name
     ReportTitle$=left$(ReportTitle$,24) 'Safety limit for report title
     '
     x=53                     _          'N of spare character spaces
      -len(CompanyName$)      _          'minus lengths of company name &
      -len(ReportTitle$)                 'report title giving spaces left.
     '
     y=x/2:x=x-y                         'Divide the spaces left in two.
     Number=ExtrFlag:gosub FourDigit:TargSer$=Number$
     '
     HeaderLine1$=HeaderDrop$         _  'First heading line comprises...
       +CompanyName$+space$(x)        _  'Company name + padding
       +ReportTitle$+space$(y)        _  '+ Report Title + padding =   52 chrs
       +"TARGET NO "+TargNum$+"  "    _  '10+4+2 characters            16 chrs
       +"SERIAL NO "+TargSer$+"  "    _  '10+4+2 characters            16 chrs
       +sd$                  +"  "    _  'System date  15+2            17 chrs
       +"PAGE"                           'Page N  4+4=                 8 chrs
     '                                                                ---
     'Total                                                           109 chrs
     '
     'Note: The page number which is 4-characters long is appended to this
     '      string at the time each page heading is set up during printing.
     '
     HeaderLine2$=BlankLine$+space$(33)+"|     MESSAGE REF      |"+NewLine$
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'SET UP TITLE LINE 4 - THE COLUMN HEADINGS
     '
SetUpReportHeading3:
     '
     BlankDotted$_
     ="|----------|---------------------|----------------------|----------|"_
     +"--------|----------------------|------------|"_
     +"-----------------------------|"_
     +"-----------------------------|"_
     +"-----------------------------|"_
     +NewLine$
     '
     ColumnHeadings$_
     ="| NAMECODE | MESSAGE TIME & DATE |  Ref  S TP TS   LS   | POSTCODE |"_
     +" STATUS | TELEX NUMBER         |EMAIL NUMBER|"_
     +" NAME OF COMPANY             |"_
     +" NAME OF CONTACT             |"_
     +" JOB TITLE                   |"_
     +NewLine$+BlankDotted$
     '
     FootNote$_
       ="Key to Message Ref: "_                               ' 20
       +"Ref=Prospect's Ref Number  "_                        ' 27
       +"S=Prospect's Sales Area I/D (see Map Display)  "_    ' 47
       +"TP=Target Profile Specification Number  "_           ' 40
       +"LS=Individual Message Serial Number"                 ' 35
     '
     return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'DISPLAY FMM STATES TABLE
     ' 
ShowStates3:
     column=41:colour=grey:ps$=space$(40):row= 5:gosub 50
     for row=6 to 15:gosub 50:next
     ps$="    Ŀ    ":row=16:gosub 50
     ps$="    N of addressees on List  0000    ":row=17:gosub 50
     ps$="    Printing Addressee N     0000    ":row=18:gosub 50
     ps$="        ":row=19:gosub 50
     ps$="    Ŀ    ":row=20:gosub 50
     ps$="    PRINTER STATUS                    ":row=21:gosub 50
     ps$="    Ĵ    ":row=22:gosub 50
     ps$="                                      ":row=23:gosub 50
     ps$="        ":row=24:gosub 50
     return
     '
ShowListSize: number=TargSize:row=17:colour=7:gosub ShowStates1:return
     '
     '--------------------------------------------------------------------------
     'DISPLAY THE FMM STATES  [COLUMN 1]
     '
ShowStates:
     if LastTargItem<>TargItem then
        LastTargItem =TargItem
        colour=7
        row=18:number=TargItem:gosub ShowStates1
        end if
     return
     '
ShowStates1: gosub FourDigit:column=72:ps$=number$:goto 50
     '
     '-------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'PRINTER INITIALIZATION & INTEGRITY MONITOR
     '
PrtInteg:
     on PrtIntegState goto  _  'State 0: inactive
        PrtInteg1,          _  'State 1: wait for initialization to complete
        PrtInteg2,          _  'State 2: check printer initially or after error
        PrtInteg3              'State 3: wait for the printer to open
     return                    'Return to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     'WAIT FOR THE INITIALIZATION PROCESS TO COMPLETE
     '
PrtInteg1:
     if ListInitState=4 then _      'If the initialization process completed
        PrtIntegState=2             'Initiate the opening of the printer
     if ListInitState=5 then _      'If the initialization process has failed
        ListInitState=1             'the re-activate it & try again.
     return                         'Return control to the Polling Loop
     '
     '--------------------------------------------------------------------------
     'SEE IF PRINTER IN OPEN
     '
PrtInteg2:
     if PrintIOstate=3 then return  'Printer I/O FMM in normal active state
     if PrintIOstate=4 then return  'Printer I/O FMM in X-off state
     PrtIntegState=3                'Advance to wait for printer on
     PrintIOstate=1                 'Activate the printer I/O FMM
     gosub ShowPreStartMsgs         'Show the `switch on the printer' message
     return                         'Return to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     'WAIT FOR PRINTER TO OPEN
     '
PrtInteg3:
     if PrintIOstate>2 then        'If the printer is on and ready or
        PrtIntegState=2            're-set the Printer Watchdog to monitoring
        end if
     return                         'Return to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'SET UP MESSAGE SKELETON FOR MAILSHOT REPORT
     '
     'This FMM generate the first page of the Mailshot Report on which is shown
     'the Page 0 title line and a skeleton version of the letter that was sent
     'to the addressees listed on the subsequent pages of the report.
     '
HderCtrl:
     '
     if HderCtrlState=0 then return   'Inactive
     '
     on HderCtrlState goto_  '
        HderCtrl1,        _  'Set up skeleton name & address & activate file
        HderCtrl2,        _  'Wait for letter text to be printed
        HderCtrl3            'Set up final salutation matter
                             'Successful termination
     return                  'Error condition
     '
     '-------------------------------------------------------------------------
     'SET UP PAGE 0 HEADING + SKELETON NAME & ADDRESS & ACTIVATE FILE PRINT FMM
     '
HderCtrl1:
     PageNum$=str$(PageNum)              'Form the page number
     PageNum$=space$(4-len(PageNum$)) _  'into a 4-character string
             +PageNum$                   'with leading spaces.
     PageNum=1
     w$=pp$(7)            _    'Set printer to 8.25 characters per inch
       +HeaderLine1$      _    'Print the first title line
       +PageNum$+NewLine$ _    'Page number
       +BlankLine$        _
       +pp$(6)            _    'Set printer to 16.5 characters per inch
       +"MESSAGE TEXT:"   _
       +BlankLine$        _
       +BlankLine$
     x$="[Addressee's Telex Number & Answerback]"                   +NewLine$_
       +"[Originator's Telex Number, Answerback & Telephone Number]"+NewLine$_
       +BlankLine$
     y$="09:44am TUE 16 JUN 1987  "_
       +"Ref 0000 S "+TargNum$+" "+TargSer$+" 0000"+NewLine$_
       +BlankLine$_
       +"To:  [Contact][Company]"+NewLine$_
       +"From:[Name   ][Company]"+NewLine$_
       +"Subj:[Subject]"+NewLine$_
       +BlankLine$_
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'INITIALIZE PRINT STACK & ACTIVATE THE FILE PRINT FMM
     '
     PrStr$=pp$(2)   _  'Reset printer and set it to draft mode
	   +pp$(5)   _  'Set printer to landscape
           +w$+x$+y$    'Put Name & address skeleton on the print output stack
     PrntFileState=1    'Activate the opening of the Print File
     HderCtrlState=2    'Advance to the next state
     return             'Return control to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     'WAIT FOR THE MESSAGE TEXT TO BE PRINTED
     '
HderCtrl2:
     if PrntFileState=4 then _    'If the letter text has been printed, then
        HderCtrlState=3
     if PrntFileState=5 then _    'If the letter printing process failed, then
        HderCtrlState=5           'Go to the failure state
     return                       'Return control to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     'PRINT THE SALUTATION MATTER
     '
HderCtrl3:
     x$="End of message"+NewLine$_
       +BlankLine$
     y$="This message's Library entry is: "_
       +chr$(34)+str$(cvi(LibNum$))+" "+MsgTitle$+chr$(34)_
       +"  Number of addressees:"+str$(TargSize)_
       +chr$(12)
     PrStr$=PrStr$+x$+y$          'Add letter salutation etc to print stack
     HderCtrlState=4              'De-activate self.
     return                       'Return control to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'LOAD ALL DETAILS FOR THE NEXT ADDRESSEE ON THE MAILSHOT LIST
     '
NextAddr:
     on NextAddrState goto _    '
        NextAddr1,         _    '
        NextAddr2,         _    'Get next addressee's record number
        NextAddr3,         _    '
        NextAddr4               '
                                'State 5: termination state
     return                     'State 6: error state
     '
     '-------------------------------------------------------------------------
     'ACTIVATE GETTING OF NEXT ADDRESSEE'S REF NUMBER
     '
NextAddr1:
     ListGeIOstate=4             'Activate getting of the next targ list rec
     NextAddrState=2             'Advance to next state
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S RECORD NUMBER
     '
NextAddr2:
     if ListGeIOstate=5  then _  'If the next target list record got OK then
        RecordIOstate=4       _  'Activate the main record `get' process
       :NextAddrState=3          'Advance to the next machine state
     if ListGeIOstate=10 then _  'If error occurred while getting record, then
        NextAddrState=6          'Go to error state
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S RECORD
     '
NextAddr3:
     if RecordIOstate=5  then _  'If the next target list record got OK then
        GetAreasState=4       _  'Activate the sales area search
       :NextAddrState=4          'Advance to next state
     if RecordIOstate=10 then _  'If error occurred while getting record, then
        NextAddrState=6          'Go to error state
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S SALES AREA
     '
NextAddr4:
     if GetAreasState=5  then _  'If the next target list record got OK then
        NextAddrState=5          'got to the termination state
     if GetAreasState=8  then _  'If error occurred while getting record, then
        NextAddrState=6          'Go to error state
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------

