





     'EXPORT TARGET LIST    Author : R J Morton     05JUL89      File:List1.Bas

     'Enables the user to print out a list of the names & addresses of all the 
     'prospects who are on a specified Target List.

     'INITIALIZATION

     DefInt a-z                         'All interger
     rem $include: 'ComVars.INC'        'Merge in the common variables
     rem $include: 'ComVarT.INC'        'Local group commons
     dim rec$(13)                       'Array to hold name & address data
     dim rec%(13)                       'Field formats
     rec%( 1)=29                        'Name
     rec%( 2)= 8                        'NameCode
     rec%( 3)=29                        'House
     rec%( 4)=29                        'Street
     rec%( 5)=29                        'Town
     rec%( 6)=17                        'County
     rec%( 7)= 8                        'PostCode
     rec%( 8)=29                        'Telephone
     rec%( 9)=29                        'Telex
     rec%(10)=29                        'Contact Name
     rec%(11)=29                        'Contact's Job Title
     rec%(12)=29      'normally Xref, used hear as the `Dear' field
     rec%(13)=10                        'sincerely/faithfully
     '
     TRUE = -1 : FALSE = 0
     RecFileNum=1              'File N under which Records File is opened
     TargFileNum=2             'File N under which Target List File is opened
     ExportFile=3              'File N under which Printer I/O File is opened
     ErrMsgRow= 3              'Row on which DOS error messages are displayed
     ErrMsgCol=45              'Start column for DOS error message displays
     LE$=chr$(13)+chr$(10)     'Line-end
     gosub ExpiryTest
     FileNameEntryState=1               'Activate the Initialization FMM

     PostAreaList$ = "ABALB BABBBDBHBLBNBRBSBTCACBCFCHCMCOCRCTCVCWDADDDEDGDHDL"_
                   + "DNDTDYEHENEXFKFYG GLGUHAHDHGHPHRHUHXIGIPIVKAKTKWKYL LALD"_
                   + "LELLLNLSLUM MEMKMLNENGNNNPNROLOXPAPEPHPLPOPRRGRHRMS SASG"_
                   + "SKSLSMSNSOSPSRSSSTSYTATDTFTNTQTRTSTWUBWAWDWFWNWRWSWVYOZE"_
                   + "E ECN NWSESWW WC"

     mode = op                          'Set mode = menu number
     if op = 6 then Alison$ = chr$(13) + chr$(10) else Alison$ = ""
     if op > 3 then mode = op - 2 : Cathy = TRUE
     LoopActive = TRUE

     '





     'FMM CONTROL LOOP

     WHILE LoopActive
     gosub KeyBoard      'Keyboard I/O FMM
     gosub FileNameEntry
     gosub LoopCtrl      'Record print loop control
     gosub RecordIO      'Handles the input of the main prospect records
     gosub GetAreas      'Handles the input of the sales area data
     gosub TargetIO      'Handles the input of the target list of prospects
     gosub OpenFileFMM   'General file opener FMM
     gosub Export        'Store bytes in Export Stack to file.
     gosub ShowMsgs      'Display any DOS messages picked up by above routines
     gosub ShowStates    'Display FMM states
     WEND
     close                           'then close printer & all files
     ps$="":gosub ShowMsgs1          'clear error message field
     prog$="EXPORT"                  'Set program identification variable
     chain"Lmenu"                    'exit this load module back to Lmenu


     'EXTERNAL SUBROUTINES

 50  Call ScrSub(ps$,row,column,colour):return

     rem $include: 'KeyBoard.FMM'
     rem $include: 'EdField.FMM'
     rem $include: 'RecordIO.FMM'
     rem $include: 'TargetIO.FMM'
     rem $include: 'OpenFile.FMM'
     rem $include: 'Expiry.INC'
     rem $include: 'Decrypt.INC'
     rem $include: 'TexCrypt.INC'


DeActivate:
     ExportOn=0         'Swich off the Export FMM
     LoopCtrlState=0    'Record print loop control
     RecordIOState=0    'Handles the input of the main prospect records
     TargetIOState=0    'Handles the input of the target list of prospects
     OpenFileState=0    'General file opener FMM
     close:return       'Close printer & all files

     '





     'FileNameEntry A LETTER FROM A NAMED FILE   by R J MORTON

FileNameEntry:
     IF FileNameEntryState=1 THEN       'If the machine is in State 1, then
        colour=2:column=41
        ps$="    Please enter the path/filename of   ":row= 5:gosub 50
        ps$="    the file into which you require     ":row= 6:gosub 50
        ps$="    the exported names & addresses to   ":row= 7:gosub 50
        ps$="    be placed. The default [C/R] only   ":row= 8:gosub 50
        ps$="    is                                  ":row= 9:gosub 50
        ps$="                                        ":row=10:gosub 50
        ps$="         Press Esc key to quit.         ":row=11:gosub 50
        ps$="Esc":column=56:colour=10:gosub 50
        ps$=space$(40):column=41:for row=12 to 24:gosub 50:next
        FieldStr$="\EXPORT.TXT"
        ps$=FieldStr$+space$(22):row=9:column=48:colour=7:gosub 50
        FieldRow=9:FieldCol=48:FieldLen=32:caps=1:CharCol=1
        EdFieldState=1:FileNameEntryState=2

 ElseIF FileNameEntryState=2 THEN       'If the machine is in State 2, then
        gosub EdFieldFMM
        if EdFieldState<3 then return   'Field editor not yet terminated.
        EdFieldState=0                  'De-activate it.
        FileNameEntryState=3
        if KbChar=27 then               'If Escape key were pressed, then
           LoopActive=0                 'de-activate the mail polling loop
      else LoopCtrlState=1              'Activate the Loop Control FMM
           ExportOn=1                   'Activate the Export FMM
           if AmendFlag>0 then          'If the field were amended, then
              ExportFile$=FieldStr$     'Filespec (Path+File Name) of Prospect
         else ExportFile$="\EXPORT.TXT"
              end if                    '
           column=41:colour=grey
           ps$="    Ŀ    ":row=16:gosub 50
           ps$="    N of addressees on List  0000    ":row=17:gosub 50
           ps$="    Now writing addressee N  0000    ":row=18:gosub 50
           ps$="        ":row=19:gosub 50
           number=TargSize:row=17:colour=7:gosub ShowStates1
           end if                       '

 ElseIF FileNameEntryState=3 THEN       'If the machine is in State 3, then
        if KbStr$>"" then               'No key has been struck
           KbChar=asc(left$(KbStr$,1))  'Get ASCII value of next character &
           KbStr$=right$(KbStr$,len(KbStr$)-1)
           if KbChar=27 then LoopActive=0 'If the `Esc' key has been pressed
           end if
        END IF

     return                             'Return control to the Polling Loop

     '





     'LOOP CONTROL FMM
     '
LoopCtrl:
     on LoopCtrlState goto LoopCtrl1, LoopCtrl2, LoopCtrl3, LoopCtrl4, LoopCtrl5
     return

LoopCtrl1:                              'INITIALIZATION
     RecordIOstate = 1                  'Activate record I/O FMM to open
     LoopCtrlState = 2                  'records file and advance to next state
     return

LoopCtrl2:                              'OPEN SALES AREAS FILE
     if RecordIOstate = 3  then         'If the records file is now open, then
        TargetIOstate = 1               'Activate target file I/O FMM to open
        LoopCtrlState = 3               'target list file; advance to next state
 elseif RecordIOstate = 10 then         'If records file wouldn't open, then
        gosub DeActivate                'De-activate
     end if
     return

LoopCtrl3:                              'ADVANCE TO NEXT PROSPECT ON TARGET LIST
     if TargetIOstate = 3  then         'If the records file is now open, then
        if TargItem < TargSize then     'If last list member has been printed
           TargItem = TargItem + 1      'Advance to [next] member of target list
           TargetIOstate = 4            'Activate getting of next targ list rec
           LoopCtrlState = 4            'Advance to Get Record state
        else                            'Else Switch off Export FMM to make
           ExportOn = 0                 'it store
           if E$ = "" then              'When printer ouput stack is
              ps$ = "FINISHED" : row = 14 : column = 57 : colour = 10 : gosub 50
              gosub DeActivate          'finally empty, de-activate all FMMs
           end if                       'and close all files.
        end if
     elseif TargetIOstate = 10 then     'If records file wouldn't open, then
        gosub DeActivate                'De-activate
     end if
     return

LoopCtrl4:                              'GET NEXT LIST MEMBER'S RECORD NUMBER
     if TargetIOstate = 5  then         'If next target list record got OK then
        RecordIOstate = 4               'Activate main record `get' process
        LoopCtrlState = 5               'Advance to next machine state
     elseif TargetIOstate = 10 then     'If error occurred while getting record,
        gosub DeActivate                'De-activate all FMMs
     end if
     '





LoopCtrl5:                              'GET NEXT LIST MEMBER'S RECORD
     if RecordIOstate = 5 then          'If next record got OK then
        if len(E$) < 256 then           'If there is plenty of room on export

           if Cathy = TRUE then         'Cathy's special requirement
              gosub Cathy
              kk = 13
           else
              kk = 12
           end if

           FOR k = 1 TO kk
           if Cathy = TRUE and ( k = 2 or k = 8 or k = 9 ) then
              flag = 0
           else
              x = rec%(k)
              x$ = left$( rec$(k), x )
              if mode = 1 then          'If normal lime-delimited mode, then
                 x$ = x$ + LE$
              elseif mode = 2 then      'If comma-delimited, then
                 if k = kk then         'Terminate last line with CR/LF
                    y$ = LE$
                 else                   'Terminate all other lines with
                    y$ = chr$(44)       'a comma.
                 end if
                 x$ = chr$(34) + x$ + chr$(34) + y$   'ASCII 34 is a "mark
              elseif mode = 3 then      'If fixed field format, then
                 x$ = x$ + space$( x - len(x$) )
              end if
              if Cathy = TRUE then
                 rec$(k) = x$
              else 
                 E$ = E$ + x$           'Add line to output stack
              end if
           end if
           NEXT

           if Cathy = TRUE then
              E$ = E$ + rec$(10) + Alison$ _
                      + rec$(11) + Alison$ _
                      + rec$(1)  + Alison$ _
                      + rec$(3)  + Alison$ _
                      + rec$(4)  + Alison$
              E$ = E$ + rec$(5)  + Alison$ _
                      + rec$(6)  + Alison$ _
                      + rec$(7)  + Alison$ _
                      + rec$(12) + Alison$ _
                      + rec$(13) + Alison$ + Alison$
           end if

           LoopCtrlState = 3            'Go back to get next record.
           TargetIOstate = 3
        end if
     elseif RecordIOstate = 10 then     'If error occurred while getting record
           gosub DeActivate             'De-activate all FMMs
     end if
     RETURN                             'Return control to Polling Loop

     '





     'EXPORT FILE FMM [ACTIVATED BY THE PRESENCE OF DATA IN E$]

     'When switched on, stores contents of stack E$ into the Export File.

Export:
     If ExportOn then                   'External On/Off switch for Export FMM
        If len(E$)>128 then             'If there is data in the Export Stack
           if ExportActive then         'if the export file is thought open
              ExportTimer=30            'Set 30-second hold when stack empty
              gosub Export0             'Store the 128-byte block to disk
           elseif OpenFileState=0 then  'If file opener not yet activated,
              FileName$=ExportFile$     'Set up the file name
              FileNum=ExportFile        'and the file number
              RecLen=128                'and the record (block) length
              OpenFileState=1           'then activate it.
           elseif OpenFileState=5 then  'If file has been opened successfully
              OpenFileState=0           'De-activate the file opener FMM
              Field ExportFile,128 as EF$
              ExportActive=1            'Set Export FMM as ACTIVE.
           elseif OpenFileState=6 then  'If file could not be opened, then
              OpenFileState=0           'De-activate the file opener FMM
              ExportActive=0            'Trip the Export FMM [self] off
           end if
        end if
     ELSEIF ExportActive THEN           'Nothing in Export Stack, so if active,
        While E$>"":gosub Export0:wend  'Store the 128-byte block to disk
        ExportActive=0                  'Set Export FMM to INACTIVE.
        OpenFileState=0
        FileNum=ExportFile              'close the Export File using the
        gosub CloseFile                 'error protected file closer and
     END IF                             '

EndExport: RETURN                       'Return to the FMM polling loop.


     'HANDLES ERRORS OCCURRING ON THE PUT# FUNCTION

Export0:
     on error goto Export1              'Set trap for PUT# error
     lset EF$=left$(E$,128)             'Set 128 block into output file buffer
     put ExportFile                     'Store the block to disk
     on error goto 0
     X=len(E$)                          'Chop the stored 128 bytes off stack
     if X>128 then E$=right$(E$,X-128) else E$=""
     return
Export1:
     if err<>52 then                    'If error shows file not open, then
        DosMsg$="Export:"+er$(err)      'Else display the DOS error message
        DosClr=12:ShowMessages=1        'Trigger the error message display.
        end if                          '
     ExportActive=0:resume Export2      'and de-activate the Export FMM.
Export2:
     on error goto 0:return EndExport

     '





     'SHOW MESSAGES

ShowMsgs:
     if ShowMessages>0 then          'Messages waiting to be displayed
        if DosClr>0 then             'If there's a DOS message to be displayed
           colour=DosClr             'set the appropriate message colour
           DosClr=0                  'Message colour acts as message trigger
           ps$=DosMsg$               'set up the message in the display string
           gosub ShowMsgs1           'display message
           end if
        ShowMessages=0               'Cancel the `message display request'
        end if
     return                          'Return control to the Polling Loop
     '
ShowMsgs1:
     row=ErrMsgRow:column=ErrMsgCol  'Set message co-ordinates
     ps$=ps$+space$(36-len(ps$))     'Pad out to 36 character message field
     gosub 50                        'Call the fast screen display routine
     return                          'Return control to the Polling Loop


     'DISPLAY THE FMM STATES

ShowStates: colour=7
     if LastTargItem<>TargItem then _
        LastTargItem =TargItem      _
       :row=18:number=TargItem:gosub ShowStates1
     return

ShowStates1: gosub FourDigit:column=72:ps$=number$:goto 50


FourDigit:
     LenFld=4
     Number$=str$(Number)
     Number$=right$(Number$,len(Number$)-1)
     LenNum=len(Number$)
     if LenNum>LenFld then
        Number$=string$(LenFld,"/")
     else
        if LenNum<LenFld then Number$=string$(LenFld-LenNum,"0")+Number$
     end if
     return
     '





     'SET UP THE NAME & ADDRESS

Cathy:
     x$ = rec$(10)                      'Get the contact name field
     C$ = x$                            'Hold for `Dear ...' field processing
     y$="{":gosub NameAddress2          'Replace qualification delimiters
     y$="}":gosub NameAddress2          'with spaces.
     y=instr(x$,"(")                    'Find bracket at start of familiar name
     if y>0 then x$=left$(x$,y-1)       'Chop off `familiar' name if present
     rec$(10) = x$
     x = 10 : gosub NameAddress1        'Set up the contact name

     x$ = rec$(9)
     y=instr(x$,"*")                    'Find comment delimiter character [*]
     if y>0 then x$=left$(x$,y-1)       'Strip off comment if there is one
     rec$(9) = x$
     
     x = 11 : gosub NameAddress1     'Job title
     x = 1  : gosub NameAddress1     'Company name
     x = 3  : gosub NameAddress1     'House
     x = 4  : gosub NameAddress1     'Street
     x = 5  : gosub NameAddress0     'TOWN
     x = 6  : gosub NameAddress1     'County


     'CHECK THAT THE POSTCODE IS AN ACTUAL UK POSTCODE

     z$ = rec$( 7)                      'Post Code
     y$ = left$( z$, 2 )                'First letter of two-letter post area
     j = 0
     K = len(PostAreaList$) - 1
     WHILE j = 0 and k > 0
     if mid$( PostAreaList$, k, 2 ) = Y$ then j = 1 else k = k - 2
     WEND


     'DE-RATIONALISE THE POSTCODE

     if k>0 then
        if mid$(z$,3,1) = "0" then z$ = left$(z$,2) + right$(z$,5)
        if mid$(z$,2,1) = " " then z$ = left$(z$,1) + mid$(z$,3,6)
        x$ = z$
     else
        x$ = "        "
     end if

     j = len(x$)
     for k = 1 to j
     if mid$(x$,k,1) = "0" then         'Replace computer zero by letter O
        mid$(x$,k,1) = "O"              'because Royal Mail OCR can't read
     end if                             'computer zeros 0.
     next
     rec$(7) = x$ 
     x = 7 : gosub NameAddress1
     '





     'EXTRACT & PRINT CONTACT'S FORENAME NAME IF GIVEN

     z = instr(C$,"*")                  'Get `contact name'
     if z > 0 then C$ = left$(C$,z - 1) 'Strip off beyond *

     if len(C$) < 2 then                'If no contact name specified, then

        if len( rec$(11) ) < 2 then     'if no office/job title given, then
           dear$ = "Sirs"               'address the company as Sirs
        else
           dear$ = "Sir/Madam"          'else address the officer as Sir etc
        end if

        rec$(13) = "faithfully"
        goto DearWho7                   'No contact name
     else
        rec$(13) = "sincerely"
     end if

     x$ = "{" : y$ = "}" : gosub DearWho8    'Cut out qualification letters.
     x$ = "(" : y$ = ")" : gosub DearWho8    'Isolate contact's familiar name.
     if x > 0 goto DearWho7                  'Familiar name given.

     x = instr(C$, " Esq")                   'Change Esq format to Mr format
     if x = 0 then x = instr(C$, " ESQ")
     if x > 0 then
        C$ = "Mr " + left$(C$, x - 1) + right$(C$, len(C$) - x - 3 )
     end if
     y = instr(C$, " ")                 'Find first space in the contact field
     if y > 0 then                      '(ie the space following Mr, Mrs etc.)
        x$ = left$(C$, y - 1)           'If found, extract contact's title
     else
        x$ = ""                         'else title is null
     end if
DearWho5:
     if right$(C$,1) = " " then         'Chop any trailing spaces which may
        C$ = left$(C$, len(C$) - 1 )    'be on the end of the contact name
        goto DearWho5                   'string
     end if
DearWho6:
     y = instr(C$, " ")                 'Locate [next] space along the string
     if y > 0 then                      'If one is found,
        C$ = right$(C$, len(C$) - y )   'chop off everything before it
        goto DearWho6                   'and the space itself.
     end if
     dear$ = x$ + " " + C$

DearWho7: rec$(12) = dear$ : return

DearWho8:                               'ISOLATE TEXT BETWEEN DELIMITERS
     x = instr(C$, x$)                  'Delimiters for first-name addressing
     y = instr(C$, y$)
     if x > 0 then
        if y < x then C$ = C$ + y$ : y = len(C$)  'y cannot = x!
        dear$ = mid$( C$, x + 1 , y - x - 1 )
        C$ = left$( C$, x - 1 ) + right$( C$, len(C$) - y )
     end if
     return
     '





     'STRIP COMMENTS OFF ADDRESS LINES AND ADD STRIPPED LINES TO OUTPUT STACK

NameAddress0:
     x$ = rec$(x)
     l = len(x$)                        'To put posttown in caps
     for k = 1 to l
     y = asc( mid$(x$, k, 1) )
     if y > 96 and y < 123 then
        mid$(x$, k, 1) = chr$(y - 32)
     end if
     next : goto NameAddress3

NameAddress1:
     x$ = rec$(x)
NameAddress3:
     y = instr(x$, "*")                 'Find comment delimiter character [*]
     if y > 0 then
        x$ = left$(x$, y - 1)           'Strip off comment if there is one
     end if
     rec$(x) = x$
     x = x + 1                          'Advance to next address line
     return                             'Return to above routine.

NameAddress2:                           'Replace { or } with a space.
     x = instr(x$,y$)
     if x > 0 then mid$(x$,x,1) = " "
     return


     '   KEYSĿ
     '                                                            dates
     '   SIC NĿ 
     '                           ATTRIBUTES        CODES       LAST   NEXT
     '   XREFĿ                                        EVENT  EVENT
     '                                                              
     '         xxxxxxxx0000@A@@aaaaaaaaaaaaaaaacccccccccccccccc////@//////@//


