





     '-------------------------------------------------------------------------
     'LOAD KEY VALUES FROM DISK TO ARRAYS    15DEC86       [File: GETKEYVS.BAS]
     '-------------------------------------------------------------------------
     'Loads the 5 major keys' names + sets of values from disk to memory array.
     'The calling routine must DIM KEYVS$(4,18)
     '
     ' 9625 goto GetKeyvs
     '
     'Input File: KEYVFILE$="[path]+KEYVS"
     '
     'Outputs: KEYVS$(0,K) - Sales Area key name + Sales Area names
     '         KEYVS$(1,K) - Relation Key name + Relation Key's values
     '         KEYVS$(2,K) - Status Key name + Status Key's values
     '         KEYVS$(3,K) - Event Key name + Event Key's values
     '         KEYVS$(4,K) - Product Line Key name + Product Key's values
     '              ERRER$ - Contains error message if there is one
     '
     'Locals  I - Key type index
     '        K - Key name index
     '        X - Name/Value string length
     '        Y - Number of values currently defined for the current key
     '
     '-------------------------------------------------------------------------
     'ENTRY POINT
     '
GetKeyvs:
     on error goto GetKeyvs3
     open keyvfile$ as #1 len=346
     for i=0 to 4                       '5 keys
     get#1,i+1                          'Load the next record
     for k=0 to 18                      'K=0 is Key Name; K=1 to A are Key Values
     x=cvi(input$(2,1))                 'Length of key value string
     if x>1 and x<19 then               'If Key value string length in range
        keyvs$(i,k)=input$(x,1)         'Load the key value string
        end if
     next                               'Next key value
     next                               'Next record
     errer$=""                          'Clear error word on completion
     '
GetKeyvs2:
     on error goto 0:close:return
     '
GetKeyvs3:
     errer$=er$(err):resume GetKeyvs2   'Set error flag
     '
     '-------------------------------------------------------------------------

