






     '-------------------------------------------------------------------------
     'GRAPHICS CHARACTER GENERATOR         08DEC86         [File: GRAFCHAR.BAS]
     '-------------------------------------------------------------------------
     'Used in START, STATI, DMAP, LOGOGEN2, MAPGEN2, MAPGEN3
     '         
     'Prints a string ps$ in small block-style characters for annotating maps &
     'bar charts. Supports Only letters A-Z and a-z, number 0-9 and - & space.
     '
     'The character raster is *****  5 by 7 pixels
     '                        *****
     '                        *****
     '                        *****
     '                        *****
     '                        *****
     '                        *****
     '
     'Inputs  PS$ - input string to be printed
     '        KF  - colour parameter
     '
     'Locals   Pixel co-ordinates within the 4 by 7 character raster
     '         X - horizontal [0=left to 4=right]
     '         Y - vertical   [0=top to 7=bottom]
     '
     '     GRAFL - length of the string to be displayed [No oc characters]
     '     GRAFK - character pointer [position within input string]
     '
     '-------------------------------------------------------------------------
     'DISPLAY A STRING A$ IN GRAPHICS LETTERING
     '
GrafChar:
     grafl=len(ps$)
     for grafk=1 to grafl
     grafa=asc(mid$(ps$,grafk,1))
     '
     if grafa=39 then line(x,y)-(x,y+3),kf    :x=x+2:goto GrafCha3   ''
     if grafa<45 then                          x=x+3:goto GrafCha3   'space
     if grafa=45 then line(x,y+3)-(x+2,y+3),kf:x=x+4:goto GrafCha3   '-
     if grafa=46 then pset(x,y+6),kf          :x=x+2:goto GrafCha3   '.
     if grafa=47 then line(x,y+6)-(x+4,y+2),kf:x=x+6:goto GrafCha3   '/
     if grafa<58 goto GrafCha2                                       'number
     if grafa<65 then                          x=x+3:goto GrafCha3   'Bum chr
     if grafa<91 goto GrafCha1                                       'capital
     if grafa<97 then                          x=x+3:goto GrafCha3   'Bum chr
     on grafa-96 gosub _
     GrafA03,GrafA10,GrafA16,GrafA21,GrafA27,GrafA34,GrafA39,GrafA46,GrafA51,_
     GrafB01,GrafB07,GrafB14,GrafB17,_
     GrafB24,GrafB29,GrafB35,GrafB41,GrafB47,GrafC01,GrafC08,GrafC13,GrafC18,_
     GrafC23,GrafC30,GrafC38,GrafC44
     x=x+4:goto GrafCha3
     '
GrafCha1:
     on grafa-64 _
     gosub GrafG00,GrafG11,GrafG15,GrafG22,GrafG26,GrafG30,GrafG35,GrafG40,GrafG45,GrafG50,GrafH01,GrafH10,GrafH14,_
           GrafH20,GrafH26,GrafH30,GrafH36,GrafH44,GrafH48,GrafI01,GrafI05,GrafI10,GrafI17,GrafI23,GrafI34,GrafI41
     x=x+6:goto GrafCha3
     '
GrafCha2:
     on grafa-47 gosub GrafD03,GrafD09,GrafD12,GrafD20,GrafD26,GrafD31,_
                       GrafD39,GrafD46,GrafD50,GrafE01
     x=x+5
GrafCha3:
     next:return
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'CAPITAL LETTERS
     '-------------------------------------------------------------------------
GrafG00:
     line(x  ,y+6)-(x  ,y+2),kf         'A
     LINE(X+4,Y+2)-(X+4,Y+6),KF
     PSET(X+2,Y  )          ,KF
     PSET(X+1,Y+1)          ,KF
     PSET(X+3,Y+1)          ,KF
     LINE(X+1,Y+4)-(X+3,Y+4),KF
     RETURN
     '-------------------------------------------------------------------------
GrafG11:
     GOSUB GrafE13                         'B
     LINE(X+1,Y+3)-(X+3,Y+3),KF
     RETURN
     '-------------------------------------------------------------------------
GrafG15:
     LINE(X+3,Y  )-(X+1,Y  ),KF
     LINE(X  ,Y+1)-(X  ,Y+5),KF
     LINE(X+1,Y+6)-(X+3,Y+6),KF
     PSET(X+4,Y+5)          ,KF
     PSET(X+4,Y+1)          ,KF
     RETURN                             'C
     '-------------------------------------------------------------------------
GrafG22:
     GOSUB GrafE13
     PSET(X+4,Y+3)          ,KF
     RETURN                             'D
     '-------------------------------------------------------------------------
GrafG26:
     LINE(X  ,Y+6)-(X+3,Y+6),KF
     GOSUB GrafG30
     RETURN                             'E
     '-------------------------------------------------------------------------
GrafG30:
     LINE(X+3,Y  )-(X  ,Y  ),KF
     LINE         -(X  ,Y+6),KF
     LINE(X+1,Y+3)-(X+3,Y+3),KF
     X=X-1:RETURN                       'F
     '-------------------------------------------------------------------------
GrafG35:
     GOSUB GrafG15
     LINE(X+2,Y+3)-(X+4,Y+3),KF
     PSET(X+4,Y+4)          ,KF
     RETURN                             'G
     '-------------------------------------------------------------------------
GrafG40:
     LINE(X  ,Y  )-(X  ,Y+6),KF
     LINE(X+4,Y  )-(X+4,Y+6),KF
     LINE(X+1,Y+3)-(X+3,Y+3),KF
     RETURN                             'H
     '-------------------------------------------------------------------------
GrafG45:
     LINE(X+1,Y  )-(X+1,Y+6),KF
     LINE(X  ,Y  )-(X+2,Y  ),KF
     LINE(X  ,Y+6)-(X+2,Y+6),KF
     X=X-2:RETURN                       'I
     '-------------------------------------------------------------------------
GrafG50:
     LINE(X+2,Y  )-(X+4,Y  ),KF
     LINE(X+3,Y+1)-(X+3,Y+5),KF
     LINE(X+2,Y+6)-(X+1,Y+6),KF
     PSET(X  ,Y+5)          ,KF
     RETURN                             'J
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
GrafH01:
     LINE(X  ,Y  )-(X  ,Y+6),KF
     PSET(X+4,Y  )          ,KF
     PSET(X+3,Y+1)          ,KF
     PSET(X+2,Y+2)          ,KF
     PSET(X+1,Y+3)          ,KF
     PSET(X+2,Y+4)          ,KF
     GOSUB GrafE24
     RETURN                              'K
     '-------------------------------------------------------------------------
GrafH10:
     LINE(X  ,Y  )-(X  ,Y+6),KF
     LINE         -(X+4,Y+6),KF
     RETURN                              'L
     '-------------------------------------------------------------------------
GrafH14:
     GOSUB GrafE20
     PSET(X+2,Y+2)         ,KF
     PSET(X+1,Y+1)         ,KF
     PSET(X+3,Y+1)         ,KF
     RETURN                              'M
     '-------------------------------------------------------------------------
GrafH20:
     GOSUB GrafE20
     PSET(X+1,Y+2)        ,KF
     PSET(X+2,Y+3)        ,KF
     PSET(X+3,Y+4)        ,KF
     RETURN                              'N
     '-------------------------------------------------------------------------
GrafH26:
     GOSUB GrafG15
     LINE(X+4,Y+2)-(X+4,Y+4),KF
     RETURN                              'O
     '-------------------------------------------------------------------------
GrafH30:
     LINE(X  ,Y+6)-(X  ,Y  ),KF
     LINE         -(X+3,Y  ),KF
     LINE(X+4,Y+1)-(X+4,Y+2),KF
     LINE(X+3,Y+3)-(X  ,Y+3),KF
     RETURN                              'P
     '-------------------------------------------------------------------------
GrafH36:
     LINE(X+4,Y+1)-(X+4,Y+4),KF
     LINE(X,  Y+1)-(X  ,Y+4),KF
     LINE(X+1,Y  )-(X+3,Y  ),KF
     LINE(X+1,Y+5)-(X+4,Y+5),KF
     LINE(X+2,Y+4)-(X+2,Y+6),KF
     PSET(X+3,Y+6)          ,KF
     RETURN                              'Q
     '-------------------------------------------------------------------------
GrafH44:
     GOSUB GrafH30
     GOSUB GrafE24
     RETURN                              'R
     '-------------------------------------------------------------------------
GrafH48:
     PSET(X+4,Y+1)          ,KF
     LINE(X+3,Y  )-(X+1,Y  ),KF
     LINE(X  ,Y+1)-(X  ,Y+2),KF
     LINE(X+1,Y+3)-(X+3,Y+3),KF
     LINE(X+4,Y+4)-(X+4,Y+5),KF
     LINE(X+3,Y+6)-(X+1,Y+6),KF
     PSET(X,Y+5)            ,KF
     RETURN                               'S
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
GrafI01:
     LINE(X+2,Y  )-(X+2,Y+6),KF
     LINE(X  ,Y  )-(X+4,Y  ),KF
     RETURN                               'T
     '-------------------------------------------------------------------------
GrafI05:
     LINE(X  ,Y  )-(X  ,Y+6),KF
     LINE         -(X+4,Y+6),KF
     LINE         -(X+4,Y  ),KF
     RETURN                               'U
     '-------------------------------------------------------------------------
GrafI10:
     LINE(X  ,Y  )-(X  ,Y+4),KF
     LINE(X+4,Y  )-(X+4,Y+4),KF
     PSET(X+2,Y+6)          ,KF
     PSET(X+1,Y+5)          ,KF
     PSET(X+3,Y+5)          ,KF
     RETURN                               'V
     '-------------------------------------------------------------------------
GrafI17:
     GOSUB GrafE20
     PSET(X+2,Y+4)          ,KF
     PSET(X+1,Y+5)          ,KF
     PSET(X+3,Y+5)          ,KF
     RETURN                               'W
     '-------------------------------------------------------------------------
GrafI23:
     LINE(X  ,Y  )-(X  ,Y+1),KF
     LINE(X+4,Y  )-(X+4,Y+1),KF
     LINE(X  ,Y+5)-(X  ,Y+6),KF
     LINE(X+4,Y+5)-(X+4,Y+6),KF
     PSET(X+1,Y+2)          ,KF
     PSET(X+3,Y+2)          ,KF
     PSET(X+1,Y+4)          ,KF
     PSET(X+3,Y+4)          ,KF
     PSET(X+2,Y+3)          ,KF
     RETURN                               'X
     '-------------------------------------------------------------------------
GrafI34:
     LINE(X+2,Y+2)-(X+2,Y+6),KF
     PSET(X  ,Y  )          ,KF
     PSET(X+4,Y  )          ,KF
     PSET(X+1,Y+1)          ,KF
     PSET(X+3,Y+1)          ,KF
     RETURN                               'Y
     '-------------------------------------------------------------------------
GrafI41:
     LINE(X  ,Y  )-(X+4,Y  ),KF
     LINE(X  ,Y+6)-(X+4,Y+6),KF
     LINE(X+4,Y+1)-(X  ,Y+5),KF
     RETURN                               'Z
     '-------------------------------------------------------------------------
GrafI46:
     PSET(X+6,Y+6)          ,KF
     X=X+9
     X=X+9:RETURN                         'Advance full character width
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
      REM SMALL LETTERS
     '-------------------------------------------------------------------------
GrafA03:
     LINE(X  ,Y+2)-(X+2,Y+2),KF
     LINE         -(X+2,Y+6),KF
     LINE         -(X  ,Y+6),KF
     LINE         -(X  ,Y+4),KF
     LINE         -(X+2,Y+4),KF
     RETURN                            'a
     '-------------------------------------------------------------------------
GrafA10:
     LINE(X  ,Y  )-(X  ,Y+6),KF
     LINE         -(X+2,Y+6),KF
     LINE         -(X+2,Y+2),KF
     LINE         -(X  ,Y+2),KF
     RETURN                            'b
     '-------------------------------------------------------------------------
GrafA16:
     LINE(X+2,Y+2)-(X  ,Y+2),KF
     LINE         -(X  ,Y+6),KF
     LINE         -(X+2,Y+6),KF
     RETURN                            'c
     '-------------------------------------------------------------------------
GrafA21:
     LINE(X+2,Y  )-(X+2,Y+6),KF
     LINE         -(X  ,Y+6),KF
     LINE         -(X  ,Y+2),KF
     LINE         -(X+2,Y+2),KF
     RETURN                            'd
     '-------------------------------------------------------------------------
GrafA27:
     LINE(X+1,Y+4)-(X+2,Y+4),KF
     LINE         -(X+2,Y+2),KF
     LINE         -(X  ,Y+2),KF
     LINE         -(X  ,Y+6),KF
     LINE         -(X+2,Y+6),KF
     RETURN                            'e
     '-------------------------------------------------------------------------
GrafA34:
     PSET(X+1,Y  )          ,KF
     LINE(X  ,Y  )-(X  ,Y+6),KF
     PSET(X+1,Y+3)          ,KF
     X=X-1:RETURN                      'f
     '-------------------------------------------------------------------------
GrafA39:
     LINE(X+2,Y+6)-(X  ,Y+6),KF
     LINE         -(X  ,Y+2),KF
     LINE         -(X+2,Y+2),KF
     LINE         -(X+2,Y+8),KF
     LINE         -(X  ,Y+8),KF
     RETURN                            'g
     '-------------------------------------------------------------------------
GrafA46:
     LINE(X  ,Y  )-(X  ,Y+6),KF
     LINE(X  ,Y+2)-(X+2,Y+2),KF
     LINE         -(X+2,Y+6),KF
     RETURN                            'h
     '-------------------------------------------------------------------------
GrafA51:
     PSET(X  ,Y+1)          ,KF
     LINE(X  ,Y+3)-(X  ,Y+6),KF
     X=X-2:RETURN                      'i
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
GrafB01:
     PSET(X+2,Y+1)          ,KF
     LINE(X+2,Y+3)-(X+2,Y+7),KF
     PSET(X+1,Y+8)          ,KF
     PSET(X  ,Y+7)          ,KF
     RETURN                            'j
     '-------------------------------------------------------------------------
GrafB07:
     LINE(X  ,Y  )-(X  ,Y+6),KF
     PSET(X+2,Y+2)          ,KF
     PSET(X+1,Y+3)          ,KF
     PSET(X+1,Y+5)          ,KF
     PSET(X+2,Y+6)          ,KF
     RETURN                            'k
     '-------------------------------------------------------------------------
GrafB14:
     LINE(X  ,Y  )-(X  ,Y+6),KF
     X=X-2:RETURN                      'l
     '-------------------------------------------------------------------------
GrafB17:
     LINE(X  ,Y+2)-(X  ,Y+6),KF
     LINE(X+2,Y+2)-(X+2,Y+6),KF
     LINE(X+4,Y+2)-(X+4,Y+6),KF
     PSET(X+1,Y+2)          ,KF
     PSET(X+3,Y+2)          ,KF
     X=X+2:RETURN                      'm
     '-------------------------------------------------------------------------
GrafB24:
     LINE(X  ,Y+2)-(X  ,Y+6),KF
     LINE(X+2,Y+2)-(X+2,Y+6),KF
     PSET(X+1,Y+2)          ,KF
     RETURN                            'n
     '-------------------------------------------------------------------------
GrafB29:
     LINE(X  ,Y+2)-(X  ,Y+6),KF
     LINE(X+2,Y+2)-(X+2,Y+6),KF
     PSET(X+1,Y+2)          ,KF
     PSET(X+1,Y+6)          ,KF
     RETURN                            'o
     '-------------------------------------------------------------------------
GrafB35:
     LINE(X  ,Y+2)-(X  ,Y+8),KF
     LINE(X+2,Y+2)-(X+2,Y+6),KF
     PSET(X+1,Y+2)          ,KF
     PSET(X+1,Y+6)          ,KF
     RETURN                            'p
     '-------------------------------------------------------------------------
GrafB41:
     LINE(X  ,Y+2)-(X  ,Y+6),KF
     LINE(X+2,Y+2)-(X+2,Y+8),KF
     PSET(X+1,Y+2)          ,KF
     PSET(X+1,Y+6)          ,KF
     RETURN                            'q
     '-------------------------------------------------------------------------
GrafB47:
     LINE(X  ,Y+6)-(X  ,Y+2),KF
     LINE         -(X+2,Y+2),KF
     RETURN                            'r
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
GrafC01:
     LINE(X+2,Y+2)-(X  ,Y+2),KF
     LINE         -(X  ,Y+4),KF
     LINE         -(X+2,Y+4),KF
     LINE         -(X+2,Y+6),KF
     LINE         -(X  ,Y+6),KF
     RETURN                            's
     '-------------------------------------------------------------------------
GrafC08:
     LINE(X  ,Y+1)-(X  ,Y+6),KF
     PSET(X+1,Y+6)          ,KF
     PSET(X+1,Y+2)          ,KF
     X=X-1:RETURN                      't
     '-------------------------------------------------------------------------
GrafC13:
     LINE(X  ,Y+2)-(X  ,Y+6),KF
     LINE(X+2,Y+2)-(X+2,Y+6),KF
     PSET(X+1,Y+6)          ,KF
     RETURN                            'u
     '-------------------------------------------------------------------------
GrafC18:
     LINE(X  ,Y+2)-(X  ,Y+5),KF
     LINE(X+2,Y+2)-(X+2,Y+5),KF
     PSET(X+1,Y+6)          ,KF
     RETURN                            'v
     '-------------------------------------------------------------------------
GrafC23:
     LINE(X  ,Y+2)-(X  ,Y+5),KF
     LINE(X+2,Y+4)-(X+2,Y+5),KF
     LINE(X+4,Y+2)-(X+4,Y+5),KF
     PSET(X+1,Y+6)          ,KF
     PSET(X+3,Y+6)          ,KF
     X=X+2:RETURN                      'w
     '-------------------------------------------------------------------------
GrafC30:
     LINE(X  ,Y+2)-(X  ,Y+3),KF
     LINE         -(X+2,Y+5),KF
     LINE         -(X+2,Y+6),KF
     LINE(X+2,Y+2)-(X+2,Y+3),KF
     LINE         -(X  ,Y+5),KF
     LINE         -(X  ,Y+6),KF
     RETURN                            'x
     '-------------------------------------------------------------------------
GrafC38:
     LINE(X  ,Y+2)-(X  ,Y+6),KF
     LINE         -(X+1,Y+6),KF
     LINE(X+2,Y+2)-(X+2,Y+8),KF
     LINE         -(X  ,Y+8),KF
     RETURN                            'y
     '-------------------------------------------------------------------------
GrafC44:
     LINE(X  ,Y+2)-(X+2,Y+2),KF
     LINE         -(X+2,Y+3),KF
     LINE         -(X  ,Y+5),KF
     LINE         -(X  ,Y+6),KF
     LINE         -(X+2,Y+6),KF
     RETURN                            'z
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'NUMBERS 1 2 3 4 5 6 7 8 9 0
     '-------------------------------------------------------------------------
GrafD03:
     LINE(X  ,Y  )-(X+3,Y  ),KF
     LINE         -(X+3,Y+6),KF
     LINE         -(X  ,Y+6),KF
     LINE         -(X  ,Y  ),KF
     RETURN                              '0
     '-------------------------------------------------------------------------
GrafD09:
     LINE(X  ,Y  )-(X  ,Y+6),KF
     X=X-3:RETURN                        '1
     '-------------------------------------------------------------------------
GrafD12:
     PSET(  X,Y+1)          ,KF
     LINE(X  ,Y  )-(X+3,Y  ),KF
     LINE         -(X+3,Y+3),KF
     LINE         -(X  ,Y+3),KF
     LINE         -(X  ,Y+6),KF
     LINE         -(X+3,Y+6),KF
     RETURN                              '2
     '-------------------------------------------------------------------------
GrafD20:
     LINE(X  ,Y  )-(X+3,Y  ),KF
     LINE         -(X+3,Y+6),KF
     LINE         -(X  ,Y+6),KF
     LINE(X  ,Y+3)-(X+2,Y+3),KF
     RETURN                              '3
     '-------------------------------------------------------------------------
GrafD26:
     LINE(X  ,Y  )-(X  ,Y+4),KF
     LINE         -(X+3,Y+4),KF
     LINE(X+2,Y+2)-(X+2,Y+6),KF
     RETURN                              '4
     '-------------------------------------------------------------------------
GrafD31:
     LINE(X+3,Y  )-(X  ,Y  ),KF
     LINE         -(X  ,Y+3),KF
     LINE         -(X+3,Y+3),KF
     LINE         -(X+3,Y+6),KF
     LINE         -(X  ,Y+6),KF
     PSET(X  ,Y+5)          ,KF
     RETURN                              '5
     '-------------------------------------------------------------------------
GrafD39:
     LINE(X+3,Y  )-(X  ,Y  ),KF
     LINE         -(X  ,Y+6),KF
     LINE         -(X+3,Y+6),KF
     LINE         -(X+3,Y+3),KF
     LINE         -(X+1,Y+3),KF
     RETURN                              '6
     '-------------------------------------------------------------------------
GrafD46:
     LINE(X  ,Y  )-(X+3,Y  ),KF
     LINE         -(X+3,Y+6),KF
     RETURN                              '7
     '-------------------------------------------------------------------------
GrafD50:
     LINE(X  ,Y  )-(X+3,Y  ),KF
     LINE         -(X+3,Y+6),KF
     LINE         -(X  ,Y+6),KF
     LINE         -(X  ,Y  ),KF
     LINE(X+1,Y+3)-(X+2,Y+3),KF
     RETURN                              '8
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
GrafE01:
     LINE(X+2,Y+3)-(X  ,Y+3),KF
     LINE         -(X  ,Y  ),KF
     LINE         -(X+3,Y  ),KF
     LINE         -(X+3,Y+6),KF
     LINE         -(X  ,Y+6),KF
     RETURN                              '9
     '-------------------------------------------------------------------------
     '
     '
     '-------------------------------------------------------------------------
     'LETTER SUB-SUBS
     '-------------------------------------------------------------------------
GrafE13:
     LINE(X+3,Y  )-(X  ,Y  ),KF
     LINE         -(X  ,Y+6),KF
     LINE         -(X+3,Y+6),KF
     LINE(X+4,Y+1)-(X+4,Y+2),KF
     LINE(X+4,Y+4)-(X+4,Y+5),KF
     RETURN
     '-------------------------------------------------------------------------
GrafE20:
     LINE(X  ,Y  )-(X  ,Y+6),KF
     LINE(X+4,Y  )-(X+4,Y+6),KF
     RETURN
     '-------------------------------------------------------------------------
GrafE24:
     PSET(X+2,Y+4)          ,KF
     PSET(X+3,Y+5)          ,KF
     PSET(X+4,Y+6)          ,KF
     RETURN
     '-------------------------------------------------------------------------
GrafE29: RETURN                 'DUMMY SUBROUTINE
     '
