





     'GENERATES MAILLING/CALLING LISTS Author : R J Morton  11JUN87 ListGen.Bas

     'Generates a mailling list, a telesales calling list or a telexshot list 
     'from the current Target List.

     'INITIALIZATION

     DefInt a-z                    'A=single precision for elapsed time Routine
     rem $include: 'ComVars.INC'   'Merge in the common variables
     rem $include: 'ComVarT.INC'   'Local group commons
     gosub ExpiryTest
     prog$="LISTGEN"               'Set program identification variable

     TargFileNum=1             'File N under which Target List File is opened
     ListFileNum=2             'File N under which Calling List File is opened
     ErrMsgRow= 3              'Row on which DOS error messages are displayed
     ErrMsgCol=45              'Start column for DOS error message displays

     ListFile$=""
     if op=6 then ListFile$=PrntList$    'NOTE: op is a common variable
     if op=7 then ListFile$=PhonList$    '      set by Lmenu.
     if op=8 then ListFile$=TelxList$
     '
     locate 21,30              'Cursor in printer control box
     gosub ShowStartDisplay
     goto  StartLoop
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'EXTERNAL SUBROUTINES
     '
 50  Call ScrSub(ps$,row,column,colour):return
     '
     rem $include: 'KeyBoard.FMM'
     rem $include: 'TargetIO.FMM'
     rem $include: 'ListGeIO.FMM'
     rem $include: 'OpenFile.FMM'
     rem $include: 'Decrypt.INC'
     rem $include: 'Expiry.INC'
     '
     '-------------------------------------------------------------------------
     'FMM CONTROL LOOP
     '
StartLoop:
     gosub KeyBoard      'Keyboard input/output FMM
     gosub LoopCtrl      'Record print loop control
     gosub FileCtrl      'Controls opening and closing of the required files
     gosub TargetIO      'Handles the input of the target list of prospects
     gosub ListGeIO      'Handles the input of the target list of prospects
     gosub OpenFileFMM   'General file opener FMM
     gosub KeybCtrl      'Loop escape watch dog for exiting this load module
     gosub ShowMsgs      'Display any DOS messages picked up by above routines
     gosub ShowStates    'Display FMM states
     goto StartLoop
     '
     '-------------------------------------------------------------------------
     'FMM CONTROL LOOP
     '
DeActivate:
     LoopCtrlState=0    'Record print loop control
     FileCtrlState=0    'Controls the opening and closing of the required files
     TargetIOState=0    'Handles the input of the target list of prospects
     ListGeIOState=0    'Handles the input of the target list of prospects
     OpenFileState=0    'General file opener FMM
     close:return       'Close printer & all files
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'SHOW MESSAGES
     '
ShowMsgs:
     if ShowMessages>0 then          'Messages waiting to be displayed
        if DosClr>0 then             'If there is a DOS message to be displayed
           colour=DosClr             'set the appropriate message colour
           DosClr=0                  'Message colour acts as message trigger
           ps$=DosMsg$               'set up the message in the display string
           gosub ShowMsgs1           'display message
           end if
        ShowMessages=0               'Cancel the `message display request'
        end if
     return                          'Return control to the Polling Loop
     '
ShowMsgs1:
     row=ErrMsgRow:column=ErrMsgCol  'Set message co-ordinates
     ps$=ps$+space$(36-len(ps$))     'Pad out to 36 character message field
     gosub 50                        'Call the fast screen display routine
     return                          'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'KEYBOARD CONTROL
     '
KeybCtrl:
     if KbStr$="" then return           'No key has been struck
     KbChar=asc(left$(KbStr$,1))        'Get ASCII value of next character &
     KbStr$=right$(KbStr$,len(KbStr$)-1)'pop it off the Keyboard input stack
     if KbChar=27 then                  'If the `Esc' key has been pressed
        close                           'then close printer & all files
        ps$="":gosub ShowMsgs1          'clear error message field
        chain"Lmenu"                    'exit this load module back to Lmenu
        end if
     if KbChar=13 then                  'Invalid key stroke if not a C/R
        gosub ShowWorkDisplay      
        LoopCtrlState=1                 'then activate the print loop FMM.
        end if
     return                             'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'LOOP CONTROL FMM
     '
     'NOTE: Target list parameters (ie the contents of Record#1 of the Target
     '      List File) are already in Local Common Variables.
LoopCtrl:
     if LoopCtrlState=1 then        'INITIATE OPENING OF ALL REQUIRED FILES
        FileCtrlState=1             'Activate the file opening process
        LoopCtrlState=2             'Advance to next machine state
     '
 elseif LoopCtrlState=2 then        'WAIT FOR FILE-OPENING TO COMPLETE
        if FileCtrlState=4 then     'If all files opened successfully, then
           LoopCtrlState=3          'set to loop advancement state.
    elseif FileCtrlState=7 then     'If file opening process failed, then
           gosub DeActivate         'De-activate all FMMs
           end if
     '
 elseif LoopCtrlState=3 then        'ADVANCE TO NEXT PROSPECT ON TARGET LIST
        if TargItem<TargSize then   'If last list member not printed
           TargItem=TargItem+1      'Advance to [next] member of target list
           TargetIOstate=4          'Activate getting of the next targ list rec
           LoopCtrlState=4          'Advance to the Get Record state
      else TargItem=0               'else set flag to store file header
           ListGeIOstate=6          'activate storing of Calling List record
           LoopCtrlState=6          'Advance to final termination state.
           end if
     '
 elseif LoopCtrlState=4 then        'GET THE NEXT LIST MEMBER'S RECORD NUMBER
        if TargetIOstate=5  then    'If the next target list record got OK then
           ListGeIOstate=6          'activate storing of Calling List record
           LoopCtrlState=5          'Advance to wait for storage confirmation
    elseif TargetIOstate=10 then    'If error occurred while getting record,
           gosub DeActivate         'then de-activate all FMMs
           end if
     '
 elseif LoopCtrlState=5 then        'PUT NEXT LIST MEMBER'S CALLING LIST RECORD
        if ListGeIOstate=7  then    'If the Calling List record stored OK then
           LoopCtrlState=3          'go back to process next record.
           end if
        if RecordIOstate=10 then    'If error occurred while getting record,
           gosub DeActivate         'De-activate all FMMs
           end if
     '
 elseif LoopCtrlState=6 then        'CONFIRM STORAGE OF `LIST PRINTED' FLAG
        if ListGeIOstate=7 then     'If Calling List File header stored OK
           gosub DeActivate         'De-activate all FMM/close files & printer
           gosub ShowEndDisplay
           end if
        end if
     RETURN                         'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'FILE OPENING CONTROL FMM
     '
FileCtrl:
     if FileCtrlState=1 then        'OPEN TARGET LIST FILE
        TargetIOstate=1             'Activate target file I/O FMM to open
        FileCtrlState=2             'records file and advance to next state.
     '
 elseif FileCtrlState=2 then        'OPEN CALLING LIST FILE
        if TargetIOState=3  then    'If the areas file is now open, then
           ListGeIOstate=1          'Activate List file I/O FMM to open
           FileCtrlState=3          'target list file; advance to next state.
    elseif TargetIOstate=10 then    'If areas file wouldn't open, then
           gosub DeActivate         'De-activate
           FileCtrlState=7          'Set this FMM to its error state
           end if
     '
 elseif FileCtrlState=3 then        'WAIT FOR CALLING LIST FILE TO OPEN
        if ListGeIOState=3  then    'If the areas file is now open, then
           FileCtrlState=4          'target list file; advance to next state.
    elseif ListGeIOState=10 then    'If areas file wouldn't open, then
           gosub DeActivate         'De-activate
           FileCtrlState=7          'Set this FMM to its error state
           end if
     '
 elseif FileCtrlState=5 then        'CLOSE ALL FILES
        FileNum=1:gosub CloseFile   'Close Records File
        FileNum=2:gosub CloseFile   'Close Areas File
        FileNum=3:gosub CloseFile   'Close Target File
        gosub DeActivate            'De-activate
        FileCtrlState=6             'All files closed: terminated OK.
        end if
     return
     '
     '--------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'DISPLAY FMM STATES TABLE
     ' 
ShowStartDisplay: row=6:column=41:colour=grey
     ps$="                    Ŀ    ":gosub ShowStartDisplay2
     ps$="                    TARGET DETAILS    ":gosub ShowStartDisplay2
     ps$="                    Ĵ    ":gosub ShowStartDisplay2
     ps$="                    Target N 0000    ":gosub ShowStartDisplay2
     ps$="                    Serial N 0000    ":gosub ShowStartDisplay2 
     ps$="                    List Size 0000    ":gosub ShowStartDisplay2
     ps$="                    List Item 0000    ":gosub ShowStartDisplay2
     ps$="                                      ":gosub ShowStartDisplay2
     ps$="                                      ":gosub ShowStartDisplay2
     ps$="                        ":gosub ShowStartDisplay2
     ps$="                                        ":gosub ShowStartDisplay2
     ps$="                                        ":gosub ShowStartDisplay2
     ps$="                                        ":gosub ShowStartDisplay2
     ps$="                                        ":gosub ShowStartDisplay2
     ps$="                                        ":gosub ShowStartDisplay2
     ps$="                                        ":gosub ShowStartDisplay2
     ps$="                                        ":gosub ShowStartDisplay2
     ps$="                                        ":gosub ShowStartDisplay2
     ps$="                                        ":gosub ShowStartDisplay2
     '
     colour=2:column=1
     row=19:ps$="                                        ":gosub 50
     row=20:ps$="                                        ":gosub 50
     row=21:ps$="          Press    to start:            ":gosub 50
     row=22:ps$="          Press     to quit.            ":gosub 50
     row=23:ps$="                                        ":gosub 50
     row=24:ps$="                                        ":gosub 50
     row=21:column=17:colour=10:ps$=chr$(17)+"":gosub 50
     row=22                    :ps$="Esc":gosub 50
     '
     number=TargNum :row= 9:colour=7:gosub ShowStates1
     number=ExtrFlag:row=10         :gosub ShowStates1
     number=TargSize:row=11         :gosub ShowStates1:return
     '
ShowStartDisplay2: gosub 50:row=row+1:return
     '
ShowWorkDisplay:
     row=21:column=11:colour= 2:ps$="Press Esc to abort:":gosub 50
            column=17:colour=10:ps$="Esc":gosub 50
     row=22:column=11:ps$="                  ":gosub 50
     row=14:column=62:ps$="Creating List":gosub 50
     return
     '
ShowEndDisplay:
     row=21:column=24:colour= 2:ps$="exit: ":gosub 50
     row=14:column=62:colour=10:ps$="FINISHED      ":gosub 50
     return
     '
     '--------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'DISPLAY THE FMM STATES
     '
ShowStates:
     column=55:colour=7
     if LastTargItem<>TargItem then
        LastTargItem =TargItem
        row=12:number=TargItem:gosub ShowStates1
        end if
     return
     '
ShowStates1: gosub FourDigit:column=72:ps$=number$:goto 50
     '
     '-------------------------------------------------------------------------
     'FORM 4-DIGIT NUMBER AS A STRING WITH LEADING ZEROS
     '
FourDigit:
     if Number<0 or Number>9999 then Number$="////":return
     Number$=str$(Number)
     Number$=right$(Number$,len(Number$)-1)
     LenNum=len(Number$)
     if LenNum<4 then Number$=string$(4-LenNum,"0")+Number$
     return
     '
     '--------------------------------------------------------------------------
     '
