






     '-------------------------------------------------------------------------
     'ELECTRONIC MAIL SERVICE MACROS ENTRY     17NOV86       [File: MACROS.BAS]
     '-------------------------------------------------------------------------
     '
     'Author : R J Morton
     '
     ' Enables you to set up PROTOCOL MACROS for the various public and
     '  private electronic mail services to which you subscribe.
     '
     DefInt a-z
     rem $include: 'ComVars.INC'
     common ems$, ems, em
     '
     dim   menu$( 9)   'Array to contain the electronic mail service names
     dim fields$(10)   'Fields to hold the subscriber details for each service
     dim   emsl$( 9)   'Input/output array for Email service names
     dim  macro$(20)   'Input/output array for macro command lines
     '
     goto Macros1
     '
     '-------------------------------------------------------------------------
     'EXTERNAL SUBROUTINES
     '
     rem $include: 'InChar.INC'
     rem $include: 'EdField.INC'
     rem $include: 'EdBlock.INC'
     rem $include: 'MultiBlk.INC'
     rem $include: 'GenMenu.INC'
     rem $include: 'GetEmsl.INC'
     rem $include: 'GetMacro.INC'
     rem $include: 'PutMacro.INC'
     rem $include: 'OpenFile.INC'
     rem $include: 'Expiry.INC'
     rem $include: 'Decrypt.INC'
     '
Display: row=row+1
50   call ScrSub(ps$,row,column,colour):return       'Screen display subr
     '
     '-------------------------------------------------------------------------
MenuHelp0: return    'dummies for GenMenu.Bas
MenuHelp1: return
MenuHelp2: return
MenuHelp3: return
MenuHelp4: return
MenuHelp5: return
MenuHelp6: return
MenuHelp7: return
MenuHelp8: return
MenuHelp9: return
     '--------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'MENU INITIALIZATION
     '
Macros1: gosub ExpiryTest
     '
     gosub GetEmsl              'Load electronic mail service names
     '
     row=3:column=1:colour=7:ps$="[COMMUNICATIONS MACROS]         ":gosub 50
     column=41:ps$=space$(40):for row=4 to 24:gosub 50:next
     '
     menu$="Services"           'Menu title
     mpos =1                    'Display menu in left half of screen
     abort=0                    'No abort indications
     menu =s                    'Number of services currently on file
     for k=1 to 9
     menu$(k)=emsl$(k)          'Transfer the service names to the menu array
     next
     menu$(0)="Unspecified"
     '
Macros2:
     gosub ShowMenu             'Display and select service names as a menu
     '
     if op=0 then      _
        prog$="MACROS" _
       :chain"Tmenu"            'Return to the Electronic mail main menu
     '
     service=op                 'E-mail service selected
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'EDIT THE SUBSCRIBER DETAILS OF SELECTED ELECTRONIC MAIL SERVICE
     '
     gosub GetMacro           'Load user's electronic mail subscriber 
     for k=1 to 20            'details for the currently selected
     MultiBlk$(k)=macro$(k)   'electronic mail service.
     next
     gosub Macros3            'Display the macro containment boxes
     '
     NumFlds=10          'Number of fields per column
     NumBlks= 2          'Number of columns of fields
     InterBlk=26         'N of chr spaces between adjacent blocks
     LenField=0          'Force Odd/Even field mode in EdBlocks subroutine
     LenOcol =20         'Length of fields in left-hand  [prompts]   column
     LenEcol =40         'Length of fields in right-hand [responses] column
     '
     MultiRow= 9         'Row on which first field appears
     MultiCol= 9         'Column in which left-hand field-column starts
     '
     NoFkeys=1           'Don't display F-key line
     InstrCol=35         'Where editing instructions are displayed
     MsgPos=1            'Message position override switch
     Msg.v=4:Msg.h=36    'Position of edit control messages
     '
     gosub ShowBlocks
     gosub EdBlocks
     '
Macros4:
     if Fkey=1 then                  'F1 is the Help Key
        gosub Macros5                'Display the Help Text
        gosub Macros3                'Re-display the boxes
        gosub ShowBlocks             'Re-display the macro data 
        gosub ReEdBlocks             'Re-enter block editor at
        goto Macros4                 'original cursor position.
        end if
     '
     if AmendM=1 then                'If editing has taken place, then
        for k=1 to 20                'store edited subscriber details
        macro$(k)=Multiblk$(k)   
        next:gosub PutMacro
        end if
     '
     ps$=space$(40):column=41:colour=7:for row=4 to 24:gosub 50:next
     goto Macros2                    'Return to select another service or exit
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'DISPLAY THE SUBSCRIBER DETAILS FRAME
     '
Macros3:
     column=1
     colour=2
     ps$=space$(46)+"NOTE: Enclose echo-suppressed     ":row=4:gosub 50
     ps$=space$(46)+"items such as passwords in {}     ":row=5:gosub 50
     colour=1
     ps$=space$(7):column= 1:gosub Macros6
     ps$=space$(4):column=30:gosub Macros6
     ps$=space$(5):column=76:gosub Macros6
     column=1
     ps$="       "+string$(22,220)+"    "+string$(42,220)+"     ":row= 6:gosub 50
     ps$="       "+string$(22,223)+"    "+string$(42,223)+"     ":row=19:gosub 50
     '
     colour=27
     row=7
     column= 8:ps$=" PROMPTS FROM SERVICE ":gosub 50
     column=34:ps$=" AUTOMATIC RESPONSES TO BE SENT IN RETURN ":gosub 50
     row=8
     column= 8:ps$="  ":gosub 50
     column=34:ps$="  ":gosub 50
     column= 8:ps$=space$(22):for row=9 to 18:gosub 50:next
     column=34:ps$=space$(42):for row=9 to 18:gosub 50:next
     '
     colour=10
     column=1
     ps$="        PLEASE ENTER/EDIT AS"+space$(52):row=20:gosub 50
     ps$="        AS YOU REQUIRE.     "+space$(52):row=21:gosub 50
     ps$=space$(80):row=22:gosub 50:row=23:gosub 50
     colour=112
     ps$="F1-HELPF2-SAVEF3-QUIT                                                  ":row=24:gosub 50
     PS$=menu$(service):row=5:column=9:colour=14:gosub 50
     return
Macros6: for row=6 to 19:gosub 50:next:return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'DISPLAY THE MACRO HELP TEXT
     '
Macros5:
     row=4:column=1:colour=3
     ps$="RESERVED NAMESĿ":gosub Display:colour= 3
     ps$="                                        ":gosub Display
     ps$="A macro command line is sent as seen    ":gosub Display
     ps$="except for the RESERVED NAMES which are ":gosub Display
     ps$="automatically replaced at transmission  ":gosub Display
     ps$="time by the data they represent.  When  ":gosub Display
     ps$="placed in a macro, a RESERVED NAME must ":gosub Display
     ps$="be enclosed in [  ] as shown:           ":gosub Display
     ps$="                                        ":gosub Display:colour=2
     PS$="RESERVED NAME  DATA SUBSTITUTED         ":gosub Display
     PS$="    [ID]       Your company identifier* ":gosub Display
     PS$=" [USER NAME]   Your personal user name* ":gosub Display
     PS$="  [PASSWORD]   Your personal password * ":gosub Display
     PS$="  [SUBJECT]    Subject of the message * ":gosub Display
     PS$="  [MESSAGE]    Text of the message    * ":gosub Display
     PS$="  [MAILBOX]    Recipient's mailbox N   ":gosub Display
     ps$="               as in his address record ":gosub Display
     ps$="                                        ":gosub Display:colour=3
     ps$="*As seen in the Subscriber Details for  ":gosub Display
     ps$=" the currently selected Comms Service.  ":gosub Display

     '--------------------------------------------------------------------------
     '
     colour= 3:row= 4:column=41
     ps$="TELETYPE CONTROL CODESĿ":gosub Display
     ps$="                                        ":gosub Display:colour=2
     ps$=" [NUL][00] [BS][08] [DLE][16] [CAN][24] ":gosub Display
     ps$=" [SOH][01] [HT][09] [DC1][17] [EM] [25] ":gosub Display
     ps$=" [STX][02] [LF][10] [DC2][18] [SUB][26] ":gosub Display
     ps$=" [ETX][03] [VT][11] [DC3][19] [ESC][27] ":gosub Display
     ps$=" [EOT][04] [FF][12] [DC4][20] [FS] [28] ":gosub Display
     ps$=" [ENQ][05] [CR][13] [NAK][21] [GS] [29] ":gosub Display
     ps$=" [ACK][06] [SO][14] [SYN][22] [RS] [30] ":gosub Display
     ps$=" [BEL][07] [SI][15] [ETB][23] [US] [31] ":gosub Display
     ps$="                                        ":gosub Display:colour=3
     ps$=" These standard TTY control codes may be":gosub Display
     ps$=" embedded in a macro line as a mnemonic ":gosub Display
     ps$=" or ASCII value enclosed in [] as shown:":gosub Display
     ps$=" [;] at the end of a line suppresses the":gosub Display
     ps$=" inherent C/R.  [nS] imposes a delay of ":gosub Display
     ps$=" n seconds where n ranges from 1 to 99. ":gosub Display
     ps$=" [RE] sets remote, [LE] sets local echo.":gosub Display
     ps$="                                        ":gosub Display:colour=2
     ps$=" Press Esc to regain macro:             ":gosub Display
     row=24:column=48:colour=10:ps$="Esc":gosub 50
     '--------------------------------------------------------------------------
     locate 24,68:gosub InChar:return
     '--------------------------------------------------------------------------
     '
