





     'MAIL/MAILSHOT PRINT PROGRAM   by R J Morton     05JUL87    File: Mail.Bas 

     'This program provides the processing necessary for the printing of a
     'pre-selected letter to a specified individual postal addressee or to a
     'target group of such addressees. For load module FMM processing structure 
     'see FMM.DOC file.

     DefInt a-z                  'Default numeric variables are 16-bit integers
     rem $include: 'ComVars.INC' 'Marketeer's universal common variables

     'DEFINITION & ARRAY DIMENSIONING

     dim pp$(20)               'Printer control strings
     dim CMDW$(10)             'Holds current set of command words
     dim task$(5)              'Holds the current set of tasks
     dim rec$(12)              'Contains the current name & address details
     dim TempRec$(12)          'Used by EdBox, but not needed by this overlay
     dim values$(12)           'Contains the current name & address details
     dim fields$(12)           'Contains the current diary note details
     dim stamps$(12)           'Contains the current date stamps details
     dim keyvs$(4,18)          'Referred to by GetRec & PutRec.
     dim OwnAddr$(6)           'For if own name & address must be printed
     dim LettForm$(6)          'Letter Formats
     LettForm$(0) = "Normal letter         "
     LettForm$(1) = "No `Dear..', `Yours..'"
     LettForm$(2) = "Memo style            "
     LettForm$(3) = "Date + address only   "
     LettForm$(4) = "Envelope address      "
     LettForm$(5) = "Invoice Format        "
     LettForm$(6) = "Type to Fax File      "
     LetterFormat = 0  'Default letter format
     LetterFormat$ = LettForm$(0)


     'BUFFER ALLOCATIONS FOR THE FILES USED BY THIS MODULE

     RecsFileNum=1     'Main prospect records
     AreaFileNum=2     'For finding which sales area a prospect is in
     KeysFileNum=3     'Contains prospect's selecion keys
     DateFileNum=4     'Dates of his last and next-planned events
     IndxFileNum=5     'Namecode or Postcode index depending on type of search
     TxFileNum  =6     'Sequential text file containing the message text
     TxRecLen=1024     '1k input block for getting message from message file
     PrtBufNum  =7     'Printer channel opened as a file
     PrRecLen=1024     '1k output block for printing message to output file


     'SET UP VARIOUS CONSTANTS FOR THIS MODULE

     TickRow=13        'Screen row on which Modem I/O ticker tape display shown
     TickCol=57        'First column for the above
     TickClr=23        'Colour in which the ticker tape text is displayed
     PrtType$="LQ"               'Set printer port for letter printer
     ListFile$=PrntList$         'Path/Filespec of the Mailing List file
     CrLf$=chr$(13)+chr$(10)     'New-Line string as found in text files
     FinalThrow$ = chr$(12)      'Throw page at end of letter tail
     NewLine$=CrLf$              'New-line string for outgoing telexes
     PStest$=NewLine$ +"P.S."
     EncTest$=NewLine$+"Enc."
     ccTest$=NewLine$ +"c.c."
     lenPStest = len(PStest$)
     BlankLine$="     "+NewLine$ 'Blank line hold character for telexes
     PostAreaList$="ABALB BABBBDBHBLBNBRBSBTCACBCFCHCMCOCRCTCVCWDADDDEDGDHDL"_
                  +"DNDTDYEHENEXFKFYG GLGUHAHDHGHPHRHUHXIGIPIVKAKTKWKYL LALD"_
                  +"LELLLNLSLUM MEMKMLNENGNNNPNROLOXPAPEPHPLPOPRRGRHRMS SASG"_
                  +"SKSLSMSNSOSPSRSSSTSYTATDTFTNTQTRTSTWUBWAWDWFWNWRWSWVYOZE"_
                  +"E ECN NWSESWW WC"
     LocalHelp=7                 'Single-letter help text record N
     ManChap=9                   'Relevant chapter of the manual

     if op = 99 then op = 1 : FromSelcLett = 1
     if op = 2 then
        MailShotFlag = 1
        TimeStamp = 1
        LocalHelp = 16
        RecNum = 0
     end if
     gosub ExpiryTest
     row=1:column=19:colour=7:ps$=top$:gosub 50         'Display module name


     'SET UP INITIAL SCREEN DISPLAYS

     if prog$ = "AMEND" then
        LeftBox$ = "Abox"
     else
        LeftBox$ = ""
        gosub ShowAbox         'Display the name & address box
     end if
     prog$ = "MAIL"            'Where control came from
     gosub StatusBoxDisplay    'Modem/printer status messages box etc.
     gosub DefineCmndWords     'Set up command words used in this section
     gosub DefineTasks         'Define the task list

     ps$ = space$(80) : column = 1 : colour = grey
     for row = 19 to 24 : gosub 50 : next

     ps$ = "INITIALISING" : row = 22 : column = 10 : colour = 10 : gosub 50

     gosub ShowTasks           'Display the Task List panel
     locate 24,1,0             'place cursor at bottom left of screen
     SearchFieldNum = 2        'Namecode is default search field
     goto Initialization       'Go to initialize the FMM polling loop.
     '





     'EXTERNAL SUBROUTINE

Display: row=row+1
50   call ScrSub(ps$,row,column,colour) 'Display as is

ShowMbox:                               'dummy
DossIO: return                          'dummy


     'FINITE-STATE MACHINES INCLUDED IN THIS LOAD MODULE

51   rem $include: 'MailInit.FMM'       'THE INITIALIZATION GROUP
52   rem $include: 'GetPrt.FMM'
53   rem $include: 'MsgTitle.FMM'
54   rem $include: 'GetSigna.FMM'

55   rem $include: 'Keyboard.FMM'       'THE GENERAL INPUT/OUTPUT GROUP
56   rem $include: 'PrintIO.FMM'

     rem $include: 'EdBox.FMM'
57   rem $include: 'Find.FMM'           'THE RECORD RETRIEVAL GROUP
58   rem $include: 'RecordIO.FMM'
59   rem $include: 'KeysIO.FMM'
60   rem $include: 'DateIO.FMM'
61   rem $include: 'LoadRec.FMM'
62   rem $include: 'UpdtRec.FMM'
63   rem $include: 'SaveDate.FMM'
64   rem $include: 'ListGeIO.FMM'
65   rem $include: 'UpdtKeys.FMM'
66   rem $include: 'AmendKey.FMM'
67   rem $include: 'OpenFile.FMM'
     ' 
68   rem $include: 'MailCtrl.FMM'       'THE Mail PROCESSING GROUP
69   rem $include: 'SendTelx.FMM'
70   rem $include: 'MailHedr.INC'
71   rem $include: 'NextTelx.FMM'
72   rem $include: 'Manual.FMM'
73   rem $include: 'Select.FMM'
     ' 
74   rem $include: 'Funckeys.FMM'       'OTHERS
75   rem $include: 'GetHelp.FMM'
76   rem $include: 'EdField.FMM'
77   rem $include: 'ShowAbox.INC'
78   rem $include: 'Decrypt.INC'
79   rem $include: 'ValiPost.INC'
80   rem $include: 'Expiry.INC'
81   rem $include: 'TexCrypt.INC'
82   rem $include: 'MakeNote.FMM'
83   rem $include: 'NotesIO.FMM'
84   rem $include: 'DragNet.FMM'
90   '





     'INITIALIZE THE FINITE STATE MACHINE POLLING LOOP

     'The service programs which perform the various tasks here are written as
     'Message-drived Finite State Machines. Each FMM is continually polled in
     'sequence from the following polling loop.

Initialization:
     MailInitState = 1      'Kick-statrt the initialization FMM hierarchy
     cmdl          = 4      'Number of characters in command word field
     caps=1                 'To cater for typing ahead a namecode etc


     'FINITE MESSAGE MACHINE POLLING LOOP

PollingLoop:
     gosub Initializer       'Transfer of control from initialization
     gosub Search            'Record retrieval control FMM [Resident]
     gosub NextPrevFMM       'Get next/previous subscriber on request
     gosub LoadRecord        'Record loader FMM
     gosub HelpFMM           'Help Screen Processor FMM
     gosub HelpTrip          'Keystroke-triggered trip out of help screen
     gosub Keyboard          'Add incoming chrs from keyboard to buffer str
     gosub CWPFMM            'Command Word Processor FMM
     gosub CWPfkeys          'Act on CWP fkey value if present
     gosub FromEntry         'Enter list N of first addressee
     gosub MailCtrl          'Mail Control supervisor FMM
     gosub StakProc          'Inter-stack transfers processor
     gosub PrintIO           'Printer input/output FMM
     gosub PrtrCtrl          'Check printer integrity
     gosub OpenFileFMM       'General File Opening FMM
     gosub ShowMessages      'Display the modem status messages
     gosub ShowMailResult    'Display call result message
     gosub Manual            'User Manual access
     gosub LetterFormatSub   'Set style in which letter is printed
     gosub DragNet
     gosub QuitLoop          'Means of escape from the FMM polling loop
     goto PollingLoop        'Back to the beginning of the polling loop
     '





     'TRANSFER OF CONTROL FROM LOAD MODULE INITIALIZATION

     'This FMM supervisor routine controls the activities of the Telex Module
     'initialization FMM MailInit.FMM and the display routine ShowInitStates
     'which displays the states of MailInit.FMM. Once the initialization
     'process has been completed once upon first entry into the FMM polling
     'loop, the MailInitState is set to zero thus ensuring that this whole
     'subsystem takes no further part in the proceedings and is thus not a
     'burden to the FMM polling loop cycle.

Initializer:
     if MailInitState=0  then return    'Initialization FMM inactive
     '
     if instr(KbStr$,chr$(27))>0 then return QuitLoop2
     '
     if MailInitState<8  then           'Initialization in progress
        gosub MailInit                  'Loop initialization FMM
     else
        if MailInitState=9 then beep    'If initialization process failed
        MailInitState=0                 'De-activate the Initialization FMM
        Signatory$=LettrSig$
        if LettrTit$>"" then
           JobTitle$=LettrTit$
           if LettrTit2$>"" then JobTitle$=JobTitle$+NewLine$+LettrTit2$
        end if
        gosub ShowLetterTitle           'Show Email Service name & message title
        gosub LetterFixedData           'Lead-in, Letter Date, Signature Gap
        if MailShotFlag=0 then          'If we are doing a one-off letter,
           if RecNum = 0 then
              SearchState=1             'Activate the Record Search FMM
           else
              UpDown = 0
              NextPrevState = 1         'load the record.
           end if
        else
           UpDown=1                     'set to search UP the mailing list
           MailCtrlState=1              'activate the command word processor
           MailCtrlInit=1               'Tells MailCtrl that it must find first
           EndSession = TargSize
        end if                          'addressee for whom a letter not yet
     end if                             'printed.
     return                             'Return control to the FMM polling loop
     '



                                                                               

     'RECORD RETRIEVAL FMM: FINITE-STATE MACHINE PROCESSING MODEL

Search:
     if SearchState = 0 then return

     gosub EdBox                        'To enter search key
     gosub FindRecord                   'Record Search utility FMM
     gosub OpenIndexFile                'To get index parameters
     gosub GetKeysRecord                'Gets retrieved record's status keys

     on SearchState goto Search1, Search2, Search3

ShowProfile: return                     'Dummy label (see EdBox.FMM)


     'STATE 1: INITIALIZE THE SEARCH PROCESS

Search1:
     Task = 0 : gosub ShowTaskLamps     'Clear the task lamps
     EdBoxState = 1                     'Activate Search Key Entry processes
     SearchState = 2                    'Set to await completion of Key Entry
     return


     'STATE 2: SUPERVISE SEARCH KEY ENTRY

Search2:
     if FindRecState = 3 then           'Await completion of search key entry
        PrevIndexType = IndexType       'Preserve search index type
        Task = 1 : gosub ShowTaskLamps  'Light the SEEKING lamp
        ps$ = str$(RecNum)
        on PrevIndexType + 1 gosub _    'According to type of search,
           ShowRefNumber,          _    'Display REFerence number
           ShowNamecode,           _    'Highlight namecode while searching
           ShowPostcode                 'Highlight postcode while searching
        SearchState = 3                 'advance to search process supervision
     elseif FindRecState = 6 then       'If entry aborted or Esc key pressed
        FindRecState = 0                'De-activate Record Retrieval Utility
        QuitFlag = 1                    'Set for quitting this load module
        end if
     return


     'STATE 3: SUPERVISE THE SEARCH PROCESSES

Search3:
     if FindRecState = 5 then           'If required record has been found OK,
        FindRecState = 0                'De-activate record retrieval utility
        LoadRecordState = 1             'Activate the record loader
        SearchState = 0                 'De-activate the Search FMM
     elseif FindRecState > 5 then       'If the required record cannot be found,
        SearchState = 1                 'then return to initial search state.
     end if
     return                             'Return control to FMM polling loop.
     '





     'TRANSFER RECEIVED CHARACTERS TO PRINT & DISPLAY STACKS

     'This routine transfers received characters from TxStr$
     'to the Printer Stack PrStr$ However, if the printer cannot handle
     'chars fast enough to keep up with the line and as a result, PrStr$
     'becomes full, the display is also held up and no more characters are
     'taken from TxStr$ until the printer catches up. If the incoming text
     'is to be displayed but not printed (ie when PrinterSwitch=0) then the
     'characters are simply passed to the ticker tape display routine.

StakProc:
     if TickFlag = 1 then gosub TickTape : TickFlag = 0

     RxChar$ = "" : RxChar = 0          'Clear current receive character
     if TxStr$ = "" then return         'Nothing to display or print
     if len(PrStr$) > PrRecLen then return
     if PrtrCtrlState <> 3 then return

     if PortType = 0 then
        x = instr( TxStr$, chr$(4) ) 
        if x then
           PrStr$ = PrStr$ + left$( TxStr$, x - 1 )
           EndOfLetter = 1
           PrintIOflush = 1             'Tell PrintIO to flush buffer
        else
           PrStr$ = PrStr$ + TxStr$
        end if
        TxStr$ = ""
      else
        if PrXoffLamp = 12 then return  'Not `Clear to Send' set by PrintIO.FMM
                                        'CTS is forced to 1 for parallel printer
        RxChar$ = left$( TxStr$, 1 )    'Get next char off Receive Stack. 

        TxStr$ = right$( TxStr$, len(TxStr$) - 1 ) 'Chop char from Receive Stack
        if RxChar$ = chr$(4) then EndOfLetter = 1
        if EndOfLetter = 0 then
           PrStr$ = PrStr$ + RxChar$    'Add char to printer stack
        end if
     end if
     return
     '  
TickTape: call ScrSub(PrTape$,TickRow,TickCol,TickClr):return
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'KEY-INITIATED EXIT FROM HELP SCREEN
     '
     'Unfortunately, striking a key is the only practical means of exiting the
     'Help Screen. Therefore, this routine has to be somewhat specific to the
     'main program in that it has to test the state of the Help FMM. If the
     'Help FMM is active, this routine therefore re-displays the main screen
     'and de-activates the Help FMM. In this event, the character struck is
     'not regarded as part of a command input, but is ignored.
     '
HelpTrip:
     if HelpState>3 then                'Help screen active or being displayed
        gosub TripSub
        if help=4 then                  'If Record Retrieval Help displayed
           gosub ShowTasks
           SearchState=1                'then re-activate Record Retrieval FMM
      else gosub DisplayRecord          'Re-display the record
           end if
        HelpState=0                     'De-activate the help screen
 elseif ManualState=8 then
        ManualState=0
        gosub TripSub
        gosub DisplayRecord
        end if
     return                             'Return control to FMM polling loop.
     '
TripSub:LeftBox$="":gosub ShowAbox      'Re-display the name & address box
        gosub StatusBoxDisplay          'Box for modem/printer status messages
        gosub ShowLetterTitle           'Show Email Service name & message title
        gosub TickTape                  'Re-display the modem I/O
        gosub ClearInstructions
        ShowMessages=1                  'Trigger a display of the messages
        return
     '-------------------------------------------------------------------------
     'DUMMY MODEM FMM
     '
     'The SendTelx FMM is used to load the letter text just the same as it is
     'used to load the telex text in the Telex System. So a dummy ModemEF
     'routine (which SendTelx calls) has to be included here to transfer the
     'text from TxChar$ direct to the TxStr$.
     '
ModemEF: TxStr$ = TxStr$ + TxChar$ : TxChar$ = "" : return
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'COMMAND EXECUTOR
     '
     'When a keyboard command has been entered, the Command Word Processor FMM
     'sets a value in CWPfkey corresponding to the command entered. This routine
     'initiates the processes required to execute the entered command.
     '
CWPfkeys:
     if nkey > 0 then                   'in case numeric hit instead of Fkey
        CWPfkey = nkey
        nkey = 0
     end if
     if CWPfkey=0 then return           'Return control to the FMM polling loop
     gosub ClearMailMsg                 'Clear the `Mail completed' message
     DosMsg$="":DosClr=12               'Clear general error message field
     ShowMessages=1                     'Activate message display routine
     task=0:gosub ShowTaskLamps         'Kill READY lamp; light WAIT lamp
     gosub ClearDown                    'Clear print status
     '
     if CWPfkey=1 then                  'Help text
        help=LocalHelp                  'Help screen for single-shot Telex calls
        HelpState=1                     'Set the HelpFMM state to `initializing'
        goto CWPfkeys1                  'Return control to the FMM polling loop
        end if
     '
     if CWPfkey=99 then QuitFlag=2:goto CWPfkeys1 'EXIT to main menu
     if CWPfkey= 3 then updown= 1:goto CWPfkeys2  'NEXT command
     if CWPfkey= 4 then updown=-1:goto CWPfkeys2  'PREV command
     '
     CWPstate=1                         'Re-activate Command Word Processor FMM
     if CWPfkey=80 then                 'Down-arrow
        DragNet = 1
     elseif CWPfkey=5 then              'If the `FORM' command were entered,
        LetterFormatState = 1
        CWPstate=0
     elseif CWPfkey=6 then              'If the `TYPE' command were entered,
        OwnAddrFlag = 0                 'Don't print sender's address
        gosub CWPfkeys3                 'Print letter in required format
     elseif CWPfkey=7 then              'If the `TYPE' command were entered,
        OwnAddrFlag = 0                 'Don't print sender's address
        if LetterFormat < 2 then OwnAddrFlag = 1    'Print sender's address
        gosub CWPfkeys3                 'Print letter in required format
     elseif CWPfkey=9 then              'TREF or FROM
        if MailShotFlag=0 then          'TREF if not mailshot mode.
           TREF=1:gosub CWPfkeys3       'Set to type reference version of
        else                                      'previous letter.
           FromEntryState=1             'Activate the Item N field editor
           CWPstate=0
        end if
     elseif CWPfkey=2 then              'If the QUIT command was entered,
        QuitFlag=1                      'Set up a `quit' request
     elseif CWPfkey=8 and _             'If the STOP command was entered,
        MailShotFlag=0 then
        QuitFlag = 3                    'Exit directly to Amend.EXE
     end if
CWPfkeys1: CWPfkey=0:return             'Clear to avoid a repeat next pass

CWPfkeys2:
     if MailShotFlag = 0 then
        if MailCtrlState = 0 then       'and a Letter is not in progress
           NextPrevState = 1            'activate next/prev record search FMM
        end if
     else
        MailCtrlState=1
        ManualNext=1
     end if
     goto CWPfkeys1

CWPfkeys3:
     ManualNext = 0                     'Kill cyclic scanning round the list
     MailCtrlState = 1                  'Activate the Mail Control FMM
     PrtrCtrlState = 1                  'Activate the Printer Control FMM
     UpDown = 0
     return         
     '






     '-------------------------------------------------------------------------
     'GET NEXT/PREVIOUS RECORD [FMM]  Self-deactivating
     '
NextPrevFMM: if NextPrevState=0 then return
     '
     IF NextPrevState=1 THEN
        if MailCtrlState=0 then         'A call is not in progress
           task=1:gosub ShowTaskLamps   'Light SEEKING lamp
           IndexType=PrevIndexType      'N of index used to retrieve last rec
           FindNextState=1              'Activate Next/Prev record retrieval FMM
           NextPrevState=2              'Advance to the Wait State
    elseif MailCtrlState<4 then         'If not in the process of releasing the
           MailCtrlState=4              'call, then initiate a call release
           end if
        END IF
     '
     IF NextPrevState=2 THEN
        gosub FindNextRec
        gosub OpenIndexFile             'Index File Opener+get index parameters
        gosub GetKeysRecord             'Gets retrieved record's status keys
        if FindNextState=4 then         'If next/previous record found OK
           FindNextState=0              'De-activate the Next/Prev search FMM
           UpDown=0                     'Clear `get next/prev record' request
           NextPrevState=0              'De-activate Next/prev search manager
           LoadRecordState=1            'Activate the record loader
    elseif FindNextState=5 then         'If no record found, or error occurred,
           FindNextState=0              'De-activate the Next/Prev search FMM
           UpDown=0                     'Clear `get next/previous rec' request
           NextPrevState=0              'De-activate Next/prev search manager
           LeftBox$=""                  'then re-display the name & address box
           gosub ShowAbox               'in order to clear it,
           end if
        END IF
     '
     RETURN                             'Return control to FMM polling loop.
     '
     '--------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'LOAD THE RETRIEVED RECORD
     '
     'Uses LoadRec.FMM RecordIO.FMM and GetAreas.FMM to load the required 
     'prospect record, and then displays the record in the name & address
     'box. Also lights the task lamps as appropriate.
     '
     'State 8: successful termination
     'State 9: error termination
     '
LoadRecord:
     if LoadRecordState=0 then return   'Record Loader FMM idle
     '
     IF LoadRecordState=1 THEN
        task=2:gosub ShowTaskLamps      'Kill `seek' lamp/light LOADING lamp
        LoadRecState=1                  'Activate Record Loading Supervisor FMM
        LoadRecordState=2               'Advance self to next state
     END IF

     IF LoadRecordState=2 THEN          'LOAD THE RETRIEVED RECORD
        gosub LoadRec                   'Record loading supervisor FMM
        if LoadRecState<6 then return   'If required record not yet loaded
        if LoadRecState=6 then          'If the record loaded OK, then
           LoadRecordState=8            'Go to successful termination state
           if MailInitState=0 then      'If not `own' record being loaded, then
              if MailShotFlag=0 then    'If single shot letter mode
                 LoadRecordState=0      'then de-activate self
              end if
              gosub DisplayRecord       'Display the Prospect Record
           end if
        else
           SearchState=1                'activate Command Word Processor FMM
           LoadRecordState=9            'go to error termination state
        end if
        task=0:gosub ShowTaskLamps      'Clear the `load' lamps
        LoadRecState=0                  'De-activate the record load supervisor
     END IF

     RETURN                             'Return to FMM polling loop.
     '





     'DISPLAY RETRIEVED RECORD

DisplayRecord:
     gosub ShowAddress            'Display the name & address
     gosub ClearInstructions
     gosub DefineCmndWords        'Display the main command words
     CWPstate=1
     gosub ShowTaskLamps          'Display current task lamps
     return


     'PRINTER INITIALLIZATION FMM

PrtrCtrl:
     if PrtrCtrlState = 0 then return
     IF PrtrCtrlState=1 THEN            'SEE IF PRINTER IN OPEN
        if PrintIOstate=3 then          'If the printer is on and ready then
           PrtrCtrlState=3              're-set to printer watchdog monitoring
           gosub ClearInstructions
      else PrtrCtrlState=2              'else advance to wait for printer on
           PrintIOstate=1               'Activate the printer I/O FMM
           gosub ShowInstructions       'switch on the printer.
           end if
 elseIF PrtrCtrlState=2 THEN            'WAIT FOR PRINTER TO OPEN
        if PrintIOstate>2 then          'If the printer is on and ready or
           PrtrCtrlState=1              're-set Printer Watchdog to monitoring
           end if
 elseIF PrtrCtrlState=3 THEN            'CHECK PRINTER STAYS OPERATIONAL
        if PrintIOstate>4 then          'If the printer is in error condition
           PrintIOstate=0               'De-activate the Printer I/O FMM
           PrtrCtrlState=1              'Re-set Printer Watchdog to monitoring
           end if
        END IF
     RETURN                             'Return control to FMM polling loop.
     '






     '--------------------------------------------------------------------------
     'DISPLAY THE STATUS MESSAGES BOX
     '
     'This routine displays the boxing and fixed text for the ticker-tape and
     'machine-state displays.
     '
StatusBoxDisplay:
     row=3:column=41:colour=1:ps$=space$(40):gosub Display    ' 4
     ps$="  ":for row=5 to 18:gosub 50:next
     row=4:column=43:colour=27
     ps$=" LETTER DETAILS & PRINTER DATA:       ":gosub Display    ' 5
     colour=19
     ps$="                                     ":gosub Display    ' 6
     ps$=" Letter Name                         ":gosub Display    ' 7
     ps$=" Signatory                           ":gosub Display    ' 8
     ps$=" Job Title                           ":gosub Display    ' 9
     ps$="                                     ":gosub Display    '10
     ps$=" Format                              ":gosub Display    '11
     ps$=" Output to                           ":gosub Display    '12
     ps$=" Data Flow                           ":gosub Display    '13
     ps$=" Printer Msg                         ":gosub Display    '14
     ps$="  ":gosub Display    '15
     ps$=" Target N 00  Target Serial N 0000  ":gosub Display    '16
     ps$=" Printing Letter N 00000  of  00000  ":gosub Display    '17
     ps$=string$(38,223):colour=1:gosub Display                    '18
     column=41:ps$=space$(40)                    :gosub Display    '19
     '
     '--------------------------------------------------------------------------
     'DISPLAY LETTER TITLE
     '
ShowLetterTitle: column=57:colour=23
     '
     ps$=MsgTitle$ :row= 7:gosub ShowMessagesSub    'Display message title
     ps$=Signatory$:row= 8:gosub ShowMessagesSub    'Display message title
     ps$=LettrTit$ :row= 9:gosub ShowMessagesSub    'Display message title
     ps$=LettrTit2$:row=10:gosub ShowMessagesSub    'Display message title
     ps$=LetterFormat$:row=11:gosub ShowMessagesSub 'Display message title
     ps$=pp$(1)    :row=12:gosub ShowMessagesSub    'I/O port
     x = TargNum  : y = 2 : gosub LeadingZeros : TargNum$ = x$
     x = ExtrFlag : y = 4 : gosub LeadingZeros : TargSer$ = x$
     '
     if MailShotFlag = 1 then
        ps$ = TargNum$ : row = 16 : column = 53 : gosub 50
        ps$ = TargSer$            : column = 74 : gosub 50
        x = TargItem : y = 5 : gosub LeadingZeros : ps$ = x$ : row = 17 : column = 62 : gosub 50
        x = TargSize : y = 5 : gosub LeadingZeros : ps$ = x$            : column = 73 : gosub 50
        end if
     return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'NUMERIC FORMATTERS
     '
     'This routine formats an interger x into a string x$ containing the number
     'padded out with leading zeros as necessary to make it y digits long, plus
     'an extra leading space or minus sign according to the sign of x.
     '
LeadingZeros:
     gosub LeadingZeros1
     if x < 0 then x$ = "-" + x$ else x$ = " " + x$
     return
LeadingZeros1:
     x$ = str$( x )            'Number x as a string with a leading space or - sign
     x = len( x$ ) - 1
     if x > y then
        x$ = string$( y, "!" )
     else
        x$ = right$( x$, x )
        if x < y then x$ = string$( y - x, "0" ) + x$
     end if
     return
     '
     '--------------------------------------------------------------------------
     'SHOW THE MODEM STATUS MESSAGES
     '
     'Displays the modem status messages etc. whenever a status condition
     'changes as indicated by one of the status flags becoming non-zero.
     '
ShowMessages:
     if ShowMessages = 0 then return    'Exit if no message to be displayed
     ShowMessages = 0                   'Clear the `display messages' switch
     column = 57                        'Start of status message fields
     colour = 3                         'Normal display colour
     if PrtClr > 0 then                      
        ps$ = Pstatus$
        row = 14
        colour = PrtClr                 'Display printIO error message
        gosub ShowMessagesSub
        PrtClr = 0                      'PrtClr used as display trigger
     end if
     if DosClr > 0 then                      
        ps$ = DOSmsg$ 
        ps$ = ps$ + space$( 80 - len(ps$) )   'Pad message field to 35 chrs
        row = 3 
        column = 1
        colour = DOSclr
        gosub 50                        'Display DOS error message
        DosClr = 0                      'DosClr used as display trigger
     end if
     if LastTargItem <> TargItem then   'Whenever the Mailing List N of the letter being sent increases, display it.
        LastTargItem = TargItem      
        x = TargItem : y = 5 : gosub LeadingZeros : ps$ = x$ : row = 17 : column = 62 : colour = 23 : gosub 50
     end if
     return                             'Return control to the FMM polling loop

ShowMessagesSub: ps$ = left$( ps$, 22 )
     ps$ = ps$ + space$( 22 - len( ps$ ) ) : goto 50  'Pad to 22 chrs & display
     '






     '--------------------------------------------------------------------------
     'QUIT FMM POLLING LOOP
     '
QuitLoop:
     if EscapeKey = 1 then QuitFlag = 1

     if QuitFlag = 0 then return        'No `quit' request pending

     if QuitFlag > 1 or MailShotFlag > 0 goto QuitLoop1
     if SearchState > 0 goto QuitLoop1
     if FromSelcLett = 1 and EscapeKey = 0 goto QuitLoop1  'TEXT
     EscapeKey = 0
     FileNum = 0 : gosub CloseFile      'Close all files and printer
     CWPstate = 0                       'De-activate the command processor
     SearchState = 1                    'Re-activate the search key entry FMM
     DragNet = 0
     gosub ClearInstructions
     LeftBox$ = "" : gosub ShowAbox     'Clear the name & address box
     QuitFlag = 0                       'Cancel the quit process
     DosMsg$ = "" : DosClr = 7          'Clear possible error message
     ShowMessages = 1                   'Activate the message display routine
     return                             'Return control to the FMM polling loop.

QuitLoop1: return QuitLoop2
QuitLoop2:
     FileNum=0:gosub CloseFile
     ps$=space$(40):row=4               'Wipe possible error message from the
     column=41:colour=7:gosub 50        'standard error messages position.
     if QuitFlag=2 then chain"Menu"
     if QuitFlag=3 then
        if FromSelclett=1 then op=99
        chain"Amend"
        end if
     if FromSelcLett=1 then chain"SelcLett"
     chain"Pmenu"                       'Exit this load module; back to menu
     '





     'Mail OUTCOME MESSAGES

ShowMailResult:
     if MailCtrlState=9 then            'Mail has not completed successfully
        ps$="LETTER ABORTED"            'display the `call aborted' message
        colour=12                       'in bright green
        goto ShowMailResult1
      elseif MailCtrlState=8 then       'Mail has completed successfully
        if EndOfLetter=1 then           'and end of text has been reached
           ps$="FINISHED      "         'so display the `call complete' message
           colour=10
           goto ShowMailResult1         'in bright red
        end if
     end if
     return

ShowMailResult1:
     CWPstate=1                      'Re-activate the command-word processor
     row=4:column=26:gosub 50        'Display the message
ClearDown:
     Pstatus$="":PrtClr=23
     ShowMessages=1                  'Clear status messages
     task=0:gosub ShowTaskLamps      'Kill the task lamps
     gosub ClearInstructions         'Clear `Switch on Printer' message
     MailCtrlState=0                 'De-activate Mail Control FMM
     PrtrCtrlState=0                 'De-activate Printer Control FMM
     PrintIOState=0                  'De-activate the printer I/O FMM
     EndOfLetter=0
     TREF=0                          'Clear printing of reference copy letter.
     FileNum=0:gosub CloseFile
     TxStr$="":return
     '
ClearMailMsg:ps$="              ":row=4:column=26:colour=7:gosub 50:return
     '





     'DISPLAY THE MAIN SET OF COMMAND WORDS

DefineCmndWords:
     cmdw=10
     cmdw$(1)="HELP"
     if FromSelcLett=1 then cmdw$(2)="TEXT" else cmdw$(2)="QUIT"
     cmdw$(3)="NEXT"     'then the NEXT and PREV commands are
     cmdw$(4)="PREV"     'effective, so display the command words
     cmdw$(5)="FORM"     'Type name & address only.
     cmdw$(6)="TYPE"
     cmdw$(7)="TSAD"     'Type letter with sender's address
     cmdw$(8)="STOP"
     if MailShotFlag=0 then
        cmdw$(8)="AMND":cmdw$(9)="TREF"
     else
        cmdw$(8)="STOP":cmdw$(9)="FROM"
     end if
     cmdw$(10)=""
     return              'Number of effective command words


     'DISPLAY THE TASKS AVAILABLE

DefineTasks:
     task$(1)="SEEKING"
     task$(2)="LOADING"
     task$(3)="STORING"
     tasks=3:return          'Number of effective tasks


     'DISPLAY THE PRINTER INSTRUCTIONS

ShowInstructions:
     row=18:column=41:colour=10

     ps$="    SWITCH ON LETTER PRINTER Ŀ       ":gosub Display
     ps$="    LOAD SHEET FEEDER WITH A4         ":gosub Display
     ps$="     NOTEPAPER FOR MAILSHOTS.         ":gosub Display
     ps$="          ":gosub Display
     ps$="                                        ":gosub Display

     return               'Return control to the FMM polling loop.

ClearInstructions:
     colour=7:column=41:ps$=space$(40):for row=19 to 23:gosub 50:next:return
     '





     'ENTER THE START/RE-START N FOR THE PRINT RUN

FromEntry:
     on FromEntryState goto FromEntry1, FromEntry2, FromEntry3, FromEntry4
     return


     'INITIALIZATION

FromEntry1:
     x = TargItem : y = 5 : gosub LeadingZeros1  'Get TargItem in string form with leading zeros in x$
     FieldStr$   =x$
     FieldCol    =62     'Screen column position of first character in field
     FieldRow    =17     'Screen row in which the field is shown
     FieldLen    = 5     'Maximum length of field
        MSG.H    =45     'Column position of first char of insert message
        MSG.V    = 4     'Screen row position for the above
        CNT.H    = 0     'Column after the LS digit of the char count display
     DisplayCount= 0     'Display Count flag [=1 display count =0 don't]
     MaxCharCount= 0     'Maximum permitted character count
     numerics    = 0     '=1 if numerics-only field with 3-digit colour groups
       kolour    = 0     'starting colour for current line
      CharCol    = 1     'Current character pointer within field
     EdFieldState= 1     'Activate the main field editor

     column=41:colour=10
     ps$="                                        ":row=20:gosub 50
     ps$="    Please enter the N within the      ":row=21:gosub 50
     ps$="    Mailing List of the addressee       ":row=22:gosub 50
     ps$="    with whom you wish to start or      ":row=23:gosub 50
     ps$="    re-start printing the letters.      ":row=24:gosub 50

     FromEntryState=2       'Go wait for field editor to terminate
     return
     '





     'WAIT FOR FIELD EDITOR TO TERMINATE

FromEntry2:
     gosub EdFieldFMM                'Exit via the main field editor
     if EdFieldState < 3 then return 'Main field editor not yet terminated
     EdFieldState = 0                'De-activate the main field editor
     if KbChar = 13 then             'If the C/R key were pressed, then
        NumDone = val(FieldStr$)     'List N of addressee to start at
        TargItem = NumDone
        if TargItem > TargSize then  'If is>N of addressees in Trarget List
           sound 3300,1              'then beep
           FromEntryState = 1        'and start again
        else
           TargItem = TargItem - 1   'Counteract initial increment in MailCtrl
           goto FromEntry3
        end if
     else                                                 'else Re-display the original TargItem N
        x = TargItem : y = 5 : colour = 23 : gosub LeadingZeros : ps$ = x$ : row = 17 : column = 62 : gosub 50
        FromEntryState = 0                                'De-activate self,
        CWPstate = 1
        gosub ClearInstructions
     end if
     return


     'INITIALIZATION

FromEntry3:
     x = TargSize : y = 5 : gosub LeadingZeros1
     FieldStr$   =x$
     FieldCol    =73  'Screen column position of first character in field
     FieldRow    =17  'Screen row in which the field is shown
     FieldLen    = 5  'Maximum length of field
        MSG.H    =45  'Column position of first char of insert message
        MSG.V    = 4  'Screen row position for the above
        CNT.H    = 0  'Column after the LS digit of the char count display
     DisplayCount= 0  'Display Count flag [=1 display count =0 don't]
     MaxCharCount= 0  'Maximum permitted character count
     numerics    = 0  '=1 if numerics-only field with 3-digit colour groups
       kolour    =11  'starting colour for current line
      CharCol    = 1  'Current character pointer within field
     EdFieldState= 1  'Activate the main field editor

     column=41:colour=10
     ps$="                                        ":row=20:gosub 50
     ps$="    Please enter the N within the      ":row=21:gosub 50
     ps$="    Mailing List of the addressee       ":row=22:gosub 50
     ps$="    with whom you wish to terminate     ":row=23:gosub 50
     ps$="    this letter printing session.       ":row=24:gosub 50

     FromEntryState=4       'Go wait for field editor to terminate
     return
     '





     'WAIT FOR FIELD EDITOR TO TERMINATE

FromEntry4:
     gosub EdFieldFMM                'Exit via the main field editor
     if EdFieldState<3 then return   'Main field editor not yet terminated
     EdFieldState=0                  'De-activate the main field editor
     if KbChar=13 then               'If the C/R key were pressed, then
        EndSession = val(FieldStr$)  'List N of addressee to end at
        if EndSession > TargSize then  'If is>N of addressees in Trarget List
           sound 3300,1              'then beep
           FromEntryState = 3        'and start again
        else
           FromEntryState=0          'else de-activate
           gosub ClearInstructions   'Clear the instructions window
           FromOverride=1            'To stop datestamp stopping display.
           UpDown=1:goto CWPfkeys2   'Get the `next' record
        end if                    '
     else
        x = TargSize : y = 5 : gosub LeadingZeros : ps$ = x$ : row = 17 : column = 73 : colour = 23 : gosub 50 'Redisplay TargSize
        EndSession = TargSize
        FromEntryState = 0             'De-activate self,
        CWPstate = 1
        gosub ClearInstructions
     end if                          'and exit
     return


LetterFormatSub:
     if LetterFormatState = 0 then return

     if LetterFormatState = 1 then
        row=3:column=41:colour=1:ps$=space$(40):gosub Display    ' 4
        ps$="  ":for row=5 to 18:gosub 50:next
        row=4:column=43:colour=27
        ps$=" SELECT REQUIRED OUTPUT FORMAT:       ":gosub Display    ' 5
        colour=19
        ps$="                                      ":gosub Display    ' 6
        ps$="                                      ":gosub Display    ' 7
        ps$="                                      ":gosub Display    ' 8
        ps$="                                      ":gosub Display    ' 9
        ps$="                                      ":gosub Display    '10
        ps$="                                      ":gosub Display    '11
        ps$="                                      ":gosub Display    '12
        ps$="                                      ":gosub Display    '13
        ps$="                                      ":gosub Display    '14
        ps$="                                      ":gosub Display    '15
        ps$=" Please highlight the format you want ":gosub Display    '16
        ps$=" using the  keys. Hit F2 to select. ":gosub Display    '17
        ps$=string$(38,223):colour=1:gosub Display                    '18
        column=41:ps$=space$(40)                    :gosub Display    '19
        TempLetterFormat = LetterFormat
        LetterFormatState = 2
     end if

     if LetterFormatState = 2 then
        column = 44
        for k = 0 to 6 
        ps$ = LettForm$(k)
        if k = TempLetterFormat then
           colour = 31
        else
           colour = 23
        end if
        row = k + 7
        gosub 50 : next
        LetterFormatState = 3
     end if

     if LetterFormatState = 3 then
        gosub NextChar
        if CtrlChar = 72 then    '
           if TempLetterFormat > 0 then
              TempLetterFormat = TempLetterFormat - 1
           else
              TempLetterFormat = 6
           end if
           LetterFormatState = 2
        elseif CtrlChar = 80 then    '
           if TempLetterFormat < 6 then
              TempLetterFormat = TempLetterFormat + 1
           else 
              TempLetterFormat = 0
           end if
           LetterFormatState = 2
        elseif CtrlChar = 60 then    'F2
           LetterFormat = TempLetterFormat
           if LetterFormat = 6 then PrtType$ = "FX" else PrtType$ = "LQ" 'FAX
           LetterFormat$ = LettForm$(LetterFormat)
           gosub LetterFixedData
           gosub StatusBoxDisplay
           CWPstate = 1
           LetterFormatState = 0
        elseif KbChar = 27 then    'Esc
           gosub StatusBoxDisplay
           CWPstate = 1
           LetterFormatState = 0
        end if
     end if
     return
