






     '-------------------------------------------------------------------------
     'SET UP TELEX HEADER               03JUL87            [File: TelxHedr.Bas]
     '-------------------------------------------------------------------------
     '
     'Author : R J Morton
     '
     'Inputs:     SD$ - Display system date common variable
     '          time$ - System time
     '        ToWhom$ - Recipient to whom the message is to be sent
     '       WhoFrom$ - Sender (author) of the message
     '       NewLine$ - Line-ending for line transmission [CR or CR/LF]
     '     BlankLine$ - Blank line holder [null or |]
     '     LetterNum$ - Serial number of message in character form
     '     LetterNum  - Serial number of message [stored & incremented]
     '
     'Output: Header$ - output string which is put onto the TxStr$ by MedemEF
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'SET UP THE MESSAGE HEADER
     '
SetUpHeader:
     hour=val(left$(time$,2))                   'Hour of day (24-hour format)
     if hour>11 then x$="pm" else x$="am"
     if hour>12 then hour=hour-12               'Afternoon
     if hour=0 then hour=12                     'Hour from midnight to 1 am
     hour$=str$(hour)+mid$(time$,3,3)+x$+" "    'Time of day (12-hour format)
     '
     if Answerback$="FAX" then
        x$="FAX "+TelexNum$
   else x$=TelexNum$+" "+Answerback$
        end if
     Header$=x$+NewLine$              _  'Addressee's Telex N + answerback
            +OwnTelx$                 _  'Own Telex Number + answerback code
            +"  (Phone "+OwnFone$+")" _  'Own phone number
            +NewLine$+BlankLine$         'Blank line
     '
     if ShowRef$="YES" then           _
        x$  =RefNum$                  _  'Prospect's Ref N
            +" "+SalesAreaID$         _  'Sales Area letter
            +TargNum$                 _  'Target Profile Number
            +TargSer$                 _  'Target Serial Number
        else x$=""                       'Limited reference
     '
     Header$=Header$                  _  '
            +"Ref"+x$                 _  '                  
            +LetterNum$+"  "          _  'Message Serial Number
            +hour$+SD$    +NewLine$   _  'Time & date stamp
            +BlankLine$                  'Blank line
     '
     Header$=Header$                    _
            +"To:   "+ToWhom$ +NewLine$ _  'Addressee
            +"From: "+Signatory$        _  'Originator of message (signatory)
            +":"     +OwnName$+NewLine$ _  'Originator of the message
            +"Subj: "+Subj$   +NewLine$ _  'Subject of message
            +BlankLine$                    'Blank line
     '
     return
     '-------------------------------------------------------------------------
     'SET UP THE MESSAGE HEADER
     '
SetUpTail:
     '
     Tail$=BlankLine$       _  'Blank line
          +"End of message" _
          +NewLine$         _  'End of message
          +BlankLine$          'Blank line
     '
     return
     '-------------------------------------------------------------------------
     '
